/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

/* 
 * Initial version
 * Gary Jennejohn (C) 2003 <gj@denx.de>
 */

/*
 * Reset the INCAIP board.
 */

#include <linux/kernel.h>
#include <asm/reboot.h>
#include <asm/system.h>
#include <asm/incaip/inca-ip.h>

static void incaip_machine_restart(char *command);
static void incaip_machine_halt(void);
static void incaip_machine_power_off(void);

static void incaip_machine_restart(char *command)
{
	local_irq_disable();

	*INCA_IP_WDT_RST_REQ = 0x3f;
	for (;;) ;
}

static void incaip_machine_halt(void)
{
	/* Disable interrupts and loop forever */
	printk(KERN_NOTICE "System halted.\n");
	local_irq_disable();
	for (;;) ;
}

static void incaip_machine_power_off(void)
{
	/* We can't power off without the user's assistance */
	printk(KERN_NOTICE "Please turn off the power now.\n");
	local_irq_disable();
	for (;;) ;
}

void incaip_reboot_setup(void)
{
	_machine_restart = incaip_machine_restart;
	_machine_halt = incaip_machine_halt;
	_machine_power_off = incaip_machine_power_off;
}
