/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
 
/******************************************************************************
   File        : $RCSfile: INCAIPOAKcommand0.c,v $
   Revision    : $Revision: 1.3 $
   Date        : $Date: 2004/02/02 12:56:52 $
   Description :

******************************************************************************/

/****************************************************************************
Description :
     Performs basic version check.
Arguments   :
Return      :
Remarks     :
****************************************************************************/
LOCAL int Check4FileID(DWNLD *pDwnLd, void **p)
{
   UINT32 len;

   len =  FILE_ID_SIZE + VERSION_NO_SIZE + PRODUCT_NAME_SIZE +
          MANUFCT_ID_SIZE + TIMESTAMP_SIZE;

   memcpy(&pDwnLd->file_hdr,*p, len);
   *p += len;

   pDwnLd->file_hdr.protocol_ID  = Read_uI32(p);
   pDwnLd->file_hdr.product_id   = Read_uI32(p);
   pDwnLd->file_hdr.head_ext_ptr = Read_uI32(p);
   pDwnLd->file_hdr.block_ptr    = Read_uI32(p);

   if (pDwnLd->file_hdr.protocol_ID != PROTOCOL_ID)
      return EXIT_FALSE_BAD_PROT_ID; 
   
   if(strcmp(pDwnLd->file_hdr.file_id, FILE_ID) != 0)
      return EXIT_FALSE_BAD_FILE_ID;

   return (OK);
}


/****************************************************************************
Description :
     stores global information about mailbox size and timeout handling
Arguments   :
Return      :
Remarks     :
****************************************************************************/
LOCAL void command_sc(DWNLD *pDwnLd, void **p)
{
   pDwnLd->glob_var.next_ptr    = Read_uI32(p);
   pDwnLd->glob_var.timeout     = Read_uI32(p);
   pDwnLd->glob_var.timeout_ptr = Read_uI32(p);
}








