/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
 
/******************************************************************************
   File        : $RCSfile: INCAIPOAKcommand2.c,v $
   Revision    : $Revision: 1.4 $
   Date        : $Date: 2004/02/19 07:24:24 $
   Description : 

******************************************************************************/

/****************************************************************************
Description :
     
Arguments   :
Return      :
Remarks     :
****************************************************************************/
LOCAL int SendMailBox(DWNLD *pDwnLd, OAK_MB_DEV_STR *pMBDev, void **p)
{
   UINT32   i, len, *ptr, *ptr2, cmd, snd;

   pDwnLd->next_ptr   = Read_uI32(p);
   /* read the number of 32 bit values  */
   len                = Read_uI32(p);
   /* get the command which has to be set at the beginning of the messages */
   cmd                = Read_uI32(p);

   /*if (len > MAX_MB_MSG_LNG_32BIT)
      len = MAX_MB_MSG_LNG_32BIT;*/
   
   ptr = pDwnLd->MBox;
   
   while (len)
   {
      /* write the data down to the device */

      if (len > (MAXMSGLEN / 4))
         snd = (MAXMSGLEN / 4);
      else
         snd = len;

      ptr2 = ptr;
      *ptr2++ = cmd | (snd << 1);  
      for(i = 0; i < snd; i++)
      {
         *ptr2++ = Read_uI32(p);
      }

      if(Prim_SendMessage(pDwnLd, pMBDev, ptr, snd + 1) ==  (ERROR))
         return (ERROR);

      len -= snd; 
   }
   
   return (OK);
}


/****************************************************************************
Description :
     
Arguments   :
Return      :
Remarks     :
****************************************************************************/
LOCAL int ReadMailBox(DWNLD *pDwnLd, void **p)
{
   INT32    i;
   UINT32   len, *ptr;

   pDwnLd->read_mbox.true_ptr   = Read_uI32(p);
   pDwnLd->read_mbox.false_ptr  = Read_uI32(p);
   len                          = Read_uI32(p);

   if (len > MAX_MSG_LNG_32BIT)
      return (ERROR);
   
   pDwnLd->read_mbox.len        = len;

   ptr = pDwnLd->read_mbox.MBox;

   for(i = 0; i < len; i++)
   {
      *ptr++ = Read_uI32(p);
   }

   return (OK);
}                                  


/****************************************************************************
Description :
     A message will be sent to the OAK. This function can return with TRUE or
  TIMEOUT.
Arguments   :
Return      :
Remarks     :
****************************************************************************/
LOCAL int SendMessage(DWNLD *pDwnLd, OAK_MB_DEV_STR *pMBDev, void **p)
{
   UINT32   i, len, *ptr, *ptr2;
   
   pDwnLd->next_ptr = Read_uI32(p);
   /* read the number of 32 bit values */
   len              = Read_uI32(p);

   if (len > (MAXMSGLEN << 1))
     return (ERROR);

   ptr2 = ptr = pDwnLd->MBox;
   
   for(i = 0; i < len; i++)
   {
      *ptr2++ = Read_uI32(p);
   }

   return Prim_SendMessage(pDwnLd, pMBDev, ptr, len);
}


/****************************************************************************
Description :
     A Message is read from the OAK and compared to a reference message.
     NOTE: Each incomming message has a message id derived during runtime. 
     This message id has to be masked out before comparison.
Arguments   :
Return      :
Remarks     :
****************************************************************************/
LOCAL int ReceiveMessage(DWNLD *pDwnLd, OAK_MB_DEV_STR *pMBDev, void **p)
{
   UINT32    i, length;
   UINT32   incoming[MAX_MSG_LNG_32BIT], len, *ptr;

   pDwnLd->rcv_msg.true_ptr  = Read_uI32(p);
   pDwnLd->rcv_msg.false_ptr = Read_uI32(p);
   len                       = Read_uI32(p);
   pDwnLd->rcv_msg.len       = len;

   ptr = pDwnLd->rcv_msg.Data;
   
   for(i = 0; i < len; i++)
   {
      *ptr++ = Read_uI32(p);
   }
   
   length = Prim_ReadMessage(pDwnLd, pMBDev, incoming, MAX_MSG_LNG_32BIT, 
         pDwnLd->glob_var.timeout);

   if (length <= 0)
      return TIMEOUT;
   
   if (length != (len * 4))
      return (ERROR);
   
   if(memcmp(incoming, pDwnLd->rcv_msg.Data, length) != 0)
      return (ERROR);   
   return (OK);
}


/****************************************************************************
Description :
  Incoming messages are parsed for a specific message.
  NOTE: Each incomming message has a message id derived during runtime.
  This message id has to be masked out before comparison.
Arguments   :
Return      :
Remarks     :
****************************************************************************/
LOCAL int ReceiveMessage_wait(DWNLD *pDwnLd, OAK_MB_DEV_STR *pMBDev, void **p)
{
  UINT32    incoming[MAX_MSG_LNG_32BIT], *ptr, *ptr2, len, i;

  pDwnLd->rcv_msg.true_ptr  = Read_uI32(p);
  len                       = Read_uI32(p);
  pDwnLd->rcv_msg.len       = len;

  ptr2 = ptr = pDwnLd->rcv_msg.Data;
  
  for(i = 0; i < len; i++)
     *ptr++ = Read_uI32(p);


  while(1)
  {
    if (Prim_ReadMessage(pDwnLd, pMBDev, incoming, MAX_MSG_LNG_32BIT, 
      pDwnLd->glob_var.timeout) <= 0)
      return TIMEOUT;

    if(memcmp(incoming,ptr2,len<<1) == 0)
      return (OK);   
  }

  return (ERROR);
}










