/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
 
/******************************************************************************
   File        : $RCSfile: INCAIPOAKdata.h,v $
   Revision    : $Revision: 1.3 $
   Date        : $Date: 2004/02/02 13:00:25 $
   Description :

******************************************************************************/
#ifndef __INCAIPOAKDATA
#define __INCAIPOAKDATA

#define FILE_ID_SIZE       16
#define VERSION_NO_SIZE    16
#define PRODUCT_NAME_SIZE  16
#define MANUFCT_ID_SIZE    64
#define TIMESTAMP_SIZE     24

#define PROTOCOL_ID        1

/* Number of Dwords for a message reserved */
#define MAX_MSG_LNG_32BIT  32
#define MAX_MB_MSG_LNG_32BIT  1024


typedef struct	{
   char  file_id[FILE_ID_SIZE];
   char  version_no[VERSION_NO_SIZE];
   char  product_name[PRODUCT_NAME_SIZE];
   char  manufct_id[MANUFCT_ID_SIZE];
   char  timestamp[TIMESTAMP_SIZE];
   UINT32 protocol_ID;
   UINT32 product_id;
   UINT32 head_ext_ptr;
   UINT32 block_ptr;

}T_FILE_HDR;

typedef struct {

   UINT32   block_type;
   UINT32   unknown_ptr;

}T_BLOCK_HDR;

typedef struct {

   UINT32   next_ptr;
   UINT32   timeout;
   UINT32   timeout_ptr;

}T_GLOB_VAR;

typedef struct {
   UINT32   next_ptr;
   INT32    status;

}T_STATUS;

typedef struct {

   UINT32   true_ptr;
   void     *pMsg;

}T_MSG_BLOCK;

typedef struct {

   UINT32   next_ptr;
   UINT32   len;     /* length of 32 bit values in MBox */
   UINT32   cmd;
   UINT32   MBox[MAX_MB_MSG_LNG_32BIT];

}T_SEND_MBOX;

typedef struct {

   UINT32   true_ptr;
   UINT32   false_ptr;
   UINT32   len;     /* length of 32 bit values in MBox */
   UINT32   MBox[MAX_MSG_LNG_32BIT];

}T_READ_MBOX;

typedef struct {

   UINT32   next_ptr;
   UINT32   len;     /* length of 32 bit values in Data */
   UINT32   Data[MAX_MSG_LNG_32BIT];

}T_SEND_MSG;

typedef struct {

   UINT32   true_ptr;
   UINT32   false_ptr;
   UINT32   len;     /* length of 32 bit values in Data */
   UINT32   Data[MAX_MSG_LNG_32BIT];

}T_RCV_MSG;

#ifdef NEVER   
typedef struct {

   UINT32   true_ptr;
   UINT32   false_ptr;
   UINT32   start_addr;
   UINT32   len;     /* length of 32 bit values in Data */
   UINT32   Data[MAX_MSG_LNG_32BIT];
   
}T_WRT_MEM;
#endif /* NEVER */

/*----------------------------------*/
/* Local structure for the download */
/*----------------------------------*/
typedef struct
{
   T_FILE_HDR  file_hdr;
   T_BLOCK_HDR block_hdr;
   T_STATUS    status;
   T_GLOB_VAR  glob_var;
   T_READ_MBOX read_mbox;
   T_RCV_MSG   rcv_msg;
   UINT32   MBox[MAX_MB_MSG_LNG_32BIT];
   UINT32   next_ptr;

   /*T_MSG_BLOCK msg_block;*/
/*   T_SEND_MBOX send_mbox;
   T_SEND_MSG  send_msg;*/
#ifdef NEVER   
   T_WRT_MEM   write_mem;
#endif /* NEVER */
}DWNLD;
/*----------------------------------*/

#endif












