/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
 
/******************************************************************************
   File        : $RCSfile: INCAIPOAKprimitives.c,v $
   Revision    : $Revision: 1.4 $
   Date        : $Date: 2004/02/19 07:24:24 $
   Description : 

******************************************************************************/


/****************************************************************************
Description :
     Sends a message to the OAK
Arguments   :
   pDwnLd   : Pointer to the download structure, which holds the local 
              download specific parameter
   pMBDev   : Pointer to the device handle structure of the device driver
   ptr      : Data pointer to the 32 bit data arrea
   len      : number of 32 bit values to be written to the device
Remarks     :
****************************************************************************/
LOCAL int Prim_SendMessage(DWNLD *pDwnLd, 
                       OAK_MB_DEV_STR *pMBDev, 
                       UINT32 *ptr, 
                       UINT32 len)
{
   OAK_READWRITE   oakrw;

   oakrw.pWrite = ptr;
   /* convert the number of 32 bit to number of bytes */
   oakrw.nWrite = len = len << 2;
 
   if (oak_write_cmd_mailbox(pMBDev, &oakrw) == OK)
   {
      if(oakrw.nWrite == len)
         return (OK);
   }
   return (ERROR);
}


/****************************************************************************
Description :
     Read a message from the OAK device driver interface
Arguments   :
Return      :
Remarks     :
****************************************************************************/
LOCAL int Prim_ReadMessage(
   DWNLD *pDwnLd, 
   OAK_MB_DEV_STR *pMBDev,
   UINT32 *data, 
   UINT32 Length, 
   INT32 timeout)
{
   OAK_READWRITE   oakrw;

   oakrw.pRead = data;
   oakrw.nRead = Length << 2;
   oakrw.nMsgRead = 1;
   
   if (oak_read_fifo(pMBDev, &oakrw, timeout) == ERROR)
      return (ERROR);
   else return oakrw.nRead;
}
