/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
 
/*
 * port_defs.h
 *
 * Local Inca-IP port header file
 *
 * Andre Messerschmidt 
 *
 * For questions about this file please contact your local Infineon 
 * representative.
 *
 */

#ifndef PORT_DEFS_H
#define PORT_DEFS_H

#define OK	0

#define INCA_PORT_OUT_REG		0x00000000
#define INCA_PORT_IN_REG			0x00000004
#define INCA_PORT_DIR_REG		0x00000008
#define INCA_PORT_ALTSEL_REG		0x0000000C
#define INCA_PORT_STOFF_REG		0x00000010
#define INCA_PORT_OD_REG			0x00000014
#define INCA_PORT_PUDEN_REG		0x00000018
#define INCA_PORT_PUDSEL_REG		0x0000001C

#define PORT_MODULE_ID	0xff

#define NOPS	asm("nop;nop;nop;nop;nop")
#define PORT_WRITE_REG(reg, value)   \
	*((volatile u32*)(reg)) = (u32)value; 
#define PORT_READ_REG(reg, value)    \
	value = (u32)*((volatile u32*)(reg)); 
			 
#define PORT_IOC_CALL(ret,port,pin,func) 	\
	ret=inca_port_reserve_pin(port,pin,PORT_MODULE_ID); \
	if (ret == 0) ret=func(port,pin,PORT_MODULE_ID); \
	if (ret == 0) ret=inca_port_free_pin(port,pin,PORT_MODULE_ID);

#endif /* PORT_DEFS_H */
