/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
 
/******************************************************************************
   Module      : INCAIPSwitchHash.h
   Date        : 24.04.2003
   Description : provide fuctions to calculate the hash algorithm used within
                 the INCA-IP switch module to calculate hash table index for
                 a MAC address
   
   $Log: IncaSwitchHash.h,v $
   Revision 1.1  2003/04/25 19:14:20  mangele
   These HASH functions are used for calculate the MAC table index within the INCA-IP switch module
   They are used first time in the "IncaSwitchEnd.c" module version 1.17.


   
******************************************************************************/
#ifndef _INCASWITCHHASH_H
#define _INCASWITCHHASH_H

/*
   structure used for provide hash codes to modulate a MAC address
*/
typedef struct inca_ip_hash_codes
{
   UINT16   Code_0[3] ;
   UINT16   Code_1[3] ;
   UINT16   Code_2[3] ;
} IncaIpHashCodes ;


/* extern definitions of the hash functions */
extern void sw21553_IncaIpInitHashGenPoly(void) ;
extern UCHAR sw21553_IncaIpSwitchCalcHash(UINT modulateNum, UCHAR inMacAddr[6]) ;


#endif   /* #ifndef _INCASWITCHHASH_H */
