/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
#ifndef __CONST_H
#define __CONST_H

/*...NULL Pointer...*/
#define 	NULL_PTR	0  
#ifndef NULL
	#define NULL 0
#endif


#define CHIP_ADDRESS_INVALID 0xFFFFFFFF
/*...........................................................
.............................................................
....constant definitions for number of ports, queues etc.....
............................................................
...........................................................*/	

#define INCAIP2_SWITCH_PORT_SELECT_LAN     0
#define INCAIP2_SWITCH_PORT_SELECT_PC      1
#define INCAIP2_SWITCH_PORT_SELECT_CPU     2


#define		TOTAL_PORTS					3	/* 0 - 2 */
#define     TOTAL_EGRESS_QUEUES			4   /* 0-3 */


/* 
#define 	TOTAL_PORT_REGS				0x1000
*/
#define     TOTAL_MIB_CNT				0x54
	
#define		TOTAL_VIDS					64
#define		TOTAL_VLAN_IDS				4095

#define		REQ			1	
#define		ACK			0	
#define		READPR		1	
#define     WRITEPR		0
#define 	PR_TIME_OUT 10000

/* LENA #define     CPU_PORT					50   */
#define     CPU_PORT_ID					8
#define     GE_PORT_1_ID				7
#define     GE_PORT_0_ID				6


/* Added by Manamohan on 18-2-2004  */

#define		MAJOR_ID_1		1
#define		MINOR_ID_3		3

/*  
...................................................
..................................................
............ Switch - Chip Related APIs ............
........... .Refered by pr_switch.c pr_pbll.c pr_interrupt.c ....
...................................................
...................................................*/


/*	prChipSet/GetMode Apis	*/

#define IIC_ADDRESS					1
#define MEM_CONFIG_MODE				2
#define ENDIAN_MODE					3
#define EXT_ROM_BOOT				4
#define BOARD_ID					5
#define EXT_DATA_EEPROM				6
#define EXT_SDRAM_EEPROM			7
#define CLOCK_CONTROL				8
#define PCI_SDRAM_SELECT			9
#define TEST_MODE					10
#define CPU_PACKET_FORWARD			11
#define EDRAM_FPI_ACCESS			12
#define MIPS_PLL_BYPASS				13
#define SYSTEM_PLL_BYPASS			14
#define CPU_CLOCK_FEEDBACK_DIVIDER	15
#define CPU_CLOCK_INPUT_DIVIDER		16
#define SYS_CLOCK_FEEDBACK_DIVIDER	17
#define SYS_CLOCK_INPUT_DIVIDER		18

/* 17-2-2004 Added the following constant */
#define CHIP_MINOR_ID_POS			28


/*	prSwSet/Getmode APis	*/

/* #define FE_MCASTQ_THRESHOLD			1  */
#define GE_MCASTQ_THRESHOLD			2
/*
#define LA_L3_BASED					3
#define LA_DA_BASED					4
#define	LA_SA_BASED					5
*/
#define	AGING_SOURCE				6
#define	AGING_TIME_SELECT			7
#define	MA_FREEZE_ALL				8
#define	MA_FREEZE_NEW				9
#define CRCERROR_PACKET_MONITOR		10
#define MACHANGE_PACKET_MONIOR		11
#define	PAUSE_PACKET_TO_CPU			12
#define	FORWARD_CFI_PACKET			13
#define	MA_REPLACE_THRESHOLD		14

#define PORT0_GE_CONF				19  
#define PORT0_GE_MODE				20
#define PORT1_GE_CONF				21  
#define PORT1_GE_MODE				22

#if 0
/* #define IVL_ENABLED					15  */
/* #define	MCAST_PER_VLAN				16  */
/* #define	FID_LEARN_CHECK				17  */
#define	CPU_TIMESTAMP				18
#define PORT0_GE_CONF				19
#define PORT0_GE_MODE				20
#define PORT1_GE_CONF				21
#define PORT1_GE_MODE				22
#define PORT2_GE_CONF				23
#define PORT2_GE_MODE				24
#define PORT3_GE_CONF				25
#define PORT3_GE_MODE				26
#define PORT4_GE_CONF				27
#define PORT4_GE_MODE				28
#define PORT5_GE_CONF				29
#define PORT5_GE_MODE				30
#define PORT0_GEONLY_MODE			31
#define PORT1_GEONLY_MODE			32
#endif
#define UNKNOWN_PROTOCOL_TO_CPU		33
#define MONITORING_PORT				34
#define SEND_RESERVED_PACKETS_2_CPU	35


/* prSwSet/GetEgressWaterMark	*/
#define QUEUE_0						0
#define QUEUE_1						1
#define QUEUE_2						2
#define QUEUE_3						3

/* prSwSet/GetEgressWaterMark	*/

#define GLOBAL_DROP_WATERMARK		1
#define PORTGROUP_FC_WATERMARK		2
#define PORTGROUP_DROP_WATERMARK	3

/* PBLL */
#define	PBLL_RPTR_SHF 				13
#define PBLL_RWPTR_MASK				0x1FFF
#define TOTAL_PBNUM                 8191

/* Port configuration	*/
#define		PORTX_MIRROR_MASK		0xFFFFFFF7
#define		PORTX_MIRROR_POS		3
#define     PORT_CONFIG_TBL     	0x6
#define     PORT_PRE_MASK			0xF7FFFFFF
#define     PORT_PRE_POS			27
#define     PORT_RATE_EN_MASK		0xBFFFFFFF
#define     PORT_RATE_EN_POS		30


#define     RE_TRANSMIT_CNT			31
#define     LATE_COLLISION_CNT		127	

#define     MAX_EGR_WM_VAL    0x3FF
#define     MAX_INGR_WM_VAL   0xFF
	
/************ declerations for RX/TX IMRs and ISRs ***********/	

/* RX and TX interrupts  */
#define    	RX_CRC_ERR			1
#define		RX_NO_RXD_CELL		2
#define		RX_NO_PKT_DISC		3
#define		RX_NO_PB_NUM		4
#define		RX_RKEY_RCV			5
#define		RX_NO_EOF_DETECT	6
#define		RX_NO_SOF_DETECT	7
#define		RX_FIFO_OVERFLOW	8

#define		RX_CRC_ERR_POS		24
#define		RX_NO_RXD_CELL_POS	16
#define		RX_NO_PKT_DISC_POS	8
#define		TX_MAX_ATTEMPTS		1
#define		TX_LATECOL			2
#define		TX_EARLYCOL			3
#define		TX_UNDERFLOW		4
#define		TX_MAX_ATTEMPTS_POS		24
#define		TX_LATECOL_POS			16
#define		TX_EARLYCOL_POS			8

#define     L3_MAX_VAL  0xFF

/*  
...................................................
..................................................
............ Port Related APIs ............
........... .Refered by pr_port.c pr_fe_port.c pr_monitoring.c pr_phy.c pr_trunk.c .....
........................pr_ge_port.c pr_MIB_counters.c ......
...................................................*/

#define PHY_CTRL   0x0
#define PHY_STATUS 0x1
#define PHY_ANAR   0x4   /* ANEG Adverisement Register select */
#define PHY_ANLPA  0x5   /* ANEG Link Partner Ability Register select */
#define PHY_ANER   0x6   /* ANEG Expansion  Register select */


#define PR_PORT_DISABLED	1
#define PR_AUTO_NEGO		2
#define PR_NO_AUTO_NEGO		3
#define PR_HALF_10			4
#define PR_FULL_10			5
#define PR_HALF_100			6
#define PR_FULL_100			7
#define PR_HALF_1000		8
#define PR_FULL_1000		9


#define	PORT_GRP_CNT		3
#define	PORTID_MASK			0x7
#define	DUPLEX_MODE_POS		8

#define	PAUSE_CTRL_POS		5
#define	PORT_LINK_POS		24

#define	SPEED_LSB_POS		13



#define PHY_FE_SPEED_POS		13
#define	PHY_FE_RESET_POS		15
#define	PHY_AUTONEGO_POS		12
#define	PHY_POWER_DOWN_POS 		11

#define	PHY_RESTRT_AUTONEGO_POS	9
#define	PHY_DUPLEX_MODE_POS		8
#define	PHY_DUPLEX_MODE_MASK		0x0100
#define	PHY_PAUSE_POS			10
#define	PHY_AUTONEGO_CP_POS		5
#define	PHY_ASYM_PAUSE_POS		11


#define	GE_PORT_DUPLEX_POS		3
#define	GE_PORT_SPEED_MASK		0x3
#define	GE_RX_PORT_PAUSE_POS	5
#define	GE_TX_PORT_PAUSE_POS	6
#define	GE_PORT_AUTHEN_MASK		0x03
#define	GE_PORT_LINK_POS		4

#define PHY_GE_SPEED1_POS		13
#define	PHY_GE_SPEED2_POS		6	
#define	PHY_GE_RESET_POS		15
		

#define	MDIO_MODE_POS			2
#define	MDIO_MODE_MASK			0x00000004
#define	AUTONEG_MODE_MASK		0x00000001
#define MDIO_INT_EXT_MASK       0x00000020
#define MDIO_INT_EXT_POS        5

#define	MDIO_ACC_READY_POS		31
#define	MDIO_ACC_READ_POS		26
#define	MDIO_ACC_WRITE_POS		27
#define	MDIO_ACC_PHYID_POS		21
#define	SWITCH_MDIO_ACCID_POS		16
#define	MDIO_ACC_DATA_MASK		0x0FFFF

#define FE_PORT_AUTONEGOTIATION 	0
#define	FE_PORT_LINK_OK				1
#define	FE_PORT_DUPLEX_MODE			2
#define	FE_PORT_SPEED				3
#define	FE_PORT_PAUSE_FLOW_CTRL		4
#define	FE_PORT_PRIORITY			5
#define	FE_PORT_MONITOR_INGRESS		6
#define	FE_PORT_MONITOR_EGRESS		7
#define	FE_PORT_AUTHENTICATION		8


#define GE_PORT_AUTONEGOTIATION 	0
#define	GE_PORT_LINK_OK				1
#define	GE_PORT_DUPLEX_MODE			2
#define	GE_PORT_SPEED				3
#define GE_RX_PORT_PAUSE_FLOW_CTRL	4
#define	GE_TX_PORT_PAUSE_FLOW_CTRL	5
#define	GE_PORT_PRIORITY			6
#define	GE_PORT_MONITOR_INGRESS		7
#define	GE_PORT_MONITOR_EGRESS		8
#define	GE_PORT_AUTHENTICATION		9

#define	AUTHEN_NO_TX_RX				0
#define	AUTHEN_TX_RX				3


#define TOTAL_FE_PORTS				2
/* #define TOTAL_FE_PORTS				48  */

#define LAN_MAX_PORTS               TOTAL_FE_PORTS
#define GE_PORT_0					TOTAL_FE_PORTS
#define GE_PORT_1					TOTAL_FE_PORTS + 1
#define CPU_PORT					TOTAL_FE_PORTS + 2
/*
#define TOTAL_PHY_PORTS             CPU_PORT
*/
#define TOTAL_PHY_PORTS  2

/*
#define TOTAL_PORT_MIB_COUNT        26
*/
#define TOTAL_PORT_MIB_COUNT        21
#define TOTAL_MAC_MIB_COUNT         6


#define IFX_TOTAL_FE_PORTS      2 /* 48  */
#define IFX_GE_PORT_0           48
#define IFX_GE_PORT_1           49
#define IFX_CPU_PORT            3
#define IFX_DROP_PORT           63
#define IFX_TOTAL_PORTS         3
#define IFX_TOTAL_PHY_PORTS     2

#define PORT_MII_MODE				0
/* #define PORT_GMII_MODE				1  */
#define PORT_RGMII_MODE				1
/*#define PORT_TBI_MODE				3  */


#define PMA_MODE					0x700000
#define PMA_SYNC_LINK_STATUS		0x60000
/*
#define GMAC_LINK_OK_MASK			0x10
#define GMAC_LINK_OK_POS            5 
*/
#define GMAC_DUPLEX_POS  3


/* pr_mac.c 
...................................................
..................................................
............ MAC Related APIs ............
........... .Refered by pr_mac.c ..............
...................................................
...................................................*/

#define HASH_CALCULATION_STEPS 4

/* MAC Address Table	*/
#define		BUCKETID_MASK	0x3
#define		HASHIND_POS		2 


#define		MAC_MASK		0xFF
#define		BUCKETID_POS	2

/* #define		MAX_MACTABLEINDEX	8191  */ /* shifted to /include/incaip2/switch.h */
/* #define		HASH_INDEX_MASK		0x7FF  */
#define		HASH_INDEX_MASK		0x3F
#define 	HASH_INDEX_POS		2

#define		INVALID				0xF
/* #define		STATIC				0  shifted to asm/incaip2/switch.h */
#define     MAX_AGING_STATE     INVALID 

#define     MAC_TABLE_ENTRIES 64

/* Critical flag	*/
#define		CRITICAL_POS	16
#define		CRITICAL_MASK   0x00010000

/* destination ports */
#define     LAN_PORT_POS   17
#define		LAN_PORT_MASK   0x00020000
#define     PC_PORT_POS    18
#define		PC_PORT_MASK   0x00040000
#define     CPU_PORT_POS   19 
#define		CPU_PORT_MASK   0x00080000
 
/* State	*/
#define		MA_STATE_POS    20
#define		MA_STATE_MASK   0xF

#define MAC_TABLE_31_0  0
#define MAC_TABLE_55_32 1

/*  
...................................................
..................................................
............ ARL Related APIs ............
........... .Refered by pr_vlan.c pr_flood.c pr_STP.c pr_cos.c ..............
...................................................
...................................................*/


#define DEFAULT_VID 		63
#define DEFAULT_VID_1022	1022

#define	MAX_PORTID			TOTAL_PORTS - 1
#define	MAX_VLANID  		4094
#define	MAX_PORTSTATE		5
#define	MAX_PRIORITY		7
#define	MAX_CoS				3
#define	MAX_RedCoS			3
#define	MAX_UNKN_DEST_ID  7
#define	MAX_VlanFlowIdx		63
#define	MAX_MIB_CNTID		3

#define	NUMBER_VIDS 		64
#define	MAX_VID				63
#define	MAX_FILTERID		1023

#define	WRITE_INDEX			63   /* 1021  */


/* VLAN/FLOW MIB Table  */
#define		VLANFLW_MIBIDX_MASK	0x3FF	


/* Stacking Port register	*/
#define		STACK_PORT_VLAN_AWARE_MASK		0xDFFFFFFF
#define		VLAN_AWRFLG_POS		29
 

/* CPU Access control register	*/
#define  RULE_TB_SEL				0x0
#define  ACTION_TB_SEL				0x1
#define		MAC_TBL_VAL		    0x2
#define		VLAN_CONV_TBL		0x3 
#define		TOKEN_BUCKET_TBL    0x4 
#define		PORT_CONFG_TBL      0x6

#define		VID_FID_TBL			0x5




/* Port configuration	*/
#define		PORTX_VLANID_MASK	0xFFFF000F
#define		PORTX_VLANID_POS	4
#define		PORTX_COS_MASK		0xFFFCFFFF
#define		PORTX_COS_POS		16
#define		PORTX_INGRESS_POS	18	
#define		PORTX_INGRESS_CTRL	0xFFFBFFFF
#define		PORTX_SVLAN_MASK	0xFFFFFFFC
#define		PORTX_LOCKED_MASK   0xFFFFFFFB


/* VLAN Table command register		*/

#define		VLAN_ENTRY_INVALID      0x7FFFF
/* #define		EGRESS_TAGGING_MASK 0x3F  */
#define		EGRESS_TAGGING_MASK     0x7
#define		VLAN_TABLE_EGRESS_MASK  0x00038000
#define		VLAN_TABLE_EGRESS_SHIFT 15
#define		VLAN_TABLE_MEMBER_MASK  0x00007000
#define		VLAN_TABLE_MEMBER_SHIFT 12
#define		VLAN_TABLE_VALID_MASK    0x00040000
#define		VLAN_TABLE_VALID_SHIFT  18
#define		VLAN_TABLE_VLANID_MASK    0x00000FFF
#define		VLAN_TABLE_VLANID_SHIFT  0

#define     SW_VLAN_TABLE_FULL      63
#define     SW_VLAN_TABLE_EMPTY     0

#define		BRIDGE_STATE_POS	4
#define		BRIDGE_STATE_MASK	0x3


/* Unknown destination register		*/
#define		UNKWN_UCASTID_MASK  0xFFFFFE3F
#define		UNKWN_UCASTID_POS	6
#define		UNKWN_MCASTID_MASK  0xFFFFFFC7
#define		UNKWN_MCASTID_POS	3
#define		BCASTID_MASK		0xFFFFFFF8


/* STP/PVST */
#define		STP					0
#define		PVST				1


/* Port states */
#define		IFX_PORT_DISABLED			1
#define		IFX_PORT_BLOCKING			2
#define		IFX_PORT_LISTENING			3
#define		IFX_PORT_LEARNING			4
#define		IFX_PORT_FORWARDING			5	

#define		VLAN_CRT_DEL_MSK	0x80000000


/* pr_qos.c 
...................................................
..................................................
............ QoS Related APIs ............
........... .Refered by pr_qos.c pr_flow_engine.c ..............
...................................................
...................................................*/


#define  MASK(n)			((1 << n) -1)
/* Macro definitions */
#define  RULE_VECTOR_SIZE           512
#define  TOTAL_FLOW_ID				24
#define  MAX_FLOW_ID				23

#define  TOTAL_BUCKET_ID			24
#define  TOTAL_RATE_REGS			8
#define  TOTAL_BURST_REGS			8
#define  TOTAL_EBURST_REGS			8

#define  TOTAL_QUEUE_STATUS_REGS	(0x20)

#define  BURST_POS					3
#define  BURST_MASK					0x7
/*
#define  REPL_IDX_POS			    3
*/
#define  REPL_IDX_MASK				0x7
#define  TOKEN_BKT_TB_SEL			0x4
#define  MAX_REPLENISH_RATE         0xFFFF
#define  MAX_TOKEN_VALUE         0xFFFF


/*	SCHEDULER Data and Command Registers  */

/* Scheduler Data Register2  */
#define  SD2_WFQ_MSK			MASK(13)			
#define  SD2_DC_SHF				13
#define  SD2_DC_MSK				MASK(17)
#define  SD2_TIMER_SHF			30
#define  SD2_TIMER_MSK			MASK(2)
#define  MAX_REPL_TIMER_VALUE   3


/* Scheduler Data Register1  */

#define  SD1_RR_MSK				MASK(8)
#define  SD1_BC_SHF				8
#define  SD1_BC_MSK				MASK(21)
#define  SD1_WFQ_SHF			29
#define  SD1_WFQ_MSK			MASK(3)

#define MAX_BUCKET_COUNT        0x1FFFF

/* Scheduler Data Register0  */	

#define  SD0_TKN_MSK			MASK(20)
#define  SD0_RR_SHF				20
#define  SD0_RR_MSK				MASK(12)


#define  SD_WFQ_SHF				3
#define  SD_WFQ_MSK				MASK(3)

#define  SD_REP_RATE_SHF		12
#define	 SD_REP_RATE_MSK		MASK(12)	

#define  SD_TKN_VAL_SEL			(1 << 0)
#define  SD_REP_RATE_SEL		(1 << 1)
#define  SD_BKT_CNT_SEL			(1 << 2)
#define  SD_WFQ_SEL				(1 << 3)
#define  SD_DEFICIT_CNT_SEL		(1 << 4)
#define  SD_TIMER_SEL			(1 << 5)


#define  TOTAL_PORT_RULE_ID		24   /* 512  */
#define  TB_CTRL_INVALID1		0x9 
#define  TB_CTRL_INVALID2		0x5

#define	 DATA_QUEUE					0x1
#define	 FREE_QUEUE					0x2
#define  FULL_QUEUE					0x1
#define	 NEAR_FULL_QUEUE			0x2
#define	 EMPTY_QUEUE				0x3

#define MAX_WEIGHT_FACTOR           0xFFFF
#define MAX_DEF_COUNT               0x1FFFF


/* pr_flow_engine.c 
...................................................
..................................................
............ Flow Engine Related APIs ............
........... .Refered by pr_qos.c ..............
...................................................
...................................................*/


#define  AT_REDIRECT_POS		26	
#define  AT_MIRROR_POS			24
#define  AT_COS_POS				21
#define  AT_VLAN_POS			8
#define  AT_TKN_BKT_ID_POS		1

#define  AT_REDIRECT_EN_DIS_POS	 25	
#define  AT_REDIRECT_EN_DIS_MASK 0x02000000

#define  AT_MIRROR_EN_DIS_POS	 23	
#define  AT_MIRROR_EN_DIS_MASK 0x00800000

#define  AT_COS_EN_DIS_POS	 20	
#define  AT_COS_EN_DIS_MASK 0x00100000

#define  AT_VLAN_EN_DIS_POS	 7	
#define  AT_VLAN_EN_DIS_MASK 0x00000080

#define  AT_TOKEN_EN_DIS_POS    0	
#define  AT_TOKEN_EN_DIS_MASK 0x00000001


/*
#define  AT_SVLAN_CONFIG_POS	0
*/

#define  AT_REDIRECT_MASK_W	 	~(MASK(3) <<  AT_REDIRECT_POS)
#define  AT_MIRROR_MASK_W 		~(MASK(1) <<  AT_MIRROR_POS)
#define  AT_COS_MASK_W	        ~(MASK(2) <<  AT_COS_POS)
#define  AT_VLAN_MASK_W   	 	~(MASK(12) << AT_VLAN_POS)
#define  AT_TKN_BKT_ID_MASK_W 	~(MASK(6) << AT_TKN_BKT_ID_POS)
/*
#define  AT_SVLAN_CONFIG_MASK_W ~(MASK(2) <<  AT_SVLAN_CONFIG_POS)
*/

#define  AT_REDIRECT_MASK_R			MASK(3)
#define  AT_MIRROR_MASK_R			MASK(1)
#define  AT_COS_MASK_R				MASK(2)
#define  AT_VLAN_MASK_R				MASK(12)
#define  AT_TKN_BKT_ID_MASK_R		MASK(6) 
/*
#define  AT_SVLAN_CONFIG_MASK_R		MASK(2)
*/

#define  REDIRECTION				1
#define	 MIRROR						2
#define  COS_ASSIGNMENT				3
#define  VLAN_ASSIGNMENT			4
#define  TKN_BKT_ID					5
#define  DELETE_ACTION_ENTRY              6
/*
#define  SVLAN_CONFIG				6
*/
#define  RULE_SET0					0
#define  RULE_SET1					1
#define  RULE_SET2					2
#define	 RULE_SET3					3

#define  RULES_PER_SECTION			32
#define  RULE_MEM_NUM				4
#define  MAX_RULE_MEM_ID            (RULE_MEM_NUM-1) 
#define  ADDRESS_PER_RULEMEM		128 
#define  MAX_ADDRESS_PER_RULEMEM	(ADDRESS_PER_RULEMEM-1)  
#define  ADDRESS_PER_IKEY			16
#define  BITS_PER_IKEY				4
/*
#define  RULES_PER_SECTION			32
#define  RULE_MEM_NUM				4 
#define  ADDRESS_PER_RULEMEM		128 
#define  ADDRESS_PER_IKEY			16
#define  BITS_PER_IKEY				4
*/
#define  PORT_RULE_REGS_NUM			4
#define  PORT_MASK_REGS_NUM			4
#define  PORT_OFFSET_REGS_NUM		2



/* pr_cpuport.c 
...................................................
..................................................
............ CPU Port Related APIs ............
........... .Refered by pr_cpuport.c ..............
...................................................
...................................................*/


#define		TOTAL_MAILBOX		3
#define		MAX_TIMESTAMP		2
#define     MAX_MBOXOWNERID		7
#define		PACKET_LEN_60		60
#define		PACKET_LEN_64		64
#define		COMMAND_PEND_POS	31

#define		MAILBOX_1			0
#define		MAILBOX_2			1
#define		MAILBOX_3			2
#define		MAILBOX_4			3			

#define		CMAC_CRITL			0
#define		CMAC_NON_CRITL		1

/* pr_led.c 
...................................................
..................................................
............ LED Related APIs ............
........... .Refered by pr_led.c ..............
...................................................
...................................................*/


#define LED_DISPLAY_MODE		1
#define LED_TX_ACTIVITY			2
#define LED_RX_ACTIVITY			3
#define LED_PACKET_DROP			4
#define LED_MA_CHANGE			5
#define LED_CRC_ERROR			6
#define LED_OVERSIZE			7
#define LED_EARLY_COLLISION		8
#define LED_LATE_COLLISION		9
#define LED_MDIO_POLL_SPEED		10


#define REG_WIDTH				32

#endif  /* _CONST_H */
