/******************************************************************************
 *
 *
 * Copyright 2000 Infineon Technologies Bangalore,India, ., All Rights Reserved
 *	
 *	
 *	
 * Revision History
 *	
 * Name					Date								Description
 * ============	======	================================================
 * Aparna				5/8/2002						Phase I Release
 *  	
 * Manamohan shetty     24/10/2002                      The macro SOFTWARE_TBL is removed
 *
 *                      4/12/2002                       Phase II Release 
 * Lubovsky Amit        12/06/2003						Port 2 uClinux
 *
 * Nick Pur				25/11/2003						DMA support
 *
 * DESCRIPTION : This is processor dependant file. 
 *               1.Depending on processor
 *                 one of the following has to be defined in the begining.
 *                 CPU_MIPS
 *                 CPU_MPC860
 *                 CPU_MPC850
 *               2.If the API parameter check option is not needed undef the 
 *                 PARAMETER_CHECK.
 *               3.If OS is vxWorks define WINDRIVER
 *               4.If OS is uClinux define INCLUDE_UCLINUX
 *
 ******************************************************************************/

#ifndef __PRDEPEND_H
#define __PRDEPEND_H

/* .................................
...Define all dependencies here ....
...................................*/

	#define CPU_MIPS	         /* processor is MIPS */
//	#define REENTRANCY
	#define PARAMETER_CHECK	     /* Paramter check from API is enabled */

/*................................
.... Processor dependencies ......
..................................*/

#ifdef  CPU_MIPS                 

#if defined (__MIPSEB__)
	#define STRUCT_31_0          
#elif defined (__MIPSEL__)
	#define STRUCT_0_31          
#else
    #error "CPU_MIPS, but neither __MIPSEB__, nor __MIPSEL__???"
#endif

#endif

/*................................
.... OS dependencies ......
..................................*/

#ifdef CONFIG_UCLINUX
#ifndef __KERNEL__
	#include "linux_ct.h"
#endif
	#define UCLINUX
#endif

#endif /*_PRDEPEND_H */
