/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

/************** INCAIP2 Switch API Error Code Definiton *********/

#ifndef __PR_ERR_H
#define __PR_ERR_H


/* common error codes used in several APIs */
#define	PR_ERR_NONE						0

#define PR_ERR_PORTID					1
/* #define PR_ERR_PARAMETER_TYPE			2  */
#define PR_ERR_NULL_PTR					2
#define PR_ERR_QUEUEID					3
/* #define PR_ERR_PORTGROUP_ID				4  */



/*	Switch API's	*/
#define PR_ERR_CHIP_REV					18
#define PR_ERR_CHIP_MODE				19
#define PR_ERR_CHIPSW_MODE				20
#define PR_ERR_INGRESS_WM_TYPE			21
#define PR_ERR_PBLL_READPTR				22
#define PR_ERR_PBLL_WRITEPTR			23
#define PR_ERR_PBLL_COUNT				24
#define PR_ERR_PBLL_ADDR				25
#define PR_ERR_PBLL_LINK				26
#define PR_ERR_PBLL_SPID				27
#define PR_ERR_PBLL_SVCNT				28

/* CPU Port API's	*/
#define	PR_ERR_CPU_PORT					29
#define	PR_ERR_MBOXID					30
#define	PR_ERR_OWNERID_INVALID			31
#define	PR_ERR_MBOX_BUSY				32
#define PR_ERR_TIMESTMP					33
#define PR_ERR_AUTOCAST_FLAG            34


#define	PR_ERR_MAC_TABLE_INDEX			57
#define	PR_ERR_FILTERID					58
#define	PR_ERR_CRITICAL_FLAG			59


/*  Switch port API's	*/
#define PR_ERR_MIB_COUNT				60
#define PR_ERR_DEFAULT					61
#define	PR_ERR_COUNTER_ID				62

#define PR_ERR_TX_WM					63
#define PR_ERR_RX_WM					64

/* PHY API's */
#define PR_ERR_PHY_WR					65
#define PR_ERR_PHY_RD					66
#define PR_ERR_PAUSE_AN_DIS				67
#define	PR_ERR_PAUSE_AN_NC				68
#define	PR_ERR_PAUSE_HD				    69
#define	PR_ERR_LINK_DOWN				70

#define PR_ERR_ETH_DUPLEX_MODE          98
#define PR_ERR_ETH_SPEED                99
#define PR_ERR_ETH_ANEG                100
#define PR_ERR_ETH_INT_EXT_PHY         101


/* port APIs */
#define PR_ERR_FE_PORT_SET				71
#define PR_ERR_GE_PORT_SET				72


#define PR_ERR_TIME_OUT					74
#define PR_ERR_TX_CONFIG				75

#define PR_ERR_CHIP_ID					76
#define PR_ERR_CHIP_NUM					77

#define	PR_ERR_INRS_FLTR_PVST			78


/* Semaphore */

#define	PR_SEM_CRT_FAIL					79
#define	PR_SEM_DEL_FAIL					80
#define	PR_ERR_SEM						81



/* MAC */
#define PR_ERR_AGING_STATE              82
#define PR_ERR_HASH_FAIL                83


/*	QOS API's	*/
#define PR_ERR_MAX_WEIGHT               85
#define PR_ERR_DEF_COUNT                86



#define PR_ERR_L3_PROG                  90
#define PR_ERR_L3_START                 91

#define PR_ERR_PAUSE_FRAME_GEN_INVALID  92

#define PR_ERR_CFI           		    94
#define PR_ERR_AGING_TIMER              95


#define PR_ERR_TOKEN_VALUE              96
#define PR_ERR_REPL_TIMER_VALUE         97




/*	QOS API's	*/
#define PR_ERR_BKT_ID_NUM				116
#define PR_ERR_BKT_CNT_NUM				117
#define PR_ERR_RATE_NUM					118
#define PR_ERR_BURST_NUM				119
#define PR_ERR_EBURST_NUM				120
#define PR_ERR_PORTRULE_ID_NUM			121
#define PR_ERR_LC_BITS					122
#define PR_ERR_NC_BITS					123
#define PR_ERR_FLOW_ACTION				124
#define PR_ERR_FLOWID					125
#define PR_ERR_RULE_MEM_ID				126
#define PR_ERR_QSTATUS_TYPE				127
#define PR_ERR_RULE_MEM_ADDRESS         128
#define PR_ERR_WM_VAL                   84

/*  VLAN API	*/
#define	PR_ERR_CHIP_VLAN_AWARE			130
#define	PR_ERR_VLANID					131
#define	PR_ERR_VLAN_FULL				132
#define	PR_ERR_VLAN_EMPTY				133
#define	PR_ERR_VLAN_NOTCONFG			134
#define	PR_ERR_VLAN_INDEX				135
#define	PR_ERR_VLAN_INGRESS_FILTER		136
#define	PR_ERR_VLAN_INGRESS_TAG			137
#define PR_ERR_VLAN_VALID               138
#define	PR_ERR_VLAN_ENTRY_NOT_FOUND 	139
#define PR_ERR_VLAN_UNAWARE				140
#define	PR_ERR_NOFREE_VID				141

/*  Flow Engine/Classification API	*/
#define	PR_ERR_UNKN_DEST_ID				150
#define	PR_ERR_REDU_CoS					151
#define	PR_ERR_VLAN_MIBIDX				152
#define	PR_ERR_MIB_CNTID				153
#define	PR_ERR_JUMBO_ENABLE				154
#define	PR_ERR_LOCK_INVALID				155
#define PR_ERR_PRE_INVALID              156
#define	PR_ERR_PORTSTATE				157
#define	PR_ERR_PRIORITY					158
#define	PR_ERR_CoS						159


#endif	/* end of __PR_ERR_H	*/

