/******************************************************************************
 *
 *
 * Copyright 2000 Infineon Technologies Bangalore,India, ., All Rights Reserved
 *	
 *	
 *	
 * Revision History
 *	
 * Name					Date								Description
 * ============	======	================================================
 * Aparna				5/8/2002						Phase I Release
 *
 *                      4/12/2002                       Phase II Release 
 *  	
 *
 * DESCRIPTION : This contains the structure definitions for all registers.
 *               Each register is a bitwise structure, each member of structure specifies
 *               corresponding bit fields in the register. Depending on compiler either 
 *               STRUCT_31_0 or STRUCT_0_31 has to be considered in depend.h.
 *               STRUCT_0_31 : Allocation of members is from 0 to 31.
 *               STRUCT_31_0 : Allocation of members is from 31 to 0.
 *               MIPS, MPC_860, MPC_850 use STRUCT_31_0
 *               
 ******************************************************************************/

#ifndef __PR_STRUCT_H
#define __PR_STRUCT_H

#include "global.h"

#ifdef STRUCT_0_31
#include "struct_le.h"
#elif defined STRUCT_31_0
#include "struct_be.h"
#else
#error neither STRUCT_31_0 nor STRUCT_0_32 defined
#endif		/* end of STRUCT_31_0 */


#endif		/* end of __PR_STRUCT_H */
