/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/


#ifndef __STRUCT_BE_H
#define __STRUCT_BE_H

#include "global.h"

/********************** PR reg_tister  ************************/

typedef struct
{
	u32 Rsv1 : 7;
	u32 MA_Replace_Threshold : 4;
	u32 Fwd_unknown2_cpu	: 1 ;
	u32 Fwd_cfi_pkts : 1;
	u32 Fwd_pause2cpu : 1;
	u32 Monitor_MA_change_pkt : 1;
	u32 Monitor_crc : 1;
	u32 MA_Freez_New : 1;
	u32 MA_Freeze : 1;
	u32 Age_Timer : 3;
	u32 Age_tick_Sw : 1;
    u32 Send_Res2_cpu : 1;
    u32 Rsv2 : 2;
	u32 ge_bcastq_threshold : 4;
    u32 Rsv3 : 3;
} pr_ctrl_reg_t ;

typedef struct
{
	u32 Rsv1 : 9;
	u32 Ma_state : 4;
    u32 Rsv2 : 5;
	u32 Ma_dest : 3;
	u32 MA_crit : 1;
	u32 Rsv3 : 10;
} ma_learn_reg_t ;

typedef struct
{
	u32 Rsv1 : 5;
	u32 En_ma_read : 1;
	u32 En_ma_learn : 1;
	u32 En_da_lookup : 1;
	u32 Rsv2 : 1;
	u32 Da_state : 4;
	u32 Rsv3 : 5;    
	u32 Dst : 3; 
	u32 Da_crit : 1;
	u32 Rsv4 : 10;
	
} dst_lookup_reg_t ;

typedef struct
{
	u32 Rsv : 11;
	u32 Table_sel : 3;
	u32 Index : 12;
	u32 Table_specific : 4;
	u32 Read_write : 1;
	u32 Req_ack : 1;
} cpu_acs_ctrl_reg_t ;

typedef u32  cpu_acs_data_reg_t  ;

typedef struct
{
	u32 Rsv : 19;
	u32 rule_base_idx : 5;
	u32 actionNC : 4;
	u32 actionLC : 4;
	
} tb_ctrl_reg_t ;

typedef u32  rate_reg_t  ;

typedef u32  burst_reg_t   ;

typedef u32  eburst_reg_t ;

typedef struct
{
	u32 Rsv:12;
	u32 Cr3:2;
	u32 Cr2:2;
	u32 Cr1:2;
	u32 Cr0:2;
	u32 Cp0:3;
	u32 Cp1:3;
	u32 Cp2:3;
	u32 Cp3:3;

} cos_sel_reg_t; 

typedef struct
{
	u32 Rsv:16;
	u32 Pc7:2;
	u32 Pc6:2;
	u32 Pc5:2;
	u32 Pc4:2;
	u32 Pc3:2;
	u32 Pc2:2;
	u32 Pc1:2;
	u32 Pc0:2;

} pri2_cos_reg_t;

typedef u32  pr_isr_reg_t  ;

typedef u32  pr_imr_reg_t  ;

/*******************    SE reg_tisters  ************************/

typedef struct{
	u32 Req_ack    : 1;
	u32 Read_write : 1;
	u32 MIBId      : 2;
	u32 Reservd    : 22;
	u32 Address    : 6;    
} vlan_mibs_cmd_reg_t; 

typedef struct
{
	u32 Req_ack    : 1;
	u32 Read_write : 1;
	u32 Res1       : 16 ;
	u32 field_sel  : 6;
	u32 Queue_id   : 2;
    u32 Res2       : 4;
	u32 Port_id    : 2;    
} sd_cmd_reg_t;

typedef struct
{
	u32 Replinish_timer : 2;
	u32 Deficit_cnt : 17;
	u32 Weight : 13;

} sd_data_reg2_t ;

typedef struct
{
	u32 Weight : 3;
	u32 Bucket_cnt : 21;
	u32 Replinish_rate : 8;
	
} sd_data_reg1_t ;

typedef struct
{
	u32 Replinish_rate :12;
	u32 Token_val : 20;

} sd_data_reg0_t;

typedef struct{
	
	u32 Req_ack    : 1;
	u32 Read_write : 1;
	u32 Reservd    :24;
	u32 Vlan_Id    :6;
    
} vlan_tbl_cmd_reg_t;


typedef struct{
	
    u32 Reservd    :13;	
	u32 valid      : 1;
	u32 egr_cpu    : 1;
	u32 egr_pc     : 1;
	u32 egr_lan    : 1;   
	u32 member_cpu : 1;
	u32 member_pc  : 1;
	u32 member_lan : 1;        
	u32 Vlan_Id    : 12;
} vlan_tbl_data_t;

typedef union
{
    vlan_tbl_data_t field;
    u32 val;
} vlan_tbl_entry_u;

typedef  u32  Port_auth_reg_t ;

typedef  u32  trunk_ctl_reg_t ; 

typedef  u32  monitoring_port ;

typedef u32 global_rx_wm_reg_t ;

typedef struct
{
	u32 Rsv : 16 ;
	u32 rx_wm2 : 8 ;
	u32 rx_wm1 : 8 ;
	
} port_rx_wm_regs_t ;

typedef struct
{
	u32 Rsv : 12;
	u32 Queue1_tx_wm : 10;
	u32 Queue0_tx_wm : 10;
	
} port_tx_wm_reg0_t ;

typedef struct
{
	u32 Rsv : 12;
	u32 Queue3_tx_wm : 10;
	u32 Queue2_tx_wm : 10;
	
} port_tx_wm_reg1_t ;

typedef  u32  queue_status_regs_t ;

typedef  u32  se_isr_reg_t  ;

typedef  u32  se_imr_reg_t  ;

typedef  u32  se_ack_reg_t  ;


typedef struct
{
	u32 Rsv     : 30;
	u32 pfg_pc  : 1;
	u32 pfg_lan : 1;
} port_pause_ctl_reg_t ;


typedef struct
{
	u32 Rsv         : 10;
	u32 rem_L2_hd   : 1;
	u32 rem_crc     : 1;
	u32 add_stat_hd : 1;
	u32 add_crc     : 1;
	u32 type_len    : 16;  
	u32 add_tag     : 1;
	u32 add_eth_hd  : 1;        
} pmac_hd_ctl_reg_t ;

typedef union
{
    pmac_hd_ctl_reg_t fld;
    u32               val;
} pmac_hd_ctl_t;


typedef struct
{
	u32 Rsv     : 16;
	u32 pri     : 3;
	u32 cfi     : 1;
	u32 vlan_id : 12;

} pmac_vlan_reg_t ;

typedef union
{
    pmac_vlan_reg_t fld;
    u32             val;
} pmac_vlan_t;


/**************************	Port reg_tisters ********************/

typedef u32  rx_isr0_reg_t   ;

typedef u32  rx_isr1_reg_t   ;

typedef u32  rx_imr0_reg_t   ;

typedef u32  rx_imr1_reg_t   ;

typedef u32  tx_isr_reg_t    ;

#define RX_TX_INTERRUPT_MASK 0x00000FFF

typedef struct   /**< port interrupt register rx and tx */ 
{
	u32 Rsv   : 20;
	u32 txma  : 1;    /**< Tx Maximum Attempts Interrupt */   
	u32 txlc  : 1;    /**< Tx Late Collision Interrupt */   
	u32 txec  : 1;    /**< Tx Early Collision Interrupt */   
	u32 txuf  : 1;    /**< Transmit Underflow Interrupt */   
	u32 rr    : 1;    /**< Rkey received Interrupt */   
	u32 noeof : 1;    /**< No EOF detected Interrupt */   
	u32 nosof : 1;    /**< No SOF detected Interrupt */   
	u32 rxfo  : 1;    /**< Receive FIFO overflow Interrupt */   
	u32 rxce  : 1;    /**< Receive CRC Error Interrupt */    
	u32 rxnrc : 1;    /**< No RxD Cell in Receive Interrupt */   
	u32 rxnpd : 1;    /**< No Packet Descriptor available Interrupt */   
	u32 rxnpn : 1;    /**< No PBNUM available Interrupt */   
} rtx_isr_reg_t;

typedef union
{
    rtx_isr_reg_t fld;
    u32           val;
} rtx_isr_t;

typedef u32  tx_imr_reg_t    ;

typedef struct
{
	u32 L3Program  : 1;
	u32 L3StartVld : 1;
	u32 L3Start    : 8;
	u32 Res        : 22;    
} rx_config_reg_t ;

typedef struct
{
	u32 Rsv              : 20;
	u32 Attempt_limit    : 5;
	u32 late_coll_thresh : 7;    
}  tx_config_reg_t  ;

typedef u32  port_offset_regs_t ;

typedef u32  port_mask_regs_t  ;

typedef u32  port_rule_regs_t  ;

typedef u32  ikey_sel_reg_t   ;

typedef struct
{
	u32 Rsv1      : 14;
	u32 t_ipg     : 6;
	u32 Rsv2      : 5;    
	u32 tpe       : 1;        
	u32 rpe       : 1;      
	u32 lg        : 1;       
	u32 dg        : 1;       
	u32 sg        : 2;           
	u32 g_sel     : 1;    
}  gmac_reg_t  ;


/********************** PHY Registers **********************/

typedef struct
{
	u16  reset : 1;
	u16  loop_back : 1;
	u16  speed_sel : 1;
	u16  auto_nego_enable : 1;
	u16  power_down : 1;
	u16  isolate : 1;
	u16  restart_auto_nego : 1;
	u16  duplex_mode : 1;
	u16  reserv : 8;
} PHY_REG0_T ;

typedef struct
{
	u16 next_page : 1;
	u16 reserved2 : 1;
	u16 remote_fault : 1;
	u16 reserved1 : 2;
	u16 pause : 1;
	u16 T4_100 : 1;
	u16 full_100 : 1;
	u16 half_100 : 1;
	u16 full_10 : 1;
	u16 half_10 : 1;
	u16 selector_field : 5;
} PHY_REG4_T;

typedef struct
{
	u16 test_mode : 3;
	u16 master_slave_enable : 1;
	u16 master_slave_conf : 1;
	u16 port_type : 1;
	u16 full_1000 : 1;
	u16 half_1000 : 1;
	u16 reserv : 8;
} PHY_REG9_T;

#endif /* __STRUCT_BE_H */
