/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
#include <asm/types.h>
#include <stddef.h>
#include "global.h"
#include "sem_type.h"
#include "const.h"
#include "struct.h"

/* Register Base Address */
u32 *Chip_Base_Address = (u32*)CHIP_ADDRESS_INVALID;

/* Number of Chips */
u8	Total_Chips = 1;

/* Software VLAN Table */
port_status_per_vlan ** PR_TABLE_PORTSTATUS; 

/* VlanId to Vlanindex(VID) association Table  */
u8 ** PR_VLAN_VID_ASC_TBL;
 
/* Vlan id to Vid software table */
u32 ** PR_VLAN_VID_TBL;

/* Ingress Filter software table */
u8 ** PR_INGRESS_FILTER;

/* SW VLAN table */
vlan_tbl_entry_u** PR_VLAN_SW_TBL;

/* STP/PVST */
//u8 * stp_pvst;

/* Chip Major and Minor version Ids */
u32 * PR_CHIP_MAJR_VER_ID;
u32 * PR_CHIP_MINR_VER_ID;


/* Vlanindex(VID) table		*/
u32 ** PR_TABLE_VID;
u32 * readIndex;
u32 * writeIndex;
u32 * freeEntries;
u32* fill_level;

u8 **	cache_speed;	
u8 **	cache_duplex;

u32 ** Ikey_Sel_Reg;

/* Added the following three tables for 4k vlan support  */
/*
u32 ** PR_VLAN_MULTIPLE_VID;

u8 ** PR_VLAN_SHARE_IND;

u8 ** PR_VLAN_STP_MSTP;
*/

/* Added for re-entrancy  */

#ifdef	REENTRANCY 

SEM_TYPE**   ifxsem_array;  

#endif

