/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

/* Group definitions for Doxygen */
/** \addtogroup Internal Internally used functions */

#ifndef EXPORT_SYMTAB
#define EXPORT_SYMTAB /* need this one 'cause we export symbols */
#endif
 
#include <linux/module.h>  
#include <linux/kernel.h>
/*
#include <linux/string.h>
*/
#include <linux/sched.h>
#include <linux/slab.h>
#include <asm/types.h>
#include <asm/incaip2/ifx_types.h>
#include <asm/addrspace.h>
#include <asm/incaip2/incaip2.h>
#include <asm/incaip2/switch.h>
#include "const.h"
#include "struct.h"
#include "mac.h"
#include "err.h"
#include "var.h"
#include "api_init_prv.h"



struct timer_list*  create_aging_update_timer( void );
void cancel_aging_update_timer( struct timer_list*  timer );
void start_aging_update_timer( struct timer_list*  timer, int ticks,
                               void* callback_function );
void ifx_update_table_aging_states( void );
s32 sysClkRateGet( void );
void set_aging_timer_active( void );
void set_aging_timer_inactive( void );
s32 aging_timer_active( void );



#ifdef CONFIG_INCAIP2_SWITCH_RESERVED_MC
extern u8 ifx_switch_reserved_mc_dst_ports[];
#endif

u32  aging_timer = 0;
s32 aging_ticks; 
BOOL aging_timer_running = FALSE;

u8  macAddr_inv[6]={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};

typedef unsigned char  crc;

crc  table_crc8[256] = {
    0x00, 0x07, 0x0e, 0x09, 0x1c, 0x1b, 0x12, 0x15,
    0x38, 0x3f, 0x36, 0x31, 0x24, 0x23, 0x2a, 0x2d,
    0x70, 0x77, 0x7e, 0x79, 0x6c, 0x6b, 0x62, 0x65,
    0x48, 0x4f, 0x46, 0x41, 0x54, 0x53, 0x5a, 0x5d,
    0xe0, 0xe7, 0xee, 0xe9, 0xfc, 0xfb, 0xf2, 0xf5,
    0xd8, 0xdf, 0xd6, 0xd1, 0xc4, 0xc3, 0xca, 0xcd,
    0x90, 0x97, 0x9e, 0x99, 0x8c, 0x8b, 0x82, 0x85,
    0xa8, 0xaf, 0xa6, 0xa1, 0xb4, 0xb3, 0xba, 0xbd,
    0xc7, 0xc0, 0xc9, 0xce, 0xdb, 0xdc, 0xd5, 0xd2,
    0xff, 0xf8, 0xf1, 0xf6, 0xe3, 0xe4, 0xed, 0xea,
    0xb7, 0xb0, 0xb9, 0xbe, 0xab, 0xac, 0xa5, 0xa2,
    0x8f, 0x88, 0x81, 0x86, 0x93, 0x94, 0x9d, 0x9a,
    0x27, 0x20, 0x29, 0x2e, 0x3b, 0x3c, 0x35, 0x32,
    0x1f, 0x18, 0x11, 0x16, 0x03, 0x04, 0x0d, 0x0a,
    0x57, 0x50, 0x59, 0x5e, 0x4b, 0x4c, 0x45, 0x42,
    0x6f, 0x68, 0x61, 0x66, 0x73, 0x74, 0x7d, 0x7a,
    0x89, 0x8e, 0x87, 0x80, 0x95, 0x92, 0x9b, 0x9c,
    0xb1, 0xb6, 0xbf, 0xb8, 0xad, 0xaa, 0xa3, 0xa4,
    0xf9, 0xfe, 0xf7, 0xf0, 0xe5, 0xe2, 0xeb, 0xec,
    0xc1, 0xc6, 0xcf, 0xc8, 0xdd, 0xda, 0xd3, 0xd4,
    0x69, 0x6e, 0x67, 0x60, 0x75, 0x72, 0x7b, 0x7c,
    0x51, 0x56, 0x5f, 0x58, 0x4d, 0x4a, 0x43, 0x44,
    0x19, 0x1e, 0x17, 0x10, 0x05, 0x02, 0x0b, 0x0c,
    0x21, 0x26, 0x2f, 0x28, 0x3d, 0x3a, 0x33, 0x34,
    0x4e, 0x49, 0x40, 0x47, 0x52, 0x55, 0x5c, 0x5b,
    0x76, 0x71, 0x78, 0x7f, 0x6a, 0x6d, 0x64, 0x63,
    0x3e, 0x39, 0x30, 0x37, 0x22, 0x25, 0x2c, 0x2b,
    0x06, 0x01, 0x08, 0x0f, 0x1a, 0x1d, 0x14, 0x13,
    0xae, 0xa9, 0xa0, 0xa7, 0xb2, 0xb5, 0xbc, 0xbb,
    0x96, 0x91, 0x98, 0x9f, 0x8a, 0x8d, 0x84, 0x83,
    0xde, 0xd9, 0xd0, 0xd7, 0xc2, 0xc5, 0xcc, 0xcb,
    0xe6, 0xe1, 0xe8, 0xef, 0xfa, 0xfd, 0xf4, 0xf3
};

static crc crc8(const uint8_t *buf, int count)
{
    crc crc=0;
    int i;

    for(i=0; i<count; i++){
        crc = table_crc8[crc ^ buf[i]];
    }
    return crc;
}

BOOL mac_addr_equal( u8* macAddr1, u8* macAddr2 )
{
    s8 i;
    
    for(i=0; i<6;i++)
    {
        if( *(macAddr1+i) != *(macAddr2+i) )
            return 0;
    }
    return 1;
}


#define CARRIAGE_RETURN    TRUE
#define NO_CARRIAGE_RETURN FALSE
void print_mac_address( u8* mac_addr, BOOL carr_ret)
{
    s32 index;
    
    for(index=0;index<6;index++)
    {
        printk("%02X : ", *(mac_addr+index));
        if((index == 5) && carr_ret)
            printk("\n");
    }
}


/*
 * This function checks whether the entry located at the passed index 
 * is invalid (free) or not.
 * It returns 1 in case of an invalid entry, 0 in case of a valid entry 
 * and -1 in case of an invalid MAC atble access or an invalid parameter.  
 */
s32 isfreeTableIndex( u32 macTableIndex, u8* mac_addr_read )
{

    BOOL lan_port;
    BOOL pc_port;
    BOOL cpu_port;
    BOOL criticalFlag;
    u32 maState;    
    u8 macAddrRead[6]={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
    s32 retflag=-1;
    
    if( macTableIndex > MAX_MACTABLEINDEX)
    {
        printk("%s: macTableIndex out of range \n",__FUNCTION__);
        return retflag;
    }

    if ( (retflag = ifx_get_MAC_table_entry_idx( 0, macTableIndex, macAddrRead,
                                                 &lan_port, & pc_port, &cpu_port,
                                                 &criticalFlag, &maState )) == PR_ERR_NONE )
    {
/*        
        printk("%s: MAC entry found at pos. %d\n",__FUNCTION__, macTableIndex);
        print_mac_address(macAddrRead, NO_CARRIAGE_RETURN);
        printk("\n");
        printk("lan_port = %d\n", lan_port);
        printk("pc_port = %d\n", pc_port);
        printk("cpu_port = %d\n", cpu_port);
        printk("maState = %d\n", maState);
        printk("criticalFlag = %d\n", criticalFlag);        
*/ 

        
        if( maState == INVALID ) /*&& 
            macAddrRead[0]==0xFF && macAddrRead[1]==0xFF && macAddrRead[2]==0xFF &&
            macAddrRead[3]==0xFF && macAddrRead[4]==0xFF && macAddrRead[5]==0xFF )  */
        {
/*            printk("%s: found free index at pos. %d \n",__FUNCTION__, macTableIndex);  */
            retflag=1;
        }
        else
        {
/*            printk("%s: index at pos. %d is occupied \n",__FUNCTION__, macTableIndex);  */
            retflag=0;
        }
        memcpy(mac_addr_read, macAddrRead, 6*sizeof(u8));
    }
    else
    {
        printk("%s: ifx_get_MAC_table_entry_idx() failed!\n", __FUNCTION__);
    }
    return retflag;
}

/**
 * Get Mac table index from MAC table.
 * Get the MAC hash index according to the MAC address.Hash index is calculated 
 * by dividing the MAC address by the polynomial defined in pr_mac.h (for 
 * INCAIP2 x^8+x^2+x+1 is used). 
 *
 * \param   macAddrPtr       Pointer to MAC address
 *                             - macAddrPtr[0] -> MAC address byte 5
 *                             - macAddrPtr[1] -> MAC address byte 4
 *                             - macAddrPtr[2] -> MAC address byte 3
 *                             - macAddrPtr[3] -> MAC address byte 2
 *                             - macAddrPtr[4] -> MAC address byte 1
 *                             - macAddrPtr[5] -> MAC address byte 0 
 * \param   hashIndexPtr     Pointer to Table Index (range is 0-63)
 * \return  PR_ERR_NONE      - Success 
 * \return  PR_ERR_NULL_PTR  - macAddrPtr or hashIndexPtr is null pointer
 * \ingroup Internal
 */
s32 ifx_get_MAC_hash_idx( u8* macAddrPtr,  u32* hashIndexPtr )
{   
#if 0   
    u32 HashIndex =0,crc =0;
    u32 Temp[2]={0,0};
    s32 i=0;
    u32 temp=0;
    u32 fId = 0x00000000;
#endif    
    crc my_crc;
    u32 table_index=0xFFFFFFFF;
    s32 free;
    u8 tmp_mac_addr[6];
    u8 mac_addr_read[6]={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
    s32 step_count=1;
    u8 bitpos=1;
    BOOL free_index_found = FALSE;

     
    memcpy(&tmp_mac_addr, macAddrPtr, 6*sizeof(u8));
#ifdef PARAMETER_CHECK      
    if(macAddrPtr == NULL)
        return PR_ERR_NULL_PTR;

    if(hashIndexPtr == NULL)
        return PR_ERR_NULL_PTR;
#endif
    do
    {
        /* calculate hash index */
        my_crc = (crc)crc8( tmp_mac_addr, 6 ); 
        table_index = my_crc & 0x0000003F;
        /*
         * check for conflict and use manipulated MAC addresses for further hash calculations
         * In case of conflict MAC address bit 0 is inverted and the manipulated  of 
         */
        if( (free=isfreeTableIndex( table_index, mac_addr_read )) == 1)
        {
/*            printk("%s - found free table index at %d\n",__FUNCTION__,table_index);  */
            free_index_found = TRUE;
/*            break;  */
        }
        else 
            if( free==0 )
            {
                /*
                 * Requested address is already in table ->
                 * Return index
                 */
                if( mac_addr_equal( macAddrPtr, mac_addr_read ) )
                {
                    printk("%s - MAC address already in table at calculated position\n",__FUNCTION__);
                    free_index_found = TRUE;
/*                    break;  */
                }
                /*
                 * Table access conflict ->
                 * Manipulate address and calculate new hash index
                 */
/*                 printk("%s - Manipulate MAC address for re-calculation\n", __FUNCTION__);  */
                 if( *(macAddrPtr+5) & bitpos )
                     tmp_mac_addr[5] = (*(macAddrPtr+5) & ~bitpos);
                 else
                     tmp_mac_addr[5] = (*(macAddrPtr+5) | bitpos);
                 bitpos<<=1;
            }
            else
            {
                printk("%s isfreeTableIndex() returned failure \n",__FUNCTION__);
                return -1;
            }
    } while( !free_index_found && (step_count++ < HASH_CALCULATION_STEPS) );

    if(step_count > 3)
    {
	    /* if there is no free MAC-Index the first used Index is cleaned to be used */
	    u8 my_crc;
	    unsigned char enetaddr_local[6] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
	    u8 mac_addr[6];
	    u32 table_index = {0xFFFFFFFF};

	    memcpy(&mac_addr, enetaddr_local, 6*sizeof(u8));
	    my_crc = crc8(&mac_addr, 6);
	    table_index = my_crc & 0x0000003F;
	    ifx_add_MAC_table_entry_idx( 0, table_index, enetaddr_local, 0,  0, 1, 0, 0xFF);
    }
    
/* 
    if(step_count != 1)
    {
        printk("Hash calculation conflicts -> needed %d steps !\n", step_count);
    }
*/
/*    
    printk("%s - MAC address %02X:%02X:%02X:%02X:%02X:%02X ->\n",  
           __FUNCTION__, *macAddrPtr, *(macAddrPtr+1), *(macAddrPtr+2),
           *(macAddrPtr+3), *(macAddrPtr+4), *(macAddrPtr+5) );   
    printk("Calculated Hash Index: %d    MAC Table Index: %d\n", my_crc, table_index);
*/ 
    *hashIndexPtr = table_index;

    return PR_ERR_NONE ;
}

/**
 * Get Mac table index.
 * Get the MAC table index according to the MAC address.
 *
 * \param   macAddrPtr       Pointer to MAC address
 *                             - macAddrPtr[0] -> MAC address byte 5
 *                             - macAddrPtr[1] -> MAC address byte 4
 *                             - macAddrPtr[2] -> MAC address byte 3
 *                             - macAddrPtr[3] -> MAC address byte 2
 *                             - macAddrPtr[4] -> MAC address byte 1
 *                             - macAddrPtr[5] -> MAC address byte 0 
 * \param   mactableIndexPtr Pointer to Table Index (range is 0-63)
 *
 * \return  PR_ERR_NONE      - Success 
 * \return  PR_ERR_NULL_PTR  - macAddrPtr or mactableIndexPtr is null pointer
 * \ingroup Internal
 */
s32 ifx_get_MAC_table_idx( u8* macAddrPtr, u32* mactableIndexPtr )
{   
    u32 hashIndex=0;

/*    printk("%s\n", __FUNCTION__);  */
#ifdef PARAMETER_CHECK
    if(macAddrPtr == 0x00000000)
    {
        printk("%s failed - invalid macAddrPtr\n", __FUNCTION__);
        return PR_ERR_NULL_PTR;
    }            
    if(mactableIndexPtr == 0x00000000)
    {
        printk("%s failed - invalid mactableIndexPtr\n", __FUNCTION__);
        return PR_ERR_NULL_PTR;
    }                    
#endif
    if(ifx_get_MAC_hash_idx( macAddrPtr, &hashIndex ) != 0)
    {
        printk("%s -> ifx_get_MAC_hash_idx failed !!!\n", __FUNCTION__); 
        return PR_ERR_HASH_FAIL;
    }

    *mactableIndexPtr = hashIndex;
    
    return PR_ERR_NONE ;
}   



/**
 * Add MAC table entry.
 * Add MAC address table entry by MAC address table index.
 *
 * \param   chipId           ChipId
 * \param   macTableIndex    Table Index (range is 0-63)
 * \param   macAddrPtr       Pointer to MAC address
 *                             - macAddrPtr[0] -> MAC address byte 5
 *                             - macAddrPtr[1] -> MAC address byte 4
 *                             - macAddrPtr[2] -> MAC address byte 3
 *                             - macAddrPtr[3] -> MAC address byte 2
 *                             - macAddrPtr[4] -> MAC address byte 1
 *                             - macAddrPtr[5] -> MAC address byte 0 
 * \param   lan_port         TRUE for LAN port
 * \param   pc_port          TRUE for PC port
 * \param   cpu_port         TRUE for CPU port
 * \param   criticalFlag     Status of the packet
 * \param   maState          aging/priority data
 * \return  PR_ERR_NONE             - Success 
 * \return  PR_ERR_AGING_STATE      - Invalid aging state
 * \return  PR_ERR_FILTERID         - If the Filter Id is invalid 
 * \return  PR_ERR_MAC_TABLE_INDEX  - MAC Table index is invalid 
 * \return  PR_ERR_CRITICAL_FLAG    - Critical flag invalid   
 * \return  PR_ERR_NULL_PTR         - macAddrPtr or base address is null pointer
 * \return  PR_ERR_TIME_OUT         - Time out
 * \return  PR_ERR_CHIP_ID          - Invalid Chip Id
 * \ingroup Internal
 */
s32 ifx_add_MAC_table_entry_idx( u8 chipId, u32 macTableIndex, u8* macAddrPtr, 
                                 BOOL lan_port,  BOOL pc_port, BOOL cpu_port,
                                 BOOL criticalFlag, u32 maState )
{   
    u32 hashIndex =0;
    u32 Temp = 0;
    s32 i=0;
    s32 retflag = PR_ERR_NONE;
    volatile cpu_acs_ctrl_reg_t*  ptr_cpu_acs_ctrl;
    u32* ptr_cpu_acs_data;  /* pointer to CPU access data register */
    volatile u32 temp1 = 0;
    u32* ptr_reg1;

/*    printk("%s\n", __FUNCTION__);  */  
    
#ifdef PARAMETER_CHECK
    if(macTableIndex > MAX_MACTABLEINDEX)
    {
        printk("%s failed - invalid macTableIndex %d\n", __FUNCTION__, macTableIndex);
        return PR_ERR_MAC_TABLE_INDEX;
    }

    if(maState > MAX_AGING_STATE)
    {
        printk("%s failed - invalid aging state %d\n", __FUNCTION__, maState);
        return PR_ERR_AGING_STATE;
    }        

    if((criticalFlag != TRUE) && (criticalFlag != FALSE))
    {
        printk("%s failed - invalid criticalFlag %d\n", __FUNCTION__, criticalFlag);
        return PR_ERR_CRITICAL_FLAG;
    }        

    if(macAddrPtr == NULL)
    {
        printk("%s failed - invalid macAddrPtr\n", __FUNCTION__);
        return PR_ERR_NULL_PTR;
    }            
#if 0
    if(chipId >= Total_Chips)
    {
        printk("%s failed - invalid chipId %d\n", __FUNCTION__, chipId);
        return PR_ERR_CHIP_ID;
    }  

    if(Chip_Base_Address[chipId] == CHIP_ADDRESS_INVALID)
    {
        printk("%s failed - invalid Chip_Base_Address\n", __FUNCTION__);
        return PR_ERR_NULL_PTR;
    }
#endif    
#endif

/*    printk("%s - cpu access control\n", __FUNCTION__);  */
    ptr_cpu_acs_data = (u32*) CPU_ACS_DATA_REG;
    ptr_reg1 = (u32*) CPU_ACS_CTRL_REG;
    ptr_cpu_acs_ctrl = (volatile cpu_acs_ctrl_reg_t*)&temp1;

    /*
     * write lower 32 bits of MAC table entry to MAC table
     */
    Temp=0;
    for(i = 2; i <= 5; i++)
        Temp |= (*(macAddrPtr+i) << (8 * (5-i)));
    *ptr_cpu_acs_data = Temp;
    /* Extract hash index from Table Index */
    /* HASHIND_POS = 2 */
    hashIndex = macTableIndex;  /*  >> HASHIND_POS;  */    
    ptr_cpu_acs_ctrl->Index          = hashIndex;
    ptr_cpu_acs_ctrl->Table_specific = MAC_TABLE_31_0;    
    ptr_cpu_acs_ctrl->Table_sel      = MAC_TBL_VAL;
    ptr_cpu_acs_ctrl->Read_write     = WRITEPR;  /* write */    
    ptr_cpu_acs_ctrl->Req_ack        = REQ;    

/*    printk("%s -> ifx_sem_take\n", __FUNCTION__);  */
    
    if((retflag = ifx_sem_take(chipId,SEM_CPU)) != PR_ERR_NONE)
    {
        printk("%s: ifx_sem_take failed\n", __FUNCTION__);
        return -1;
    }

    PR_Indirect_Reg_Write_Sem( ptr_reg1,         /* CPU_ACS_CTRL_REG */
                               ptr_cpu_acs_data,
                               ptr_cpu_acs_ctrl, 
                               temp1,
                               Temp, 
                               SEM_CPU );

    /*
     * write upper 32 bits of MAC table entry to MAC table
     * These are: MAC address bits 32...55, critical bit, LAN, PC and 
     * CPU port destination bits, aging state 
     */
    Temp=0;
    for(i = 0; i <= 1; i++)  /* MAC address byte 5 & 4 */
        Temp |= (*(macAddrPtr+i) << (8 * (1-i)));
    
    /* set critical bit acc. to passed parameter */
    Temp |= criticalFlag ? (1<< CRITICAL_POS) : 0;        
    /* set port destination bits acc. to passed parameters */
    Temp |= lan_port ? (1<< LAN_PORT_POS) : 0;     
    Temp |= pc_port ? (1<< PC_PORT_POS) : 0;       
    Temp |= cpu_port ? (1<< CPU_PORT_POS) : 0;         
    /* set state value */
    Temp |= (maState << MA_STATE_POS);    
    *ptr_cpu_acs_data = Temp;  

    
    hashIndex = macTableIndex;  /*  >> HASHIND_POS;  */    
    ptr_cpu_acs_ctrl->Index          = hashIndex;
    ptr_cpu_acs_ctrl->Table_sel      = MAC_TBL_VAL;
    ptr_cpu_acs_ctrl->Table_specific = MAC_TABLE_55_32;  
    ptr_cpu_acs_ctrl->Read_write     = WRITEPR; 
    ptr_cpu_acs_ctrl->Req_ack        = REQ;  

    PR_Indirect_Reg_Write_Sem( ptr_reg1, ptr_cpu_acs_data,
                               ptr_cpu_acs_ctrl, temp1, 
                               Temp, SEM_CPU );
                        
    
    if((retflag = ifx_sem_give(chipId,SEM_CPU)) != PR_ERR_NONE)
    {
        printk("%s: ifx_sem_give failed\n", __FUNCTION__);
        return retflag;
    }

    /* print valid MAC address that was added to the MAC table */
    if( (*macAddrPtr != 0xFF) ||  (*(macAddrPtr+1) != 0xFF) ||
        (*(macAddrPtr+2) != 0xFF) || (*(macAddrPtr+3) != 0xFF) || 
        (*(macAddrPtr+4) != 0xFF) || (*(macAddrPtr+5) != 0xFF) )  
    {
        printk("Added MAC address %02X:%02X:%02X:%02X:%02X:%02X at index %d\n", 
                *macAddrPtr, *(macAddrPtr+1), *(macAddrPtr+2),*(macAddrPtr+3),
                *(macAddrPtr+4), *(macAddrPtr+5), macTableIndex);
    }
           
    return PR_ERR_NONE ;
}

/**
 * Get MAC table entry index.
 * Get MAC address table entry by MAC address table index.
 *
 * \param   chipId           ChipId
 * \param   macTableIndex    Table Index (range is 0-63)
 * \param   macAddrPtr       Pointer to MAC address
 *                             - macAddrPtr[0] -> MAC address byte 5
 *                             - macAddrPtr[1] -> MAC address byte 4
 *                             - macAddrPtr[2] -> MAC address byte 3
 *                             - macAddrPtr[3] -> MAC address byte 2
 *                             - macAddrPtr[4] -> MAC address byte 1
 *                             - macAddrPtr[5] -> MAC address byte 0 
 * \param   lan_portPtr      TRUE for LAN port
 * \param   pc_portPtr       TRUE for PC port
 * \param   cpu_portPtr      TRUE for CPU port
 * \param   criticalFlagPtr  Pointer to Status of the packet
 * \param   maStatePtr       Pointer to aging/priority data
 * \return  PR_ERR_NONE             - Success 
 * \return  PR_ERR_MAC_TABLE_INDEX  - MAC Table index is invalid 
 * \return  PR_ERR_NULL_PTR         - macAddrPtr, lan_portPtr, pc_portPtr, 
 *                                    cpu_portPtr, criticalFlagPtr, maStatePtr 
 *                                    or base address is null pointer
 * \return  PR_ERR_TIME_OUT         - Time out
 * \return  PR_ERR_CHIP_ID          - Invalid Chip Id
 * \ingroup Internal
 */
s32 ifx_get_MAC_table_entry_idx( u8 chipId, u32 macTableIndex, u8* macAddrPtr,
                                 BOOL* lan_portPtr,  BOOL* pc_portPtr, BOOL* cpu_portPtr,
                                 BOOL* criticalFlagPtr, u32* maStatePtr )
{
    u32 hashIndex =0;
    u32 Temp = 0;
    s32 i =0;
    volatile cpu_acs_ctrl_reg_t*  ptr_cpu_acs_ctrl;  /* pointer to CPU access control register */
    u32* ptr_cpu_acs_data;              /* pointer to CPU access data register */
    volatile u32 temp1 = 0;
    u32* ptr_reg1;
    s32 retflag = PR_ERR_NONE;

/*    printk("%s( macTableIndex=%d )\n", __FUNCTION__, macTableIndex);  */    

#ifdef PARAMETER_CHECK
    if(macTableIndex > MAX_MACTABLEINDEX)
        return PR_ERR_MAC_TABLE_INDEX;

    if((macAddrPtr == NULL) ||
       (lan_portPtr == NULL) ||
       (pc_portPtr == NULL) ||
       (cpu_portPtr == NULL) ||
       (criticalFlagPtr == NULL) ||
       (maStatePtr == NULL) )
        return PR_ERR_NULL_PTR;
#if 0
    if(chipId >= Total_Chips)
        return PR_ERR_CHIP_ID ;
 
    if( (Chip_Base_Address == NULL) /*
        || (Chip_Base_Address[chipId] == (void*)CHIP_ADDRESS_INVALID) */ )
        return PR_ERR_NULL_PTR;
#endif        

#endif
    ptr_cpu_acs_data = (u32*) CPU_ACS_DATA_REG;
    ptr_reg1 = (u32*) CPU_ACS_CTRL_REG;
    ptr_cpu_acs_ctrl = (volatile cpu_acs_ctrl_reg_t*)&temp1;

    /*
     * read lower 32 bits of MAC table entry from MAC table
     */
    hashIndex = macTableIndex; /*  >> HASHIND_POS;  */    
    ptr_cpu_acs_ctrl->Index          = hashIndex; 
    ptr_cpu_acs_ctrl->Table_specific = MAC_TABLE_31_0;    
    ptr_cpu_acs_ctrl->Table_sel      = MAC_TBL_VAL;
    ptr_cpu_acs_ctrl->Read_write     = READPR;  /* read */
    ptr_cpu_acs_ctrl->Req_ack        = REQ;    

    
    if((retflag = ifx_sem_take(chipId,SEM_CPU)) != PR_ERR_NONE)
            return retflag;
    
    /* First read operation, Data reg -> MAC3 MAC2 MAC1 MAC0 */ 
    PR_Indirect_Reg_Read_Sem( ptr_reg1, ptr_cpu_acs_data,
                                           ptr_cpu_acs_ctrl, temp1,
                                           Temp, SEM_CPU );    

    for(i = 5; i >= 2; i--)
        *(macAddrPtr+i) = (Temp >> (8 * (5-i))) & MAC_MASK;
        
    /*
     * read upper 32 bits of MAC table entry from MAC table
     * These are: MAC address bits 32...55, critical bit, LAN, PC and 
     * CPU port destination bits, aging state 
     */
    Temp=0;
    ptr_cpu_acs_ctrl->Index          = hashIndex; 
    ptr_cpu_acs_ctrl->Table_sel      = MAC_TBL_VAL;
    ptr_cpu_acs_ctrl->Read_write     = READPR;  /* read */    
    ptr_cpu_acs_ctrl->Table_specific = MAC_TABLE_55_32;    
    ptr_cpu_acs_ctrl->Req_ack        = REQ;    

    PR_Indirect_Reg_Read_Sem( ptr_reg1, ptr_cpu_acs_data,
                              ptr_cpu_acs_ctrl, temp1,
                              Temp, SEM_CPU );

    /* 
     * get destination port, critical bit and aging state information
     * from data word read from ACS_DATA_REG
     */                         
    *lan_portPtr = (Temp & LAN_PORT_MASK) !=0 ? TRUE : FALSE;       
    *pc_portPtr = (Temp & PC_PORT_MASK) !=0 ? TRUE : FALSE;     
    *cpu_portPtr = (Temp & CPU_PORT_MASK) !=0 ? TRUE : FALSE;     
    *criticalFlagPtr = (Temp & CRITICAL_MASK) !=0 ? TRUE : FALSE;           
    *maStatePtr = (Temp >> MA_STATE_POS) &  MA_STATE_MASK;   
    
    /* MAC address byte 4 & 5 */
    *(macAddrPtr+1) = Temp & MAC_MASK;  
    *macAddrPtr = (Temp >> 8) & MAC_MASK;

    
    if((retflag = ifx_sem_give(chipId,SEM_CPU)) != PR_ERR_NONE)
            return retflag;
/*
    printk("Read MAC address %02X:%02X:%02X:%02X:%02X:%02X at index %d\n",
                *macAddrPtr, *(macAddrPtr+1), *(macAddrPtr+2),*(macAddrPtr+3),
                *(macAddrPtr+4), *(macAddrPtr+5), macTableIndex);
    printk("lan_port = %d\n", *lan_portPtr);
    printk("pc_port = %d\n", *pc_portPtr);
    printk("cpu_port = %d\n", *cpu_portPtr);
    printk("maState = %d\n", *maStatePtr);
    printk("criticalFlag = %d\n", *criticalFlagPtr);
*/
    return PR_ERR_NONE ;
}



/**
 * Get MAC table entry hash.
 * Add MAC address table entry by MAC address hash value. It adds an entry by
 * sending dummy packet to CPU port with MA learn enabled.
 *
 * \param   chipId           ChipId
 * \param   macAddrPtr       Pointer to MAC address
 *                             - macAddrPtr[0] -> MAC address byte 5
 *                             - macAddrPtr[1] -> MAC address byte 4
 *                             - macAddrPtr[2] -> MAC address byte 3
 *                             - macAddrPtr[3] -> MAC address byte 2
 *                             - macAddrPtr[4] -> MAC address byte 1
 *                             - macAddrPtr[5] -> MAC address byte 0
 * \param   mpid             floodId/portID(Bit31 = TRUE for mcast ID)
 * \param   criticalFlag     Pointer to Status of the packet
 * \param   maState          Pointer to aging/priority data
 * \param   fId              Filter ID
 * \return  PR_ERR_NONE          - Success
 * \return  PR_ERR_FILTERID      - FilterId is invalid
 * \return  PR_ERR_CRITICAL_FLAG - Critical flag invalid
 * \return  PR_ERR_NULL_PTR      - macAddrPtr or base address is null pointer
 * \return  PR_ERR_TIME_OUT      - Time out
 * \return  PR_ERR_CHIP_ID       - Invalid Chip Id
 * \ingroup Internal
 */
s32 ifx_add_MAC_table_entry_hash(u8 chipId,u8* macAddrPtr,u32 mpid,BOOL criticalFlag,
                             u32 maState, u32 fId)
{
#if 0
/* Pointer to Destination lookup structure */
    dst_lookup_reg_t* ptr_dst_lookup_reg;

/* Pointer to MA learn register */
    ma_learn_reg_t* ptr_ma_learn_reg;

/* Pointer to CMAC CRX control register  */
    cmac_crx_ctrl_reg_t* ptr_cmac_crx_ctrl;
    
    u8 TxPktData[14];
    u8* txPktPtr = TxPktData;
    u32* ptr_mailbox;
    u32 txSize=14;
    u32 mboxState=0;
    u32 mboxId=0;
    u32 i=0;
    u32 j=0;
    u32 Temp=0;
    s32 timeout = PR_TIME_OUT;

    u32 temp1=0;
    u32 temp2=0;
    u32 temp3=0;
    u32* ptr_reg1;
    u32* ptr_reg2;
    u32* ptr_reg3;
    s32 retflag = PR_ERR_NONE;

#ifdef PARAMETER_CHECK  

    if((criticalFlag != TRUE) && (criticalFlag != FALSE))
        return PR_ERR_CRITICAL_FLAG;

    if(macAddrPtr == NULL)
        return PR_ERR_NULL_PTR;

    if(chipId >= Total_Chips)
        return PR_ERR_CHIP_ID ;

    if(Chip_Base_Address[chipId] == CHIP_ADDRESS_INVALID)
        return PR_ERR_NULL_PTR;
#endif


    ptr_reg1 = (u32*)(Chip_Base_Address[chipId] + MA_LEARN_REG);
    ptr_reg2 = (u32*)(Chip_Base_Address[chipId] + DST_LOOKUP_REG);
#if 0
    ptr_reg3 = (u32*)(Chip_Base_Address[chipId] + CMAC_CRX_CTRL_REG);
#endif  

    if((retflag = ifx_sem_take(chipId,SEM_CPU_TX)) != PR_ERR_NONE)
            return retflag;

    PR_Reg_Read(ptr_reg1,temp1);
    ptr_ma_learn_reg = (ma_learn_reg_t*)&temp1;

    PR_Reg_Read(ptr_reg2,temp2);
    ptr_dst_lookup_reg = (dst_lookup_reg_t*)&temp2;
#if 0
    PR_Reg_Read(ptr_reg3,temp3);
    ptr_cmac_crx_ctrl = (cmac_crx_ctrl_reg_t*)&temp3;
#endif
#if 0
/* Intialization of Mailbox owner ID */ 
    ifx_set_Mbox_owner(chipId,MAILBOX_1,CMAC_CRITL);
    ifx_set_Mbox_owner(chipId,MAILBOX_3,CMAC_NON_CRITL);
#endif

#if 0
    ptr_cmac_crx_ctrl -> Crc_gen = 1;
    ptr_cmac_crx_ctrl -> Pkt_padding = 1;
    ptr_cmac_crx_ctrl -> Pkt_len = PACKET_LEN_64;

    PR_Reg_Write(ptr_reg3,temp3);
#endif  
/* Configuration of MA Learn Register */        
/*  ptr_ma_learn_reg -> FID = fId;  */
    ptr_ma_learn_reg -> MA_crit = (criticalFlag == TRUE) ? 1 :0;
    ptr_ma_learn_reg -> Ma_dest = mpid & 0xFF;      
    ptr_ma_learn_reg -> Ma_is_mcast = (mpid >> MCAST_POS) & 0x1; 
    ptr_ma_learn_reg -> Ma_state = maState;

    PR_Reg_Write(ptr_reg1,temp1);

/* Configuration of Destination lookup and CPU control register */  
    ptr_dst_lookup_reg -> En_ma_learn = 1;
    ptr_dst_lookup_reg -> En_da_lookup = 0;
/*  ptr_dst_lookup_reg -> Da_is_mcast = 0;  */
    ptr_dst_lookup_reg -> Da_state = 1; 
/*  ptr_dst_lookup_reg -> Da_dest = 63; */
    ptr_dst_lookup_reg -> Da_crit = 0;


    PR_Reg_Write(ptr_reg2,temp2);
/* init DA */
    for(i=0;i<6;i++)
        TxPktData[i] = 0x00;


/* Copy the SA(Source Address) to transmission buffer */
    for(i=0;i<6;i++)
        TxPktData[i+6] = *(macAddrPtr+i);

/* init Type field */

    TxPktData[12] = 0x08;
    TxPktData[13] = 0x00;
#if 0
/* Select the mailbox depending upon the critical flag */
    if(criticalFlag == TRUE)
    {   
        mboxId = 0;
        ptr_mailbox = (u32*)(Chip_Base_Address[chipId] + MBOX1_MEM);  /* Mailbox 1 */
        
    }
    else
    {
        mboxId = 2;
        ptr_mailbox = (u32*) (Chip_Base_Address[chipId] + MBOX3_MEM);  /* Mailbox 3 */
        
    }

/* Wait till the MB_busy bit is reset to access the mail box */
    do
    {
        if(ifx_get_Mbox_state(chipId,mboxId,&mboxState) != PR_ERR_NONE)
        {
            ifx_sem_give(chipId,SEM_CPU_TX);
            return PR_ERR_CPU_PORT;
        }
        timeout--;
                    
    }while(((mboxState & 0x1) == 1) && (timeout > 0));

    if(timeout == 0)
    {
        ifx_sem_give(chipId,SEM_CPU_TX);
        return PR_ERR_TIME_OUT;
    }
    
        
/* Write the data to Mailbox  */    
    for(i = 0; i < txSize/4; i++,txPktPtr += 4)
    {
        Temp = *((u32*)txPktPtr);
        PR_Reg_Write((ptr_mailbox+i),Temp);
    }
    
    
    Temp=0;
    if(txSize % 4 != 0)
    {
        for(j=0;j<(txSize%4);j++)
            Temp |= (*(txPktPtr+j)<< 8*j);
        
        PR_Reg_Write((ptr_mailbox+i),Temp);
    }
                
/* Set the command pending bit in the MBOX Status Register */
    if(ifx_set_Mbox_command(chipId,mboxId,i) != PR_ERR_NONE)
    {
        ifx_sem_give(chipId,SEM_CPU_TX);
        return PR_ERR_CPU_PORT;
    }


    if((retflag = ifx_sem_give(chipId,SEM_CPU_TX)) != PR_ERR_NONE)
            return retflag;


    return PR_ERR_NONE;

#endif    
#endif
/* Configuration of CMAC_CRX_CONTROL register  */
    printk("Function %s disabled for the following porting problems\n", __FUNCTION__);
    printk("%s: cmac_crx_ctrl does not exist, can't configure CRC Generation,", __FUNCTION__);
    printk("Pkt_padding and packet length that way.\n");    
    printk("%s: mailboxes do not exist, can't write commands\n", __FUNCTION__);
    
    return -1;

}





/******************************************************************************
  *
  * FUNCTION:    ifx_delete_MAC_table_entry_hash
  *
  * DESCRIPTION: Delete a MAC address table entry by MAC address hash value.
  *              It deletes an entry by sending dummy packet to CPU port with 
  *              MAC state value 0xF(i.e Invalid, Entry has been aged out or deleted).
  *
  * PARAMETERS:
  *     IN:
  *         ChipId      ChipId.
  *         macAddrPtr      Pointer to MAC address
  *                         macAddrPtr[0] -> MAC address byte 5
  *                         macAddrPtr[1] -> MAC address byte 4
  *                         macAddrPtr[2] -> MAC address byte 3
  *                         macAddrPtr[3] -> MAC address byte 2
  *                         macAddrPtr[4] -> MAC address byte 1
  *                         macAddrPtr[5] -> MAC address byte 0 
  *
  *         fId             Filter ID
  *     OUT:
  *         None
  *
  * RETURNS:
  *     PR_ERR_NONE                 Success 
  *     PR_ERR_FILTERID             FilterId is invalid
  *     PR_ERR_NULL_PTR             Null pointer
  *     PR_ERR_TIME_OUT             Time out
  *     PR_ERR_CHIP_ID              Invaild Chip Id
  *
  ******************************************************************************/

s32 ifx_delete_MAC_table_entry_hash(u8 chipId,u8* macAddrPtr, u32 fId)
{


    return(ifx_add_MAC_table_entry_hash(chipId,macAddrPtr,0,FALSE,0xf,fId));    
}

/**
 * Get MAC table statistics.
 * Get the MAC table statistics like number of static and valid 
 * entries.
 *
 * \param   chipId           ChipId
 * \param   staticPtr        Pointer to number of Static entries
 * \param   validPtr         Pointer to number of Vaild entries
 * \return  PR_ERR_NONE            - Success 
 * \return  PR_ERR_MAC_TABLE_INDEX - MAC Table index is invalid
 * \return  PR_ERR_NULL_PTR        - staticPtr, validPtr or base address is null pointer
 * \return  PR_ERR_TIME_OUT        - Time out
 * \return  PR_ERR_CHIP_ID         - Invalid Chip Id
 * \ingroup Internal
 */
s32 ifx_get_MAC_table_stat(u8 chipId, /* u32* multiCastPtr, */u32* staticPtr,u32* validPtr)
{

    u32 stat_cnt = 0,valid_cnt = 0;
    u8  macAddr[6];
    u32 maState=0;
    u32 macTableIndex=0;
    BOOL criticalFlag;
    BOOL lan_port=0;
    BOOL pc_port=0;
    BOOL cpu_port=0;    
    s32 retflag;
    
#ifdef PARAMETER_CHECK  
/*  
    if(multiCastPtr == NULL)
        return PR_ERR_NULL_PTR;
*/
    if(staticPtr == NULL)
        return PR_ERR_NULL_PTR;

    if(validPtr == NULL)
        return PR_ERR_NULL_PTR;

    if(chipId >= Total_Chips)
        return PR_ERR_CHIP_ID ;

#endif

    for ( macTableIndex = 0; macTableIndex <= MAX_MACTABLEINDEX  ;  macTableIndex++ )
    {
        if ( (retflag = ifx_get_MAC_table_entry_idx( chipId, macTableIndex, macAddr,     
                                                     &lan_port, & pc_port, &cpu_port,
                                                     &criticalFlag, &maState )) == PR_ERR_NONE )
        {
                if(maState != INVALID)
                {
                    valid_cnt += 1;

                    if(maState == STATIC)
                        stat_cnt += 1;
                }
        }
        else
            return retflag;
        
    }
    
/*  *multiCastPtr = multi_cnt;  */
    *staticPtr = stat_cnt;
    *validPtr  = valid_cnt;
    
    return PR_ERR_NONE; 
}


/**
 * Resets the MAC table.
 * This function clears the MAC address table by overwriting all entries 
 * with invalid identifiers. 
 *
 * \return PR_ERR_NONE - in case of successful table clean
 *         PR_ERR_XXX  - in case of failed table access
 */
s32 ifx_mac_table_reset( void )
{
    s32 retflag = -1;
    u32 macTableIndex=0;
    u8  macAddr_inv_tmp[6]={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
/*  u32 mpid=0;  */
    u32 maState=INVALID;
/*  u32 fId=0;  */
    BOOL lan_port=0; 
    BOOL pc_port=0;
    BOOL cpu_port=0;
    BOOL criticalFlag=0;
    
    
    BOOL lan_port_read;  
    BOOL pc_port_read; 
    BOOL cpu_port_read;
    BOOL criticalFlag_read; 
    u32  maState_read;
    u8 macAddr_read[6]={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
    
/*    memset(macAddr_inv, 0xFF, sizeof(macAddr_inv));  */
    
/*    printk("%s\n", __FUNCTION__);  */
    for ( macTableIndex = 0; macTableIndex <= MAX_MACTABLEINDEX; macTableIndex++ )
    {
        memcpy(macAddr_inv_tmp, macAddr_inv, sizeof(macAddr_inv));
        maState=INVALID;
        lan_port=0; 
        pc_port=0;
        cpu_port=0;
        criticalFlag=0;
                
        /* what has to be written here to set invalid MAC entries ??? */
        if((retflag = ifx_add_MAC_table_entry_idx( 0, /* chipid = 0 */
                                                   macTableIndex, 
                                                   macAddr_inv_tmp, 
                                                   lan_port, 
                                                   pc_port, 
                                                   cpu_port, 
                                                   criticalFlag, 
                                                   maState ) ) != PR_ERR_NONE)
        {
            printk("%s resetting mac table index %d failed\n", __FUNCTION__, macTableIndex);
            return retflag;
        }
        else
        {
            printk("Check written reset entry\n");
            if( ifx_get_MAC_table_entry_idx( 0, 
                                             macTableIndex, 
                                             macAddr_read,
                                             &lan_port_read,  
                                             &pc_port_read, 
                                             &cpu_port_read,
                                             &criticalFlag_read, 
                                             &maState_read ) == PR_ERR_NONE)
            {
                if( !mac_addr_equal( macAddr_inv_tmp, macAddr_read ) )
                {
                    printk("%s - read address different from written\n", __FUNCTION__);
                    printk("written %02X:%02X:%02X:%02X:%02X:%02X at index %d\n", 
                           *macAddr_inv_tmp, *(macAddr_inv_tmp+1), *(macAddr_inv_tmp+2),*(macAddr_inv_tmp+3),
                           *(macAddr_inv_tmp+4), *(macAddr_inv_tmp+5), macTableIndex);
                    printk("read %02X:%02X:%02X:%02X:%02X:%02X at index %d\n", 
                           *macAddr_read, *(macAddr_read+1), *(macAddr_read+2),*(macAddr_read+3),
                           *(macAddr_read+4), *(macAddr_read+5), macTableIndex);                           
                           
                    retflag = -1;
                }   
                if(lan_port != lan_port_read) 
                {
                    printk("%s - read lan_port (%d) different from written (%d)\n",
                           __FUNCTION__, lan_port_read, lan_port);  
                    retflag = -1;
                }   
                if(pc_port != pc_port_read) 
                {
                    printk("%s - read pc_port (%d) different from written (%d)\n",
                           __FUNCTION__, pc_port_read, pc_port);
                    retflag = -1;
                }                  
                if(cpu_port != cpu_port_read) 
                {
                    printk("%s - read cpu_port (%d) different from written (%d)\n", 
                           __FUNCTION__, cpu_port_read, cpu_port);
                    retflag = -1;
                }                   
                if(criticalFlag != criticalFlag_read) 
                {
                    printk("%s - read criticalFlag (%d) different from written (%d)\n", 
                           __FUNCTION__, criticalFlag_read, criticalFlag);
                    retflag = -1;
                }                    
                if(maState != maState_read) 
                {
                    printk("%s - read maState (%d) different from written (%d)\n", 
                           __FUNCTION__, maState_read, maState);
                    retflag = -1;
                }                   
                if(retflag == -1)
                {
                    printk("%s read back entry read at pos. %d differs from written\n", __FUNCTION__, macTableIndex);
                    return retflag;
                }
                else
                    printk("%s - MAC table index %d reseted\n", __FUNCTION__, macTableIndex);
            }
            else
            {
                printk("%s read back mac table entry at index %d failed\n", __FUNCTION__, macTableIndex);
/*                retflag = -1;  */
            }
        }

    }
    printk("%s successful\n", __FUNCTION__);    
    return retflag;
}

/**
 * Add MAC address to MAC address table.
 * This function adds the passed MAC address and attributes to the MAC table.
 * It first calculates the table index by applying a CRC calculation before 
 * inserting the address. Afterwards the previously written entry is read back 
 * and compared.
 *
 * \param   macAddrPtr       Pointer to MAC address
 *                             - macAddrPtr[0] -> MAC address byte 5
 *                             - macAddrPtr[1] -> MAC address byte 4
 *                             - macAddrPtr[2] -> MAC address byte 3
 *                             - macAddrPtr[3] -> MAC address byte 2
 *                             - macAddrPtr[4] -> MAC address byte 1
 *                             - macAddrPtr[5] -> MAC address byte 0  
 * \param lan_port     - MAC address assignment to LAN port 
 * \param pc_port      - MAC address assignment to PC port 
 * \param cpu_port     - MAC address assignment to CPU port 
 * \param criticalFlag - new entry to be handled as 'normal' or critical entry 
 * \param maState      - initial aging state the entry is inserted with (0...15)
 *
 * \return PR_ERR_NONE - in case of successful table clean
 *         PR_ERR_XXX  - in case of failed table access
 */
s32 ifx_add_MAC_table_entry( u8* macAddrPtr, 
                             BOOL lan_port, BOOL pc_port, BOOL cpu_port,
                             BOOL criticalFlag, u32 maState )
{
    u32 macTableIndex;

    
    BOOL lan_portRead;  
    BOOL pc_portRead; 
    BOOL cpu_portRead;
    BOOL criticalFlagRead; 
    u32  maStateRead;
    u8 macAddr_read[6]={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};    
    s32 retflag = -1;
    
/*    printk("%s\n", __FUNCTION__);  */
#ifdef CONFIG_INCAIP2_SWITCH_RESERVED_MC
    /* is this a reserved multicast address? */
    if ( macAddrPtr[0] == 0x01
      && macAddrPtr[1] == 0x80
      && macAddrPtr[2] == 0xC2
      && macAddrPtr[3] == 0x00
      && macAddrPtr[4] == 0x00
      && (macAddrPtr[5] <= 0x2F && ((macAddrPtr[5] <= 0x10) || (macAddrPtr[5] >= 0x20))) )
    {
        int rsvd_idx = macAddrPtr[5];
        ifx_switch_reserved_mc_dst_ports[rsvd_idx] = 
                              (lan_port ? (1 << INCAIP2_SWITCH_PORT_SELECT_LAN) : 0)
                            | (pc_port  ? (1 << INCAIP2_SWITCH_PORT_SELECT_PC ) : 0)
                            | (cpu_port ? (1 << INCAIP2_SWITCH_PORT_SELECT_CPU) : 0);
        return PR_ERR_NONE;
    }
#endif /* CONFIG_INCAIP2_SWITCH_RESERVED_MC */
    /* 
     * get table index and insert new entry at calculated position 
     */
    if( (retflag = ifx_get_MAC_table_idx( macAddrPtr, &macTableIndex ))
        == PR_ERR_NONE )
    {
        retflag = ifx_add_MAC_table_entry_idx( 0, /* chipid = 0 */
                                               macTableIndex,
                                               macAddrPtr,
                                               lan_port,
                                               pc_port, 
                                               cpu_port, 
                                               criticalFlag,
                                               maState );   
                                       
        if(retflag== PR_ERR_NONE)  
        {     
            if( (retflag = ifx_get_MAC_table_entry_idx( 0, 
                                                       macTableIndex, 
                                                       macAddr_read,
                                                       &lan_portRead,  
                                                       &pc_portRead, 
                                                       &cpu_portRead,
                                                       &criticalFlagRead, 
                                                       &maStateRead )) == PR_ERR_NONE)
            {
                if( !mac_addr_equal( macAddrPtr, macAddr_read ) )
                {
                    printk("%s - read address different from written\n", __FUNCTION__);
                    printk("written %02X:%02X:%02X:%02X:%02X:%02X at index %d\n", 
                           *macAddrPtr, *(macAddrPtr+1), *(macAddrPtr+2),*(macAddrPtr+3),
                           *(macAddrPtr+4), *(macAddrPtr+5), macTableIndex);
                    printk("read %02X:%02X:%02X:%02X:%02X:%02X at index %d\n", 
                           *macAddr_read, *(macAddr_read+1), *(macAddr_read+2),*(macAddr_read+3),
                           *(macAddr_read+4), *(macAddr_read+5), macTableIndex);                           
                           
                    retflag = -1;
                }   
                if(lan_port != lan_portRead) 
                {
                    printk("%s - read lan_port (%d) different from written (%d)\n",
                           __FUNCTION__, lan_portRead, lan_port);  
                    retflag = -1;
                }   
                if(pc_port != pc_portRead) 
                {
                    printk("%s - read pc_port (%d) different from written (%d)\n", 
                           __FUNCTION__,pc_portRead, pc_port);
                    retflag = -1;
                }                  
                if(cpu_port != cpu_portRead) 
                {
                    printk("%s - read cpu_port (%d) different from written  (%d)\n", 
                           __FUNCTION__, cpu_portRead, cpu_port);
                    retflag = -1;
                }                   
                if(criticalFlag != criticalFlagRead) 
                {
                    printk("%s - read criticalFlag (%d) different from written (%d)\n", 
                           __FUNCTION__,criticalFlagRead,criticalFlag);
                    retflag = -1;
                }                    
                if(maState != maStateRead) 
                {
                    printk("%s - read maState (0x%X) different from written (0x%X)\n",
                           __FUNCTION__, maStateRead, maState);
                    retflag = -1;
                } 
                
                if(retflag == -1)
                {
                    printk("%s read back entry read at pos. %d differs from written\n", __FUNCTION__, macTableIndex);
                    return retflag;
                }
                else
                {
                    printk("%s - read MAC table entry from pos. %d equals written\n", __FUNCTION__, macTableIndex);
                    retflag = PR_ERR_NONE;
                }
            }
            else
            {
                printk("%s read back mac table entry at index %d failed\n", __FUNCTION__, macTableIndex);
            }
        }
                                              
    }
    else
        printk("%s -> ifx_get_MAC_table_idx failed\n", __FUNCTION__);

    return retflag;
}






/**
 * Create new timer for SW based MAC table aging
 * This function allocates memory for a new timer structure and initializes the structure
 *
 * \return NULL   - in case of failed memory allocation
 *         !=NULL - pointer to created timer list element structure
 *
 * \ingroup Internal
 * \internal 
 */ 
struct timer_list*  create_aging_update_timer( void )
{
   struct timer_list* timer = NULL; 

   timer = (struct timer_list*) KSEG1ADDR( kmalloc(sizeof(struct timer_list), GFP_KERNEL));
   if(timer)
       init_timer( timer );
   return timer;
}


/**
 * Cancel SW based MAC table aging timer.
 * This function removes the passed timer from the list
 *
 * \param timer   - pointer to timer control structure
 *
 * \ingroup Internal
 * \internal 
 */ 
void cancel_aging_update_timer( struct timer_list*  timer )
{
   del_timer( timer );
}

 
/**
 * Start MAC table aging timer.
 * This function starts a new timer acc. to the passed parameters by 
 * adding the parameters to the timer list.
 *
 * \param timer   - pointer to timer control structure
 * \param ticks   - timer ticks until expiration
 * \param callback_function - pointer to function to be called on timer expiration
 *
 * \ingroup Internal
 * \internal 
 */
void start_aging_update_timer( struct timer_list*  timer,   
                               int                 ticks,  
                               void*               callback_function ) 
{
    timer->expires  = jiffies + ticks;
    timer->function = callback_function;
    timer->data     = (unsigned long) NULL; 

    add_timer( timer );
}


/**
 * Update table aging status.
 * This functions updates the aging status of the MAC table entries 
 * when using the SW based aging mechanism.
 * The function is called as callback function on expiration of the 
 * SW aging timer. It stops the current timer, updates the MAC table 
 * and restarts a new aging timer with the calculated aging period.
 *
 * \ingroup Internal
 * \internal 
 */
void ifx_update_table_aging_states( void )
{
    s32 i;
    
/*    printk("%s - update MAC table status !!!\n", __FUNCTION__);  */  
    cancel_aging_update_timer(  (struct timer_list*) aging_timer );    
    set_aging_timer_inactive();
    
    for(i=0; i<MAC_TABLE_ENTRIES; i++)
        INCAIP2_SW_REG32( GEN_SFT_AGE_STB ) = 0x12345678;

    aging_timer = (u32) create_aging_update_timer();
    start_aging_update_timer( (struct timer_list*) aging_timer,
                              aging_ticks,         
                              (void*) ifx_update_table_aging_states );  
                              
    set_aging_timer_active();
/*    printk("%s - SW aging Timer restarted !!!\n", __FUNCTION__);  */    
}


/* returns the number of ticks per second */
s32 sysClkRateGet( void )
{
   return 100;
}


/**
 * Set global aging variable. 
 * This functions sets the value of the global variable aging_timer_running to 1,
 * which indicates that the SW based aging is currently active.
 *
 * \ingroup Internal
 * \internal 
 */
void set_aging_timer_active( void )
{
    aging_timer_running = TRUE;
}


/**
 * Clear global aging variable. 
 * This functions sets the value of the global variable aging_timer_running to 0,
 * which indicates that the SW based aging is currently inactive.
 *
 * \ingroup Internal
 * \internal 
 */
void set_aging_timer_inactive( void )
{
    aging_timer_running = FALSE;
}



/**
 * Returns global aging variable.
 * This functions returns the value of the global variable aging_timer_running,
 * which indicates if the SW based aging is currently active or not.
 *
 * \return 0 - in case of inactive SW aging, no timer running
 *         1 - in case of active software timer
 * \ingroup Internal
 * \internal 
 */
s32 aging_timer_active( void )
{
    return aging_timer_running;
}

/**
 * Control MAC table aging mechanism.
 * This functions controls the MAC table aging mechanism depending on the 
 * passed aging period. A bug in the hardware aging functionality causes that 
 * the aging is ~10 times faster that configured when using HW controlled aging.
 * To workaround this an alternative SW based mechanism is acivated for periods 
 * that are not covered by the hardware functionality. 
 *
 * \param aging_period
 *
 * \return PR_ERR_NONE - in case of successful table clean
 *         PR_ERR_AGING_TIMER  - 
 *         PR_ERR_AGING_STATE  - 
 */
s32 ifx_control_MAC_table_aging( aging_period_e aging_period )
{


/*
    printk("%s( aging_period=0x%08X )\n", __FUNCTION__, aging_period);
*/    
    /*
     * if an SW MAC aging timer is active stop this timer before setting up a new one 
     */
    if(aging_timer_active())
    {
        cancel_aging_update_timer( (struct timer_list*)  aging_timer );
        set_aging_timer_inactive();
    }
    
    switch( aging_period )
    {
        /* 
         * The following aging periods are controlled by HW MAC table aging
         */
        case MAC_AGING_IMMEDIATE:
        case MAC_AGING_2_SEC: 
        case MAC_AGING_35_SEC:
        case MAC_AGING_95_SEC:
        case MAC_AGING_388_SEC:
        case MAC_AGING_24_MIN: 
        case MAC_AGING_150_MIN:
        case MAC_AGING_NO_AGING:
            /*
             * enable HW controlled aging and set passed aging period.
             * The aging bug that ages ~10times faster leads to the 
             * aging periods reflected by aging_period_e.
             */
            INCAIP2_SW_REG32(PR_CTRL_REG) = 
                (INCAIP2_SW_REG32(PR_CTRL_REG) & 0xFFFFC3FF) | (aging_period << 11) ;
            printk("HW MAC table aging activated ...\n");
            break;

        case MAC_AGING_1_HRS:                
        case MAC_AGING_6_HRS:             
        case MAC_AGING_10_HRS: 
        case MAC_AGING_12_HRS: 
        case MAC_AGING_1_DAY:            
        case MAC_AGING_3_DAYS:
            /* create an SW aging timer if not yet done */
            if( !aging_timer )
            {
                aging_timer = (u32) create_aging_update_timer();    
            }
            
            if( !aging_timer )
            {
                return PR_ERR_AGING_TIMER;    
            }    
    
            INCAIP2_SW_REG32(PR_CTRL_REG) |= (1<< 10);  /* disable HW aging */
            /* 
             * start SW timer according to passed aging period. 
             * Since we handle 14 aging states the period needs to be divided 
             * before timer setup.
             */
            aging_ticks = (aging_period /*ms*/ * sysClkRateGet()/(14*1000));  
/*            printk("%s - aging_ticks=%d\n", __FUNCTION__, aging_ticks);  */
            start_aging_update_timer( (struct timer_list*) aging_timer,
                                      aging_ticks,         
                                      (void*) ifx_update_table_aging_states /* call back function pointer */
                                       /* unsigned long int   cb_fnct_par */ ); 
            set_aging_timer_active();
            printk("SW MAC table aging activated with %d hour(s) aging period\n", 
                   aging_period/3600000);
/*             printk("%s - PR_CTRL_REG=0x%08X\n",  __FUNCTION__, INCAIP2_SW_REG32(PR_CTRL_REG));  */
            break;
            
            default:
                return PR_ERR_AGING_STATE;
    }

    return PR_ERR_NONE;
}

EXPORT_SYMBOL(ifx_get_MAC_table_idx);
EXPORT_SYMBOL(ifx_add_MAC_table_entry_idx);
