/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

#ifndef __PR_MACC_H
#define __PR_MACC_H



/* Forward declaration 		*/
/*
s32 ifx_get_MAC_table_idx( u8* macAddrPtr, u32 fId, u32* tableIndexPtr);
*/
s32 ifx_get_MAC_hash_idx( u8* macAddrPtr,  u32* hashIndexPtr );
s32 ifx_get_MAC_table_idx( u8* macAddrPtr, u32* mactableIndexPtr );

s32 ifx_add_MAC_table_entry( u8* macAddrPtr, 
                             BOOL lan_port, BOOL pc_port, BOOL cpu_port,
                             BOOL criticalFlag, u32 maState );

s32 ifx_add_MAC_table_entry_idx( u8 chipId, u32 macTableIndex, u8* macAddrPtr, 
                                 BOOL lan_port,  BOOL pc_port, BOOL cpu_port,
                                 BOOL criticalFlag, u32 maState );

s32 ifx_get_MAC_table_entry_idx( u8 chipId, u32 macTableIndex, u8* macAddrPtr,
                                 BOOL* lan_portPtr,  BOOL* pc_portPtr, BOOL* cpu_portPtr,
                                 BOOL* criticalFlagPtr, u32* maStatePtr );

s32 ifx_add_MAC_table_entry_hash(u8 chipId,u8* macAddrPtr,u32 mpid,BOOL criticalFlag,
							       u32 maState, u32 fId);

s32 ifx_delete_MAC_table_entry_hash(u8 chipId,u8* macAddrPtr, u32 fId);


s32 ifx_get_MAC_table_stat(u8 chipId, /* u32* multiCastPtr, */ u32* staticPtr,u32* validPtr);

s32 ifx_control_MAC_table_aging( aging_period_e aging_period );


#endif    /* __PR_MEMACC_H */
