/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/


#ifndef _PR_PHY_H
#define _PR_PHY_H

#include "global.h"

#define PHY_RETRY_TIME	1000


#define IFX_HALF_DUPLEX 0
#define IFX_FULL_DUPLEX 1

#define IFX_SPEED_10_MBIT   0 
#define IFX_SPEED_100_MBIT  1
#define IFX_SPEED_1000_MBIT 2

#define IFX_USE_INTERNAL_PHY 0
#define IFX_USE_EXTERNAL_PHY 1

#define GMAC_MII   0
#define GMAC_RGMII 1

s32 ifx_set_port_autoneg(u8 chipId,u32 portId, BOOL Enable);
s32 ifx_get_port_autoneg(u8 chipId,u32 portId, BOOL * EnablePtr);
s32 ifx_start_port_autoneg(u8 chipId,u32 portId);
s32 ifx_get_MDIO_mode(u8 chipId, u32 port_group, BOOL * mdioMode, BOOL * autoNegMode);
s32 ifx_set_MDIO_mode(u8 chipId,u32 port_group, BOOL mdioMode, BOOL autoNegMode);
s32 ifx_get_port_eth_conf( u8 chipId, u32 portId, \
                           u32* speed_ptr, u32* duplex_ptr, BOOL* autoneg_ptr, \
                           u32* int_ext_phy_ptr, u32* link_status_ptr);

#endif /* _PR_PHY_H */
