/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

#ifndef __FLOWENGINE_H
#define __FLOWENGINE_H


/*	function prototype	*/

s32 ifx_set_port_key(u8 chipId,u32 portId, u32 IKey);
s32 ifx_get_port_key(u8 chipId,u32 portId, u32 *IKeyPtr);

s32 ifx_set_flow_pattern(u8 chipId,u32 flowId, u32* IKeyData, u32* IKeyMask);
s32 ifx_get_flow_pattern(u8 chipId,u32 flowId, u32* IKeyData, u32* IKeyMask);
s32 ifx_delete_flow_pattern(u8 chipId,u32 flowId);

s32 ifx_set_flow_action_param(u8 chipId,u32 flowId, u32 feature,u32 flowAction);
s32 ifx_get_flow_action_param(u8 chipId,u32 flowId, u32 feature,u32 * flowActionPtr);

s32 ifx_set_flow_action(u8 chipId,u32 flowsetId, u32 flowsetSelection);
s32 ifx_get_flow_action(u8 chipId,u32 flowsetId, u32* flowsetSelectionPtr);

s32 ifx_set_port_rule(u8 chipId,u32 portId, u32 *portRulePtr);
s32 ifx_get_port_rule(u8 chipId,u32 portId, u32 *portRulePtr);

s32 ifx_set_port_mask(u8 chipId,u32 portId, u32 *portMaskPtr);
s32 ifx_get_port_mask(u8 chipId,u32 portId, u32 *portMaskPtr);

s32 ifx_set_port_offset(u8 chipId,u32 portId, u32 *portOffsetPtr);
s32 ifx_get_port_offset(u8 chipId,u32 portId, u32 *portOffsetPtr);

s32 ifx_set_Rx_config(u8 chipId,u32 portId,BOOL L3Program, BOOL L3StartVld, 
					  u32 L3Start);
s32 ifx_get_Rx_config(u8 chipId,u32 portId,BOOL* L3ProgramPtr, BOOL* L3StartVldPtr,
					  u32* L3StartPtr);
                      
s32 ifx_delete_flow_action_param( u8 chipId, u32 flowId, u32 feature );                      

#endif	/* end of __FLOWENGINE_H	*/

