/******************************************************************************
 *
 *
 *
 * Copyright 2000 Infineon Technologies Bangalore,India, ., All Rights Reserved
 *	
 *	
 *	
 * Revision History
 *	
 * Name					Date								Description
 * ============	======	================================================
 * Aparna				5/8/2002						Phase I Release
 *                      4/12/2002                       Phase II Release 
 *  	
 *                      3/6/2003                        Removed constant declerations (see pr_const.h)
 *														Removed static array Ikey_Sel_Reg.
 *  	
 * DESCRIPTION : This module contains the constant and function declerations for
 *               QoS Configuration API's
 ******************************************************************************/

#ifndef __PR_QOS_H
#define __PR_QOS_H



/*	function prototype	*/

s32 ifx_set_QoS_bucket(u8 chipId,u32 tBucketId, u32 tBucketCnt,
					  u32 tReplenishRateIdx, u32 tBurstSizeIdx);
s32 ifx_get_QoS_bucket(u8 chipId,u32 tBucketId,u32 * tBucketCntPtr,
				  u32 * tReplenishRateIdxPtr,u32 * tBurstSizeIdxPtr);
s32 ifx_set_QoS_bucket_flow_control(u8 chipId,u32 portRuleBaseIdx, u32 actionLC,
								 u32 actionNC);
s32 ifx_get_QoS_bucket_flow_control(u8 chipId,u32* portRuleBaseIdxPtr, 
			   u32* actionLCPtr, u32* actionNCPtr);
s32 ifx_set_QoS_WF_queue(u8 chipId,u32 portId, u32 queueId, 
						  u32 weightFactor, u32 deficitCount);
s32 ifx_get_QoS_WF_queue(u8 chipId,u32 portId, u32 queueId, 
		u32 * weightFactorPtr, u32 * deficitCountPtr);
s32 ifx_set_QoS_shaping_queue(u8 chipId,u32 portId, u32 queueId, u32 bucketCnt,
					  u32 replenishRate, u32 tokenValue,u32 tReplenishTimer);
s32 ifx_get_QoS_shaping_queue(u8 chipId,u32 portId, u32 queueId, u32 *bucketCntPtr, 
					 u32 *replenishRatePtr, u32 *tokenValuePtr,u32*tReplenishTimer);

s32 ifx_set_QoS_replenish_rate(u8 chipId,u32 tReplenishRateIdx, u32 tReplenishRate);
s32 ifx_get_QoS_replenish_rate(u8 chipId,u32 tReplenishRateIdx, 
							u32 * tReplenishRatePtr);
s32 ifx_set_QoS_burst_size(u8 chipId,u32 tBurstSizeIdx, u32 tBurstSize);
s32 ifx_get_QoS_burst_size(u8 chipId,u32 tBurstSizeIdx, u32 *tBurstSizePtr);
s32 ifx_set_QoS_extend_burst_size(u8 chipId,u32 tEBurstSizeIdx, u32 tEBurstSize);
s32 ifx_get_QoS_extend_burst_size(u8 chipId,u32 tEBurstSizeIdx, u32 *tEBurstSizePtr);


s32 ifx_get_port_queue_data_count(u8 chipId,u32 portId, u32 queueId, 
					 u32 queueType, u32 *countPtr);
s32 ifx_get_port_queue_status(u8 chipId,u32 portId, u32 queueId,
					 u32 queueStatusType, BOOL* queueStatusPtr);


#endif	/* end of __PR_QOS_H	*/
