/******************************************************************************
 *
 *
 * Copyright 2000 Infineon Technologies Bangalore,India, ., All Rights Reserved
 *	
 *	
 *	
 * Revision History
 *	
 * Name					Date								Description
 * ============	======	================================================
 * Manamohan     	    1/9/2003
 *
 * Manamohan			9/8/2004			For windriver malloc and free are
 *											replaced by cacheDmaMalloc and cacheDmaFree 						
 *
 *  	
 * DESCRIPTION : This module contains the function declerations for
 *               Initialization routines
 ******************************************************************************/ 

#include "global.h"

/*MACROS and includes for malloc and kmalloc*/
#if defined(LINUX) && defined(__KERNEL__)

#include <linux/slab.h>
	#define MALLOC(pMem) kmalloc(pMem,GFP_KERNEL)
	#define FREE(pMem) kfree(pMem)

#else
	#ifdef WINDRIVER	
		#include "stdlib.h"
		#include "cacheLib.h"
		#define MALLOC(pMem) cacheDmaMalloc(pMem)
		#define FREE(pMem) cacheDmaFree(pMem)
	#endif

#endif /*UCLINUX*/

#ifndef _PR_APIINIT_H
#define _PR_APIINIT_H

/* #ifdef UCLINUX
void* tbiInit (void*);
#else
void tbiInit (void);
#endif */



s32 ifx_release_API_mem(u8 No_of_Chips);
s32 ifx_get_chip_number(u8* No_of_Chips);
/* shifted to include/asm/switch.h
s32 ifx_set_chip_number(u8 No_of_Chips);
s32 ifx_set_base_address(u8 chipId,u32 Base_Address);
*/
s32 ifx_get_base_address(u8 chipId,u32* Base_Address);


#endif /* _PR_APIINIT_H */
