/***********************************************************************/
/*  Module      :  TSF register addresses and bits                     */
/***********************************************************************/

#define INCA_IP2_TSF                          (KSEG1+0x1E001000)
/***********************************************************************/

#define INCA_IP2_TSF_TSF_CONF      ((volatile u32*)(INCA_IP2_TSF + 0x0000))
#define INCA_IP2_TSF_KEY_CONF      ((volatile u32*)(INCA_IP2_TSF + 0x0004))
#define INCA_IP2_TSF_SREG01        ((volatile u32*)(INCA_IP2_TSF + 0x0008))
#define INCA_IP2_TSF_SREG23        ((volatile u32*)(INCA_IP2_TSF + 0x000C))
#define INCA_IP2_TSF_SREG456       ((volatile u32*)(INCA_IP2_TSF + 0x0010))
#define INCA_IP2_TSF_SREG7TO13     ((volatile u32*)(INCA_IP2_TSF + 0x0014))
#define INCA_IP2_TSF_LEDMUX_CONF   ((volatile u32*)(INCA_IP2_TSF + 0x0018))
#define INCA_IP2_TSF_LED_REG		((volatile u32*)(INCA_IP2_TSF + 0x001C))
#define INCA_IP2_TSF_PWM12         ((volatile u32*)(INCA_IP2_TSF + 0x0020))
#define INCA_IP2_TSF_SREG7TO10     ((volatile u32*)(INCA_IP2_TSF + 0x0024))
#define INCA_IP2_TSF_SREG11TP14    ((volatile u32*)(INCA_IP2_TSF + 0x0028))

#define INCA_IP2_TSF_TSF_CONF_PWMEN                  (1 << 2)
#define INCA_IP2_TSF_TSF_CONF_LEDEN                  (1 << 1)
#define INCA_IP2_TSF_TSF_CONF_KEYEN                  (1 << 0)

#define INCA_IP2_TSF_LEDMUX_CONF_INV                 (1 << 1)
#define INCA_IP2_TSF_LEDMUX_CONF_NCOL                (1 << 0)

/* LED Matrix acc. to User's Manual; LED(x,y) corresponds to Lxy

   pins  |   LED0     LED1     LED2*    LED3*
  -------+-------------------------------------	   
   LED4  | LED(0,4) LED(1,4) LED(2,4) LED(3,4)
   LED5  | LED(0,5) LED(1,5) LED(2,5) LED(3,5)
   ...	 |	...	...	...	...
         |
   LED8  | LED(0,8) LED(1,8) LED(2,8) LED(3,8)
   LED9* | LED(0,9) LED(1,9) LED(2,9) LED(3,9)                    
   
   *: Pins LED2, LED3 and LED9 may be unavailable!                */
#define LED(x,y) 	(1 << ((y-4)*4 + x)) 	/* x=0..3, y=4..9 */

/* LEDs optionally controlled autonomously by Ethernet HW */
#define LED_ETHPORT_PC	0	
#define LED_ETHPORT_LAN	1

#define LED_ETH_SPD	(1 << 0)	/* LAN: LED(0,4) ; PC: LED(0,5) */
#define LED_ETH_ACT	(1 << 1)	/* LAN: LED(1,4) ; PC: LED(1,5) */
#define LED_ETH_DPX	(1 << 2)	/* LAN: LED(2,4) ; PC: LED(2,5) */
#define LED_ETH_STA	(1 << 3)	/* LAN: LED(3,4) ; PC: LED(3,5) */
#define LED_ETH_TL	(1 << 4)

/* other defines */
#define KEY_FIFO_DEPTH	32

#define KEY_RELEASED 	0
#define KEY_PRESSED	1

#define PTR_INCR(x) x = (x == &key_fifo[KEY_FIFO_DEPTH-1] ? key_fifo : x +1)
#define FIFO_FULL(rp,wp) ((rp + KEY_FIFO_DEPTH - wp) % KEY_FIFO_DEPTH == 1)

#define INCAIP2_KEY_IRQ_LINE    INT_NUM_IM3_IRL28
#define INCAIP2_KEY_IRQ_NR    		 28

#define KEYPAD_INTERRUPTS_ENABLE()  set_bit(INCAIP2_KEY_IRQ_NR,INCA_IP2_ICU_IM3_IER)
#define KEYPAD_INTERRUPTS_DISABLE() clear_bit(INCAIP2_KEY_IRQ_NR,INCA_IP2_ICU_IM3_IER)
#define KEYPAD_INTERRUPTS_CLEAR()   set_bit(INCAIP2_KEY_IRQ_NR,INCA_IP2_ICU_IM3_ISR)

