/****************************************************************************************
	Copyright (c) Siemens Enterprise Communications Limited

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
****************************************************************************************/

#ifndef __FPGA_DEFS_H
#define __FPGA_DEFS_H

#define SIEMENS_FPGA		(KSEG1+0x1c000000)

#define FPGA_VERSION6


#define FPGA_VER_REG		((volatile u8*)((SIEMENS_FPGA) + 0x0000))
#define FPGA_BT_RES			((volatile u8*)((SIEMENS_FPGA) + 0x0001))
#define FPGA_BT_WAKUP		((volatile u8*)((SIEMENS_FPGA) + 0x0002))
#define FPGA_CS_REG			((volatile u8*)((SIEMENS_FPGA) + 0x0003))
#define FPGA_PS2_RXDAT		((volatile u8*)((SIEMENS_FPGA) + 0x0004))
#define FPGA_PS2_TXDAT		((volatile u8*)((SIEMENS_FPGA) + 0x0005))
#define FPGA_PS2_STATCON	((volatile u8*)((SIEMENS_FPGA) + 0x0006))
#define FPGA_DHSG_STATCON	((volatile u8*)((SIEMENS_FPGA) + 0x0007))
#define FPGA_INT_PEN1		((volatile u8*)((SIEMENS_FPGA) + 0x0008))
#define FPGA_INT_PEN2		((volatile u8*)((SIEMENS_FPGA) + 0x0009))
#define FPGA_INT_MASK1		((volatile u8*)((SIEMENS_FPGA) + 0x000a))
#define FPGA_INT_MASK2		((volatile u8*)((SIEMENS_FPGA) + 0x000b))
#define FPGA_INT_EVENT1		((volatile u8*)((SIEMENS_FPGA) + 0x000c))
#define FPGA_INT_EVENT2		((volatile u8*)((SIEMENS_FPGA) + 0x000d))
#define FPGA_TEST_REG1		((volatile u8*)((SIEMENS_FPGA) + 0x000e))
#define FPGA_TEST_REG2		((volatile u8*)((SIEMENS_FPGA) + 0x000f))

#define FPGA_V24_RXDAT		((volatile u8*)((SIEMENS_FPGA) + 0x0010))
#define FPGA_V24_TXDAT		((volatile u8*)((SIEMENS_FPGA) + 0x0011))
#define FPGA_V24_STATCON	((volatile u8*)((SIEMENS_FPGA) + 0x0012))
#define FPGA_LAN_RESET		((volatile u8*)((SIEMENS_FPGA) + 0x0013))
#define FPGA_DISP_RESET		((volatile u8*)((SIEMENS_FPGA) + 0x0014))
#define FPGA_NAND_WP		((volatile u8*)((SIEMENS_FPGA) + 0x0015))
#define FPGA_GU_EN			((volatile u8*)((SIEMENS_FPGA) + 0x0016))
#define FPGA_GU_OFFHOOK		((volatile u8*)((SIEMENS_FPGA) + 0x0017))
#define FPGA_USB_EN			((volatile u8*)((SIEMENS_FPGA) + 0x0018))
#define FPGA_SPK_EN			((volatile u8*)((SIEMENS_FPGA) + 0x0019))
#define FPGA_SC_EN			((volatile u8*)((SIEMENS_FPGA) + 0x001A))
#define FPGA_SC_CS			((volatile u8*)((SIEMENS_FPGA) + 0x001B))
#define FPGA_MMI_PWM		((volatile u8*)((SIEMENS_FPGA) + 0x001C))
#define FPGA_INT_POL		((volatile u8*)((SIEMENS_FPGA) + 0x001D))
#define FPGA_PAN_CNTRL		((volatile u8*)((SIEMENS_FPGA) + 0x001E))



#define FPGA_INT_PEN		((volatile u16*)((SIEMENS_FPGA) + 0x0008))
#define FPGA_INT_MASK		((volatile u16*)((SIEMENS_FPGA) + 0x000a))
#define FPGA_INT_EVENT		((volatile u16*)((SIEMENS_FPGA) + 0x000c))



#define MM_WHEEL_RDY_BIT		(1<<7)
#define MM_SLIDER_RDY_BIT		(1<<6)
#define MM_KEY_RDY_BIT			(1<<5)
#define DM_KEY_RDY_BIT			(1<<4)
#define DM_DRDY_STATE_BIT		(1<<3)

#define FPGA_GPIO_GU		(1<<3)
#define FPGA_GPIO_SPI_SEL	(1<<1)
#define FPGA_GPIO_BT		(1<<0)

#define GU_ONHOOK			(0)
#define GU_OFFHOOK			(1<<3)
#define BT_WAKEUP_LOW		(0)
#define BT_WAKEUP_HIGH		(1<<1)
#define SPI_SEL_LOW			(0)
#define SPI_SEL_HIGH		(1<<0)

#define FPGA_SPI_SS(x)		(*FPGA_GPIO_REG = ((x)& 0x7))
#define FPGA_SPI_RDY(x)		(*FPGA_GPIO_REG & ((x)& 0xf0))
#define FPGA_SPI_INUSE		(*FPGA_GPIO_REG & 0x7)

// DHSG (wireless headset) status control register bit fields
// (For use with FPGA_DHSG_STATCON register - see above)
#define FPGA_DHSG_RX_SIG_MASK	(3<<0)
#define FPGA_DHSG_RX_SIG_NOSIG		(0<<0)
#define FPGA_DHSG_RX_SIG_ONHOOK		(1<<0)
#define FPGA_DHSG_RX_SIG_OFFHOOK	(2<<0)
#define FPGA_DHSG_RX_ERROR		(1<<2)
#define FPGA_DHSG_RX_READY		(1<<3)
#define FPGA_DHSG_TX_SIG_MASK	(3<<4)
#define FPGA_DHSG_TX_SIG_NOSIG		(0<<4)
#define FPGA_DHSG_TX_SIG_RINGER		(1<<4)
#define FPGA_DHSG_TX_SIG_CALL_ON	(2<<4)
#define FPGA_DHSG_TX_SIG_CALL_OFF	(3<<4)
// Bit 6 not used
#define FPGA_DHSG_TX_RUNNING	(1<<7)

// V24 status control register bit fields
// (For use with FPGA_V24_STATCON register - see above)
#define FPGA_V24_LOOPEN		(1<<0)
#define FPGA_V24_RXFLUSH	(1<<1)
#define FPGA_V24_TXBUSY		(1<<2)
#define FPGA_V24_RXNOTEMPTY	(1<<3)
#define FPGA_V24_RXALLMOSTFULL	(1<<4)
#define FPGA_V24_RXFULL		(1<<5)
#define FPGA_V24_CTS		(1<<6)
#define FPGA_V24_RTS		(1<<7)


#define FPGA_PANEL_POWER_EN_BIT (1<<0)
#define FPGA_PANEL_SPI_EN_BIT (1<<1)
#define FPGA_PANEL_SPI_CLK_BIT (1<<2)
#define FPGA_PANEL_SPI_DATA_BIT (1<<3)
#define FPGA_PANEL_SPI_DIR_BIT (1<<4)
#define FPGA_PANEL_DEFAULT_WRITE_BITS ( FPGA_PANEL_POWER_EN_BIT | FPGA_PANEL_SPI_EN_BIT | FPGA_PANEL_SPI_DIR_BIT)
#define FPGA_PANEL_DEFAULT_READ_BITS ( FPGA_PANEL_POWER_EN_BIT | FPGA_PANEL_SPI_EN_BIT )

#define FPGA_SPK_EN_SPEAKER_EN_BIT (1<<0)

#endif
