/****************************************************************************************
	Copyright (c) Siemens Enterprise Communications Limited

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
****************************************************************************************/

/*MH******************************************************************
* MOD-NAME     :  latch.h                    VAR./VERSION:  H1/001   *
* LONG-NAME    :  header file for external latch device in WP1/2     *
* AUTHOR       :  Elmar Albert              					     *
* DEPARTMENT   :  MCH-H/SC 8                                         *
* TELEPHONE    :  35965                                              *
* CREATION-DATE:  20.01.2006                                         *
* SP-NO        :                                                     *
* FUNCTION     :                                                     *
* NOTES        :                                                     *
* SS-NO        :                                                     *
* STRUCTURE    :                                                     *
* SUBSYSTEM    :                                                     *
* INT-STRUCTURE:                                                     *
* EXT-STRUCTURE:                                                     *
* FILES        :                                                     *
*                                                                    *
*********************************************************************/


/*HOC*****************************************************************
*                                                                    *
*  HISTORY OF CHANGE:                    VARIANTE: H1                *
*                                                                    *
*----+------+--------------------------------------------+----+------*
*VERS| DATE | CHANGES                                    | KZ | CNO  *
*    |TTMMJJ|                                            |    |      *
*----+------+--------------------------------------------+----+------*
*001 |200306| - INITIAL CREATION                         | Al |Mxxxxx*
*----+------+--------------------------------------------+----+------*
*********************************************************************/

#ifndef _LATCH_H_
#define _LATCH_H_

/*-----------------------------------------------------------------------
 * external LATCH
 */
#define CSLATCH	((unsigned char *) (0xBC000000))
// A23 will be used as /CS for the external LATCH device

#define LATCH_INIT	0xC0	// bit 0:	not used:			0
							// bit 1:	not used:			0
							// bit 2:	/SIDECAR_POWER_EN: 	0 => sidecar power on
							// bit 3:	SIDECAR_SPI_SEL:	0 => sidecar 0 selected
							// bit 4:	SPEAKER_EN:			0 => disabled
							// bit 5:	not used:			0
							// bit 6:   /CSQ_KEY:			1 => not selected
							// bit 7:   /CSQ_LED:			1 => not selected

#define CSQ_LED				0x80
#define CSQ_KEY				0x40
#define SPEAKER_EN			0x10
#define SIDECAR_SPI_SEL		0x08
#define SIDECAR_POWER_EN	0x04
#define RESET_LCD_OS40core	0x01

#define LATCH_SET		0			//Active low signal
#define LATCH_CLEAR		1			//Active low signal

//extern unsigned char yLatchValue ;		// holds the content of the LATCH device
// write access only allowed in the writeLatch function

//extern void writeLatch (unsigned char yMask, unsigned char ySetReset);

#endif	// _LATCH_H_
