/****************************************************************************************
	Copyright (c) Siemens Enterprise Communications Limited

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
****************************************************************************************/

#ifndef _MMIBOARD_H_
#define _MMIBOARD_H_

#define CSQ_KEY_PIN		(14) /* LED7 */
#define CSQ_LED_PIN		(15) /* LED8 */
#define CSQ_WHEEL_PIN	(16)
#define CSQ_SLIDER_PIN	(17)

	
#define DRDY_SLIDER_PIN	(1) /* DU  */
#define DRDY_KEY_PIN	(2) /* DCL */
#define DRDY_WHEEL_PIN	(3) /* FSC */

#define CSQ_KEY			(1 << CSQ_KEY_PIN) /* port 1 */
#define CSQ_LED			(1 << CSQ_LED_PIN)
#define CSQ_WHEEL		(1 << CSQ_WHEEL_PIN)
#define CSQ_SLIDER		(1 << CSQ_SLIDER_PIN)

	
#define DRDY_SLIDER		(1 << DRDY_SLIDER_PIN) /* port 2 */
#define DRDY_KEY		(1 << DRDY_KEY_PIN)
#define DRDY_WHEEL		(1 << DRDY_WHEEL_PIN)

#define CS_PORT			(1)
#define DRDY_PORT		(2)
#define DRDY_TRUE		(0)


# define MINI_HSI_SSC_NUM (0)
# define MINI_HSI_SSC_INODE ((struct inode *)MINI_HSI_SSC_NUM)
# define MINI_HSI_SSC_BAUDRATE 32000
# define MINI_HSI_DATAWIDTH 8

typedef struct {
	unsigned char poll;
} poll_data_t;

typedef struct {
	unsigned int ledmap;
} led_data_t;

#define TOUCH_BIT (1<<7)
#define QW_TYPE_BIT (1<<6)
#define QW_POLE_BIT (1<<1)
#define QW_PROX_BIT (1<<0)
#define IS_TOUCHED(x) ((x)& TOUCH_BIT)
#define IS_ERROR(x) ((x)& QW_POLE_BIT)
#define IS_NEAR(x) ((x)& QW_PROX_BIT)
#define IS_QWHEEL(x) (((x)& QW_TYPE_BIT)== QW_TYPE_BIT)
#define IS_QSLIDER(x) ((x)& QW_TYPE_BIT)!= QW_TYPE_BIT)
#define QWHEEL_DATA(x) ((x) & (~TOUCH_BIT))
#define QSLIDER_DATA(x) ((x) & (~TOUCH_BIT))

#endif //_MMIBOARD_H_
