/****************************************************************************************
	Copyright (c) Siemens Enterprise Communications Limited

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
****************************************************************************************/

#ifndef __MPS_EVENT_H
#define __MPS_EVENT_H

typedef int (*mps_headset_callback_t) (int state);

#define MPS_HEADSET_CONNECTED (1)
#define MPS_HEADSET_DISCONNECTED (0)

typedef struct {
    u32 fdp_err;
    u32 lin_req;
    u32 epq_st;    
    u32 vpou_st;   
    u32 vpou_jbl;   
    u32 vpou_jbh;    
    u32 dec_chg;        
} MPS_Voice_Event_Count_t;

typedef struct {
    u32 rcv_ov;
    u32 mips_ol;
    u32 pcm_crash;
    u32 cmd_err;    
    u32 data_err;   
    u32 hs_con;   
    u32 hs_dis;       
    u32 utga;       
    u32 sr_err;       
    u32 sr_ivw;       
    u32 sr_req;       
} MPS_Command_Event_Count_t;

/******************************************************************************
 * Exported functions
 ******************************************************************************/
#ifdef __KERNEL__

s32 mps_register_headset_callback( mps_headset_callback_t callback );

s32 mps_unregister_headset_callback(void);

#endif

#endif /* #ifndef __MPS_H */
