/*==================================================================
**  Generic Header information generated by 13732CFG.EXE (Build 21)
**  Copyright (c) 2002 Epson Research and Development, Inc.
**  All rights reserved.
**
**  DISPLAYS      WxHxBPP     FREQ    SUBTYPE                                    
**  ------------- ----------- ------- -------------------------------------------
** *LCD1=Parallel 176x220x8   0 Hz    Type 80
**  LCD2=Parallel 2x1x8       0 Hz    Type 80
**
**  DIMENSIONS    WxHxBPP @ STRIDE   START   SADDR                    ADDITIONAL 
**  ------------- ------------------ ------- ------------------------ -----------
**  Main Window   176x220x8 @ 176    NA      00042000h + bias of 0h   Swivel=0
**  PIP+ Window   64x64x8 @ 64       10,10   00020000h + bias of 0h   Swivel=0
**  View Resizer  64x64              0,0     00020000h                Scaling=OFF
**  Capt Resizer  352x288            0,0     00020000h                Scaling=OFF
** 
**  CLOCKS        FREQ        SOURCE                                             
**  ------------- ----------- ---------------------------------------------------
**  INCLK         54.001 MHz  PLL
**  SYSCLK        54.001 MHz  INCLK/1
**  PCLK          6.750 MHz   SYSCLK/8
**  SERCLK        4.500 MHz   SYSCLK/12
**  CM1CLK        13.500 MHz  SYSCLK/4
**  I2CCLK        3.000 MHz   SYSCLK/18
**
**  This file defines the configuration environment and registers,
**  which can be used by any software, such as display drivers.
**
**  Note: If you transfer this file to any non-PC system, use ASCII
**  mode (not BINARY) to maintain system-specific line terminators.
**==================================================================*/

#define S1D_13732
#define S1D_DISPLAY_WIDTH               176
#define S1D_DISPLAY_HEIGHT              220
#define S1D_DISPLAY_BPP                 8
#define S1D_DISPLAY_SCANLINE_BYTES      176
#define S1D_DISPLAY_FRAME_RATE          0
#define S1D_DISPLAY_PCLK                6750208L
#define S1D_PHYSICAL_REG_ADDR           0x01250000L
#define S1D_PHYSICAL_VMEM_ADDR          0x01450000L
#define S1D_PHYSICAL_REG_SIZE           36864L
#define S1D_PHYSICAL_VMEM_SIZE          458752L
#define S1D_PHYSICAL_VMEM_REQUIRED      76800L
#define S1D_PALETTE_SIZE                256
#define S1D_POWER_DELAY_OFF             0
#define S1D_POWER_DELAY_ON              0
#define S1D_HWBLT
#define S1D_SWBLT
#define S1D_REGRESERVED                 0xFFF0
#define S1D_REGDELAYPLL                 0xFFFC
#define S1D_REGDELAYOFF                 0xFFFD
#define S1D_REGDELAYON                  0xFFFE

#define S1D_WRITE_PALETTE(p,i,r,g,b)  \
  {  \
    ((volatile S1D_VALUE*)(p))[(0x400/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))] = (S1D_VALUE)(g)<<8 | (r); \
    ((volatile S1D_VALUE*)(p))[(0x402/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))] = (b); \
  }

#define S1D_READ_PALETTE(p,i,r,g,b)  \
  {  \
    S1D_VALUE reg1, reg2;  \
    reg1 = ((volatile S1D_VALUE*)(p))[(0x400/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))];  \
    reg2 = ((volatile S1D_VALUE*)(p))[(0x402/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))];  \
    (g) = (reg1>>8)&0xFF;  \
    (r) = reg1&0xFF;  \
    (b) = reg2&0xFF;  \
  }

#define S1D_WRITE_PALETTE_LUT2(p,i,r,g,b)  \
  {  \
    ((volatile S1D_VALUE*)(p))[(0x800/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))] = (S1D_VALUE)(g)<<8 | (r); \
    ((volatile S1D_VALUE*)(p))[(0x802/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))] = (b); \
  }

#define S1D_READ_PALETTE_LUT2(p,i,r,g,b)  \
  {  \
    S1D_VALUE reg1, reg2;  \
    reg1 = ((volatile S1D_VALUE*)(p))[(0x800/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))];  \
    reg2 = ((volatile S1D_VALUE*)(p))[(0x802/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))];  \
    (g) = (reg1>>8)&0xFF;  \
    (r) = reg1&0xFF;  \
    (b) = reg2&0xFF;  \
  }

typedef unsigned short S1D_INDEX;
typedef unsigned short S1D_VALUE;
typedef struct
{
    S1D_INDEX Index;
    S1D_VALUE Value;
} S1D_REGS;

#define S1D_INSTANTIATE_REGISTERS(scope_prefix,variable_name)  \
  scope_prefix S1D_REGS variable_name[] =  \
  {  \
    { 0x0006,           0x0003 },   /* Bus Timeout Reset Register                         */  \
    { 0x0014,           0x0411 },   /* Miscellaneous Configuration Register               */  \
    { 0x0012,           0x0001 },   /* PLL Setting Register 3                             */  \
    { 0x000C,           0x1027 },   /* PLL Setting Register 0                             */  \
    { 0x000E,           0xF198 },   /* PLL Setting Register 1                             */  \
    { 0x0010,           0x0103 },   /* PLL Setting Register 2                             */  \
    { 0x0018,           0x0000 },   /* System Clock Setting Register                      */  \
    { 0x0012,           0x0000 },   /* PLL Setting Register 3                             */  \
    { S1D_REGDELAYPLL,  0x0064 },   /* PLL REGISTER PROGRAMMING DELAY (in ms)             */  \
    { 0x0014,           0x0410 },   /* Miscellaneous Configuration Register               */  \
    { 0x8000,           0x0000 },   \
    { 0x0300,           0x0000 },   /* GPIO Configuration Register 0                      */  \
    { 0x0302,           0x0000 },   /* GPIO Configuration Register 1                      */  \
    { 0x0304,           0x0006 },   /* GPIO Input Control Register 0                      */  \
    { 0x0306,           0x0000 },   /* GPIO Input Control Register 1                      */  \
    { 0x0308,           0xFFF9 },   /* GPIO Pull Down Control Register 0                  */  \
    { 0x030A,           0x003F },   /* GPIO Pull Down Control Register 1                  */  \
    { 0x030C,           0x0000 },   /* GPIO Status Register 0                             */  \
    { 0x030E,           0x0000 },   /* GPIO Status Register 1                             */  \
    { 0x0022,           0x0000 },   /* Indirect Interface Memory Address Register 0       */  \
    { 0x0024,           0x0000 },   /* Indirect Interface Memory Address Register 2       */  \
    { 0x0030,           0x0503 },   /* LCD Interface Clock Setting Register               */  \
    { 0x0032,           0x0032 },   /* LCD Interface Panel Setting Register               */  \
    { 0x0034,           0x0000 },   /* LCD Interface Command PortRegister                 */  \
    { 0x0036,           0x0000 },   /* LCD Interface Parameter Port Register              */  \
    { 0x003A,           0x0000 },   /* LCD Interface Frame Transfer Register              */  \
    { 0x003C,           0x0000 },   /* LCD Interface Transfer Setting Register            */  \
    { 0x0040,           0x0031 },   /* LCD1 Horizontal Total Register                     */  \
    { 0x0042,           0x0057 },   /* LCD1 Horizontal Display Period Register            */  \
    { 0x0044,           0x0034 },   /* LCD1 Horizontal Display Period Start Position Register */  \
    { 0x0046,           0x008F },   /* LCD1 FPLINE Register                               */  \
    { 0x0048,           0x000F },   /* LCD1 FPLINE Pulse Position Register                */  \
    { 0x004A,           0x0106 },   /* LCD1 Vertical Total Register                       */  \
    { 0x004C,           0x00DB },   /* LCD1 Vertical Display Period Register              */  \
    { 0x004E,           0x0016 },   /* LCD1 Vertical Display Period Start Position Register */  \
    { 0x0050,           0x0081 },   /* LCD1 FPFRAME Register                              */  \
    { 0x0052,           0x0010 },   /* LCD1 FPFRAME Pulse Position Register               */  \
    { 0x0054,           0x0003 },   /* LCD1 Serial Interface Setting Register             */  \
    { 0x0056,           0x0006 },   /* LCD1 Parallel Interface Setting Register           */  \
    { 0x0058,           0x0000 },   /* LCD2 Horizontal Display Period Register            */  \
    { 0x005A,           0x0000 },   /* LCD2 Vertical Display Period Register              */  \
    { 0x005C,           0x0001 },   /* LCD2 Serial Interface Setting Register             */  \
    { 0x005E,           0x0000 },   /* LCD2 Parallel Interface Setting Register           */  \
    { 0x0180,           0x0700 },   /* I2C Status Register                                */  \
    { 0x0200,           0x0024 },   /* Display Mode Setting Register 0                    */  \
    { 0x0202,           0x0400 },   /* Display Mode Setting Register 1                    */  \
    { 0x0204,           0x0000 },   /* Transparent Overlay Key Color Red Data Register    */  \
    { 0x0206,           0x0000 },   /* Transparent Overlay Key Color Green Data Register  */  \
    { 0x0208,           0x0000 },   /* Transparent Overlay Key Color Blue Data Register   */  \
    { 0x0210,           0x2000 },   /* Main Window Display Start Address Register 0       */  \
    { 0x0212,           0x0004 },   /* Main Window Display Start Address Register 1       */  \
    { 0x0216,           0x00B0 },   /* Main Window Line Address Offset Register           */  \
    { 0x0218,           0x0000 },   /* PIP+ Display Start Address Register 0              */  \
    { 0x021A,           0x0002 },   /* PIP+ Display Start Address Register 1              */  \
    { 0x021E,           0x0080 },   /* PIP+ Window Line Address Offset Register           */  \
    { 0x0220,           0x000A },   /* PIP+ X Start Positions Register                    */  \
    { 0x0222,           0x000A },   /* PIP+ Y Start Positions Register                    */  \
    { 0x0224,           0x0049 },   /* PIP+ X End Positions Register"                     */  \
    { 0x0226,           0x0049 },   /* PIP+ Y End Positions Register                      */  \
    { 0x022A,           0x0000 },   /* Back Buffer Display Start Address Register 0       */  \
    { 0x022C,           0x0000 },   /* Back Buffer Display Start Address Register 1       */  \
    { 0x0240,           0x0505 },   /* YUV/RGB Converter 1 Translate Mode Register        */  \
    { 0x0242,           0x0000 },   /* YUV/RGB Converter 1 Write Start Address Register 0 */  \
    { 0x0244,           0x0002 },   /* YUV/RGB Converter 1 Write Start Address Register 1 */  \
    { 0x0246,           0x0000 },   /* YUV/RGB Converter 1 Write Start Address 1 Register 0 */  \
    { 0x0248,           0x0000 },   /* YUV/RGB Converter 1 Write Start Address 1 Register 1 */  \
    { 0x024A,           0x0000 },   /* YUV/RGB Converter 1 UV Data Clip Register          */  \
    { 0x024C,           0x0030 },   /* YUV/RGB Converter 1 Rectangular Pixel Width Register */  \
    { 0x024E,           0x0000 },   /* YUV/RGB Converter 1 Rectangular Line Address Offset Register */  \
    { 0x0260,           0x0005 },   /* RGB/YUV Converter Configuration Register           */  \
    { 0x0264,           0x0000 },   /* RGB/YUV Converter Horizontal Display Size Register */  \
    { 0x0266,           0x0000 },   /* RGB/YUV Converter Vertical Display Size Register   */  \
    { 0x0310,           0x0000 },   /* Average Overlay Key Color Red Data Register        */  \
    { 0x0312,           0x0000 },   /* Average Overlay Key Color Green Data Register      */  \
    { 0x0314,           0x0000 },   /* Average Overlay Key Color Blue Data Register       */  \
    { 0x0316,           0x0000 },   /* AND Overlay Key Color Red Data Register            */  \
    { 0x0318,           0x0000 },   /* AND Overlay Key Color Green Data Register          */  \
    { 0x031A,           0x0000 },   /* AND Overlay Key Color Blue Data Register           */  \
    { 0x031C,           0x0000 },   /* OR Overlay Key Color Red Data Register             */  \
    { 0x031E,           0x0000 },   /* OR Overlay Key Color Green Data Register           */  \
    { 0x0320,           0x0000 },   /* OR Overlay Key Color Blue Data Register            */  \
    { 0x0322,           0x0000 },   /* INV Overlay Key Color Red Data Register            */  \
    { 0x0324,           0x0000 },   /* INV Overlay Key Color Green Data Register          */  \
    { 0x0326,           0x0000 },   /* INV Overlay Key Color Blue Data Register           */  \
    { 0x0328,           0x0000 },   /* Overlay Miscellaneous Register                     */  \
    { 0x0944,           0x0000 },   /* View Resize Start X Position Register              */  \
    { 0x0946,           0x0000 },   /* View Resize Start Y Position Register              */  \
    { 0x0948,           0x003F },   /* View Resize End X Position Register                */  \
    { 0x094A,           0x003F },   /* View Resize End Y Position Register                */  \
    { 0x094E,           0x0000 },   /* View Resize Operation Setting Register 1           */  \
    { 0x094C,           0x0101 },   /* View Resize Operation Setting Register 0           */  \
    { 0x0964,           0x0000 },   /* Capture Resize Start X Position Register           */  \
    { 0x0966,           0x0000 },   /* Capture Resize Start Y Position Register           */  \
    { 0x0968,           0x015F },   /* Capture Resize End X Position Register             */  \
    { 0x096A,           0x011F },   /* Capture Resize End Y Position Register             */  \
    { 0x096E,           0x0000 },   /* Capture Resdo_write_shadow_fbize Operation Setting Register 1        */  \
    { 0x096C,           0x0101 },   /* Capture Resize Operation Setting Register 0        */  \
    { 0x0930,           0x0000 },   /* Global Resize Control Register                     */  \
    { 0x0940,           0x0000 },   /* View Resize Control Register                       */  \
    { 0x0960,           0x0000 },   /* Capture Resize Control Register                    */  \
    { 0x0980,           0x0000 },   /* JPEG Control Register                              */  \
    { 0x09A0,           0x0020 },   /* JPEG FIFO Control Register                         */  \
    { 0x09A4,           0x000F },   /* JPEG FIFO Size Register                            */  \
    { 0x09B0,           0x0000 },   /* Encode Size Limit Register 0                       */  \
    { 0x09B2,           0x0020 },   /* Encode Size Limit Register 1                       */  \
    { 0x09BC,           0x0040 },   /* JPEG FIFO Start Address Register                   */  \
    { 0x09D0,           0x0000 },   /* JPEG Line Buffer Configuration Register            */  \
    { 0x09D2,           0x0000 },   /* JPEG Line Bdo_write_shadow_fbuffer Configuration Register            */  \
    { 0x0100,           0x0003 },   /* Camera 1 Clock Setting Register                    */  \
    { 0x0102,           0x0000 },   /* Camera 1 Signal Setting Register                   */  \
    { 0x0112,           0x0000 },   /* Camera Frame Setting Register                      */  \
    { 0x0114,           0x0000 },   /* Camera Control Register [WRITEONLY]                */  \
    { 0x0110,           0x1000 },   /* Camera Mode Setting Register                       */  \
    { 0x0A02,           0x0000 },   /* Interrupt Control Register                         */  \
    { 0x0A06,           0x0000 },   /* LCD Interrupt Flag Register                        */  \
    { 0x0A08,           0x0000 },   /* LCD Interrupt Control Register                     */  \
    { 0x0A0A,           0x0000 },   /* Host Interface Interrupt Flag Register             */  \
    { 0x0A0C,           0x0000 },   /* Host Interface Interrupt Control Register          */  \
    { 0x0A0E,           0x1F1F },   /* Cycle Cycle Time Out Control Register              */  \
    { 0x0F02,           0x0100 },   /* JPEG Extend Address Register                       */  \
    { S1D_REGDELAYON,   0x0000 }    /* LCD PANEL POWER ON DELAY (in ms)                   */  \
  }
