/*==================================================================
**  Generic Header information generated by 13733B00CFG.EXE (Build 54)
**  Copyright (c) 2005 Epson Research and Development, Inc.
**  All rights reserved.
**
**  DISPLAYS      WxHxBPP     FREQ    ADDITIONAL                                 
**  ------------- ----------- ------- -------------------------------------------
** *LCD1=RGB      640x480x16  35 Hz   General TFT / EPSON ND-TFD (18-bit)
**  LCD2=Parallel 2x1x16      0 Hz    Type 80
** 
**  DIMENSIONS    WxHxBPP @ STRIDE   START   SADDR                    ADDITIONAL 
**  ------------- ------------------ ------- ------------------------ -----------
**  Main Window   640x480x16 @ 1280  NA      00000h + bias of 0h      Swivel=0
**  PIP+ Window   320x240x16 @ 640   0,0     4C000h + bias of 0h      Swivel=0
**  Preview Trim  640x480            0,0     NA                      
**  Capture Trim  640x480            0,0     NA                      
**  View Resizer  320x240            NA      000D2000h               
**  Capt Resizer  640x480            NA      000D0000h               
** 
**  CLOCKS        FREQ        SOURCE                                             
**  ------------- ----------- ---------------------------------------------------
**  INCLK         60.030 MHz  PLL
**  SYSCLK        60.030 MHz  INCLK/1
**  PCLK          15.007 MHz  SYSCLK/4
**  SERCLK        5.002 MHz   SYSCLK/12
**  CMCLKOUT      20.010 MHz  CMCLK1
**  CMCLK1        20.010 MHz  SYSCLK/3
**  CMCLK2        32.768 KHz  PLL2/1
**  SDCLK         20.010 MHz  SYSCLK/3
**  I2CCLK        3.335 MHz   SYSCLK/18
** 
**  SHOW          COLOR FORMAT     SUB-ORDER                      LUT            
**  ------------- ---------------- ------------------------------ ---------------
**  Main Window   RGB 5:6:5        RGB                            LUT Bypass On  
**  PIP+ Window   RGB 5:6:5        RGB                            LUT Bypass On  
**
**  This file defines the configuration environment and registers,
**  which can be used by any software, such as display drivers.
**
**  Note: If you transfer this file to any non-PC system, use ASCII
**  mode (not BINARY) to maintain system-specific line terminators.
**==================================================================*/

#define S1D_13733B00
#define S1D_DISPLAY_WIDTH               640
#define S1D_DISPLAY_HEIGHT              480
#define S1D_DISPLAY_BPP                 16
#define S1D_DISPLAY_SCANLINE_BYTES      1280
#define S1D_DISPLAY_FRAME_RATE          35
#define S1D_DISPLAY_PCLK                15007744L
#define S1D_PHYSICAL_REG_ADDR           0x11000000L
#define S1D_PHYSICAL_VMEM_ADDR          0x11100000L
#define S1D_PHYSICAL_REG_SIZE           200L
#define S1D_PHYSICAL_VMEM_SIZE          868352L
#define S1D_PHYSICAL_VMEM_REQUIRED      76800L
#define S1D_PALETTE_SIZE                256
#define S1D_POWER_DELAY_OFF             0
#define S1D_POWER_DELAY_ON              0
#define S1D_HWBLT
#define S1D_SWBLT
#define S1D_REGRESERVED                 0xFFF0
#define S1D_REGDELAYPLL                 0xFFFC
#define S1D_REGDELAYOFF                 0xFFFD
#define S1D_REGDELAYON                  0xFFFE

#define S1D_WRITE_PALETTE(p,i,r,g,b)  \
  {  \
    ((volatile S1D_VALUE*)(p))[(0x400/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))] = (S1D_VALUE)(g)<<8 | (r); \
    ((volatile S1D_VALUE*)(p))[(0x402/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))] = (b); \
  }

#define S1D_READ_PALETTE(p,i,r,g,b)  \
  {  \
    S1D_VALUE reg1, reg2;  \
    reg1 = ((volatile S1D_VALUE*)(p))[(0x400/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))];  \
    reg2 = ((volatile S1D_VALUE*)(p))[(0x402/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))];  \
    (g) = (reg1>>8)&0xFF;  \
    (r) = reg1&0xFF;  \
    (b) = reg2&0xFF;  \
  }

#define S1D_WRITE_PALETTE_LUT2(p,i,r,g,b)  \
  {  \
    ((volatile S1D_VALUE*)(p))[(0x800/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))] = (S1D_VALUE)(g)<<8 | (r); \
    ((volatile S1D_VALUE*)(p))[(0x802/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))] = (b); \
  }

#define S1D_READ_PALETTE_LUT2(p,i,r,g,b)  \
  {  \
    S1D_VALUE reg1, reg2;  \
    reg1 = ((volatile S1D_VALUE*)(p))[(0x800/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))];  \
    reg2 = ((volatile S1D_VALUE*)(p))[(0x802/sizeof(S1D_VALUE))+((i)*sizeof(S1D_VALUE))];  \
    (g) = (reg1>>8)&0xFF;  \
    (r) = reg1&0xFF;  \
    (b) = reg2&0xFF;  \
  }

typedef unsigned short S1D_INDEX;
typedef unsigned short S1D_VALUE;
typedef struct
{
    S1D_INDEX Index;
    S1D_VALUE Value;
} S1D_REGS;

#define S1D_INSTANTIATE_REGISTERS(scope_prefix,variable_name)  \
  scope_prefix S1D_REGS variable_name[] =  \
  {  \
    { 0x0006,           0x0003 },   /* Bus Timeout Reset Register                         */  \
    { 0x0014,           0x0411 },   /* Miscellaneous Configuration Register               */  \
    { 0x0012,           0x0001 },   /* PLL Setting Register 3                             */  \
    { 0x000C,           0x1027 },   /* PLL Setting Register 0                             */  \
    { 0x000E,           0x7390 },   /* PLL Setting Register 1                             */  \
    { 0x0010,           0x0103 },   /* PLL Setting Register 2                             */  \
    { 0x0018,           0x0000 },   /* System Clock Setting Register                      */  \
    { 0x0012,           0x0000 },   /* PLL Setting Register 3                             */  \
    { 0x001A,           0x0000 },   /* PLL2 Setting Register 0 [RESERVED]                 */  \
    { 0x001C,           0x0000 },   /* PLL2 Setting Register 1 [RESERVED]                 */  \
    { 0x001E,           0x0000 },   /* PLL2 Setting Register 2 [RESERVED]                 */  \
    { S1D_REGDELAYPLL,  0x0064 },   /* PLL REGISTER PROGRAMMING DELAY (in ms)             */  \
    { 0x0014,           0x0410 },   /* Miscellaneous Configuration Register               */  \
    { 0x0300,           0x0000 },   /* GPIO Configuration Register 0                      */  \
    { 0x0302,           0x0000 },   /* GPIO Configuration Register 1                      */  \
    { 0x0304,           0x0000 },   /* GPIO Input Control Register 0                      */  \
    { 0x0306,           0x0000 },   /* GPIO Input Control Register 1                      */  \
    { 0x0308,           0xFFFF },   /* GPIO Pull Down Control Register 0                  */  \
    { 0x030A,           0x003F },   /* GPIO Pull Down Control Register 1                  */  \
    { 0x030C,           0x0000 },   /* GPIO Status Register 0                             */  \
    { 0x030E,           0x0000 },   /* GPIO Status Register 1                             */  \
    { 0x0022,           0x0000 },   /* Indirect Interface Memory Address Register 0       */  \
    { 0x0024,           0x0000 },   /* Indirect Interface Memory Address Register 2       */  \
    { 0x0030,           0x0501 },   /* LCD Interface Clock Setting Register               */  \
    { 0x0032,           0x0031 },   /* LCD Interface Panel Setting Register               */  \
    { 0x0034,           0x0000 },   /* LCD Interface Command Port Register                */  \
    { 0x0036,           0x0000 },   /* LCD Interface Parameter Port Register              */  \
    { 0x003A,           0x0000 },   /* LCD Interface Frame Transfer Register              */  \
    { 0x003C,           0x0000 },   /* LCD Interface Transfer Setting Register            */  \
    { 0x0040,           0x0063 },   /* LCD1 Horizontal Total Register                     */  \
    { 0x0042,           0x013F },   /* LCD1 Horizontal Display Period Register            */  \
    { 0x0044,           0x0032 },   /* LCD1 Horizontal Display Period Start Position Register */  \
    { 0x0046,           0x00DF },   /* LCD1 FPLINE Register                               */  \
    { 0x0048,           0x003B },   /* LCD1 FPLINE Pulse Position Register                */  \
    { 0x004A,           0x020C },   /* LCD1 Vertical Total Register                       */  \
    { 0x004C,           0x01DF },   /* LCD1 Vertical Display Period Register              */  \
    { 0x004E,           0x002C },   /* LCD1 Vertical Display Period Start Position Register */  \
    { 0x0050,           0x0087 },   /* LCD1 FPFRAME Register                              */  \
    { 0x0052,           0x0002 },   /* LCD1 FPFRAME Pulse Position Register               */  \
    { 0x0054,           0x0003 },   /* LCD1 Serial Interface Setting Register             */  \
    { 0x0056,           0x0006 },   /* LCD1 Parallel Interface Setting Register           */  \
    { 0x0058,           0x0000 },   /* LCD2 Horizontal Display Period Register            */  \
    { 0x005A,           0x0000 },   /* LCD2 Vertical Display Period Register              */  \
    { 0x005C,           0x0001 },   /* LCD2 Serial Interface Setting Register             */  \
    { 0x005E,           0x0000 },   /* LCD2 Parallel Interface Setting Register           */  \
    { 0x0180,           0x0FC0 },   /* I2C Status Register                                */  \
    { 0x0200,           0x0035 },   /* Display Mode Setting Register 0                    */  \
    { 0x0202,           0x0400 },   /* Display Mode Setting Register 1                    */  \
    { 0x0204,           0x0000 },   /* Transparent Overlay Key Color Red Data Register    */  \
    { 0x0206,           0x0000 },   /* Transparent Overlay Key Color Green Data Register  */  \
    { 0x0208,           0x0000 },   /* Transparent Overlay Key Color Blue Data Register   */  \
    { 0x0210,           0x0000 },   /* Main Window Display Start Address Register 0       */  \
    { 0x0212,           0x0000 },   /* Main Window Display Start Address Register 1       */  \
    { 0x0216,           0x0500 },   /* Main Window Line Address Offset Register           */  \
    { 0x0218,           0xC000 },   /* PIP+ Display Start Address Register 0              */  \
    { 0x021A,           0x0004 },   /* PIP+ Display Start Address Register 1              */  \
    { 0x021E,           0x0280 },   /* PIP+ Window Line Address Offset Register           */  \
    { 0x0220,           0x0000 },   /* PIP+ X Start Positions Register                    */  \
    { 0x0222,           0x0000 },   /* PIP+ Y Start Positions Register                    */  \
    { 0x0224,           0x013F },   /* PIP+ X End Positions Register                      */  \
    { 0x0226,           0x00EF },   /* PIP+ Y End Positions Register                      */  \
    { 0x022A,           0x0000 },   /* Back Buffer Display Start Address Register 0       */  \
    { 0x022C,           0x0000 },   /* Back Buffer Display Start Address Register 1       */  \
    { 0x0240,           0x0545 },   /* YUV/RGB Converter 1 Translate Mode Register        */  \
    { 0x0242,           0xC000 },   /* YUV/RGB Converter 1 Write Start Address Register 0 */  \
    { 0x0244,           0x0004 },   /* YUV/RGB Converter 1 Write Start Address Register 1 */  \
    { 0x0246,           0x0000 },   /* YUV/RGB Converter 1 Write Start Address 1 Register 0 */  \
    { 0x0248,           0x0000 },   /* YUV/RGB Converter 1 Write Start Address 1 Register 1 */  \
    { 0x024A,           0x0000 },   /* YUV/RGB Converter 1 UV Data Clip Register          */  \
    { 0x024C,           0x00A0 },   /* YUV/RGB Converter 1 Rectangular Pixel Width Register */  \
    { 0x024E,           0x00A0 },   /* YUV/RGB Converter 1 Rectangular Line Address Offset Register */  \
    { 0x0260,           0x0005 },   /* RGB/YUV Converter Configuration Register           */  \
    { 0x0264,           0x0000 },   /* RGB/YUV Converter Horizontal Display Size Register */  \
    { 0x0266,           0x0000 },   /* RGB/YUV Converter Vertical Display Size Register   */  \
    { 0x0284,           0x0000 },   /* Main Window Swivel View Offset Register 0          */  \
    { 0x0286,           0x0000 },   /* Main Window Swivel View Offset Register 1          */  \
    { 0x028C,           0x0000 },   /* Main Window Swivel View Offset Register 0          */  \
    { 0x028E,           0x0000 },   /* PIP Window Swivel View Offset Register 1           */  \
    { 0x0310,           0x0000 },   /* Average Overlay Key Color Red Data Register        */  \
    { 0x0312,           0x0000 },   /* Average Overlay Key Color Green Data Register      */  \
    { 0x0314,           0x0000 },   /* Average Overlay Key Color Blue Data Register       */  \
    { 0x0316,           0x0000 },   /* AND Overlay Key Color Red Data Register            */  \
    { 0x0318,           0x0000 },   /* AND Overlay Key Color Green Data Register          */  \
    { 0x031A,           0x0000 },   /* AND Overlay Key Color Blue Data Register           */  \
    { 0x031C,           0x0000 },   /* OR Overlay Key Color Red Data Register             */  \
    { 0x031E,           0x0000 },   /* OR Overlay Key Color Green Data Register           */  \
    { 0x0320,           0x0000 },   /* OR Overlay Key Color Blue Data Register            */  \
    { 0x0322,           0x0000 },   /* INV Overlay Key Color Red Data Register            */  \
    { 0x0324,           0x0000 },   /* INV Overlay Key Color Green Data Register          */  \
    { 0x0326,           0x0000 },   /* INV Overlay Key Color Blue Data Register           */  \
    { 0x0328,           0x0000 },   /* Overlay Miscellaneous Register                     */  \
    { 0x092C,           0xFFFC },   /* Resizer Camera Input Line Buffer SRAM End Address Register 0 */  \
    { 0x092E,           0x000C },   /* Resizer Camera Input Line Buffer SRAM End Address Register 1 */  \
    { 0x0930,           0x0001 },   /* Global Resize Control Register                     */  \
    { 0x0932,           0x0030 },   /* Resizer Mode Select Register                       */  \
    { 0x0940,           0x0000 },   /* Preview Trimming Start X Position Register         */  \
    { 0x0942,           0x0000 },   /* Preview Trimming Start Y Position Register         */  \
    { 0x0944,           0x027F },   /* Preview Trimming End X Position Register           */  \
    { 0x0946,           0x01DF },   /* Preview Trimming End Y Position Register           */  \
    { 0x0948,           0x0000 },   /* Capture Trimming Start X Position Register         */  \
    { 0x094A,           0x0000 },   /* Capture Trimming Start Y Position Register         */  \
    { 0x094C,           0x027F },   /* Capture Trimming End X Position Register           */  \
    { 0x094E,           0x01DF },   /* Capture Trimming End Y Position Register           */  \
    { 0x0950,           0x0001 },   /* View Resizer Control Register                      */  \
    { 0x0954,           0x0140 },   /* View Resizer Horizontal Output Size Register       */  \
    { 0x0956,           0x00F0 },   /* View Resizer Vertical Output Size Register         */  \
    { 0x095C,           0x2000 },   /* View Resizer Line Buffer SRAM Start Address Register */  \
    { 0x0960,           0x0000 },   /* Capture Resizer Control Register                   */  \
    { 0x0964,           0x0280 },   /* Capture Resizer Horizontal Output Size Register    */  \
    { 0x0966,           0x01E0 },   /* Capture Resizer Vertical Output Size Register      */  \
    { 0x096C,           0x0000 },   /* Capture Resizer Line Buffer SRAM Start Address Register */  \
    { 0x0974,           0x0000 },   /* SRAM Read Width Register                           */  \
    { 0x0976,           0x0000 },   /* SRAM Read Height Register                          */  \
    { 0x0978,           0x0000 },   /* SRAM Read Start Address Register 0                 */  \
    { 0x097A,           0x0000 },   /* SRAM Read Start Address Register 1                 */  \
    { 0x097C,           0x0000 },   /* SRAM Read Line Offset Register                     */  \
    { 0x0980,           0x0000 },   /* JPEG Control Register                              */  \
    { 0x09A0,           0x0020 },   /* JPEG FIFO Control Register                         */  \
    { 0x09A4,           0x001F },   /* JPEG FIFO Size Register                            */  \
    { 0x09B0,           0x0000 },   /* Encode Size Limit Register 0                       */  \
    { 0x09B2,           0x0020 },   /* Encode Size Limit Register 1                       */  \
    { 0x09BC,           0x0140 },   /* JPEG FIFO Start Address Register 0 [READONLY]      */  \
    { 0x09BE,           0x0000 },   /* JPEG FIFO Start Address Register 1 [READONLY]      */  \
    { 0x09D0,           0x0000 },   /* JPEG Line Buffer Configuration Register            */  \
    { 0x09D2,           0x0000 },   /* JPEG Line Buffer Start Address Register            */  \
    { 0x0100,           0x0002 },   /* Camera Clock Setting Register                      */  \
    { 0x0110,           0x1800 },   /* Camera Mode Setting Register                       */  \
    { 0x0102,           0x0012 },   /* Camera Signal Setting Register                     */  \
    { 0x0112,           0x0000 },   /* Camera Frame Setting Register                      */  \
    { 0x0114,           0x0000 },   /* Camera Control Register [WRITEONLY]                */  \
    { 0x0A02,           0x0000 },   /* Interrupt Control Register                         */  \
    { 0x0A06,           0x0000 },   /* LCD Interrupt Flag Register                        */  \
    { 0x0A08,           0x0000 },   /* LCD Interrupt Control Register                     */  \
    { 0x0A0A,           0x0000 },   /* Host Interface Interrupt Flag Register             */  \
    { 0x0A0C,           0x0000 },   /* Host Interface Interrupt Control Register          */  \
    { 0x0A0E,           0x1F1F },   /* Cycle Cycle Time Out Control Register              */  \
    { 0x6100,           0x0021 },   /* SD Memory Card Control Register 0                  */  \
    { S1D_REGDELAYON,   0x0000 }    /* LCD PANEL POWER ON DELAY (in ms)                   */  \
  }


