/*==================================================================
**  Generic Header information generated by 13A05CFG.EXE (Build 15)
**  Copyright (c) 2000,2001 Epson Research and Development, Inc.
**  All rights reserved.
**
++  This file is subject to the terms and conditions of the GNU General Public
++  License. See the file COPYING in the main directory of this archive for
++  more details.
++
**  Panel: 320x240 67Hz Mono 4-Bit STN (PCLK=6.000MHz)
**
**  This file defines the configuration environment and registers,
**  which can be used by any software, such as display drivers.
**
**  Note: If you transfer this file to any non-PC system, use ASCII
**  mode (not BINARY) to maintain system-specific line terminators.
++
++  This file was tested on Epson S5U13A05B00C with 
++  ALPS LRUBL616XA-1 320x240 4Bit STN Mono Single 5V Panel
++  U7 = 6.144MHz
++  U6 = 40.000MHz
++  Dip switches:  Closed: 1,2,4, Open: 3,5,6,7,8
++  JP1: 2-3, JP2: 2-3, JP3: 2-3, JP4: Out, JP5: 1-2

**==================================================================*/

#define S1D_13A05
#define S1D_DISPLAY_WIDTH               320
#define S1D_DISPLAY_HEIGHT              240
#define S1D_DISPLAY_BPP                 4
#define S1D_DISPLAY_SCANLINE_BYTES      160
#define S1D_DISPLAY_FRAME_RATE          67
#define S1D_DISPLAY_PCLK                6000000L
#define S1D_PHYSICAL_REG_ADDR           0x00000000L
#define S1D_PHYSICAL_BLT_ADDR           0x00010000L
#define S1D_PHYSICAL_VMEM_ADDR          0x00000000L
#define S1D_PHYSICAL_REG_SIZE           36864L
#define S1D_PHYSICAL_VMEM_SIZE          262144L
#define S1D_PHYSICAL_VMEM_REQUIRED      38400L
#define S1D_PALETTE_SIZE                256
#define S1D_POWER_DELAY_OFF             1200
#define S1D_POWER_DELAY_ON              50
#define S1D_HWBLT
#define S1D_SWBLT
#define S1D_REGRESERVED                 0xF0
#define S1D_REGDELAYOFF                 0xFD
#define S1D_REGDELAYON                  0xFE

#define S1D_WRITE_PALETTE(p,i,r,g,b)  \
  (((volatile S1D_VALUE*)(p))[0x18/sizeof(S1D_VALUE)] = (S1D_VALUE)(i)<<24 | (S1D_VALUE)(r)<<16 | (S1D_VALUE)(g)<<8 | (b))

#define S1D_READ_PALETTE(p,i,r,g,b)  \
  {  \
    S1D_VALUE reg;  \
    ((volatile S1D_VALUE*)(p))[0x1C/sizeof(S1D_VALUE)] = (S1D_VALUE)(i)<<24;  \
    reg = ((volatile S1D_VALUE*)(p))[0x1C/sizeof(S1D_VALUE)];  \
    (r) = (reg>>16)&0xFF;  \
    (g) = (reg>>8)&0xFF;  \
    (b) = reg&0xFF;  \
  }

typedef unsigned char S1D_INDEX;
typedef unsigned long S1D_VALUE;
typedef struct
{
    S1D_INDEX Index;
    S1D_VALUE Value;
} S1D_REGS;

#define S1D_INSTANTIATE_REGISTERS(scope_prefix,variable_name)  \
  scope_prefix S1D_REGS variable_name[] =  \
  {  \
    { 0x64,             0x00010000 },   /* GPIO Status and Control Register                   */  \
    { 0x68,             0x00000000 },   /* GPO Control Register                               */  \
    { 0x04,             0x00000000 },   /* Memory Clock Configuration Register                */  \
    { 0x08,             0x00000003 },   /* Pixel Clock Configuration Register                 */  \
    { 0x0C,             0x00000000 },   /* Panel Type and MOD Rate Register                   */  \
    { 0x10,             0x00000004 },   /* Display Settings Register                          */  \
    { 0x20,             0x0000002B },   /* Horizontal Total Register                          */  \
    { 0x24,             0x00000027 },   /* Horizontal Display Period Register                 */  \
    { 0x28,             0x00000000 },   /* Horizontal Display Period Start Position Register  */  \
    { 0x2C,             0x00870156 },   /* FPLINE Register                                    */  \
    { 0x30,             0x000000FA },   /* Vertical Total Register                            */  \
    { 0x34,             0x000000EF },   /* Vertical Display Period Register                   */  \
    { 0x38,             0x00000000 },   /* Vertical Display Period Start Position Register    */  \
    { 0x3C,             0x00800000 },   /* FPFRAME Register                                   */  \
    { 0x40,             0x00000000 },   /* Main Window Display Start Address Register         */  \
    { 0x44,             0x00000028 },   /* Main Window Line Address Offset Register           */  \
    { 0x48,             0x00000000 },   /* Extended Panel Type Register                       */  \
    { 0x50,             0x00000000 },   /* PIP+ Window Display Start Address Register         */  \
    { 0x54,             0x00000028 },   /* PIP+ Window Line Address Offset Register           */  \
    { 0x58,             0x00000000 },   /* PIP+ Window X Positions Register                   */  \
    { 0x5C,             0x00000000 },   /* PIP+ Window Y Positions Register                   */  \
    { 0x60,             0x00000000 },   /* Special Purpose Register                           */  \
    { 0x70,             0x00000000 },   /* PWM Clock Configuration Register                   */  \
    { 0x74,             0x00000000 },   /* PWMOUT Duty Cycle Register                         */  \
    { 0x80,             0x00000000 },   /* Scratch Pad A Register                             */  \
    { 0x84,             0x00000000 },   /* Scratch Pad B Register                             */  \
    { 0x88,             0x00000000 },   /* Scratch Pad C Register                             */  \
    { 0xA0,             0x0000012C },   /* HR-TFT CLS Width Register                          */  \
    { 0xA4,             0x00000032 },   /* HR-TFT PS1 Rising Edge Register                    */  \
    { 0xA8,             0x00000064 },   /* HR-TFT PS2 Rising Edge Register                    */  \
    { 0xAC,             0x0000000A },   /* HR-TFT PS2 Toggle Width Register                   */  \
    { 0xB0,             0x00000064 },   /* HR-TFT PS3 Signal Width Register                   */  \
    { 0xB4,             0x0000000A },   /* HR-TFT REV Toggle Point Register                   */  \
    { 0xB8,             0x00000007 },   /* HR-TFT PS1/2 End Register                          */  \
    { 0xBC,             0x00000000 },   /* Type 2 TFT Configuration Register                  */  \
    { 0xC0,             0x09180E09 },   /* Casio TFT Timing Register                          */  \
    { 0xD8,             0x00000000 },   /* Type 3 TFT Configuration Register 0                */  \
    { 0xDC,             0x00000000 },   /* Type 3 TFT Configuration Register 1                */  \
    { 0xE0,             0x00000000 },   /* Type 3 TFT PCLK Divide Register                    */  \
    { 0xE4,             0x00000000 },   /* Type 3 TFT Partial Mode Display Area Control Register */  \
    { 0xE8,             0x00000000 },   /* Type 3 TFT Partial Area 0 Positions Register       */  \
    { 0xEC,             0x00000000 },   /* Type 3 TFT Partial Area 1 Positions Register       */  \
    { 0xF0,             0x00000000 },   /* Type 3 TFT Partial Area 2 Positions Register       */  \
    { 0xF4,             0x00000000 },   /* Type 3 TFT Command Store Register                  */  \
    { 0xF8,             0x00000000 },   /* Type 3 TFT Miscellaneous Register                  */  \
    { 0x14,             0x00000000 },   /* Power Save Configuration Register                  */  \
    { S1D_REGDELAYON,   0x00000032 },   /* LCD Panel Power On Delay (in ms)                   */  \
    { 0x68,             0x00000001 },   /* GPO Control Register                               */  \
    { 0x64,             0x00010001 }    /* GPIO Status and Control Register                   */  \
  }
