//============================================================================
//
//  Copyright (c) 2000,2005 Epson Research and Development, Inc.
//  All rights reserved.
//
//  This file is subject to the terms and conditions of the GNU General Public
//  License. See the file COPYING in the main directory of this archive for
//  more details.
//
//=============================================================================

// This file is for ram based LCD L2F50216T00. Resolution=176X220
typedef unsigned short LCD_INDEX;
typedef unsigned short LCD_VALUE;
typedef struct
{
    LCD_INDEX Index;
    LCD_VALUE Value;
} LCD_REGS;


#define LCD_INSTANTIATE_REGISTERS(scope_prefix,variable_name)  \
  scope_prefix LCD_REGS variable_name[] =  \
  {  \
    { S1D_REGDELAYON,  0x0064 },    \
    { 0x003C,           0x0000 },   \
    { 0x0202,           0x0400 },   \
    { 0x0034,           0x00B0 },   \
    { 0x0036,           0x00CA },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x00F8 },   \
    { 0x0036,           0x00DC },   \
    { 0x0036,           0x000E },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0080 },   \
    { 0x0034,           0x0026 },   \
    { 0x0036,           0x0001 },   \
    { 0x0034,           0x00B1 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0002 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0008 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0010 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0010 },   \
    { 0x0036,           0x0001 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0040 },   \
    { 0x0036,           0x0020 },   \
    { 0x0036,           0x0082 },   \
    { 0x0036,           0x0010 },   \
    { 0x0036,           0x0088 },   \
    { 0x0036,           0x0092 },   \
    { 0x0036,           0x004A },   \
    { 0x0036,           0x00AB },   \
    { 0x0036,           0x005B },   \
    { 0x0036,           0x00AD },   \
    { 0x0036,           0x006B },   \
    { 0x0036,           0x007F },   \
    { 0x0036,           0x00FF },   \
    { 0x0036,           0x00FF },   \
    { 0x0036,           0x0080 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0034,           0x00B2 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0002 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0008 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0010 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0010 },   \
    { 0x0036,           0x0001 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0040 },   \
    { 0x0036,           0x0020 },   \
    { 0x0036,           0x0082 },   \
    { 0x0036,           0x0010 },   \
    { 0x0036,           0x0088 },   \
    { 0x0036,           0x0092 },   \
    { 0x0036,           0x004A },   \
    { 0x0036,           0x00AB },   \
    { 0x0036,           0x005B },   \
    { 0x0036,           0x00AD },   \
    { 0x0036,           0x006B },   \
    { 0x0036,           0x007F },   \
    { 0x0036,           0x00FF },   \
    { 0x0036,           0x00FF },   \
    { 0x0036,           0x0080 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0034,           0x002A },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0002 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x00B1 },   \
    { 0x0034,           0x002B },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x0000 },   \
    { 0x0036,           0x00DB },   \
    { 0x0034,           0x0036 },   \
    { 0x0036,           0x0040 },   \
    { 0x0034,           0x003A },   \
    { 0x0036,           0x0005 },   \
    { 0x0034,           0x00BA },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0036,           0x0055 },   \
    { 0x0034,           0x0011 },   \
    { S1D_REGDELAYON,   0x0064 },   \
    { 0x0034,   	0x0029 },   \
    { 0x0034,   	0x002C },   \
    { 0x003C,   	0x0000 }    \
  }
