/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
 
/******************************************************************************
   Module      : keypad.h
   Date        : 2003-08-08
   Description :
      Driver Module for the keypad hardware of INCA-IP
******************************************************************************/
#ifndef _inca_keypad_H
#define _inca_keypad_H

#ifdef __KERNEL__
typedef int (*keypad_callback_t) (char key, int updown, 
					unsigned long timestamp);

/* Function Prototypes */
extern int 	inca_key_register_callback	(keypad_callback_t fp);
extern int 	inca_key_unregister_callback	(void);
#endif

typedef struct {
	char 		key_code;
	int 		key_state;
	unsigned long 	time_stamp;
} key_event_t;

/* IOCTLs */
#define KEYPAD_GET	_IOR('G', 1, key_event_t)

/* other defines */
#define KEY_FIFO_DEPTH	32

#define KEY_RELEASED 	0
#define KEY_PRESSED	1


#endif /* _inca_keypad_H */
