/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
 
/*
 * mux.h
 *
 * Global Inca-IP multiplexer header file
 *
 * Andre Messerschmidt 
 *
 * For questions about this file please contact your local Infineon 
 * representative.
 *
 */

#ifndef MUX_H
#define MUX_H

#define INCAIP_MUX_IOM2_FSC	0x00000001
#define INCAIP_MUX_IOM2_DCL	0x00000002
#define INCAIP_MUX_IOM2_DU	0x00000004
#define INCAIP_MUX_IOM2_DD	0x00000008
#define INCAIP_MUX_IOM2_SDS	0x00000010
#define INCAIP_MUX_IOM2_BCL	0x00000020

#define INCAIP_MUX_ASC_RXD	0x00000001
#define INCAIP_MUX_ASC_TXD	0x00000002

#define INCAIP_MUX_EXIN0	0x00000001
#define INCAIP_MUX_EXIN1	0x00000002
#define INCAIP_MUX_EXIN2	0x00000004
#define INCAIP_MUX_EXIN3	0x00000008
#define INCAIP_MUX_EXIN4	0x00000010
#define INCAIP_MUX_EXIN5	0x00000020

#define INCAIP_MUX_P0_0		0x00000001
#define INCAIP_MUX_P0_1		0x00000002
#define INCAIP_MUX_P0_2		0x00000004
#define INCAIP_MUX_P0_3		0x00000008
#define INCAIP_MUX_P0_4		0x00000010
#define INCAIP_MUX_P0_5		0x00000020
#define INCAIP_MUX_P0_6		0x00000040
#define INCAIP_MUX_P0_7		0x00000080
#define INCAIP_MUX_P0_8		0x00000100
#define INCAIP_MUX_P0_9		0x00000200
#define INCAIP_MUX_P0_10	0x00000400

#define INCAIP_MUX_P1_0		0x00000001
#define INCAIP_MUX_P1_1		0x00000002
#define INCAIP_MUX_P1_2		0x00000004
#define INCAIP_MUX_P1_3		0x00000008
#define INCAIP_MUX_P1_4		0x00000010
#define INCAIP_MUX_P1_5		0x00000020
#define INCAIP_MUX_P1_6		0x00000040
#define INCAIP_MUX_P1_7		0x00000080
#define INCAIP_MUX_P1_8		0x00000100
#define INCAIP_MUX_P1_9		0x00000200
#define INCAIP_MUX_P1_10	0x00000400
#define INCAIP_MUX_P1_11	0x00000800
#define INCAIP_MUX_P1_12	0x00001000
#define INCAIP_MUX_P1_13	0x00002000
#define INCAIP_MUX_P1_14	0x00004000
#define INCAIP_MUX_P1_15	0x00008000
#define INCAIP_MUX_P1_16	0x00010000
#define INCAIP_MUX_P1_17	0x00020000
#define INCAIP_MUX_P1_18	0x00040000
#define INCAIP_MUX_P1_19	0x00080000
#define INCAIP_MUX_P1_20	0x00100000
#define INCAIP_MUX_P1_21	0x00200000
#define INCAIP_MUX_P1_22	0x00400000
#define INCAIP_MUX_P1_23	0x00800000

#define INCAIP_MUX_P2_0		0x00000001
#define INCAIP_MUX_P2_1		0x00000002
#define INCAIP_MUX_P2_2		0x00000004
#define INCAIP_MUX_P2_3		0x00000008
#define INCAIP_MUX_P2_4		0x00000010
#define INCAIP_MUX_P2_5		0x00000020
#define INCAIP_MUX_P2_6		0x00000040
#define INCAIP_MUX_P2_7		0x00000080
#define INCAIP_MUX_P2_8		0x00000100
#define INCAIP_MUX_P2_9		0x00000200
#define INCAIP_MUX_P2_10	0x00000400
#define INCAIP_MUX_P2_11	0x00000800
#define INCAIP_MUX_P2_12	0x00001000
#define INCAIP_MUX_P2_13	0x00002000
#define INCAIP_MUX_P2_14	0x00004000
#define INCAIP_MUX_P2_15	0x00008000
#define INCAIP_MUX_P2_16	0x00010000
#define INCAIP_MUX_P2_17	0x00020000
#define INCAIP_MUX_P2_18	0x00040000
#define INCAIP_MUX_P2_19	0x00080000
#define INCAIP_MUX_P2_20	0x00100000
#define INCAIP_MUX_P2_21	0x00200000


void inca_mux_init(void);
int inca_mux_addr_pins(void);
int inca_mux_led_pins(void);
int inca_mux_key_pins(void);
u32 inca_mux_gpio_pins(int port);
u32 inca_mux_asc_pins(void);
u32 inca_mux_ssc1_pins(void);
u32 inca_mux_ssc2_pins(void);
u32 inca_mux_iom_pins(void);
u32 inca_mux_pwm1_pins(void);
u32 inca_mux_pwm2_pins(void);
u32 inca_mux_exin_pins(void);


#endif /* MUX_H */


