/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/
 
/*
 * Global Inca-IP port driver header file
 *
 * Andre Messerschmidt 
 *
 * For questions about this file please contact your local Infineon 
 * representative.
 *
 */

#ifndef PORT_H
#define PORT_H

struct inca_port_ioctl_parm {
	int port;
	int pin;
	int value;
};

#define INCA_PORT_IOC_MAGIC	0xbf
#define INCA_PORT_IOCOD		_IOW(INCA_PORT_IOC_MAGIC,0,struct inca_port_ioctl_parm)
#define INCA_PORT_IOCPUDSEL	_IOW(INCA_PORT_IOC_MAGIC,1,struct inca_port_ioctl_parm)
#define INCA_PORT_IOCPUDEN	_IOW(INCA_PORT_IOC_MAGIC,2,struct inca_port_ioctl_parm)
#define INCA_PORT_IOCSTOFF	_IOW(INCA_PORT_IOC_MAGIC,3,struct inca_port_ioctl_parm)
#define INCA_PORT_IOCDIR		_IOW(INCA_PORT_IOC_MAGIC,4,struct inca_port_ioctl_parm)
#define INCA_PORT_IOCOUTPUT	_IOW(INCA_PORT_IOC_MAGIC,5,struct inca_port_ioctl_parm)
#define INCA_PORT_IOCINPUT	_IOWR(INCA_PORT_IOC_MAGIC,6,struct inca_port_ioctl_parm)


int inca_port_reserve_pin(int port, int pin, int module_id);
int inca_port_free_pin(int port, int pin, int module_id);
int inca_port_set_open_drain(int port, int pin, int module_id);
int inca_port_clear_open_drain(int port, int pin, int module_id);
int inca_port_set_pudsel(int port, int pin, int module_id);
int inca_port_clear_pudsel(int port, int pin, int module_id);
int inca_port_set_puden(int port, int pin, int module_id);
int inca_port_clear_puden(int port, int pin, int module_id);
int inca_port_set_stoff(int port, int pin, int module_id);
int inca_port_clear_stoff(int port, int pin, int module_id);
int inca_port_set_dir_out(int port, int pin, int module_id);
int inca_port_set_dir_in(int port, int pin, int module_id);
int inca_port_set_output(int port, int pin, int module_id);
int inca_port_clear_output(int port, int pin, int module_id);
int inca_port_get_input(int port, int pin, int module_id);


#endif /* PORT_H */


