/******************************************************************************
 *
 *
 *
 * Copyright 2000 Infineon Technologies Bangalore,India, ., All Rights Reserved
 *	
 *	
 *	
 * Revision History
 *	
 * Name					Date								Description
 * ============	======	================================================
 * Manamohan shetty		5/8/2002						Phase I Release
 *
 *                      4/12/2002                       Phase II Release 
 *                      3/6/2003                        Removed constant declerations (see pr_const.h)  
 * DESCRIPTION : This file contains the constants and forward declarations for 
 *               MAC address(MA) table configuration API's
 *
 ******************************************************************************/

#ifndef _INCAIP2_MAILBOX_H_
#define _INCAIP2_MAILBOX_H_

#define CMD_VOICEREC_STATUS_PACKET  0x0
#define CMD_VOICEREC_DATA_PACKET    0x1
#define CMD_RTP_VOICE_DATA_PACKET   0x4
#define CMD_RTP_EVENT_PACKET        0x5
#define CMD_ADDRESS_PACKET          0x8
#define CMD_FAX_DATA_PACKET         0x10
#define CMD_FAX_STATUS_PACKET       0x11
#define CMD_P_PHONE_DATA_PACKET     0x12
#define CMD_P_PHONE_STATUS_PACKET   0x13
#define CMD_CID_DATA_PACKET         0x14

#define CMD_ALI_PACKET         0x1
#define CMD_COP_PACKET         0x2
#define CMD_EOP_PACKET         0x6

typedef struct
{
   u8   *pData;      /**< Pointer to data location in SDRAM to be passed to other CPU */
   u32  nDataBytes; /**< Amount of valid data bytes in SDRAM starting at pData */ 
   u32  RTP_PaylOffset;
   u8   cmd_type;
} mps_message;

typedef enum
{
   unknown,
   command,
   voice0,
   voice1,
   voice2,
   voice3
} mps_devices;

#endif    /* _INCAIP2_MAILBOX_H_ */
