/************************************************************************
 *
 * Copyright (c) 2005
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

/* irq.h - INCA-IP2 interrupts */

#ifndef __INCAIP2_IRQ_H
#define __INCAIP2_IRQ_H

/************************************************************************
 *  Interrupt information
*************************************************************************/

/* these vectors are to handle the interrupts from the internal INCA-IP2
   interrupt controller. The INT_NUM values are really just indices into
   an array and are set up so that we can use the INT_NUM as a shift
   to calculate a mask value. */
#define INT_NUM_IRQ0		0x00
#define INT_NUM_IM0_IRL0	(INT_NUM_IRQ0 + 0) 
#define INT_NUM_IM0_IRL1	(INT_NUM_IRQ0 + 1) 
#define INT_NUM_IM0_IRL2	(INT_NUM_IRQ0 + 2) 
#define INT_NUM_IM0_IRL3	(INT_NUM_IRQ0 + 3) 
#define INT_NUM_IM0_IRL4	(INT_NUM_IRQ0 + 4) 
#define INT_NUM_IM0_IRL5	(INT_NUM_IRQ0 + 5) 
#define INT_NUM_IM0_IRL6	(INT_NUM_IRQ0 + 6) 
#define INT_NUM_IM0_IRL7	(INT_NUM_IRQ0 + 7) 
#define INT_NUM_IM0_IRL8	(INT_NUM_IRQ0 + 8) 
#define INT_NUM_IM0_IRL9	(INT_NUM_IRQ0 + 9) 
#define INT_NUM_IM0_IRL10	(INT_NUM_IRQ0 + 10) 
#define INT_NUM_IM0_IRL11	(INT_NUM_IRQ0 + 11) 
#define INT_NUM_IM0_IRL12	(INT_NUM_IRQ0 + 12) 
#define INT_NUM_IM0_IRL13	(INT_NUM_IRQ0 + 13) 
#define INT_NUM_IM0_IRL14	(INT_NUM_IRQ0 + 14) 
#define INT_NUM_IM0_IRL15	(INT_NUM_IRQ0 + 15) 
#define INT_NUM_IM0_IRL16	(INT_NUM_IRQ0 + 16) 
#define INT_NUM_IM0_IRL17	(INT_NUM_IRQ0 + 17) 
#define INT_NUM_IM0_IRL18	(INT_NUM_IRQ0 + 18) 
#define INT_NUM_IM0_IRL19	(INT_NUM_IRQ0 + 19) 
#define INT_NUM_IM0_IRL20	(INT_NUM_IRQ0 + 20) 
#define INT_NUM_IM0_IRL21	(INT_NUM_IRQ0 + 21) 
#define INT_NUM_IM0_IRL22	(INT_NUM_IRQ0 + 22) 
#define INT_NUM_IM0_IRL23	(INT_NUM_IRQ0 + 23) 
#define INT_NUM_IM0_IRL24	(INT_NUM_IRQ0 + 24) 
#define INT_NUM_IM0_IRL25	(INT_NUM_IRQ0 + 25) 
#define INT_NUM_IM0_IRL26	(INT_NUM_IRQ0 + 26) 
#define INT_NUM_IM0_IRL27	(INT_NUM_IRQ0 + 27) 
#define INT_NUM_IM0_IRL28	(INT_NUM_IRQ0 + 28) 
#define INT_NUM_IM0_IRL29	(INT_NUM_IRQ0 + 29) 
#define INT_NUM_IM0_IRL30	(INT_NUM_IRQ0 + 30) 
#define INT_NUM_IM0_IRL31	(INT_NUM_IRQ0 + 31) 

#define INT_NUM_IM1_IRL0	(INT_NUM_IRQ0 + 32 + 0) 
#define INT_NUM_IM1_IRL1	(INT_NUM_IRQ0 + 32 + 1) 
#define INT_NUM_IM1_IRL2	(INT_NUM_IRQ0 + 32 + 2) 
#define INT_NUM_IM1_IRL3	(INT_NUM_IRQ0 + 32 + 3) 
#define INT_NUM_IM1_IRL4	(INT_NUM_IRQ0 + 32 + 4) 
#define INT_NUM_IM1_IRL5	(INT_NUM_IRQ0 + 32 + 5) 
#define INT_NUM_IM1_IRL6	(INT_NUM_IRQ0 + 32 + 6) 
#define INT_NUM_IM1_IRL7	(INT_NUM_IRQ0 + 32 + 7) 
#define INT_NUM_IM1_IRL8	(INT_NUM_IRQ0 + 32 + 8) 
#define INT_NUM_IM1_IRL9	(INT_NUM_IRQ0 + 32 + 9) 
#define INT_NUM_IM1_IRL10	(INT_NUM_IRQ0 + 32 + 10) 
#define INT_NUM_IM1_IRL11	(INT_NUM_IRQ0 + 32 + 11) 
#define INT_NUM_IM1_IRL12	(INT_NUM_IRQ0 + 32 + 12) 
#define INT_NUM_IM1_IRL13	(INT_NUM_IRQ0 + 32 + 13) 
#define INT_NUM_IM1_IRL14	(INT_NUM_IRQ0 + 32 + 14) 
#define INT_NUM_IM1_IRL15	(INT_NUM_IRQ0 + 32 + 15) 
#define INT_NUM_IM1_IRL16       (INT_NUM_IRQ0 + 32 + 16) 
#define INT_NUM_IM1_IRL17	(INT_NUM_IRQ0 + 32 + 17) 
#define INT_NUM_IM1_IRL18	(INT_NUM_IRQ0 + 32 + 18) 
#define INT_NUM_IM1_IRL19	(INT_NUM_IRQ0 + 32 + 19) 
#define INT_NUM_IM1_IRL20	(INT_NUM_IRQ0 + 32 + 20) 
#define INT_NUM_IM1_IRL21	(INT_NUM_IRQ0 + 32 + 21) 
#define INT_NUM_IM1_IRL22	(INT_NUM_IRQ0 + 32 + 22) 
#define INT_NUM_IM1_IRL23	(INT_NUM_IRQ0 + 32 + 23) 
#define INT_NUM_IM1_IRL24	(INT_NUM_IRQ0 + 32 + 24) 
#define INT_NUM_IM1_IRL25	(INT_NUM_IRQ0 + 32 + 25) 
#define INT_NUM_IM1_IRL26	(INT_NUM_IRQ0 + 32 + 26) 
#define INT_NUM_IM1_IRL27	(INT_NUM_IRQ0 + 32 + 27) 
#define INT_NUM_IM1_IRL28	(INT_NUM_IRQ0 + 32 + 28) 
#define INT_NUM_IM1_IRL29	(INT_NUM_IRQ0 + 32 + 29) 
#define INT_NUM_IM1_IRL30	(INT_NUM_IRQ0 + 32 + 30) 
#define INT_NUM_IM1_IRL31	(INT_NUM_IRQ0 + 32 + 31) 

#define INT_NUM_IM2_IRL0	(INT_NUM_IRQ0 + 64 + 0) 
#define INT_NUM_IM2_IRL1	(INT_NUM_IRQ0 + 64 + 1) 
#define INT_NUM_IM2_IRL2	(INT_NUM_IRQ0 + 64 + 2) 
#define INT_NUM_IM2_IRL3	(INT_NUM_IRQ0 + 64 + 3) 
#define INT_NUM_IM2_IRL4	(INT_NUM_IRQ0 + 64 + 4) 
#define INT_NUM_IM2_IRL5	(INT_NUM_IRQ0 + 64 + 5) 
#define INT_NUM_IM2_IRL6	(INT_NUM_IRQ0 + 64 + 6) 
#define INT_NUM_IM2_IRL7	(INT_NUM_IRQ0 + 64 + 7) 
#define INT_NUM_IM2_IRL8	(INT_NUM_IRQ0 + 64 + 8) 
#define INT_NUM_IM2_IRL9	(INT_NUM_IRQ0 + 64 + 9) 
#define INT_NUM_IM2_IRL10	(INT_NUM_IRQ0 + 64 + 10) 
#define INT_NUM_IM2_IRL11	(INT_NUM_IRQ0 + 64 + 11) 
#define INT_NUM_IM2_IRL12	(INT_NUM_IRQ0 + 64 + 12) 
#define INT_NUM_IM2_IRL13	(INT_NUM_IRQ0 + 64 + 13) 
#define INT_NUM_IM2_IRL14	(INT_NUM_IRQ0 + 64 + 14) 
#define INT_NUM_IM2_IRL15	(INT_NUM_IRQ0 + 64 + 15) 
#define INT_NUM_IM2_IRL16	(INT_NUM_IRQ0 + 64 + 16) 
#define INT_NUM_IM2_IRL17	(INT_NUM_IRQ0 + 64 + 17) 
#define INT_NUM_IM2_IRL18	(INT_NUM_IRQ0 + 64 + 18) 
#define INT_NUM_IM2_IRL19	(INT_NUM_IRQ0 + 64 + 19) 
#define INT_NUM_IM2_IRL20	(INT_NUM_IRQ0 + 64 + 20) 
#define INT_NUM_IM2_IRL21	(INT_NUM_IRQ0 + 64 + 21) 
#define INT_NUM_IM2_IRL22	(INT_NUM_IRQ0 + 64 + 22) 
#define INT_NUM_IM2_IRL23	(INT_NUM_IRQ0 + 64 + 23) 
#define INT_NUM_IM2_IRL24	(INT_NUM_IRQ0 + 64 + 24) 
#define INT_NUM_IM2_IRL25	(INT_NUM_IRQ0 + 64 + 25) 
#define INT_NUM_IM2_IRL26	(INT_NUM_IRQ0 + 64 + 26) 
#define INT_NUM_IM2_IRL27	(INT_NUM_IRQ0 + 64 + 27) 
#define INT_NUM_IM2_IRL28	(INT_NUM_IRQ0 + 64 + 28) 
#define INT_NUM_IM2_IRL29	(INT_NUM_IRQ0 + 64 + 29) 
#define INT_NUM_IM2_IRL30	(INT_NUM_IRQ0 + 64 + 30) 
#define INT_NUM_IM2_IRL31	(INT_NUM_IRQ0 + 64 + 31) 

#define INT_NUM_IM3_IRL0	(INT_NUM_IRQ0 + 96 + 0) 
#define INT_NUM_IM3_IRL1	(INT_NUM_IRQ0 + 96 + 1) 
#define INT_NUM_IM3_IRL2	(INT_NUM_IRQ0 + 96 + 2) 
#define INT_NUM_IM3_IRL3	(INT_NUM_IRQ0 + 96 + 3) 
#define INT_NUM_IM3_IRL4	(INT_NUM_IRQ0 + 96 + 4) 
#define INT_NUM_IM3_IRL5	(INT_NUM_IRQ0 + 96 + 5) 
#define INT_NUM_IM3_IRL6	(INT_NUM_IRQ0 + 96 + 6) 
#define INT_NUM_IM3_IRL7	(INT_NUM_IRQ0 + 96 + 7) 
#define INT_NUM_IM3_IRL8	(INT_NUM_IRQ0 + 96 + 8) 
#define INT_NUM_IM3_IRL9	(INT_NUM_IRQ0 + 96 + 9) 
#define INT_NUM_IM3_IRL10	(INT_NUM_IRQ0 + 96 + 10) 
#define INT_NUM_IM3_IRL11	(INT_NUM_IRQ0 + 96 + 11) 
#define INT_NUM_IM3_IRL12	(INT_NUM_IRQ0 + 96 + 12) 
#define INT_NUM_IM3_IRL13	(INT_NUM_IRQ0 + 96 + 13) 
#define INT_NUM_IM3_IRL14	(INT_NUM_IRQ0 + 96 + 14) 
#define INT_NUM_IM3_IRL15	(INT_NUM_IRQ0 + 96 + 15) 
#define INT_NUM_IM3_IRL16	(INT_NUM_IRQ0 + 96 + 16) 
#define INT_NUM_IM3_IRL17	(INT_NUM_IRQ0 + 96 + 17) 
#define INT_NUM_IM3_IRL18	(INT_NUM_IRQ0 + 96 + 18) 
#define INT_NUM_IM3_IRL19	(INT_NUM_IRQ0 + 96 + 19) 
#define INT_NUM_IM3_IRL20	(INT_NUM_IRQ0 + 96 + 20) 
#define INT_NUM_IM3_IRL21	(INT_NUM_IRQ0 + 96 + 21) 
#define INT_NUM_IM3_IRL22	(INT_NUM_IRQ0 + 96 + 22) 
#define INT_NUM_IM3_IRL23	(INT_NUM_IRQ0 + 96 + 23) 
#define INT_NUM_IM3_IRL24	(INT_NUM_IRQ0 + 96 + 24) 
#define INT_NUM_IM3_IRL25	(INT_NUM_IRQ0 + 96 + 25) 
#define INT_NUM_IM3_IRL26	(INT_NUM_IRQ0 + 96 + 26) 
#define INT_NUM_IM3_IRL27	(INT_NUM_IRQ0 + 96 + 27) 
#define INT_NUM_IM3_IRL28	(INT_NUM_IRQ0 + 96 + 28) 
#define INT_NUM_IM3_IRL29	(INT_NUM_IRQ0 + 96 + 29) 
#define INT_NUM_IM3_IRL30	(INT_NUM_IRQ0 + 96 + 30) 
#define INT_NUM_IM3_IRL31	(INT_NUM_IRQ0 + 96 + 31) 

#define INT_NUM_IM4_IRL0	(INT_NUM_IRQ0 + 128 + 0) 
#define INT_NUM_IM4_IRL1	(INT_NUM_IRQ0 + 128 + 1) 
#define INT_NUM_IM4_IRL2	(INT_NUM_IRQ0 + 128 + 2) 
#define INT_NUM_IM4_IRL3	(INT_NUM_IRQ0 + 128 + 3) 
#define INT_NUM_IM4_IRL4	(INT_NUM_IRQ0 + 128 + 4) 
#define INT_NUM_IM4_IRL5	(INT_NUM_IRQ0 + 128 + 5) 
#define INT_NUM_IM4_IRL6	(INT_NUM_IRQ0 + 128 + 6) 
#define INT_NUM_IM4_IRL7	(INT_NUM_IRQ0 + 128 + 7) 
#define INT_NUM_IM4_IRL8	(INT_NUM_IRQ0 + 128 + 8) 
#define INT_NUM_IM4_IRL9	(INT_NUM_IRQ0 + 128 + 9) 
#define INT_NUM_IM4_IRL10	(INT_NUM_IRQ0 + 128 + 10) 
#define INT_NUM_IM4_IRL11	(INT_NUM_IRQ0 + 128 + 11) 
#define INT_NUM_IM4_IRL12	(INT_NUM_IRQ0 + 128 + 12) 
#define INT_NUM_IM4_IRL13	(INT_NUM_IRQ0 + 128 + 13) 
#define INT_NUM_IM4_IRL14	(INT_NUM_IRQ0 + 128 + 14) 
#define INT_NUM_IM4_IRL15	(INT_NUM_IRQ0 + 128 + 15) 
#define INT_NUM_IM4_IRL16	(INT_NUM_IRQ0 + 128 + 16) 
#define INT_NUM_IM4_IRL17	(INT_NUM_IRQ0 + 128 + 17) 
#define INT_NUM_IM4_IRL18	(INT_NUM_IRQ0 + 128 + 18) 
#define INT_NUM_IM4_IRL19	(INT_NUM_IRQ0 + 128 + 19) 
#define INT_NUM_IM4_IRL20	(INT_NUM_IRQ0 + 128 + 20) 
#define INT_NUM_IM4_IRL21	(INT_NUM_IRQ0 + 128 + 21) 
#define INT_NUM_IM4_IRL22	(INT_NUM_IRQ0 + 128 + 22) 
#define INT_NUM_IM4_IRL23	(INT_NUM_IRQ0 + 128 + 23) 
#define INT_NUM_IM4_IRL24	(INT_NUM_IRQ0 + 128 + 24) 
#define INT_NUM_IM4_IRL25	(INT_NUM_IRQ0 + 128 + 25) 
#define INT_NUM_IM4_IRL26	(INT_NUM_IRQ0 + 128 + 26) 
#define INT_NUM_IM4_IRL27	(INT_NUM_IRQ0 + 128 + 27) 
#define INT_NUM_IM4_IRL28	(INT_NUM_IRQ0 + 128 + 28) 
#define INT_NUM_IM4_IRL29	(INT_NUM_IRQ0 + 128 + 29) 
#define INT_NUM_IM4_IRL30	(INT_NUM_IRQ0 + 128 + 30) 
#define INT_NUM_IM4_IRL31	(INT_NUM_IRQ0 + 128 + 31) 

#define INT_NUM_IM5_IRL0	(INT_NUM_IRQ0 + 160 + 0) 
#define INT_NUM_IM5_IRL1	(INT_NUM_IRQ0 + 160 + 1) 
#define INT_NUM_IM5_IRL2	(INT_NUM_IRQ0 + 160 + 2) 
#define INT_NUM_IM5_IRL3	(INT_NUM_IRQ0 + 160 + 3) 
#define INT_NUM_IM5_IRL4	(INT_NUM_IRQ0 + 160 + 4) 
#define INT_NUM_IM5_IRL5	(INT_NUM_IRQ0 + 160 + 5) 
#define INT_NUM_IM5_IRL6	(INT_NUM_IRQ0 + 160 + 6) 
#define INT_NUM_IM5_IRL7	(INT_NUM_IRQ0 + 160 + 7) 
#define INT_NUM_IM5_IRL8	(INT_NUM_IRQ0 + 160 + 8) 
#define INT_NUM_IM5_IRL9	(INT_NUM_IRQ0 + 160 + 9) 
#define INT_NUM_IM5_IRL10	(INT_NUM_IRQ0 + 160 + 10) 
#define INT_NUM_IM5_IRL11	(INT_NUM_IRQ0 + 160 + 11) 
#define INT_NUM_IM5_IRL12	(INT_NUM_IRQ0 + 160 + 12) 
#define INT_NUM_IM5_IRL13	(INT_NUM_IRQ0 + 160 + 13) 
#define INT_NUM_IM5_IRL14	(INT_NUM_IRQ0 + 160 + 14) 
#define INT_NUM_IM5_IRL15	(INT_NUM_IRQ0 + 160 + 15) 
#define INT_NUM_IM5_IRL16	(INT_NUM_IRQ0 + 160 + 16) 
#define INT_NUM_IM5_IRL17	(INT_NUM_IRQ0 + 160 + 17) 
#define INT_NUM_IM5_IRL18	(INT_NUM_IRQ0 + 160 + 18) 
#define INT_NUM_IM5_IRL19	(INT_NUM_IRQ0 + 160 + 19) 
#define INT_NUM_IM5_IRL20	(INT_NUM_IRQ0 + 160 + 20) 
#define INT_NUM_IM5_IRL21	(INT_NUM_IRQ0 + 160 + 21) 
#define INT_NUM_IM5_IRL22	(INT_NUM_IRQ0 + 160 + 22) 
#define INT_NUM_IM5_IRL23	(INT_NUM_IRQ0 + 160 + 23) 
#define INT_NUM_IM5_IRL24	(INT_NUM_IRQ0 + 160 + 24) 
#define INT_NUM_IM5_IRL25	(INT_NUM_IRQ0 + 160 + 25) 
#define INT_NUM_IM5_IRL26	(INT_NUM_IRQ0 + 160 + 26) 
#define INT_NUM_IM5_IRL27	(INT_NUM_IRQ0 + 160 + 27) 
#define INT_NUM_IM5_IRL28	(INT_NUM_IRQ0 + 160 + 28) 
#define INT_NUM_IM5_IRL29	(INT_NUM_IRQ0 + 160 + 29) 
#define INT_NUM_IM5_IRL30	(INT_NUM_IRQ0 + 160 + 30) 
#define INT_NUM_IM5_IRL31	(INT_NUM_IRQ0 + 160 + 31) 

/* Functions for EXINT handling */
void incaip2_enable_external_int(u32 exint, u32 mode);
void incaip2_disable_external_int(u32 exint);

#endif	/* __INCAIP2_IRQ_H */
