/************************************************************************
 *
 * Copyright (c) 2004
 * Infineon Technologies AG
 * St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 ************************************************************************/

#ifndef  _INCA_IP_H
#define  _INCA_IP_H 

#ifdef __cplusplus
	extern "C" {
#endif

/*************************************************************************/
/*   */
/*************************************************************************/
#ifndef _ASMLANGUAGE

#if ! defined( VUINT32 ) && ! defined( _SYS_DEFS_H )
typedef volatile UINT VUINT32;
#endif

#define VREG32 (VUINT32*)

#else
#define VREG32
#endif

/***********************************************************************/
/*  Module      :  TSF register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_TSF                     (0xB8000900)
/***********************************************************************/   

      
/***TSF Configuration Register***/ 
#define INCA_IP_TSF_TSF_CONF                     (VREG32 (INCA_IP_TSF + 0x0000))
#define INCA_IP_TSF_TSF_CONF_PWMEN                    (1 << 2)
#define INCA_IP_TSF_TSF_CONF_LEDEN                    (1 << 1)
#define INCA_IP_TSF_TSF_CONF_KEYEN                    (1 << 0)
      
/***Key scan Configuration Register***/ 
#define INCA_IP_TSF_KEY_CONF                     (VREG32 (INCA_IP_TSF + 0x0004))                         
#define INCA_IP_TSF_KEY_CONF_SL_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_TSF_KEY_CONF_SL_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Scan Register Line 0 and 1***/ 
#define INCA_IP_TSF_SREG01                     (VREG32 (INCA_IP_TSF + 0x0008))                         
#define INCA_IP_TSF_SREG01_RES1x_GET(value)           (((value) >> 16) & ((1 << 12) - 1))
#define INCA_IP_TSF_SREG01_RES1x_SET(value)           ((((1 << 12) - 1) &(value)) << 16)                         
#define INCA_IP_TSF_SREG01_RES0x_GET(value)           (((value) >> 0) & ((1 << 13) - 1))
#define INCA_IP_TSF_SREG01_RES0x_SET(value)           ((((1 << 13) - 1) &(value)) << 0)
      
/***Scan Register Line 2 and 3***/ 
#define INCA_IP_TSF_SREG23                     (VREG32 (INCA_IP_TSF + 0x000C))                         
#define INCA_IP_TSF_SREG23_RES3x_GET(value)           (((value) >> 16) & ((1 << 10) - 1))
#define INCA_IP_TSF_SREG23_RES3x_SET(value)           ((((1 << 10) - 1) &(value)) << 16)                         
#define INCA_IP_TSF_SREG23_RES2x_GET(value)           (((value) >> 0) & ((1 << 11) - 1))
#define INCA_IP_TSF_SREG23_RES2x_SET(value)           ((((1 << 11) - 1) &(value)) << 0)
      
/***Scan Register Line 4, 5 and 6***/ 
#define INCA_IP_TSF_SREG456                     (VREG32 (INCA_IP_TSF + 0x0010))                         
#define INCA_IP_TSF_SREG456_RES6x_GET(value)           (((value) >> 24) & ((1 << 7) - 1))
#define INCA_IP_TSF_SREG456_RES6x_SET(value)           ((((1 << 7) - 1) &(value)) << 24)                         
#define INCA_IP_TSF_SREG456_RES5x_GET(value)           (((value) >> 16) & ((1 << 8) - 1))
#define INCA_IP_TSF_SREG456_RES5x_SET(value)           ((((1 << 8) - 1) &(value)) << 16)                         
#define INCA_IP_TSF_SREG456_RES4x_GET(value)           (((value) >> 0) & ((1 << 9) - 1))
#define INCA_IP_TSF_SREG456_RES4x_SET(value)           ((((1 << 9) - 1) &(value)) << 0)
      
/***Scan Register Line 7 to 12***/ 
#define INCA_IP_TSF_SREG7to12                     (VREG32 (INCA_IP_TSF + 0x0014))
#define INCA_IP_TSF_SREG7to12_RES12x                    (1 << 28)                         
#define INCA_IP_TSF_SREG7to12_RES11x_GET(value)           (((value) >> 24) & ((1 << 2) - 1))
#define INCA_IP_TSF_SREG7to12_RES11x_SET(value)           ((((1 << 2) - 1) &(value)) << 24)                         
#define INCA_IP_TSF_SREG7to12_RES10x_GET(value)           (((value) >> 20) & ((1 << 3) - 1))
#define INCA_IP_TSF_SREG7to12_RES10x_SET(value)           ((((1 << 3) - 1) &(value)) << 20)                         
#define INCA_IP_TSF_SREG7to12_RES9x_GET(value)           (((value) >> 16) & ((1 << 4) - 1))
#define INCA_IP_TSF_SREG7to12_RES9x_SET(value)           ((((1 << 4) - 1) &(value)) << 16)                         
#define INCA_IP_TSF_SREG7to12_RES8x_GET(value)           (((value) >> 8) & ((1 << 5) - 1))
#define INCA_IP_TSF_SREG7to12_RES8x_SET(value)           ((((1 << 5) - 1) &(value)) << 8)                         
#define INCA_IP_TSF_SREG7to12_RES7x_GET(value)           (((value) >> 0) & ((1 << 6) - 1))
#define INCA_IP_TSF_SREG7to12_RES7x_SET(value)           ((((1 << 6) - 1) &(value)) << 0)
      
/***LEDMUX Configuration Register***/ 
#define INCA_IP_TSF_LEDMUX_CONF                     (VREG32 (INCA_IP_TSF + 0x0018))
#define INCA_IP_TSF_LEDMUX_CONF_ETL1                (1 << 25)
#define INCA_IP_TSF_LEDMUX_CONF_ESTA1               (1 << 24)
#define INCA_IP_TSF_LEDMUX_CONF_EDPX1               (1 << 23)
#define INCA_IP_TSF_LEDMUX_CONF_EACT1               (1 << 22)
#define INCA_IP_TSF_LEDMUX_CONF_ESPD1               (1 << 21)
#define INCA_IP_TSF_LEDMUX_CONF_ETL0                (1 << 20)
#define INCA_IP_TSF_LEDMUX_CONF_ESTA0               (1 << 19)
#define INCA_IP_TSF_LEDMUX_CONF_EDPX0               (1 << 18)
#define INCA_IP_TSF_LEDMUX_CONF_EACT0               (1 << 17)
#define INCA_IP_TSF_LEDMUX_CONF_ESPD0               (1 << 16)
#define INCA_IP_TSF_LEDMUX_CONF_INV                 (1 << 1)
#define INCA_IP_TSF_LEDMUX_CONF_NCOL                (1 << 0)
#define INCA_IP_TSF_LEDMUX_CONF_SW_MASK             0x03FF0000
#define INCA_IP_TSF_LEDMUX_CONF_SW_MASK_LAN         0x03E00000
#define INCA_IP_TSF_LEDMUX_CONF_SW_MASK_PC          0x001F0000
      
/***LED Register***/ 
#define INCA_IP_TSF_LED_REG                     (VREG32 (INCA_IP_TSF + 0x001C))                         
#define INCA_IP_TSF_LED_REG_Lxy_GET(value)           (((value) >> 0) & ((1 << 24) - 1))
#define INCA_IP_TSF_LED_REG_Lxy_SET(value)           ((((1 << 24) - 1) &(value)) << 0)

#define INCA_IP_TSF_LED_REG_L04     (1 << 0)
#define INCA_IP_TSF_LED_REG_L14     (1 << 1)
#define INCA_IP_TSF_LED_REG_L24     (1 << 2)
#define INCA_IP_TSF_LED_REG_L34     (1 << 3)

#define INCA_IP_TSF_LED_REG_L05     (1 << 4)
#define INCA_IP_TSF_LED_REG_L15     (1 << 5)
#define INCA_IP_TSF_LED_REG_L25     (1 << 6)
#define INCA_IP_TSF_LED_REG_L35     (1 << 7)

#define INCA_IP_TSF_LED_REG_L06     (1 << 8)
#define INCA_IP_TSF_LED_REG_L16     (1 << 9)
#define INCA_IP_TSF_LED_REG_L26     (1 << 10)
#define INCA_IP_TSF_LED_REG_L36     (1 << 11)

#define INCA_IP_TSF_LED_REG_L07     (1 << 12)
#define INCA_IP_TSF_LED_REG_L17     (1 << 13)
#define INCA_IP_TSF_LED_REG_L27     (1 << 14)
#define INCA_IP_TSF_LED_REG_L37     (1 << 15)

#define INCA_IP_TSF_LED_REG_L08     (1 << 16)
#define INCA_IP_TSF_LED_REG_L18     (1 << 17)
#define INCA_IP_TSF_LED_REG_L28     (1 << 18)
#define INCA_IP_TSF_LED_REG_L38     (1 << 19)

#define INCA_IP_TSF_LED_REG_L09     (1 << 20)
#define INCA_IP_TSF_LED_REG_L19     (1 << 21)
#define INCA_IP_TSF_LED_REG_L29     (1 << 22)
#define INCA_IP_TSF_LED_REG_L39     (1 << 23)



/***Pulse Width Modulator 1 and 2 Register***/ 
#define INCA_IP_TSF_PWM12                     (VREG32 (INCA_IP_TSF + 0x0020))                         
#define INCA_IP_TSF_PWM12_PW2_GET(value)           (((value) >> 16) & ((1 << 8) - 1))
#define INCA_IP_TSF_PWM12_PW2_SET(value)           ((((1 << 8) - 1) &(value)) << 16)                         
#define INCA_IP_TSF_PWM12_PW1_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_TSF_PWM12_PW1_SET(value)           ((((1 << 8) - 1) &(value)) << 0)		
         
/***********************************************************************/
/*  Module      :  IOM register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_IOM                     (0xBF105000)
/***********************************************************************/   

      
/***Receive FIFO***/ 
#define INCA_IP_IOM_RFIFO                     (VREG32 (INCA_IP_IOM + 0x0000))                         
#define INCA_IP_IOM_RFIFO_RXD_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_IOM_RFIFO_RXD_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***Transmit FIFO***/ 
#define INCA_IP_IOM_XFIFO                     (VREG32 (INCA_IP_IOM + 0x0000))                         
#define INCA_IP_IOM_XFIFO_TXD_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_IOM_XFIFO_TXD_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***Interrupt Status Register HDLC***/ 
#define INCA_IP_IOM_ISTAH                     (VREG32 (INCA_IP_IOM + 0x0080))
#define INCA_IP_IOM_ISTAH_RME                    (1 << 7)
#define INCA_IP_IOM_ISTAH_RPF                    (1 << 6)
#define INCA_IP_IOM_ISTAH_RFO                    (1 << 5)
#define INCA_IP_IOM_ISTAH_XPR                    (1 << 4)
#define INCA_IP_IOM_ISTAH_XMR                    (1 << 3)
#define INCA_IP_IOM_ISTAH_XDU                    (1 << 2)
      
/***Interrupt Mask Register HDLC***/ 
#define INCA_IP_IOM_MASKH                     (VREG32 (INCA_IP_IOM + 0x0080))
#define INCA_IP_IOM_MASKH_RME                    (1 << 7)
#define INCA_IP_IOM_MASKH_RPF                    (1 << 6)
#define INCA_IP_IOM_MASKH_RFO                    (1 << 5)
#define INCA_IP_IOM_MASKH_XPR                    (1 << 4)
#define INCA_IP_IOM_MASKH_XMR                    (1 << 3)
#define INCA_IP_IOM_MASKH_XDU                    (1 << 2)
#define INCA_IP_IOM_MASKH_UMASK_ALL              0
#define INCA_IP_IOM_MASKH_MASK_ALL               0xFC

#define INCA_IP_IOM_MASKH_RX                     ( INCA_IP_IOM_MASKH_RME | \
                                                   INCA_IP_IOM_MASKH_RPF | \
                                                   INCA_IP_IOM_MASKH_RFO )
#define INCA_IP_IOM_MASKH_TX                     ( INCA_IP_IOM_MASKH_XPR | \
                                                   INCA_IP_IOM_MASKH_XMR | \
                                                   INCA_IP_IOM_MASKH_XDU )

      
/***Status Register***/ 
#define INCA_IP_IOM_STAR                     (VREG32 (INCA_IP_IOM + 0x0084))
#define INCA_IP_IOM_STAR_XDOV                    (1 << 7)
#define INCA_IP_IOM_STAR_XFW                    (1 << 6)
#define INCA_IP_IOM_STAR_RACI                    (1 << 3)
#define INCA_IP_IOM_STAR_XACI                    (1 << 1)
      
/***Command Register***/ 
#define INCA_IP_IOM_CMDR                     (VREG32 (INCA_IP_IOM + 0x0084))
#define INCA_IP_IOM_CMDR_RMC                    (1 << 7)
#define INCA_IP_IOM_CMDR_RRES                    (1 << 6)
#define INCA_IP_IOM_CMDR_XTF                    (1 << 3)
#define INCA_IP_IOM_CMDR_XME                    (1 << 1)
#define INCA_IP_IOM_CMDR_XRES                    (1 << 0)
      
/***Mode Register***/ 
#define INCA_IP_IOM_MODEH                     (VREG32 (INCA_IP_IOM + 0x0088))
#define INCA_IP_IOM_MODEH_MDS2                    (1 << 7)
#define INCA_IP_IOM_MODEH_MDS1                    (1 << 6)
#define INCA_IP_IOM_MODEH_MDS0                    (1 << 5)
#define INCA_IP_IOM_MODEH_RAC                    (1 << 3)
#define INCA_IP_IOM_MODEH_DIM2                    (1 << 2)
#define INCA_IP_IOM_MODEH_DIM1                    (1 << 1)
#define INCA_IP_IOM_MODEH_DIM0                    (1 << 0)
      
/***Extended Mode Register***/ 
#define INCA_IP_IOM_EXMR                     (VREG32 (INCA_IP_IOM + 0x008C))
#define INCA_IP_IOM_EXMR_XFBS                    (1 << 7)                         
#define INCA_IP_IOM_EXMR_RFBS_GET(value)           (((value) >> 5) & ((1 << 2) - 1))
#define INCA_IP_IOM_EXMR_RFBS_SET(value)           ((((1 << 2) - 1) &(value)) << 5)
#define INCA_IP_IOM_EXMR_SRA                    (1 << 4)
#define INCA_IP_IOM_EXMR_XCRC                    (1 << 3)
#define INCA_IP_IOM_EXMR_RCRC                    (1 << 2)
#define INCA_IP_IOM_EXMR_ITF                    (1 << 0)
      
/***SAPI1 Register***/ 
#define INCA_IP_IOM_SAP1                     (VREG32 (INCA_IP_IOM + 0x0094))                         
#define INCA_IP_IOM_SAP1_SAPI1_GET(value)           (((value) >> 2) & ((1 << 6) - 1))
#define INCA_IP_IOM_SAP1_SAPI1_SET(value)           ((((1 << 6) - 1) &(value)) << 2)
#define INCA_IP_IOM_SAP1_MHA                    (1 << 0)
      
/***Receive Frame Byte Count Low***/ 
#define INCA_IP_IOM_RBCL                     (VREG32 (INCA_IP_IOM + 0x0098))
#define INCA_IP_IOM_RBCL_RBC(value)          (1 << value)
      
/***SAPI2 Register***/ 
#define INCA_IP_IOM_SAP2                     (VREG32 (INCA_IP_IOM + 0x0098))                         
#define INCA_IP_IOM_SAP2_SAPI2_GET(value)           (((value) >> 2) & ((1 << 6) - 1))
#define INCA_IP_IOM_SAP2_SAPI2_SET(value)           ((((1 << 6) - 1) &(value)) << 2)
#define INCA_IP_IOM_SAP2_MLA                    (1 << 0)
      
/***Receive Frame Byte Count High***/ 
#define INCA_IP_IOM_RBCH                     (VREG32 (INCA_IP_IOM + 0x009C))
#define INCA_IP_IOM_RBCH_OV                    (1 << 4)
#define INCA_IP_IOM_RBCH_RBC11                    (1 << 3)
#define INCA_IP_IOM_RBCH_RBC10                    (1 << 2)
#define INCA_IP_IOM_RBCH_RBC9                    (1 << 1)
#define INCA_IP_IOM_RBCH_RBC8                    (1 << 0)
      
/***TEI1 Register 1***/ 
#define INCA_IP_IOM_TEI1                     (VREG32 (INCA_IP_IOM + 0x009C))                         
#define INCA_IP_IOM_TEI1_TEI1_GET(value)           (((value) >> 1) & ((1 << 7) - 1))
#define INCA_IP_IOM_TEI1_TEI1_SET(value)           ((((1 << 7) - 1) &(value)) << 1)
#define INCA_IP_IOM_TEI1_EA                    (1 << 0)
      
/***Receive Status Register***/ 
#define INCA_IP_IOM_RSTA                     (VREG32 (INCA_IP_IOM + 0x00A0))
#define INCA_IP_IOM_RSTA_VFR                    (1 << 7)
#define INCA_IP_IOM_RSTA_RDO                    (1 << 6)
#define INCA_IP_IOM_RSTA_CRC                    (1 << 5)
#define INCA_IP_IOM_RSTA_RAB                    (1 << 4)
#define INCA_IP_IOM_RSTA_SA1                    (1 << 3)
#define INCA_IP_IOM_RSTA_SA0                    (1 << 2)
#define INCA_IP_IOM_RSTA_TA                    (1 << 0)
#define INCA_IP_IOM_RSTA_CR                    (1 << 1)
      
/***TEI2 Register***/ 
#define INCA_IP_IOM_TEI2                     (VREG32 (INCA_IP_IOM + 0x00A0))                         
#define INCA_IP_IOM_TEI2_TEI2_GET(value)           (((value) >> 1) & ((1 << 7) - 1))
#define INCA_IP_IOM_TEI2_TEI2_SET(value)           ((((1 << 7) - 1) &(value)) << 1)
#define INCA_IP_IOM_TEI2_EA                    (1 << 0)
      
/***Test Mode Register HDLC***/ 
#define INCA_IP_IOM_TMH                     (VREG32 (INCA_IP_IOM + 0x00A4))
#define INCA_IP_IOM_TMH_TLP                    (1 << 0)
      
/***Command/Indication Receive 0***/ 
#define INCA_IP_IOM_CIR0                     (VREG32 (INCA_IP_IOM + 0x00B8))                         
#define INCA_IP_IOM_CIR0_CODR0_GET(value)           (((value) >> 4) & ((1 << 4) - 1))
#define INCA_IP_IOM_CIR0_CODR0_SET(value)           ((((1 << 4) - 1) &(value)) << 4)
#define INCA_IP_IOM_CIR0_CIC0                    (1 << 3)
#define INCA_IP_IOM_CIR0_CIC1                    (1 << 2)
#define INCA_IP_IOM_CIR0_SG                    (1 << 1)
#define INCA_IP_IOM_CIR0_BAS                    (1 << 0)
      
/***Command/Indication Transmit 0***/ 
#define INCA_IP_IOM_CIX0                     (VREG32 (INCA_IP_IOM + 0x00B8))                         
#define INCA_IP_IOM_CIX0_CODX0_GET(value)           (((value) >> 4) & ((1 << 4) - 1))
#define INCA_IP_IOM_CIX0_CODX0_SET(value)           ((((1 << 4) - 1) &(value)) << 4)
#define INCA_IP_IOM_CIX0_TBA2                    (1 << 3)
#define INCA_IP_IOM_CIX0_TBA1                    (1 << 2)
#define INCA_IP_IOM_CIX0_TBA0                    (1 << 1)
#define INCA_IP_IOM_CIX0_BAC                    (1 << 0)
      
/***Command/Indication Receive 1***/ 
#define INCA_IP_IOM_CIR1                     (VREG32 (INCA_IP_IOM + 0x00BC))                         
#define INCA_IP_IOM_CIR1_CODR1_GET(value)           (((value) >> 2) & ((1 << 6) - 1))
#define INCA_IP_IOM_CIR1_CODR1_SET(value)           ((((1 << 6) - 1) &(value)) << 2)
      
/***Command/Indication Transmit 1***/ 
#define INCA_IP_IOM_CIX1                     (VREG32 (INCA_IP_IOM + 0x00BC))                         
#define INCA_IP_IOM_CIX1_CODX1_GET(value)           (((value) >> 2) & ((1 << 6) - 1))
#define INCA_IP_IOM_CIX1_CODX1_SET(value)           ((((1 << 6) - 1) &(value)) << 2)
#define INCA_IP_IOM_CIX1_CICW                    (1 << 1)
#define INCA_IP_IOM_CIX1_CI1E                    (1 << 0)
      
/***Controller Data Access Reg. (CH10)***/ 
#define INCA_IP_IOM_CDA10                     (VREG32 (INCA_IP_IOM + 0x0100))                         
#define INCA_IP_IOM_CDA10_CDA_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_IOM_CDA10_CDA_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***Controller Data Access Reg. (CH11)***/ 
#define INCA_IP_IOM_CDA11                     (VREG32 (INCA_IP_IOM + 0x0104))                         
#define INCA_IP_IOM_CDA11_CDA_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_IOM_CDA11_CDA_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***Controller Data Access Reg. (CH20)***/ 
#define INCA_IP_IOM_CDA20                     (VREG32 (INCA_IP_IOM + 0x0108))                         
#define INCA_IP_IOM_CDA20_CDA_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_IOM_CDA20_CDA_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***Controller Data Access Reg. (CH21)***/ 
#define INCA_IP_IOM_CDA21                     (VREG32 (INCA_IP_IOM + 0x010C))                         
#define INCA_IP_IOM_CDA21_CDA_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_IOM_CDA21_CDA_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***Time Slot and Data Port Sel. (CH10)***/ 
#define INCA_IP_IOM_CDA_TSDP10                     (VREG32 (INCA_IP_IOM + 0x0110))
#define INCA_IP_IOM_CDA_TSDP10_DPS                    (1 << 7)                         
#define INCA_IP_IOM_CDA_TSDP10_TSS_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_IOM_CDA_TSDP10_TSS_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Time Slot and Data Port Sel. (CH11)***/ 
#define INCA_IP_IOM_CDA_TSDP11                     (VREG32 (INCA_IP_IOM + 0x0114))
#define INCA_IP_IOM_CDA_TSDP11_DPS                    (1 << 7)                         
#define INCA_IP_IOM_CDA_TSDP11_TSS_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_IOM_CDA_TSDP11_TSS_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Time Slot and Data Port Sel. (CH20)***/ 
#define INCA_IP_IOM_CDA_TSDP20                     (VREG32 (INCA_IP_IOM + 0x0118))
#define INCA_IP_IOM_CDA_TSDP20_DPS                    (1 << 7)                         
#define INCA_IP_IOM_CDA_TSDP20_TSS_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_IOM_CDA_TSDP20_TSS_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Time Slot and Data Port Sel. (CH21)***/ 
#define INCA_IP_IOM_CDA_TSDP21                     (VREG32 (INCA_IP_IOM + 0x011C))
#define INCA_IP_IOM_CDA_TSDP21_DPS                    (1 << 7)                         
#define INCA_IP_IOM_CDA_TSDP21_TSS_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_IOM_CDA_TSDP21_TSS_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Time Slot and Data Port Sel. (CH10)***/ 
#define INCA_IP_IOM_CO_TSDP10                     (VREG32 (INCA_IP_IOM + 0x0120))
#define INCA_IP_IOM_CO_TSDP10_DPS                    (1 << 7)                         
#define INCA_IP_IOM_CO_TSDP10_TSS_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_IOM_CO_TSDP10_TSS_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Time Slot and Data Port Sel. (CH11)***/ 
#define INCA_IP_IOM_CO_TSDP11                     (VREG32 (INCA_IP_IOM + 0x0124))
#define INCA_IP_IOM_CO_TSDP11_DPS                    (1 << 7)                         
#define INCA_IP_IOM_CO_TSDP11_TSS_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_IOM_CO_TSDP11_TSS_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Time Slot and Data Port Sel. (CH20)***/ 
#define INCA_IP_IOM_CO_TSDP20                     (VREG32 (INCA_IP_IOM + 0x0128))
#define INCA_IP_IOM_CO_TSDP20_DPS                    (1 << 7)                         
#define INCA_IP_IOM_CO_TSDP20_TSS_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_IOM_CO_TSDP20_TSS_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Time Slot and Data Port Sel. (CH21)***/ 
#define INCA_IP_IOM_CO_TSDP21                     (VREG32 (INCA_IP_IOM + 0x012C))
#define INCA_IP_IOM_CO_TSDP21_DPS                    (1 << 7)                         
#define INCA_IP_IOM_CO_TSDP21_TSS_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_IOM_CO_TSDP21_TSS_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Ctrl. Reg. Contr. Data Access CH1x***/ 
#define INCA_IP_IOM_CDA1_CR                     (VREG32 (INCA_IP_IOM + 0x0138))
#define INCA_IP_IOM_CDA1_CR_EN_TBM                    (1 << 5)
#define INCA_IP_IOM_CDA1_CR_EN_I1                    (1 << 4)
#define INCA_IP_IOM_CDA1_CR_EN_I0                    (1 << 3)
#define INCA_IP_IOM_CDA1_CR_EN_O1                    (1 << 2)
#define INCA_IP_IOM_CDA1_CR_EN_O0                    (1 << 1)
#define INCA_IP_IOM_CDA1_CR_SWAP                    (1 << 0)
      
/***Ctrl. Reg. Contr. Data Access CH1x***/ 
#define INCA_IP_IOM_CDA2_CR                     (VREG32 (INCA_IP_IOM + 0x013C))
#define INCA_IP_IOM_CDA2_CR_EN_TBM                    (1 << 5)
#define INCA_IP_IOM_CDA2_CR_EN_I1                    (1 << 4)
#define INCA_IP_IOM_CDA2_CR_EN_I0                    (1 << 3)
#define INCA_IP_IOM_CDA2_CR_EN_O1                    (1 << 2)
#define INCA_IP_IOM_CDA2_CR_EN_O0                    (1 << 1)
#define INCA_IP_IOM_CDA2_CR_SWAP                    (1 << 0)
      
/***Control Register B-Channel Data***/ 
#define INCA_IP_IOM_BCHA_CR                     (VREG32 (INCA_IP_IOM + 0x0144))
#define INCA_IP_IOM_BCHA_CR_EN_BC2                    (1 << 4)
#define INCA_IP_IOM_BCHA_CR_EN_BC1                    (1 << 3)
      
/***Control Register B-Channel Data***/ 
#define INCA_IP_IOM_BCHB_CR                     (VREG32 (INCA_IP_IOM + 0x0148))
#define INCA_IP_IOM_BCHB_CR_EN_BC2                    (1 << 4)
#define INCA_IP_IOM_BCHB_CR_EN_BC1                    (1 << 3)
      
/***Control Register for D and CI1 Handler***/ 
#define INCA_IP_IOM_DCI_CR                     (VREG32 (INCA_IP_IOM + 0x014C))
#define INCA_IP_IOM_DCI_CR_DPS_CI1                    (1 << 7)
#define INCA_IP_IOM_DCI_CR_EN_CI1                    (1 << 6)
#define INCA_IP_IOM_DCI_CR_EN_D                    (1 << 5)
      
/***Control Register for CI0 Handler***/ 
#define INCA_IP_IOM_DCIC_CR                     (VREG32 (INCA_IP_IOM + 0x014C))
#define INCA_IP_IOM_DCIC_CR_DPS_CI0                    (1 << 7)
#define INCA_IP_IOM_DCIC_CR_EN_CI0                    (1 << 6)
#define INCA_IP_IOM_DCIC_CR_DPS_D                    (1 << 5)
      
/***Control Reg. Serial Data Strobe x***/ 
#define INCA_IP_IOM_SDS_CR                     (VREG32 (INCA_IP_IOM + 0x0154))
#define INCA_IP_IOM_SDS_CR_ENS_TSS                    (1 << 7)
#define INCA_IP_IOM_SDS_CR_ENS_TSS_1                    (1 << 6)
#define INCA_IP_IOM_SDS_CR_ENS_TSS_3                    (1 << 5)                         
#define INCA_IP_IOM_SDS_CR_TSS_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_IOM_SDS_CR_TSS_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***Control Register IOM Data***/ 
#define INCA_IP_IOM_IOM_CR                     (VREG32 (INCA_IP_IOM + 0x015C))
#define INCA_IP_IOM_IOM_CR_SPU                    (1 << 7)
#define INCA_IP_IOM_IOM_CR_CI_CS                    (1 << 5)
#define INCA_IP_IOM_IOM_CR_TIC_DIS                    (1 << 4)
#define INCA_IP_IOM_IOM_CR_EN_BCL                    (1 << 3)
#define INCA_IP_IOM_IOM_CR_CLKM                    (1 << 2)
#define INCA_IP_IOM_IOM_CR_Res                    (1 << 1)
#define INCA_IP_IOM_IOM_CR_DIS_IOM                    (1 << 0)
      
/***Synchronous Transfer Interrupt***/ 
#define INCA_IP_IOM_STI                     (VREG32 (INCA_IP_IOM + 0x0160))
#define INCA_IP_IOM_STI_STOV21                    (1 << 7)
#define INCA_IP_IOM_STI_STOV20                    (1 << 6)
#define INCA_IP_IOM_STI_STOV11                    (1 << 5)
#define INCA_IP_IOM_STI_STOV10                    (1 << 4)
#define INCA_IP_IOM_STI_STI21                    (1 << 3)
#define INCA_IP_IOM_STI_STI20                    (1 << 2)
#define INCA_IP_IOM_STI_STI11                    (1 << 1)
#define INCA_IP_IOM_STI_STI10                    (1 << 0)
      
/***Acknowledge Synchronous Transfer Interrupt***/ 
#define INCA_IP_IOM_ASTI                     (VREG32 (INCA_IP_IOM + 0x0160))
#define INCA_IP_IOM_ASTI_ACK21                    (1 << 3)
#define INCA_IP_IOM_ASTI_ACK20                    (1 << 2)
#define INCA_IP_IOM_ASTI_ACK11                    (1 << 1)
#define INCA_IP_IOM_ASTI_ACK10                    (1 << 0)
      
/***Mask Synchronous Transfer Interrupt***/ 
#define INCA_IP_IOM_MSTI                     (VREG32 (INCA_IP_IOM + 0x0164))
#define INCA_IP_IOM_MSTI_STOV21                    (1 << 7)
#define INCA_IP_IOM_MSTI_STOV20                    (1 << 6)
#define INCA_IP_IOM_MSTI_STOV11                    (1 << 5)
#define INCA_IP_IOM_MSTI_STOV10                    (1 << 4)
#define INCA_IP_IOM_MSTI_STI21                    (1 << 3)
#define INCA_IP_IOM_MSTI_STI20                    (1 << 2)
#define INCA_IP_IOM_MSTI_STI11                    (1 << 1)
#define INCA_IP_IOM_MSTI_STI10                    (1 << 0)
      
/***Configuration Register for Serial Data Strobes***/ 
#define INCA_IP_IOM_SDS_CONF                     (VREG32 (INCA_IP_IOM + 0x0168))
#define INCA_IP_IOM_SDS_CONF_SDS_BCL                    (1 << 0)
      
/***Monitoring CDA Bits***/ 
#define INCA_IP_IOM_MCDA                     (VREG32 (INCA_IP_IOM + 0x016C))                         
#define INCA_IP_IOM_MCDA_MCDA21_GET(value)           (((value) >> 6) & ((1 << 2) - 1))
#define INCA_IP_IOM_MCDA_MCDA21_SET(value)           ((((1 << 2) - 1) &(value)) << 6)                         
#define INCA_IP_IOM_MCDA_MCDA20_GET(value)           (((value) >> 4) & ((1 << 2) - 1))
#define INCA_IP_IOM_MCDA_MCDA20_SET(value)           ((((1 << 2) - 1) &(value)) << 4)                         
#define INCA_IP_IOM_MCDA_MCDA11_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_IOM_MCDA_MCDA11_SET(value)           ((((1 << 2) - 1) &(value)) << 2)                         
#define INCA_IP_IOM_MCDA_MCDA10_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_IOM_MCDA_MCDA10_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***Mode 1 Register***/ 
#define INCA_IP_IOM_MODE1                     (VREG32 (INCA_IP_IOM + 0x0188))
#define INCA_IP_IOM_MODE1_CFS                    (1 << 2)
#define INCA_IP_IOM_MODE1_MSM                   (1 << 0)
      
/***Mode 2 Register***/ 
#define INCA_IP_IOM_MODE2                     (VREG32 (INCA_IP_IOM + 0x018C))
#define INCA_IP_IOM_MODE2_MSM                    (1 << 4)
      
/***Mode 3 Register***/ 
#define INCA_IP_IOM_MODE3                     (VREG32 (INCA_IP_IOM + 0x00F8))
#define INCA_IP_IOM_MODE3_ASEL                    (1 << 0)
      
/***Receive Data Register***/ 
#define INCA_IP_IOM_RXDAT                     (VREG32 (INCA_IP_IOM + 0x00FC))
#define INCA_IP_IOM_RXDAT_VAL                    (1 << 31)                         
#define INCA_IP_IOM_RXDAT_RXDATA_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_IOM_RXDAT_RXDATA_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***Software Reset Register (0190H)***/ 
#define INCA_IP_IOM_SRES                     (VREG32 (INCA_IP_IOM + 0x0190))
#define INCA_IP_IOM_SRES_RES_CI                    (1 << 7)
#define INCA_IP_IOM_SRES_RES_DCH                    (1 << 3)
#define INCA_IP_IOM_SRES_RES_IOM                    (1 << 2)
      
/***Interrupt Status Register***/ 
#define INCA_IP_IOM_ISTA                     (VREG32 (INCA_IP_IOM + 0x01F8))
#define INCA_IP_IOM_ISTA_ICD                    (1 << 2)
#define INCA_IP_IOM_ISTA_CIC                    (1 << 1)
#define INCA_IP_IOM_ISTA_ST                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  SSC1 register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_SSC1                     (0xB8000500)
/***********************************************************************/   

      
/***Control Register (Programming Mode)***/ 
#define INCA_IP_SSC1_SSC_CON_PRG                     (VREG32 (INCA_IP_SSC1 + 0x0010))
#define INCA_IP_SSC1_SSC_CON_PRG_EN                    (1 << 15)
#define INCA_IP_SSC1_SSC_CON_PRG_MS                    (1 << 14)
#define INCA_IP_SSC1_SSC_CON_PRG_AREN                    (1 << 12)
#define INCA_IP_SSC1_SSC_CON_PRG_BEN                    (1 << 11)
#define INCA_IP_SSC1_SSC_CON_PRG_PEN                    (1 << 10)
#define INCA_IP_SSC1_SSC_CON_PRG_REN                    (1 << 9)
#define INCA_IP_SSC1_SSC_CON_PRG_TEN                    (1 << 8)
#define INCA_IP_SSC1_SSC_CON_PRG_LB                    (1 << 7)
#define INCA_IP_SSC1_SSC_CON_PRG_PO                    (1 << 6)
#define INCA_IP_SSC1_SSC_CON_PRG_PH                    (1 << 5)
#define INCA_IP_SSC1_SSC_CON_PRG_HB                    (1 << 4)                         
#define INCA_IP_SSC1_SSC_CON_PRG_BM_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_SSC1_SSC_CON_PRG_BM_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***SSC Control Register (Operating Mode)***/ 
#define INCA_IP_SSC1_SSC_CON_OPR                     (VREG32 (INCA_IP_SSC1 + 0x0010))
#define INCA_IP_SSC1_SSC_CON_OPR_EN                    (1 << 15)
#define INCA_IP_SSC1_SSC_CON_OPR_MS                    (1 << 14)
#define INCA_IP_SSC1_SSC_CON_OPR_BSY                    (1 << 12)
#define INCA_IP_SSC1_SSC_CON_OPR_BE                    (1 << 11)
#define INCA_IP_SSC1_SSC_CON_OPR_PE                    (1 << 10)
#define INCA_IP_SSC1_SSC_CON_OPR_RE                    (1 << 9)
#define INCA_IP_SSC1_SSC_CON_OPR_TE                    (1 << 8)                         
#define INCA_IP_SSC1_SSC_CON_OPR_BC_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_SSC1_SSC_CON_OPR_BC_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***SSC Write Hardware Modified Control Register***/ 
#define INCA_IP_SSC1_SSC_WHBCON                     (VREG32 (INCA_IP_SSC1 + 0x0040))
#define INCA_IP_SSC1_SSC_WHBCON_SETBE                    (1 << 15)
#define INCA_IP_SSC1_SSC_WHBCON_SETPE                    (1 << 14)
#define INCA_IP_SSC1_SSC_WHBCON_SETRE                    (1 << 13)
#define INCA_IP_SSC1_SSC_WHBCON_SETTE                    (1 << 12)
#define INCA_IP_SSC1_SSC_WHBCON_CLRBE                    (1 << 11)
#define INCA_IP_SSC1_SSC_WHBCON_CLRPE                    (1 << 10)
#define INCA_IP_SSC1_SSC_WHBCON_CLRRE                    (1 << 9)
#define INCA_IP_SSC1_SSC_WHBCON_CLRTE                    (1 << 8)
      
/***SSC Baudrate Timer Reload Register***/ 
#define INCA_IP_SSC1_SSC_BR                     (VREG32 (INCA_IP_SSC1 + 0x0014))                         
#define INCA_IP_SSC1_SSC_BR_BR_VALUE_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_SSC1_SSC_BR_BR_VALUE_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***SSC Transmitter Buffer Register***/ 
#define INCA_IP_SSC1_SSC_TB                     (VREG32 (INCA_IP_SSC1 + 0x0020))                         
#define INCA_IP_SSC1_SSC_TB_TB_VALUE_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_SSC1_SSC_TB_TB_VALUE_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***SSC Receiver Buffer Register***/ 
#define INCA_IP_SSC1_SSC_RB                     (VREG32 (INCA_IP_SSC1 + 0x0024))                         
#define INCA_IP_SSC1_SSC_RB_RB_VALUE_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_SSC1_SSC_RB_RB_VALUE_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***SSC Receive FIFO Control Register***/ 
#define INCA_IP_SSC1_SSC_RXFCON                     (VREG32 (INCA_IP_SSC1 + 0x0030))                         
#define INCA_IP_SSC1_SSC_RXFCON_RXFITL_GET(value)           (((value) >> 8) & ((1 << 6) - 1))
#define INCA_IP_SSC1_SSC_RXFCON_RXFITL_SET(value)           ((((1 << 6) - 1) &(value)) << 8)
#define INCA_IP_SSC1_SSC_RXFCON_RXTMEN                    (1 << 2)
#define INCA_IP_SSC1_SSC_RXFCON_RXFLU                    (1 << 1)
#define INCA_IP_SSC1_SSC_RXFCON_RXFEN                    (1 << 0)
      
/***SSC Transmit FIFO Control Register***/ 
#define INCA_IP_SSC1_SSC_TXFCON                     (VREG32 (INCA_IP_SSC1 + 0x0034))                         
#define INCA_IP_SSC1_SSC_TXFCON_TXFITL_GET(value)           (((value) >> 8) & ((1 << 6) - 1))
#define INCA_IP_SSC1_SSC_TXFCON_TXFITL_SET(value)           ((((1 << 6) - 1) &(value)) << 8)
#define INCA_IP_SSC1_SSC_TXFCON_TXTMEN                    (1 << 2)
#define INCA_IP_SSC1_SSC_TXFCON_TXFLU                    (1 << 1)
#define INCA_IP_SSC1_SSC_TXFCON_TXFEN                    (1 << 0)
      
/***SSC FIFO Status Register***/ 
#define INCA_IP_SSC1_SSC_FSTAT                     (VREG32 (INCA_IP_SSC1 + 0x0038))                         
#define INCA_IP_SSC1_SSC_FSTAT_TXFFL_GET(value)           (((value) >> 8) & ((1 << 6) - 1))
#define INCA_IP_SSC1_SSC_FSTAT_TXFFL_SET(value)           ((((1 << 6) - 1) &(value)) << 8)                         
#define INCA_IP_SSC1_SSC_FSTAT_RXFFL_GET(value)           (((value) >> 0) & ((1 << 6) - 1))
#define INCA_IP_SSC1_SSC_FSTAT_RXFFL_SET(value)           ((((1 << 6) - 1) &(value)) << 0)
      
/***SSC Clock Control Register***/ 
#define INCA_IP_SSC1_SSC_CLC                     (VREG32 (INCA_IP_SSC1 + 0x0000))                         
#define INCA_IP_SSC1_SSC_CLC_RMC_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_SSC1_SSC_CLC_RMC_SET(value)           ((((1 << 8) - 1) &(value)) << 8)
#define INCA_IP_SSC1_SSC_CLC_DISS                    (1 << 1)
#define INCA_IP_SSC1_SSC_CLC_DISR                    (1 << 0)
      
/***SSC Interrupt Node Control Register 0***/ 
#define INCA_IP_SSC1_SSC_IRNCR0                     (VREG32 (INCA_IP_SSC1 + 0x00F8))
#define INCA_IP_SSC1_SSC_IRNCR0_EIR                    (1 << 2)
#define INCA_IP_SSC1_SSC_IRNCR0_RIR                    (1 << 1)
#define INCA_IP_SSC1_SSC_IRNCR0_TIR                    (1 << 0)
      
/***SSC Interrupt Node Control Register 1***/ 
#define INCA_IP_SSC1_SSC_IRNCR1                     (VREG32 (INCA_IP_SSC1 + 0x00FC))
#define INCA_IP_SSC1_SSC_IRNCR1_EIR                    (1 << 2)
#define INCA_IP_SSC1_SSC_IRNCR1_RIR                    (1 << 1)
#define INCA_IP_SSC1_SSC_IRNCR1_TIR                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  SSC2 register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_SSC2                     (0xB8000600)
/***********************************************************************/   

      
/***Control Register (Programming Mode)***/ 
#define INCA_IP_SSC2_SSC_CON_PRG                     (VREG32 (INCA_IP_SSC2 + 0x0010))
#define INCA_IP_SSC2_SSC_CON_PRG_EN                    (1 << 15)
#define INCA_IP_SSC2_SSC_CON_PRG_MS                    (1 << 14)
#define INCA_IP_SSC2_SSC_CON_PRG_AREN                    (1 << 12)
#define INCA_IP_SSC2_SSC_CON_PRG_BEN                    (1 << 11)
#define INCA_IP_SSC2_SSC_CON_PRG_PEN                    (1 << 10)
#define INCA_IP_SSC2_SSC_CON_PRG_REN                    (1 << 9)
#define INCA_IP_SSC2_SSC_CON_PRG_TEN                    (1 << 8)
#define INCA_IP_SSC2_SSC_CON_PRG_LB                    (1 << 7)
#define INCA_IP_SSC2_SSC_CON_PRG_PO                    (1 << 6)
#define INCA_IP_SSC2_SSC_CON_PRG_PH                    (1 << 5)
#define INCA_IP_SSC2_SSC_CON_PRG_HB                    (1 << 4)                         
#define INCA_IP_SSC2_SSC_CON_PRG_BM_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_SSC2_SSC_CON_PRG_BM_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***SSC Control Register (Operating Mode)***/ 
#define INCA_IP_SSC2_SSC_CON_OPR                     (VREG32 (INCA_IP_SSC2 + 0x0010))
#define INCA_IP_SSC2_SSC_CON_OPR_EN                    (1 << 15)
#define INCA_IP_SSC2_SSC_CON_OPR_MS                    (1 << 14)
#define INCA_IP_SSC2_SSC_CON_OPR_BSY                    (1 << 12)
#define INCA_IP_SSC2_SSC_CON_OPR_BE                    (1 << 11)
#define INCA_IP_SSC2_SSC_CON_OPR_PE                    (1 << 10)
#define INCA_IP_SSC2_SSC_CON_OPR_RE                    (1 << 9)
#define INCA_IP_SSC2_SSC_CON_OPR_TE                    (1 << 8)                         
#define INCA_IP_SSC2_SSC_CON_OPR_BC_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_SSC2_SSC_CON_OPR_BC_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***SSC Write Hardware Modified Control Register***/ 
#define INCA_IP_SSC2_SSC_WHBCON                     (VREG32 (INCA_IP_SSC2 + 0x0040))
#define INCA_IP_SSC2_SSC_WHBCON_SETBE                    (1 << 15)
#define INCA_IP_SSC2_SSC_WHBCON_SETPE                    (1 << 14)
#define INCA_IP_SSC2_SSC_WHBCON_SETRE                    (1 << 13)
#define INCA_IP_SSC2_SSC_WHBCON_SETTE                    (1 << 12)
#define INCA_IP_SSC2_SSC_WHBCON_CLRBE                    (1 << 11)
#define INCA_IP_SSC2_SSC_WHBCON_CLRPE                    (1 << 10)
#define INCA_IP_SSC2_SSC_WHBCON_CLRRE                    (1 << 9)
#define INCA_IP_SSC2_SSC_WHBCON_CLRTE                    (1 << 8)
      
/***SSC Baudrate Timer Reload Register***/ 
#define INCA_IP_SSC2_SSC_BR                     (VREG32 (INCA_IP_SSC2 + 0x0014))                         
#define INCA_IP_SSC2_SSC_BR_BR_VALUE_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_SSC2_SSC_BR_BR_VALUE_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***SSC Transmitter Buffer Register***/ 
#define INCA_IP_SSC2_SSC_TB                     (VREG32 (INCA_IP_SSC2 + 0x0020))                         
#define INCA_IP_SSC2_SSC_TB_TB_VALUE_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_SSC2_SSC_TB_TB_VALUE_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***SSC Receiver Buffer Register***/ 
#define INCA_IP_SSC2_SSC_RB                     (VREG32 (INCA_IP_SSC2 + 0x0024))                         
#define INCA_IP_SSC2_SSC_RB_RB_VALUE_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_SSC2_SSC_RB_RB_VALUE_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***SSC Clock Control Register***/ 
#define INCA_IP_SSC2_SSC_CLC                     (VREG32 (INCA_IP_SSC2 + 0x0000))                         
#define INCA_IP_SSC2_SSC_CLC_RMC_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_SSC2_SSC_CLC_RMC_SET(value)           ((((1 << 8) - 1) &(value)) << 8)
#define INCA_IP_SSC2_SSC_CLC_DISS                    (1 << 1)
#define INCA_IP_SSC2_SSC_CLC_DISR                    (1 << 0)
      
/***SSC Interrupt Node Control Register 0***/ 
#define INCA_IP_SSC2_SSC_IRNCR0                     (VREG32 (INCA_IP_SSC2 + 0x00F8))
#define INCA_IP_SSC2_SSC_IRNCR0_EIR                    (1 << 2)
#define INCA_IP_SSC2_SSC_IRNCR0_RIR                    (1 << 1)
#define INCA_IP_SSC2_SSC_IRNCR0_TIR                    (1 << 0)
      
/***SSC Interrupt Node Control Register 1***/ 
#define INCA_IP_SSC2_SSC_IRNCR1                     (VREG32 (INCA_IP_SSC2 + 0x00FC))
#define INCA_IP_SSC2_SSC_IRNCR1_EIR                    (1 << 2)
#define INCA_IP_SSC2_SSC_IRNCR1_RIR                    (1 << 1)
#define INCA_IP_SSC2_SSC_IRNCR1_TIR                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  ASC register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_ASC                     (0xB8000400)
/***********************************************************************/   

      
/***ASC Port Input Select Register***/ 
#define INCA_IP_ASC_ASC_PISEL                     (VREG32 (INCA_IP_ASC + 0x0004))
#define INCA_IP_ASC_ASC_PISEL_RIS                    (1 << 0)
      
/***ASC Control Register***/ 
#define INCA_IP_ASC_ASC_CON                     (VREG32 (INCA_IP_ASC + 0x0010))
#define INCA_IP_ASC_ASC_CON_R                    (1 << 15)
#define INCA_IP_ASC_ASC_CON_LB                    (1 << 14)
#define INCA_IP_ASC_ASC_CON_BRS                    (1 << 13)
#define INCA_IP_ASC_ASC_CON_ODD                    (1 << 12)
#define INCA_IP_ASC_ASC_CON_FDE                    (1 << 11)
#define INCA_IP_ASC_ASC_CON_OE                    (1 << 10)
#define INCA_IP_ASC_ASC_CON_FE                    (1 << 9)
#define INCA_IP_ASC_ASC_CON_PE                    (1 << 8)
#define INCA_IP_ASC_ASC_CON_OEN                    (1 << 7)
#define INCA_IP_ASC_ASC_CON_FEN                    (1 << 6)
#define INCA_IP_ASC_ASC_CON_PENRXDI                    (1 << 5)
#define INCA_IP_ASC_ASC_CON_REN                    (1 << 4)
#define INCA_IP_ASC_ASC_CON_STP                    (1 << 3)                         
#define INCA_IP_ASC_ASC_CON_M_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_ASC_ASC_CON_M_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***ASC Write Hardware Modified Control Register***/ 
#define INCA_IP_ASC_ASC_WHBCON                     (VREG32 (INCA_IP_ASC + 0x0050))
#define INCA_IP_ASC_ASC_WHBCON_SETOE                    (1 << 13)
#define INCA_IP_ASC_ASC_WHBCON_SETFE                    (1 << 12)
#define INCA_IP_ASC_ASC_WHBCON_SETPE                    (1 << 11)
#define INCA_IP_ASC_ASC_WHBCON_CLROE                    (1 << 10)
#define INCA_IP_ASC_ASC_WHBCON_CLRFE                    (1 << 9)
#define INCA_IP_ASC_ASC_WHBCON_CLRPE                    (1 << 8)
#define INCA_IP_ASC_ASC_WHBCON_SETREN                    (1 << 5)
#define INCA_IP_ASC_ASC_WHBCON_CLRREN                    (1 << 4)
      
/***ASC Baudrate Timer/Reload Register***/ 
#define INCA_IP_ASC_ASC_BTR                     (VREG32 (INCA_IP_ASC + 0x0014))                         
#define INCA_IP_ASC_ASC_BTR_BR_VALUE_GET(value)           (((value) >> 0) & ((1 << 13) - 1))
#define INCA_IP_ASC_ASC_BTR_BR_VALUE_SET(value)           ((((1 << 13) - 1) &(value)) << 0)
      
/***ASC Fractional Divider Register***/ 
#define INCA_IP_ASC_ASC_FDV                     (VREG32 (INCA_IP_ASC + 0x0018))                         
#define INCA_IP_ASC_ASC_FDV_FD_VALUE_GET(value)           (((value) >> 0) & ((1 << 9) - 1))
#define INCA_IP_ASC_ASC_FDV_FD_VALUE_SET(value)           ((((1 << 9) - 1) &(value)) << 0)
      
/***ASC IrDA Pulse Mode/Width Register***/ 
#define INCA_IP_ASC_ASC_PMW                     (VREG32 (INCA_IP_ASC + 0x001C))
#define INCA_IP_ASC_ASC_PMW_IRPW                    (1 << 8)                         
#define INCA_IP_ASC_ASC_PMW_PW_VALUE_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_ASC_ASC_PMW_PW_VALUE_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***ASC Transmit Buffer Register***/ 
#define INCA_IP_ASC_ASC_TBUF                     (VREG32 (INCA_IP_ASC + 0x0020))                         
#define INCA_IP_ASC_ASC_TBUF_TD_VALUE_GET(value)           (((value) >> 0) & ((1 << 9) - 1))
#define INCA_IP_ASC_ASC_TBUF_TD_VALUE_SET(value)           ((((1 << 9) - 1) &(value)) << 0)
      
/***ASC Receive Buffer Register***/ 
#define INCA_IP_ASC_ASC_RBUF                     (VREG32 (INCA_IP_ASC + 0x0024))                         
#define INCA_IP_ASC_ASC_RBUF_RD_VALUE_GET(value)           (((value) >> 0) & ((1 << 9) - 1))
#define INCA_IP_ASC_ASC_RBUF_RD_VALUE_SET(value)           ((((1 << 9) - 1) &(value)) << 0)
      
/***ASC Autobaud Control Register***/ 
#define INCA_IP_ASC_ASC_ABCON                     (VREG32 (INCA_IP_ASC + 0x0030))
#define INCA_IP_ASC_ASC_ABCON_RXINV                    (1 << 11)
#define INCA_IP_ASC_ASC_ABCON_TXINV                    (1 << 10)                         
#define INCA_IP_ASC_ASC_ABCON_ABEM_GET(value)           (((value) >> 8) & ((1 << 2) - 1))
#define INCA_IP_ASC_ASC_ABCON_ABEM_SET(value)           ((((1 << 2) - 1) &(value)) << 8)
#define INCA_IP_ASC_ASC_ABCON_FCDETEN                    (1 << 4)
#define INCA_IP_ASC_ASC_ABCON_ABDETEN                    (1 << 3)
#define INCA_IP_ASC_ASC_ABCON_ABSTEN                    (1 << 2)
#define INCA_IP_ASC_ASC_ABCON_AUREN                    (1 << 1)
#define INCA_IP_ASC_ASC_ABCON_ABEN                    (1 << 0)
      
/***Receive FIFO Control Register***/ 
#define INCA_IP_ASC_RXFCON                     (VREG32 (INCA_IP_ASC + 0x0040))                         
#define INCA_IP_ASC_RXFCON_RXFITL_GET(value)           (((value) >> 8) & ((1 << 6) - 1))
#define INCA_IP_ASC_RXFCON_RXFITL_SET(value)           ((((1 << 6) - 1) &(value)) << 8)
#define INCA_IP_ASC_RXFCON_RXTMEN                    (1 << 2)
#define INCA_IP_ASC_RXFCON_RXFFLU                    (1 << 1)
#define INCA_IP_ASC_RXFCON_RXFEN                    (1 << 0)
      
/***Transmit FIFO Control Register***/ 
#define INCA_IP_ASC_TXFCON                     (VREG32 (INCA_IP_ASC + 0x0044))                         
#define INCA_IP_ASC_TXFCON_TXFITL_GET(value)           (((value) >> 8) & ((1 << 6) - 1))
#define INCA_IP_ASC_TXFCON_TXFITL_SET(value)           ((((1 << 6) - 1) &(value)) << 8)
#define INCA_IP_ASC_TXFCON_TXTMEN                    (1 << 2)
#define INCA_IP_ASC_TXFCON_TXFFLU                    (1 << 1)
#define INCA_IP_ASC_TXFCON_TXFEN                    (1 << 0)
      
/***FIFO Status Register***/ 
#define INCA_IP_ASC_FSTAT                     (VREG32 (INCA_IP_ASC + 0x0048))                         
#define INCA_IP_ASC_FSTAT_TXFFL_GET(value)           (((value) >> 8) & ((1 << 6) - 1))
#define INCA_IP_ASC_FSTAT_TXFFL_SET(value)           ((((1 << 6) - 1) &(value)) << 8)                         
#define INCA_IP_ASC_FSTAT_RXFFL_GET(value)           (((value) >> 0) & ((1 << 6) - 1))
#define INCA_IP_ASC_FSTAT_RXFFL_SET(value)           ((((1 << 6) - 1) &(value)) << 0)
      
/***ASC Write HW Modified Autobaud Control Register***/ 
#define INCA_IP_ASC_ASC_WHBABCON                     (VREG32 (INCA_IP_ASC + 0x0054))
#define INCA_IP_ASC_ASC_WHBABCON_SETABEN                    (1 << 1)
#define INCA_IP_ASC_ASC_WHBABCON_CLRABEN                    (1 << 0)
      
/***ASC Autobaud Status Register***/ 
#define INCA_IP_ASC_ASC_ABSTAT                     (VREG32 (INCA_IP_ASC + 0x0034))
#define INCA_IP_ASC_ASC_ABSTAT_DETWAIT                    (1 << 4)
#define INCA_IP_ASC_ASC_ABSTAT_SCCDET                    (1 << 3)
#define INCA_IP_ASC_ASC_ABSTAT_SCSDET                    (1 << 2)
#define INCA_IP_ASC_ASC_ABSTAT_FCCDET                    (1 << 1)
#define INCA_IP_ASC_ASC_ABSTAT_FCSDET                    (1 << 0)
      
/***ASC Write HW Modified Autobaud Status Register***/ 
#define INCA_IP_ASC_ASC_WHBABSTAT                 (VREG32 (INCA_IP_ASC + 0x0058))
#define INCA_IP_ASC_ASC_WHBABSTAT_SETDETWAIT                    (1 << 9)
#define INCA_IP_ASC_ASC_WHBABSTAT_CLRDETWAIT                    (1 << 8)
#define INCA_IP_ASC_ASC_WHBABSTAT_SETSCCDET                    (1 << 7)
#define INCA_IP_ASC_ASC_WHBABSTAT_CLRSCCDET                    (1 << 6)
#define INCA_IP_ASC_ASC_WHBABSTAT_SETSCSDET                    (1 << 5)
#define INCA_IP_ASC_ASC_WHBABSTAT_CLRSCSDET                    (1 << 4)
#define INCA_IP_ASC_ASC_WHBABSTAT_SETFCCDET                    (1 << 3)
#define INCA_IP_ASC_ASC_WHBABSTAT_CLRFCCDET                    (1 << 2)
#define INCA_IP_ASC_ASC_WHBABSTAT_SETFCSDET                    (1 << 1)
#define INCA_IP_ASC_ASC_WHBABSTAT_CLRFCSDET                    (1 << 0)
      
/***ASC Clock Control Register***/ 
#define INCA_IP_ASC_ASC_CLC                     (VREG32 (INCA_IP_ASC + 0x0000))                         
#define INCA_IP_ASC_ASC_CLC_RMC_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_ASC_ASC_CLC_RMC_SET(value)           ((((1 << 8) - 1) &(value)) << 8)
#define INCA_IP_ASC_ASC_CLC_DISS                    (1 << 1)
#define INCA_IP_ASC_ASC_CLC_DISR                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  IC register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_IIC                     (0xB8000700)
/***********************************************************************/   

      
/***IC Port Input Select Register***/ 
#define INCA_IP_IIC_IIC_PISEL                     (VREG32 (INCA_IP_IIC + 0x0004))
#define INCA_IP_IIC_IIC_PISEL_SDAIS(value)          (1 << value)
#define INCA_IP_IIC_IIC_PISEL_SCLIS(value)          (1 << value)
      
/***IC Clock Control Register***/ 
#define INCA_IP_IIC_IIC_CLC                     (VREG32 (INCA_IP_IIC + 0x0000))                         
#define INCA_IP_IIC_IIC_CLC_RMC_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_IIC_IIC_CLC_RMC_SET(value)           ((((1 << 8) - 1) &(value)) << 8)
#define INCA_IP_IIC_IIC_CLC_DISS                    (1 << 1)
#define INCA_IP_IIC_IIC_CLC_DISR                    (1 << 0)
      
/***IC System Control Register***/ 
#define INCA_IP_IIC_IIC_SYSCON_0                     (VREG32 (INCA_IP_IIC + 0x0010))
#define INCA_IP_IIC_IIC_SYSCON_0_WMEN                    (1 << 31)                         
#define INCA_IP_IIC_IIC_SYSCON_0_CI_GET(value)           (((value) >> 26) & ((1 << 2) - 1))
#define INCA_IP_IIC_IIC_SYSCON_0_CI_SET(value)           ((((1 << 2) - 1) &(value)) << 26)
#define INCA_IP_IIC_IIC_SYSCON_0_STP                    (1 << 25)
#define INCA_IP_IIC_IIC_SYSCON_0_IGE                    (1 << 24)
#define INCA_IP_IIC_IIC_SYSCON_0_TRX                    (1 << 23)
#define INCA_IP_IIC_IIC_SYSCON_0_INT                    (1 << 22)
#define INCA_IP_IIC_IIC_SYSCON_0_ACKDIS                    (1 << 21)
#define INCA_IP_IIC_IIC_SYSCON_0_BUM                    (1 << 20)                         
#define INCA_IP_IIC_IIC_SYSCON_0_MOD_GET(value)           (((value) >> 18) & ((1 << 2) - 1))
#define INCA_IP_IIC_IIC_SYSCON_0_MOD_SET(value)           ((((1 << 2) - 1) &(value)) << 18)
#define INCA_IP_IIC_IIC_SYSCON_0_RSC                    (1 << 17)
#define INCA_IP_IIC_IIC_SYSCON_0_M10                    (1 << 16)
#define INCA_IP_IIC_IIC_SYSCON_0_RMEN                    (1 << 15)                         
#define INCA_IP_IIC_IIC_SYSCON_0_CO_GET(value)           (((value) >> 8) & ((1 << 3) - 1))
#define INCA_IP_IIC_IIC_SYSCON_0_CO_SET(value)           ((((1 << 3) - 1) &(value)) << 8)
#define INCA_IP_IIC_IIC_SYSCON_0_IRQE                    (1 << 7)
#define INCA_IP_IIC_IIC_SYSCON_0_IRQP                    (1 << 6)
#define INCA_IP_IIC_IIC_SYSCON_0_IRQD                    (1 << 5)
#define INCA_IP_IIC_IIC_SYSCON_0_BB                    (1 << 4)
#define INCA_IP_IIC_IIC_SYSCON_0_LRB                    (1 << 3)
#define INCA_IP_IIC_IIC_SYSCON_0_SLA                    (1 << 2)
#define INCA_IP_IIC_IIC_SYSCON_0_AL                    (1 << 1)
#define INCA_IP_IIC_IIC_SYSCON_0_ADR                    (1 << 0)
      
/***IC System Control Register***/ 
#define INCA_IP_IIC_IIC_SYSCON_1                     (VREG32 (INCA_IP_IIC + 0x0010))                         
#define INCA_IP_IIC_IIC_SYSCON_1_RM_GET(value)           (((value) >> 24) & ((1 << 8) - 1))
#define INCA_IP_IIC_IIC_SYSCON_1_RM_SET(value)           ((((1 << 8) - 1) &(value)) << 24)
#define INCA_IP_IIC_IIC_SYSCON_1_TRX                    (1 << 23)
#define INCA_IP_IIC_IIC_SYSCON_1_INT                    (1 << 22)
#define INCA_IP_IIC_IIC_SYSCON_1_ACKDIS                    (1 << 21)
#define INCA_IP_IIC_IIC_SYSCON_1_BUM                    (1 << 20)                         
#define INCA_IP_IIC_IIC_SYSCON_1_MOD_GET(value)           (((value) >> 18) & ((1 << 2) - 1))
#define INCA_IP_IIC_IIC_SYSCON_1_MOD_SET(value)           ((((1 << 2) - 1) &(value)) << 18)
#define INCA_IP_IIC_IIC_SYSCON_1_RSC                    (1 << 17)
#define INCA_IP_IIC_IIC_SYSCON_1_M10                    (1 << 16)
#define INCA_IP_IIC_IIC_SYSCON_1_RMEN                    (1 << 15)                         
#define INCA_IP_IIC_IIC_SYSCON_1_CO_GET(value)           (((value) >> 8) & ((1 << 3) - 1))
#define INCA_IP_IIC_IIC_SYSCON_1_CO_SET(value)           ((((1 << 3) - 1) &(value)) << 8)
#define INCA_IP_IIC_IIC_SYSCON_1_IRQE                    (1 << 7)
#define INCA_IP_IIC_IIC_SYSCON_1_IRQP                    (1 << 6)
#define INCA_IP_IIC_IIC_SYSCON_1_IRQD                    (1 << 5)
#define INCA_IP_IIC_IIC_SYSCON_1_BB                    (1 << 4)
#define INCA_IP_IIC_IIC_SYSCON_1_LRB                    (1 << 3)
#define INCA_IP_IIC_IIC_SYSCON_1_SLA                    (1 << 2)
#define INCA_IP_IIC_IIC_SYSCON_1_AL                    (1 << 1)
#define INCA_IP_IIC_IIC_SYSCON_1_ADR                    (1 << 0)
      
/***IC System Control Register***/ 
#define INCA_IP_IIC_IIC_SYSCON_2                     (VREG32 (INCA_IP_IIC + 0x0010))
#define INCA_IP_IIC_IIC_SYSCON_2_WMEN                    (1 << 31)                         
#define INCA_IP_IIC_IIC_SYSCON_2_CI_GET(value)           (((value) >> 26) & ((1 << 2) - 1))
#define INCA_IP_IIC_IIC_SYSCON_2_CI_SET(value)           ((((1 << 2) - 1) &(value)) << 26)
#define INCA_IP_IIC_IIC_SYSCON_2_STP                    (1 << 25)
#define INCA_IP_IIC_IIC_SYSCON_2_IGE                    (1 << 24)
#define INCA_IP_IIC_IIC_SYSCON_2_TRX                    (1 << 23)
#define INCA_IP_IIC_IIC_SYSCON_2_INT                    (1 << 22)
#define INCA_IP_IIC_IIC_SYSCON_2_ACKDIS                    (1 << 21)
#define INCA_IP_IIC_IIC_SYSCON_2_BUM                    (1 << 20)                         
#define INCA_IP_IIC_IIC_SYSCON_2_MOD_GET(value)           (((value) >> 18) & ((1 << 2) - 1))
#define INCA_IP_IIC_IIC_SYSCON_2_MOD_SET(value)           ((((1 << 2) - 1) &(value)) << 18)
#define INCA_IP_IIC_IIC_SYSCON_2_RSC                    (1 << 17)
#define INCA_IP_IIC_IIC_SYSCON_2_M10                    (1 << 16)                         
#define INCA_IP_IIC_IIC_SYSCON_2_WM_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_IIC_IIC_SYSCON_2_WM_SET(value)           ((((1 << 8) - 1) &(value)) << 8)
#define INCA_IP_IIC_IIC_SYSCON_2_IRQE                    (1 << 7)
#define INCA_IP_IIC_IIC_SYSCON_2_IRQP                    (1 << 6)
#define INCA_IP_IIC_IIC_SYSCON_2_IRQD                    (1 << 5)
#define INCA_IP_IIC_IIC_SYSCON_2_BB                    (1 << 4)
#define INCA_IP_IIC_IIC_SYSCON_2_LRB                    (1 << 3)
#define INCA_IP_IIC_IIC_SYSCON_2_SLA                    (1 << 2)
#define INCA_IP_IIC_IIC_SYSCON_2_AL                    (1 << 1)
#define INCA_IP_IIC_IIC_SYSCON_2_ADR                    (1 << 0)
      
/***IC Write Hardware Modified System Control Register
***/
#define INCA_IP_IIC_IIC_WHBSYSCON                 (VREG32 (INCA_IP_IIC + 0x0020))
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRWMEN                    (1 << 31)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETWMEN                    (1 << 30)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETSTP                    (1 << 26)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRSTP                    (1 << 25)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETTRX                    (1 << 24)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRTRX                    (1 << 23)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETACKDIS                    (1 << 22)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRACKDIS                    (1 << 21)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETBUM                    (1 << 20)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRBUM                    (1 << 19)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETRSC                    (1 << 17)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRRSC                    (1 << 16)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETRMEN                    (1 << 15)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRRMEN                    (1 << 14)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETIRQE                    (1 << 10)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETIRQP                    (1 << 9)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETIRQD                    (1 << 8)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRIRQE                    (1 << 7)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRIRQP                    (1 << 6)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRIRQD                    (1 << 5)
#define INCA_IP_IIC_IIC_WHBSYSCON_SETAL                    (1 << 2)
#define INCA_IP_IIC_IIC_WHBSYSCON_CLRAL                    (1 << 1)
      
/***IC Bus Control Register***/ 
#define INCA_IP_IIC_IIC_BUSCON_0                     (VREG32 (INCA_IP_IIC + 0x0014))
#define INCA_IP_IIC_IIC_BUSCON_0_BRPMOD                    (1 << 31)                         
#define INCA_IP_IIC_IIC_BUSCON_0_PREDIV_GET(value)           (((value) >> 29) & ((1 << 2) - 1))
#define INCA_IP_IIC_IIC_BUSCON_0_PREDIV_SET(value)           ((((1 << 2) - 1) &(value)) << 29)                         
#define INCA_IP_IIC_IIC_BUSCON_0_ICA9_0_GET(value)           (((value) >> 16) & ((1 << 10) - 1))
#define INCA_IP_IIC_IIC_BUSCON_0_ICA9_0_SET(value)           ((((1 << 10) - 1) &(value)) << 16)                         
#define INCA_IP_IIC_IIC_BUSCON_0_BRP_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_IIC_IIC_BUSCON_0_BRP_SET(value)           ((((1 << 8) - 1) &(value)) << 8)
#define INCA_IP_IIC_IIC_BUSCON_0_SCLEN(value)          (1 << value)
#define INCA_IP_IIC_IIC_BUSCON_0_SDAEN(value)          (1 << value)
      
/***IC Bus Control Register***/ 
#define INCA_IP_IIC_IIC_BUSCON_1                     (VREG32 (INCA_IP_IIC + 0x0014))
#define INCA_IP_IIC_IIC_BUSCON_1_BRPMOD                    (1 << 31)                         
#define INCA_IP_IIC_IIC_BUSCON_1_PREDIV_GET(value)           (((value) >> 29) & ((1 << 2) - 1))
#define INCA_IP_IIC_IIC_BUSCON_1_PREDIV_SET(value)           ((((1 << 2) - 1) &(value)) << 29)                         
#define INCA_IP_IIC_IIC_BUSCON_1_ICA7_1_GET(value)           (((value) >> 17) & ((1 << 7) - 1))
#define INCA_IP_IIC_IIC_BUSCON_1_ICA7_1_SET(value)           ((((1 << 7) - 1) &(value)) << 17)                         
#define INCA_IP_IIC_IIC_BUSCON_1_BRP_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_IIC_IIC_BUSCON_1_BRP_SET(value)           ((((1 << 8) - 1) &(value)) << 8)
#define INCA_IP_IIC_IIC_BUSCON_1_SCLEN(value)          (1 << value)
#define INCA_IP_IIC_IIC_BUSCON_1_SDAEN(value)          (1 << value)
      
/***IC Receive Transmit Buffer***/ 
#define INCA_IP_IIC_IIC_RTB                     (VREG32 (INCA_IP_IIC + 0x0018))
#define INCA_IP_IIC_IIC_RTB_RTB(value)          (1 << value)		
         
/***********************************************************************/
/*  Module      :  GPTU register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_GPTU                     (0xB8000300)
/***********************************************************************/   

      
/***GPT Clock Control Register***/ 
#define INCA_IP_GPTU_GPT_CLC                     (VREG32 (INCA_IP_GPTU + 0x0000))                         
#define INCA_IP_GPTU_GPT_CLC_RMC_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_GPTU_GPT_CLC_RMC_SET(value)           ((((1 << 8) - 1) &(value)) << 8)
#define INCA_IP_GPTU_GPT_CLC_DISS                    (1 << 1)
#define INCA_IP_GPTU_GPT_CLC_DISR                    (1 << 0)
      
/***GPT Timer 3 Control Register***/ 
#define INCA_IP_GPTU_GPT_T3CON                     (VREG32 (INCA_IP_GPTU + 0x0014))
#define INCA_IP_GPTU_GPT_T3CON_T3RDIR                    (1 << 15)
#define INCA_IP_GPTU_GPT_T3CON_T3CHDIR                    (1 << 14)
#define INCA_IP_GPTU_GPT_T3CON_T3EDGE                    (1 << 13)                         
#define INCA_IP_GPTU_GPT_T3CON_BPS1_GET(value)           (((value) >> 11) & ((1 << 2) - 1))
#define INCA_IP_GPTU_GPT_T3CON_BPS1_SET(value)           ((((1 << 2) - 1) &(value)) << 11)
#define INCA_IP_GPTU_GPT_T3CON_T3OTL                    (1 << 10)
#define INCA_IP_GPTU_GPT_T3CON_T3UD                    (1 << 7)
#define INCA_IP_GPTU_GPT_T3CON_T3R                    (1 << 6)                         
#define INCA_IP_GPTU_GPT_T3CON_T3M_GET(value)           (((value) >> 3) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T3CON_T3M_SET(value)           ((((1 << 3) - 1) &(value)) << 3)                         
#define INCA_IP_GPTU_GPT_T3CON_T3I_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T3CON_T3I_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***GPT Write Hardware Modified Timer 3 Control Register 
If set and clear bit are written concurrently with 1, the associated bit is not changed.***/
#define INCA_IP_GPTU_GPT_WHBT3CON                     (VREG32 (INCA_IP_GPTU + 0x004C))
#define INCA_IP_GPTU_GPT_WHBT3CON_SETT3CHDIR                    (1 << 15)
#define INCA_IP_GPTU_GPT_WHBT3CON_CLRT3CHDIR                    (1 << 14)
#define INCA_IP_GPTU_GPT_WHBT3CON_SETT3EDGE                    (1 << 13)
#define INCA_IP_GPTU_GPT_WHBT3CON_CLRT3EDGE                    (1 << 12)
#define INCA_IP_GPTU_GPT_WHBT3CON_SETT3OTL                    (1 << 11)
#define INCA_IP_GPTU_GPT_WHBT3CON_CLRT3OTL                    (1 << 10)
      
/***GPT Timer 2 Control Register***/ 
#define INCA_IP_GPTU_GPT_T2CON                     (VREG32 (INCA_IP_GPTU + 0x0010))
#define INCA_IP_GPTU_GPT_T2CON_TxRDIR                    (1 << 15)
#define INCA_IP_GPTU_GPT_T2CON_TxCHDIR                    (1 << 14)
#define INCA_IP_GPTU_GPT_T2CON_TxEDGE                    (1 << 13)
#define INCA_IP_GPTU_GPT_T2CON_TxIRDIS                    (1 << 12)
#define INCA_IP_GPTU_GPT_T2CON_TxRC                    (1 << 9)
#define INCA_IP_GPTU_GPT_T2CON_TxUD                    (1 << 7)
#define INCA_IP_GPTU_GPT_T2CON_TxR                    (1 << 6)                         
#define INCA_IP_GPTU_GPT_T2CON_TxM_GET(value)           (((value) >> 3) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T2CON_TxM_SET(value)           ((((1 << 3) - 1) &(value)) << 3)                         
#define INCA_IP_GPTU_GPT_T2CON_TxI_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T2CON_TxI_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***GPT Timer 4 Control Register***/ 
#define INCA_IP_GPTU_GPT_T4CON                     (VREG32 (INCA_IP_GPTU + 0x0018))
#define INCA_IP_GPTU_GPT_T4CON_TxRDIR                    (1 << 15)
#define INCA_IP_GPTU_GPT_T4CON_TxCHDIR                    (1 << 14)
#define INCA_IP_GPTU_GPT_T4CON_TxEDGE                    (1 << 13)
#define INCA_IP_GPTU_GPT_T4CON_TxIRDIS                    (1 << 12)
#define INCA_IP_GPTU_GPT_T4CON_TxRC                    (1 << 9)
#define INCA_IP_GPTU_GPT_T4CON_TxUD                    (1 << 7)
#define INCA_IP_GPTU_GPT_T4CON_TxR                    (1 << 6)                         
#define INCA_IP_GPTU_GPT_T4CON_TxM_GET(value)           (((value) >> 3) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T4CON_TxM_SET(value)           ((((1 << 3) - 1) &(value)) << 3)                         
#define INCA_IP_GPTU_GPT_T4CON_TxI_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T4CON_TxI_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***GPT Write HW Modified Timer 2 Control Register If set
 and clear bit are written concurrently with 1, the associated bit is not changed.***/
#define INCA_IP_GPTU_GPT_WHBT2CON                     (VREG32 (INCA_IP_GPTU + 0x0048))
#define INCA_IP_GPTU_GPT_WHBT2CON_SETTxCHDIR                    (1 << 15)
#define INCA_IP_GPTU_GPT_WHBT2CON_CLRTxCHDIR                    (1 << 14)
#define INCA_IP_GPTU_GPT_WHBT2CON_SETTxEDGE                    (1 << 13)
#define INCA_IP_GPTU_GPT_WHBT2CON_CLRTxEDGE                    (1 << 12)
      
/***GPT Write HW Modified Timer 4 Control Register If set
 and clear bit are written concurrently with 1, the associated bit is not changed.***/
#define INCA_IP_GPTU_GPT_WHBT4CON                     (VREG32 (INCA_IP_GPTU + 0x0050))
#define INCA_IP_GPTU_GPT_WHBT4CON_SETTxCHDIR                    (1 << 15)
#define INCA_IP_GPTU_GPT_WHBT4CON_CLRTxCHDIR                    (1 << 14)
#define INCA_IP_GPTU_GPT_WHBT4CON_SETTxEDGE                    (1 << 13)
#define INCA_IP_GPTU_GPT_WHBT4CON_CLRTxEDGE                    (1 << 12)
      
/***GPT Capture Reload Register***/ 
#define INCA_IP_GPTU_GPT_CAPREL                     (VREG32 (INCA_IP_GPTU + 0x0030))                         
#define INCA_IP_GPTU_GPT_CAPREL_CAPREL_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_GPTU_GPT_CAPREL_CAPREL_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***GPT Timer 2 Register***/ 
#define INCA_IP_GPTU_GPT_T2                     (VREG32 (INCA_IP_GPTU + 0x0034))                         
#define INCA_IP_GPTU_GPT_T2_TVAL_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_GPTU_GPT_T2_TVAL_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***GPT Timer 3 Register***/ 
#define INCA_IP_GPTU_GPT_T3                     (VREG32 (INCA_IP_GPTU + 0x0038))                         
#define INCA_IP_GPTU_GPT_T3_TVAL_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_GPTU_GPT_T3_TVAL_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***GPT Timer 4 Register***/ 
#define INCA_IP_GPTU_GPT_T4                     (VREG32 (INCA_IP_GPTU + 0x003C))                         
#define INCA_IP_GPTU_GPT_T4_TVAL_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_GPTU_GPT_T4_TVAL_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***GPT Timer 5 Register***/ 
#define INCA_IP_GPTU_GPT_T5                     (VREG32 (INCA_IP_GPTU + 0x0040))                         
#define INCA_IP_GPTU_GPT_T5_TVAL_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_GPTU_GPT_T5_TVAL_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***GPT Timer 6 Register***/ 
#define INCA_IP_GPTU_GPT_T6                     (VREG32 (INCA_IP_GPTU + 0x0044))                         
#define INCA_IP_GPTU_GPT_T6_TVAL_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_GPTU_GPT_T6_TVAL_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***GPT Timer 6 Control Register***/ 
#define INCA_IP_GPTU_GPT_T6CON                     (VREG32 (INCA_IP_GPTU + 0x0020))
#define INCA_IP_GPTU_GPT_T6CON_T6SR                    (1 << 15)
#define INCA_IP_GPTU_GPT_T6CON_T6CLR                    (1 << 14)                         
#define INCA_IP_GPTU_GPT_T6CON_BPS2_GET(value)           (((value) >> 11) & ((1 << 2) - 1))
#define INCA_IP_GPTU_GPT_T6CON_BPS2_SET(value)           ((((1 << 2) - 1) &(value)) << 11)
#define INCA_IP_GPTU_GPT_T6CON_T6OTL                    (1 << 10)
#define INCA_IP_GPTU_GPT_T6CON_T6UD                    (1 << 7)
#define INCA_IP_GPTU_GPT_T6CON_T6R                    (1 << 6)                         
#define INCA_IP_GPTU_GPT_T6CON_T6M_GET(value)           (((value) >> 3) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T6CON_T6M_SET(value)           ((((1 << 3) - 1) &(value)) << 3)                         
#define INCA_IP_GPTU_GPT_T6CON_T6I_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T6CON_T6I_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***GPT Write HW Modified Timer 6 Control Register If set
 and clear bit are written concurrently with 1, the associated bit is not changed.***/
#define INCA_IP_GPTU_GPT_WHBT6CON                     (VREG32 (INCA_IP_GPTU + 0x0054))
#define INCA_IP_GPTU_GPT_WHBT6CON_SETT6OTL                    (1 << 11)
#define INCA_IP_GPTU_GPT_WHBT6CON_CLRT6OTL                    (1 << 10)
      
/***GPT Timer 5 Control Register***/ 
#define INCA_IP_GPTU_GPT_T5CON                     (VREG32 (INCA_IP_GPTU + 0x001C))
#define INCA_IP_GPTU_GPT_T5CON_T5SC                    (1 << 15)
#define INCA_IP_GPTU_GPT_T5CON_T5CLR                    (1 << 14)                         
#define INCA_IP_GPTU_GPT_T5CON_CI_GET(value)           (((value) >> 12) & ((1 << 2) - 1))
#define INCA_IP_GPTU_GPT_T5CON_CI_SET(value)           ((((1 << 2) - 1) &(value)) << 12)
#define INCA_IP_GPTU_GPT_T5CON_T5CC                    (1 << 11)
#define INCA_IP_GPTU_GPT_T5CON_CT3                    (1 << 10)
#define INCA_IP_GPTU_GPT_T5CON_T5RC                    (1 << 9)
#define INCA_IP_GPTU_GPT_T5CON_T5UDE                    (1 << 8)
#define INCA_IP_GPTU_GPT_T5CON_T5UD                    (1 << 7)
#define INCA_IP_GPTU_GPT_T5CON_T5R                    (1 << 6)                         
#define INCA_IP_GPTU_GPT_T5CON_T5M_GET(value)           (((value) >> 3) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T5CON_T5M_SET(value)           ((((1 << 3) - 1) &(value)) << 3)                         
#define INCA_IP_GPTU_GPT_T5CON_T5I_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_GPTU_GPT_T5CON_T5I_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***GPTInterrupt Node Control Register 0***/ 
#define INCA_IP_GPTU_GPT_IRNCR0                     (VREG32 (INCA_IP_GPTU + 0x00FC))
#define INCA_IP_GPTU_GPT_IRNCR0_T2IR                    (1 << 5)
#define INCA_IP_GPTU_GPT_IRNCR0_T3IR                    (1 << 4)
#define INCA_IP_GPTU_GPT_IRNCR0_T4IR                    (1 << 3)
#define INCA_IP_GPTU_GPT_IRNCR0_T5IR                    (1 << 2)
#define INCA_IP_GPTU_GPT_IRNCR0_T6IR                    (1 << 1)
#define INCA_IP_GPTU_GPT_IRNCR0_CAPIR                    (1 << 0)
      
/***GPT Interrupt Node Control Register 1***/ 
#define INCA_IP_GPTU_GPT_IRNCR1                     (VREG32 (INCA_IP_GPTU + 0x00F8))
#define INCA_IP_GPTU_GPT_IRNCR1_T2IR                    (1 << 5)
#define INCA_IP_GPTU_GPT_IRNCR1_T3IR                    (1 << 4)
#define INCA_IP_GPTU_GPT_IRNCR1_T4IR                    (1 << 3)
#define INCA_IP_GPTU_GPT_IRNCR1_T5IR                    (1 << 2)
#define INCA_IP_GPTU_GPT_IRNCR1_T6IR                    (1 << 1)
#define INCA_IP_GPTU_GPT_IRNCR1_CAPIR                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  SDRAM register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_SDRAM                     (0xBF800000)
/***********************************************************************/   

      
/***MC Access Error Cause Register***/ 
#define INCA_IP_SDRAM_MC_ERRCAUSE                     (VREG32 (INCA_IP_SDRAM + 0x0100))
#define INCA_IP_SDRAM_MC_ERRCAUSE_ERR                    (1 << 31)                         
#define INCA_IP_SDRAM_MC_ERRCAUSE_PORT_GET(value)           (((value) >> 16) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_ERRCAUSE_PORT_SET(value)           ((((1 << 4) - 1) &(value)) << 16)                         
#define INCA_IP_SDRAM_MC_ERRCAUSE_CAUSE_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_SDRAM_MC_ERRCAUSE_CAUSE_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***MC Access Error Address Register***/ 
#define INCA_IP_SDRAM_MC_ERRADDR                     (VREG32 (INCA_IP_SDRAM + 0x0108))
#define INCA_IP_SDRAM_MC_ERRADDR_ADDR
      
/***MC I/O General Purpose Register***/ 
#define INCA_IP_SDRAM_MC_IOGP                     (VREG32 (INCA_IP_SDRAM + 0x0800))                         
#define INCA_IP_SDRAM_MC_IOGP_GPR6_GET(value)           (((value) >> 28) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_IOGP_GPR6_SET(value)           ((((1 << 4) - 1) &(value)) << 28)                         
#define INCA_IP_SDRAM_MC_IOGP_GPR5_GET(value)           (((value) >> 24) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_IOGP_GPR5_SET(value)           ((((1 << 4) - 1) &(value)) << 24)                         
#define INCA_IP_SDRAM_MC_IOGP_GPR4_GET(value)           (((value) >> 20) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_IOGP_GPR4_SET(value)           ((((1 << 4) - 1) &(value)) << 20)                         
#define INCA_IP_SDRAM_MC_IOGP_GPR3_GET(value)           (((value) >> 16) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_IOGP_GPR3_SET(value)           ((((1 << 4) - 1) &(value)) << 16)                         
#define INCA_IP_SDRAM_MC_IOGP_GPR2_GET(value)           (((value) >> 12) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_IOGP_GPR2_SET(value)           ((((1 << 4) - 1) &(value)) << 12)
#define INCA_IP_SDRAM_MC_IOGP_CPS                    (1 << 11)                         
#define INCA_IP_SDRAM_MC_IOGP_CLKDELAY_GET(value)           (((value) >> 8) & ((1 << 3) - 1))
#define INCA_IP_SDRAM_MC_IOGP_CLKDELAY_SET(value)           ((((1 << 3) - 1) &(value)) << 8)                         
#define INCA_IP_SDRAM_MC_IOGP_CLKRAT_GET(value)           (((value) >> 4) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_IOGP_CLKRAT_SET(value)           ((((1 << 4) - 1) &(value)) << 4)                         
#define INCA_IP_SDRAM_MC_IOGP_RDDEL_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_IOGP_RDDEL_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***MC Self Refresh Register***/ 
#define INCA_IP_SDRAM_MC_SELFRFSH                     (VREG32 (INCA_IP_SDRAM + 0x0A00))
#define INCA_IP_SDRAM_MC_SELFRFSH_PWDS                    (1 << 1)
#define INCA_IP_SDRAM_MC_SELFRFSH_PWD                    (1 << 0)
#define INCA_IP_SDRAM_MC_SELFRFSH_Res_GET(value)           (((value) >> 2) & ((1 << 30) - 1))
#define INCA_IP_SDRAM_MC_SELFRFSH_Res_SET(value)           (((( 1 << 30) - 1) &(value)) << 2)                         
      
/***MC Enable Register***/ 
#define INCA_IP_SDRAM_MC_CTRLENA                     (VREG32 (INCA_IP_SDRAM + 0x1000))
#define INCA_IP_SDRAM_MC_CTRLENA_ENA                    (1 << 0)
#define INCA_IP_SDRAM_MC_CTRLENA_Res_GET(value)           (((value) >> 1) & ((1 << 31) - 1))
#define INCA_IP_SDRAM_MC_CTRLENA_Res_SET(value)           (((( 1 << 31) - 1) &(value)) << 1)                         
      
/***MC Mode Register Setup Code***/ 
#define INCA_IP_SDRAM_MC_MRSCODE                     (VREG32 (INCA_IP_SDRAM + 0x1008))                         
#define INCA_IP_SDRAM_MC_MRSCODE_UMC_GET(value)           (((value) >> 7) & ((1 << 5) - 1))
#define INCA_IP_SDRAM_MC_MRSCODE_UMC_SET(value)           ((((1 << 5) - 1) &(value)) << 7)                         
#define INCA_IP_SDRAM_MC_MRSCODE_CL_GET(value)           (((value) >> 4) & ((1 << 3) - 1))
#define INCA_IP_SDRAM_MC_MRSCODE_CL_SET(value)           ((((1 << 3) - 1) &(value)) << 4)
#define INCA_IP_SDRAM_MC_MRSCODE_WT                    (1 << 3)                         
#define INCA_IP_SDRAM_MC_MRSCODE_BL_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_SDRAM_MC_MRSCODE_BL_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***MC Configuration Data-word Width Register***/ 
#define INCA_IP_SDRAM_MC_CFGDW                     (VREG32 (INCA_IP_SDRAM + 0x1010))                         
#define INCA_IP_SDRAM_MC_CFGDW_DW_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_CFGDW_DW_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***MC Configuration Physical Bank 0 Register***/ 
#define INCA_IP_SDRAM_MC_CFGPB0                     (VREG32 (INCA_IP_SDRAM + 0x1018))                         
#define INCA_IP_SDRAM_MC_CFGPB0_MCSEN0_GET(value)           (((value) >> 12) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_CFGPB0_MCSEN0_SET(value)           ((((1 << 4) - 1) &(value)) << 12)                         
#define INCA_IP_SDRAM_MC_CFGPB0_BANKN0_GET(value)           (((value) >> 8) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_CFGPB0_BANKN0_SET(value)           ((((1 << 4) - 1) &(value)) << 8)                         
#define INCA_IP_SDRAM_MC_CFGPB0_ROWW0_GET(value)           (((value) >> 4) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_CFGPB0_ROWW0_SET(value)           ((((1 << 4) - 1) &(value)) << 4)                         
#define INCA_IP_SDRAM_MC_CFGPB0_COLW0_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_CFGPB0_COLW0_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***MC Latency Register***/ 
#define INCA_IP_SDRAM_MC_LATENCY                     (VREG32 (INCA_IP_SDRAM + 0x1038))                         
#define INCA_IP_SDRAM_MC_LATENCY_TRP_GET(value)           (((value) >> 16) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_LATENCY_TRP_SET(value)           ((((1 << 4) - 1) &(value)) << 16)                         
#define INCA_IP_SDRAM_MC_LATENCY_TRAS_GET(value)           (((value) >> 12) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_LATENCY_TRAS_SET(value)           ((((1 << 4) - 1) &(value)) << 12)                         
#define INCA_IP_SDRAM_MC_LATENCY_TRCD_GET(value)           (((value) >> 8) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_LATENCY_TRCD_SET(value)           ((((1 << 4) - 1) &(value)) << 8)                         
#define INCA_IP_SDRAM_MC_LATENCY_TDPL_GET(value)           (((value) >> 4) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_LATENCY_TDPL_SET(value)           ((((1 << 4) - 1) &(value)) << 4)                         
#define INCA_IP_SDRAM_MC_LATENCY_TDAL_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_SDRAM_MC_LATENCY_TDAL_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***MC Refresh Cycle Time Register***/ 
#define INCA_IP_SDRAM_MC_TREFRESH                     (VREG32 (INCA_IP_SDRAM + 0x1040))                         
#define INCA_IP_SDRAM_MC_TREFRESH_TREF_GET(value)           (((value) >> 0) & ((1 << 13) - 1))
#define INCA_IP_SDRAM_MC_TREFRESH_TREF_SET(value)           ((((1 << 13) - 1) &(value)) << 0)		
         
/***********************************************************************/
/*  Module      :  EBU register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_EBU                     (0xB8000200)
/***********************************************************************/   

      
/***EBU Clock Control Register***/ 
#define INCA_IP_EBU_EBU_CLC                     (VREG32 (INCA_IP_EBU + 0x0000))
#define INCA_IP_EBU_EBU_CLC_DISS                    (1 << 1)
#define INCA_IP_EBU_EBU_CLC_DISR                    (1 << 0)
      
/***EBU Global Control Register***/ 
#define INCA_IP_EBU_EBU_CON                     (VREG32 (INCA_IP_EBU + 0x0010))                         
#define INCA_IP_EBU_EBU_CON_DTACS_GET(value)           (((value) >> 20) & ((1 << 3) - 1))
#define INCA_IP_EBU_EBU_CON_DTACS_SET(value)           ((((1 << 3) - 1) &(value)) << 20)                         
#define INCA_IP_EBU_EBU_CON_DTARW_GET(value)           (((value) >> 16) & ((1 << 3) - 1))
#define INCA_IP_EBU_EBU_CON_DTARW_SET(value)           ((((1 << 3) - 1) &(value)) << 16)                         
#define INCA_IP_EBU_EBU_CON_TOUTC_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_EBU_EBU_CON_TOUTC_SET(value)           ((((1 << 8) - 1) &(value)) << 8)                         
#define INCA_IP_EBU_EBU_CON_ARBMODE_GET(value)           (((value) >> 6) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_CON_ARBMODE_SET(value)           ((((1 << 2) - 1) &(value)) << 6)
#define INCA_IP_EBU_EBU_CON_ARBSYNC                    (1 << 5)
#define INCA_IP_EBU_EBU_CON_1                    (1 << 3)
      
/***EBU Address Select Register 0***/ 
#define INCA_IP_EBU_EBU_ADDSEL0                     (VREG32 (INCA_IP_EBU + 0x0020))                         
#define INCA_IP_EBU_EBU_ADDSEL0_BASE_GET(value)           (((value) >> 12) & ((1 << 20) - 1))
#define INCA_IP_EBU_EBU_ADDSEL0_BASE_SET(value)           ((((1 << 20) - 1) &(value)) << 12)                         
#define INCA_IP_EBU_EBU_ADDSEL0_MASK_GET(value)           (((value) >> 4) & ((1 << 4) - 1))
#define INCA_IP_EBU_EBU_ADDSEL0_MASK_SET(value)           ((((1 << 4) - 1) &(value)) << 4)
#define INCA_IP_EBU_EBU_ADDSEL0_MIRRORE                    (1 << 1)
#define INCA_IP_EBU_EBU_ADDSEL0_REGEN                    (1 << 0)
      
/***EBU Address Select Register 1***/ 
#define INCA_IP_EBU_EBU_ADDSEL1                     (VREG32 (INCA_IP_EBU + 0x0024))                         
#define INCA_IP_EBU_EBU_ADDSEL1_BASE_GET(value)           (((value) >> 12) & ((1 << 20) - 1))
#define INCA_IP_EBU_EBU_ADDSEL1_BASE_SET(value)           ((((1 << 20) - 1) &(value)) << 12)                         
#define INCA_IP_EBU_EBU_ADDSEL1_MASK_GET(value)           (((value) >> 4) & ((1 << 4) - 1))
#define INCA_IP_EBU_EBU_ADDSEL1_MASK_SET(value)           ((((1 << 4) - 1) &(value)) << 4)
#define INCA_IP_EBU_EBU_ADDSEL1_MIRRORE                    (1 << 1)
#define INCA_IP_EBU_EBU_ADDSEL1_REGEN                    (1 << 0)
      
/***EBU Address Select Register 2***/ 
#define INCA_IP_EBU_EBU_ADDSEL2                     (VREG32 (INCA_IP_EBU + 0x0028))                         
#define INCA_IP_EBU_EBU_ADDSEL2_BASE_GET(value)           (((value) >> 12) & ((1 << 20) - 1))
#define INCA_IP_EBU_EBU_ADDSEL2_BASE_SET(value)           ((((1 << 20) - 1) &(value)) << 12)                         
#define INCA_IP_EBU_EBU_ADDSEL2_MASK_GET(value)           (((value) >> 4) & ((1 << 4) - 1))
#define INCA_IP_EBU_EBU_ADDSEL2_MASK_SET(value)           ((((1 << 4) - 1) &(value)) << 4)
#define INCA_IP_EBU_EBU_ADDSEL2_MIRRORE                    (1 << 1)
#define INCA_IP_EBU_EBU_ADDSEL2_REGEN                    (1 << 0)
      
/***EBU Bus Configuration Register 0***/ 
#define INCA_IP_EBU_EBU_BUSCON0                     (VREG32 (INCA_IP_EBU + 0x0060))
#define INCA_IP_EBU_EBU_BUSCON0_WRDIS                    (1 << 31)                         
#define INCA_IP_EBU_EBU_BUSCON0_ADSWP                    (1 << 30)                         
#define INCA_IP_EBU_EBU_BUSCON0_ALEC_GET(value)           (((value) >> 29) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_ALEC_SET(value)           ((((1 << 2) - 1) &(value)) << 29)                         
#define INCA_IP_EBU_EBU_BUSCON0_BCGEN_GET(value)           (((value) >> 27) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_BCGEN_SET(value)           ((((1 << 2) - 1) &(value)) << 27)                         
#define INCA_IP_EBU_EBU_BUSCON0_AGEN_GET(value)           (((value) >> 24) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_AGEN_SET(value)           ((((1 << 2) - 1) &(value)) << 24)                         
#define INCA_IP_EBU_EBU_BUSCON0_CMULTR_GET(value)           (((value) >> 22) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_CMULTR_SET(value)           ((((1 << 2) - 1) &(value)) << 22)                         
#define INCA_IP_EBU_EBU_BUSCON0_WAIT_GET(value)           (((value) >> 20) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_WAIT_SET(value)           ((((1 << 2) - 1) &(value)) << 20)
#define INCA_IP_EBU_EBU_BUSCON0_WAITINV                    (1 << 19)
#define INCA_IP_EBU_EBU_BUSCON0_SETUP                    (1 << 18)                         
#define INCA_IP_EBU_EBU_BUSCON0_PORTW_GET(value)           (((value) >> 16) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_PORTW_SET(value)           ((((1 << 2) - 1) &(value)) << 16)                         
#define INCA_IP_EBU_EBU_BUSCON0_WAITRDC_GET(value)           (((value) >> 9) & ((1 << 7) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_WAITRDC_SET(value)           ((((1 << 7) - 1) &(value)) << 9)                         
#define INCA_IP_EBU_EBU_BUSCON0_WAITWRC_GET(value)           (((value) >> 6) & ((1 << 3) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_WAITWRC_SET(value)           ((((1 << 3) - 1) &(value)) << 6)                         
#define INCA_IP_EBU_EBU_BUSCON0_HOLDC_GET(value)           (((value) >> 4) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_HOLDC_SET(value)           ((((1 << 2) - 1) &(value)) << 4)                         
#define INCA_IP_EBU_EBU_BUSCON0_RECOVC_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_RECOVC_SET(value)           ((((1 << 2) - 1) &(value)) << 2)                         
#define INCA_IP_EBU_EBU_BUSCON0_CMULT_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON0_CMULT_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***EBU Bus Configuration Register 1***/ 
#define INCA_IP_EBU_EBU_BUSCON1                     (VREG32 (INCA_IP_EBU + 0x0064))
#define INCA_IP_EBU_EBU_BUSCON1_WRDIS                    (1 << 31)                         
#define INCA_IP_EBU_EBU_BUSCON1_ADSWP                    (1 << 30)                         
#define INCA_IP_EBU_EBU_BUSCON1_ALEC_GET(value)           (((value) >> 29) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_ALEC_SET(value)           ((((1 << 2) - 1) &(value)) << 29)                         
#define INCA_IP_EBU_EBU_BUSCON1_BCGEN_GET(value)           (((value) >> 27) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_BCGEN_SET(value)           ((((1 << 2) - 1) &(value)) << 27)                         
#define INCA_IP_EBU_EBU_BUSCON1_AGEN_GET(value)           (((value) >> 24) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_AGEN_SET(value)           ((((1 << 2) - 1) &(value)) << 24)                         
#define INCA_IP_EBU_EBU_BUSCON1_CMULTR_GET(value)           (((value) >> 22) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_CMULTR_SET(value)           ((((1 << 2) - 1) &(value)) << 22)                         
#define INCA_IP_EBU_EBU_BUSCON1_WAIT_GET(value)           (((value) >> 20) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_WAIT_SET(value)           ((((1 << 2) - 1) &(value)) << 20)
#define INCA_IP_EBU_EBU_BUSCON1_WAITINV                    (1 << 19)
#define INCA_IP_EBU_EBU_BUSCON1_SETUP                    (1 << 18)                         
#define INCA_IP_EBU_EBU_BUSCON1_PORTW_GET(value)           (((value) >> 16) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_PORTW_SET(value)           ((((1 << 2) - 1) &(value)) << 16)                         
#define INCA_IP_EBU_EBU_BUSCON1_WAITRDC_GET(value)           (((value) >> 9) & ((1 << 7) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_WAITRDC_SET(value)           ((((1 << 7) - 1) &(value)) << 9)                         
#define INCA_IP_EBU_EBU_BUSCON1_WAITWRC_GET(value)           (((value) >> 6) & ((1 << 3) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_WAITWRC_SET(value)           ((((1 << 3) - 1) &(value)) << 6)                         
#define INCA_IP_EBU_EBU_BUSCON1_HOLDC_GET(value)           (((value) >> 4) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_HOLDC_SET(value)           ((((1 << 2) - 1) &(value)) << 4)                         
#define INCA_IP_EBU_EBU_BUSCON1_RECOVC_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_RECOVC_SET(value)           ((((1 << 2) - 1) &(value)) << 2)                         
#define INCA_IP_EBU_EBU_BUSCON1_CMULT_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON1_CMULT_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***EBU Bus Configuration Register 2***/ 
#define INCA_IP_EBU_EBU_BUSCON2                     (VREG32 (INCA_IP_EBU + 0x0068))
#define INCA_IP_EBU_EBU_BUSCON2_WRDIS                    (1 << 31)                         
#define INCA_IP_EBU_EBU_BUSCON2_ADSWP                    (1 << 30)                         
#define INCA_IP_EBU_EBU_BUSCON2_ALEC_GET(value)           (((value) >> 29) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_ALEC_SET(value)           ((((1 << 2) - 1) &(value)) << 29)                         
#define INCA_IP_EBU_EBU_BUSCON2_BCGEN_GET(value)           (((value) >> 27) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_BCGEN_SET(value)           ((((1 << 2) - 1) &(value)) << 27)                         
#define INCA_IP_EBU_EBU_BUSCON2_AGEN_GET(value)           (((value) >> 24) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_AGEN_SET(value)           ((((1 << 2) - 1) &(value)) << 24)                         
#define INCA_IP_EBU_EBU_BUSCON2_CMULTR_GET(value)           (((value) >> 22) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_CMULTR_SET(value)           ((((1 << 2) - 1) &(value)) << 22)                         
#define INCA_IP_EBU_EBU_BUSCON2_WAIT_GET(value)           (((value) >> 20) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_WAIT_SET(value)           ((((1 << 2) - 1) &(value)) << 20)
#define INCA_IP_EBU_EBU_BUSCON2_WAITINV                    (1 << 19)
#define INCA_IP_EBU_EBU_BUSCON2_SETUP                    (1 << 18)                         
#define INCA_IP_EBU_EBU_BUSCON2_PORTW_GET(value)           (((value) >> 16) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_PORTW_SET(value)           ((((1 << 2) - 1) &(value)) << 16)                         
#define INCA_IP_EBU_EBU_BUSCON2_WAITRDC_GET(value)           (((value) >> 9) & ((1 << 7) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_WAITRDC_SET(value)           ((((1 << 7) - 1) &(value)) << 9)                         
#define INCA_IP_EBU_EBU_BUSCON2_WAITWRC_GET(value)           (((value) >> 6) & ((1 << 3) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_WAITWRC_SET(value)           ((((1 << 3) - 1) &(value)) << 6)                         
#define INCA_IP_EBU_EBU_BUSCON2_HOLDC_GET(value)           (((value) >> 4) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_HOLDC_SET(value)           ((((1 << 2) - 1) &(value)) << 4)                         
#define INCA_IP_EBU_EBU_BUSCON2_RECOVC_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_RECOVC_SET(value)           ((((1 << 2) - 1) &(value)) << 2)                         
#define INCA_IP_EBU_EBU_BUSCON2_CMULT_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_EBU_EBU_BUSCON2_CMULT_SET(value)           ((((1 << 2) - 1) &(value)) << 0)		
         
/***********************************************************************/
/*  Module      :  Switch register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_Switch                     (0xBF104000)
/***********************************************************************/   

      
/***Unknown Destination Register***/ 
#define INCA_IP_Switch_UN_DEST                     (VREG32 (INCA_IP_Switch + 0x0000))
#define INCA_IP_Switch_UN_DEST_CB                    (1 << 8)
#define INCA_IP_Switch_UN_DEST_LB                    (1 << 7)
#define INCA_IP_Switch_UN_DEST_PB                    (1 << 6)
#define INCA_IP_Switch_UN_DEST_CM                    (1 << 5)
#define INCA_IP_Switch_UN_DEST_LM                    (1 << 4)
#define INCA_IP_Switch_UN_DEST_PM                    (1 << 3)
#define INCA_IP_Switch_UN_DEST_CU                    (1 << 2)
#define INCA_IP_Switch_UN_DEST_LU                    (1 << 1)
#define INCA_IP_Switch_UN_DEST_PU                    (1 << 0)
      
/***VLAN Control Register***/ 
#define INCA_IP_Switch_VLAN_CTRL                     (VREG32 (INCA_IP_Switch + 0x0004))
#define INCA_IP_Switch_VLAN_CTRL_SC                    (1 << 6)
#define INCA_IP_Switch_VLAN_CTRL_SL                    (1 << 5)
#define INCA_IP_Switch_VLAN_CTRL_SP                    (1 << 4)
#define INCA_IP_Switch_VLAN_CTRL_TC                    (1 << 3)
#define INCA_IP_Switch_VLAN_CTRL_TL                    (1 << 2)
#define INCA_IP_Switch_VLAN_CTRL_TP                    (1 << 1)
#define INCA_IP_Switch_VLAN_CTRL_VA                    (1 << 0)
      
/***PC VLAN Configuration Register***/ 
#define INCA_IP_Switch_PC_VLAN                     (VREG32 (INCA_IP_Switch + 0x0008))                         
#define INCA_IP_Switch_PC_VLAN_PRI_GET(value)           (((value) >> 12) & ((1 << 3) - 1))
#define INCA_IP_Switch_PC_VLAN_PRI_SET(value)           ((((1 << 3) - 1) &(value)) << 12)                         
#define INCA_IP_Switch_PC_VLAN_VLAN_ID_GET(value)           (((value) >> 0) & ((1 << 12) - 1))
#define INCA_IP_Switch_PC_VLAN_VLAN_ID_SET(value)           ((((1 << 12) - 1) &(value)) << 0)
      
/***LAN VLAN Configuration Register***/ 
#define INCA_IP_Switch_LAN_VLAN                     (VREG32 (INCA_IP_Switch + 0x000C))                         
#define INCA_IP_Switch_LAN_VLAN_PRI_GET(value)           (((value) >> 12) & ((1 << 3) - 1))
#define INCA_IP_Switch_LAN_VLAN_PRI_SET(value)           ((((1 << 3) - 1) &(value)) << 12)                         
#define INCA_IP_Switch_LAN_VLAN_VLAN_ID_GET(value)           (((value) >> 0) & ((1 << 12) - 1))
#define INCA_IP_Switch_LAN_VLAN_VLAN_ID_SET(value)           ((((1 << 12) - 1) &(value)) << 0)
      
/***CPU VLAN Configuration Register***/ 
#define INCA_IP_Switch_CPU_VLAN                     (VREG32 (INCA_IP_Switch + 0x0010))                         
#define INCA_IP_Switch_CPU_VLAN_PRI_GET(value)           (((value) >> 12) & ((1 << 3) - 1))
#define INCA_IP_Switch_CPU_VLAN_PRI_SET(value)           ((((1 << 3) - 1) &(value)) << 12)                         
#define INCA_IP_Switch_CPU_VLAN_VLAN_ID_GET(value)           (((value) >> 0) & ((1 << 12) - 1))
#define INCA_IP_Switch_CPU_VLAN_VLAN_ID_SET(value)           ((((1 << 12) - 1) &(value)) << 0)
      
/***Priority CoS Mapping Register***/ 
#define INCA_IP_Switch_PRI_CoS                     (VREG32 (INCA_IP_Switch + 0x0014))
#define INCA_IP_Switch_PRI_CoS_P7                    (1 << 7)
#define INCA_IP_Switch_PRI_CoS_P6                    (1 << 6)
#define INCA_IP_Switch_PRI_CoS_P5                    (1 << 5)
#define INCA_IP_Switch_PRI_CoS_P4                    (1 << 4)
#define INCA_IP_Switch_PRI_CoS_P3                    (1 << 3)
#define INCA_IP_Switch_PRI_CoS_P2                    (1 << 2)
#define INCA_IP_Switch_PRI_CoS_P1                    (1 << 1)
#define INCA_IP_Switch_PRI_CoS_P0                    (1 << 0)
      
/***Spanning Tree Port Status Register***/ 
#define INCA_IP_Switch_ST_PT                     (VREG32 (INCA_IP_Switch + 0x0018))                         
#define INCA_IP_Switch_ST_PT_CPS_GET(value)           (((value) >> 4) & ((1 << 2) - 1))
#define INCA_IP_Switch_ST_PT_CPS_SET(value)           ((((1 << 2) - 1) &(value)) << 4)                         
#define INCA_IP_Switch_ST_PT_LPS_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_Switch_ST_PT_LPS_SET(value)           ((((1 << 2) - 1) &(value)) << 2)                         
#define INCA_IP_Switch_ST_PT_PPS_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_Switch_ST_PT_PPS_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***ARL Control Register***/ 
#define INCA_IP_Switch_ARL_CTL                     (VREG32 (INCA_IP_Switch + 0x001C))
#define INCA_IP_Switch_ARL_CTL_CHCC                    (1 << 15)
#define INCA_IP_Switch_ARL_CTL_CHCL                    (1 << 14)
#define INCA_IP_Switch_ARL_CTL_CHCP                    (1 << 13)
#define INCA_IP_Switch_ARL_CTL_CC                    (1 << 12)
#define INCA_IP_Switch_ARL_CTL_CL                    (1 << 11)
#define INCA_IP_Switch_ARL_CTL_CP                    (1 << 10)
#define INCA_IP_Switch_ARL_CTL_CG                    (1 << 9)
#define INCA_IP_Switch_ARL_CTL_PS                    (1 << 8)
#define INCA_IP_Switch_ARL_CTL_MRO                    (1 << 7)
#define INCA_IP_Switch_ARL_CTL_SRC                    (1 << 6)
#define INCA_IP_Switch_ARL_CTL_ATS                    (1 << 5)                         
#define INCA_IP_Switch_ARL_CTL_AGE_TICK_SEL_GET(value)           (((value) >> 2) & ((1 << 3) - 1))
#define INCA_IP_Switch_ARL_CTL_AGE_TICK_SEL_SET(value)           ((((1 << 3) - 1) &(value)) << 2)
#define INCA_IP_Switch_ARL_CTL_MAF                    (1 << 1)
#define INCA_IP_Switch_ARL_CTL_ENL                    (1 << 0)
#define INCA_IP_Switch_ARL_CTL_Res_GET(value)           (((value) >> 13) & ((1 << 19) - 1))
#define INCA_IP_Switch_ARL_CTL_Res_SET(value)           ((((1 << 19) - 1) &(value)) << 13)
      
/***CPU Access Control Register***/ 
#define INCA_IP_Switch_CPU_ACTL                     (VREG32 (INCA_IP_Switch + 0x0020))
#define INCA_IP_Switch_CPU_ACTL_RA                    (1 << 31)
#define INCA_IP_Switch_CPU_ACTL_RW                    (1 << 30)
#define INCA_IP_Switch_CPU_ACTL_Res_GET(value)           (((value) >> 9) & ((1 << 21) - 1))
#define INCA_IP_Switch_CPU_ACTL_Res_SET(value)           ((((1 << 21) - 1) &(value)) << 9)
#define INCA_IP_Switch_CPU_ACTL_AVA                    (1 << 8)                         
#define INCA_IP_Switch_CPU_ACTL_IDX_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_Switch_CPU_ACTL_IDX_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***CPU Access Data Register 1***/ 
#define INCA_IP_Switch_DATA1                     (VREG32 (INCA_IP_Switch + 0x0024))                         
#define INCA_IP_Switch_DATA1_Data_GET(value)           (((value) >> 0) & ((1 << 24) - 1))
#define INCA_IP_Switch_DATA1_Data_SET(value)           ((((1 << 24) - 1) &(value)) << 0)
      
/***CPU Access Data Register 2***/ 
#define INCA_IP_Switch_DATA2                     (VREG32 (INCA_IP_Switch + 0x0028))
#define INCA_IP_Switch_DATA2_Data
      
/***CPU Port Control Register***/ 
#define INCA_IP_Switch_CPU_PCTL                     (VREG32 (INCA_IP_Switch + 0x002C))                         
#define INCA_IP_Switch_CPU_PCTL_DA_PORTS_GET(value)    (((value) >> 11) & ((1 << 3) - 1))
#define INCA_IP_Switch_CPU_PCTL_DA_PORTS_SET(value)    ((((1 << 3) - 1) &(value)) << 11)
#define INCA_IP_Switch_CPU_PCTL_DAC                    (1 << 10)                         
#define INCA_IP_Switch_CPU_PCTL_MA_STATE_GET(value)    (((value) >> 7) & ((1 << 3) - 1))
#define INCA_IP_Switch_CPU_PCTL_MA_STATE_SET(value)    ((((1 << 3) - 1) &(value)) << 7)
#define INCA_IP_Switch_CPU_PCTL_MAM                    (1 << 6)                         
#define INCA_IP_Switch_CPU_PCTL_MA_Ports_GET(value)    (((value) >> 3) & ((1 << 3) - 1))
#define INCA_IP_Switch_CPU_PCTL_MA_Ports_SET(value)    ((((1 << 3) - 1) &(value)) << 3)
#define INCA_IP_Switch_CPU_PCTL_MAC                    (1 << 2)
#define INCA_IP_Switch_CPU_PCTL_EML                    (1 << 1)
#define INCA_IP_Switch_CPU_PCTL_EDL                    (1 << 0)
#define INCA_IP_Switch_CPU_PCTL_Res_GET(value)         (((value) >> 14) & ((1 << 18) - 1))
#define INCA_IP_Switch_CPU_PCTL_Res_SET(value)         ((((1 << 18) - 1) &(value)) << 14)                         


/***DSCP CoS Mapping Register 1***/ 
#define INCA_IP_Switch_DSCP_COS1                     (VREG32 (INCA_IP_Switch + 0x0030))
#define INCA_IP_Switch_DSCP_COS1_DSCP
      
/***DSCP CoS Mapping Register 1***/ 
#define INCA_IP_Switch_DSCP_COS2                     (VREG32 (INCA_IP_Switch + 0x0034))
#define INCA_IP_Switch_DSCP_COS2_DSCP
      
/***PC WFQ Control Register***/ 
#define INCA_IP_Switch_PC_WFQ_CTL                     (VREG32 (INCA_IP_Switch + 0x0080))
#define INCA_IP_Switch_PC_WFQ_CTL_P1                    (1 << 9)
#define INCA_IP_Switch_PC_WFQ_CTL_P0                    (1 << 8)                         
#define INCA_IP_Switch_PC_WFQ_CTL_WT1_GET(value)           (((value) >> 5) & ((1 << 3) - 1))
#define INCA_IP_Switch_PC_WFQ_CTL_WT1_SET(value)           ((((1 << 3) - 1) &(value)) << 5)                         
#define INCA_IP_Switch_PC_WFQ_CTL_WT0_GET(value)           (((value) >> 2) & ((1 << 3) - 1))
#define INCA_IP_Switch_PC_WFQ_CTL_WT0_SET(value)           ((((1 << 3) - 1) &(value)) << 2)                         
#define INCA_IP_Switch_PC_WFQ_CTL_SCH_SEL_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_Switch_PC_WFQ_CTL_SCH_SEL_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***PC TX Control Register***/ 
#define INCA_IP_Switch_PC_TX_CTL                     (VREG32 (INCA_IP_Switch + 0x0084))
#define INCA_IP_Switch_PC_TX_CTL_ELR                    (1 << 1)
#define INCA_IP_Switch_PC_TX_CTL_EER                    (1 << 0)
      
/***LAN WFQ Control Register***/ 
#define INCA_IP_Switch_LAN_WFQ_CTL                     (VREG32 (INCA_IP_Switch + 0x0100))
#define INCA_IP_Switch_LAN_WFQ_CTL_P1                    (1 << 9)
#define INCA_IP_Switch_LAN_WFQ_CTL_P0                    (1 << 8)                         
#define INCA_IP_Switch_LAN_WFQ_CTL_WT1_GET(value)           (((value) >> 5) & ((1 << 3) - 1))
#define INCA_IP_Switch_LAN_WFQ_CTL_WT1_SET(value)           ((((1 << 3) - 1) &(value)) << 5)                         
#define INCA_IP_Switch_LAN_WFQ_CTL_WT0_GET(value)           (((value) >> 2) & ((1 << 3) - 1))
#define INCA_IP_Switch_LAN_WFQ_CTL_WT0_SET(value)           ((((1 << 3) - 1) &(value)) << 2)                         
#define INCA_IP_Switch_LAN_WFQ_CTL_SCH_SEL_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_Switch_LAN_WFQ_CTL_SCH_SEL_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***LAN TX Control Register***/ 
#define INCA_IP_Switch_LAN_TX_CTL                     (VREG32 (INCA_IP_Switch + 0x0104))
#define INCA_IP_Switch_LAN_TX_CTL_ELR                    (1 << 1)
#define INCA_IP_Switch_LAN_TX_CTL_EER                    (1 << 0)
      
/***CPU WFQ Control Register***/ 
#define INCA_IP_Switch_CPU_WFQ_CTL                     (VREG32 (INCA_IP_Switch + 0x0180))
#define INCA_IP_Switch_CPU_WFQ_CTL_P1                    (1 << 9)
#define INCA_IP_Switch_CPU_WFQ_CTL_P0                    (1 << 8)                         
#define INCA_IP_Switch_CPU_WFQ_CTL_WT1_GET(value)           (((value) >> 5) & ((1 << 3) - 1))
#define INCA_IP_Switch_CPU_WFQ_CTL_WT1_SET(value)           ((((1 << 3) - 1) &(value)) << 5)                         
#define INCA_IP_Switch_CPU_WFQ_CTL_WT0_GET(value)           (((value) >> 2) & ((1 << 3) - 1))
#define INCA_IP_Switch_CPU_WFQ_CTL_WT0_SET(value)           ((((1 << 3) - 1) &(value)) << 2)                         
#define INCA_IP_Switch_CPU_WFQ_CTL_SCH_SEL_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_Switch_CPU_WFQ_CTL_SCH_SEL_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***PM PC RX Watermark Register***/ 
#define INCA_IP_Switch_PC_WM                     (VREG32 (INCA_IP_Switch + 0x0200))                         
#define INCA_IP_Switch_PC_WM_RX_WM1_GET(value)           (((value) >> 24) & ((1 << 8) - 1))
#define INCA_IP_Switch_PC_WM_RX_WM1_SET(value)           ((((1 << 8) - 1) &(value)) << 24)                         
#define INCA_IP_Switch_PC_WM_RX_WM2_GET(value)           (((value) >> 16) & ((1 << 8) - 1))
#define INCA_IP_Switch_PC_WM_RX_WM2_SET(value)           ((((1 << 8) - 1) &(value)) << 16)                         
#define INCA_IP_Switch_PC_WM_RX_WM3_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_Switch_PC_WM_RX_WM3_SET(value)           ((((1 << 8) - 1) &(value)) << 8)                         
#define INCA_IP_Switch_PC_WM_RX_WM4_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_Switch_PC_WM_RX_WM4_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***PM LAN RX Watermark Register***/ 
#define INCA_IP_Switch_LAN_WM                     (VREG32 (INCA_IP_Switch + 0x0204))                         
#define INCA_IP_Switch_LAN_WM_RX_WM1_GET(value)           (((value) >> 24) & ((1 << 8) - 1))
#define INCA_IP_Switch_LAN_WM_RX_WM1_SET(value)           ((((1 << 8) - 1) &(value)) << 24)                         
#define INCA_IP_Switch_LAN_WM_RX_WM2_GET(value)           (((value) >> 16) & ((1 << 8) - 1))
#define INCA_IP_Switch_LAN_WM_RX_WM2_SET(value)           ((((1 << 8) - 1) &(value)) << 16)                         
#define INCA_IP_Switch_LAN_WM_RX_WM3_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_Switch_LAN_WM_RX_WM3_SET(value)           ((((1 << 8) - 1) &(value)) << 8)                         
#define INCA_IP_Switch_LAN_WM_RX_WM4_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_Switch_LAN_WM_RX_WM4_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***PM CPU RX Watermark Register***/ 
#define INCA_IP_Switch_CPU_WM                     (VREG32 (INCA_IP_Switch + 0x0208))                         
#define INCA_IP_Switch_CPU_WM_RX_WM1_GET(value)           (((value) >> 24) & ((1 << 8) - 1))
#define INCA_IP_Switch_CPU_WM_RX_WM1_SET(value)           ((((1 << 8) - 1) &(value)) << 24)                         
#define INCA_IP_Switch_CPU_WM_RX_WM2_GET(value)           (((value) >> 16) & ((1 << 8) - 1))
#define INCA_IP_Switch_CPU_WM_RX_WM2_SET(value)           ((((1 << 8) - 1) &(value)) << 16)                         
#define INCA_IP_Switch_CPU_WM_RX_WM3_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_Switch_CPU_WM_RX_WM3_SET(value)           ((((1 << 8) - 1) &(value)) << 8)                         
#define INCA_IP_Switch_CPU_WM_RX_WM4_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_Switch_CPU_WM_RX_WM4_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***PM CPU RX Watermark Register***/ 
#define INCA_IP_Switch_GBL_WM                     (VREG32 (INCA_IP_Switch + 0x020C))                         
#define INCA_IP_Switch_GBL_WM_GBL_RX_WM1_GET(value)           (((value) >> 24) & ((1 << 8) - 1))
#define INCA_IP_Switch_GBL_WM_GBL_RX_WM1_SET(value)           ((((1 << 8) - 1) &(value)) << 24)                         
#define INCA_IP_Switch_GBL_WM_GBL_RX_WM2_GET(value)           (((value) >> 16) & ((1 << 8) - 1))
#define INCA_IP_Switch_GBL_WM_GBL_RX_WM2_SET(value)           ((((1 << 8) - 1) &(value)) << 16)                         
#define INCA_IP_Switch_GBL_WM_GBL_RX_WM3_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_Switch_GBL_WM_GBL_RX_WM3_SET(value)           ((((1 << 8) - 1) &(value)) << 8)                         
#define INCA_IP_Switch_GBL_WM_GBL_RX_WM4_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_Switch_GBL_WM_GBL_RX_WM4_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***PM Control Register***/ 
#define INCA_IP_Switch_PM_CTL                     (VREG32 (INCA_IP_Switch + 0x0210))
#define INCA_IP_Switch_PM_CTL_GDN                    (1 << 3)
#define INCA_IP_Switch_PM_CTL_CDN                    (1 << 2)
#define INCA_IP_Switch_PM_CTL_LDN                    (1 << 1)
#define INCA_IP_Switch_PM_CTL_PDN                    (1 << 0)
      
/***PM Header Control Register***/ 
#define INCA_IP_Switch_PMAC_HD_CTL                     (VREG32 (INCA_IP_Switch + 0x0280))
#define INCA_IP_Switch_PMAC_HD_CTL_RL2                    (1 << 21)
#define INCA_IP_Switch_PMAC_HD_CTL_RC                    (1 << 20)
#define INCA_IP_Switch_PMAC_HD_CTL_CM                    (1 << 19)
#define INCA_IP_Switch_PMAC_HD_CTL_CV                    (1 << 18)                         
#define INCA_IP_Switch_PMAC_HD_CTL_TYPE_LEN_GET(value)           (((value) >> 2) & ((1 << 16) - 1))
#define INCA_IP_Switch_PMAC_HD_CTL_TYPE_LEN_SET(value)           ((((1 << 16) - 1) &(value)) << 2)
#define INCA_IP_Switch_PMAC_HD_CTL_TAG                    (1 << 1)
#define INCA_IP_Switch_PMAC_HD_CTL_ADD                    (1 << 0)
      
/***PM Source Address Register 1***/ 
#define INCA_IP_Switch_PMAC_SA1                     (VREG32 (INCA_IP_Switch + 0x0284))                         
#define INCA_IP_Switch_PMAC_SA1_SA_47_32_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_Switch_PMAC_SA1_SA_47_32_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***PM Source Address Register 2***/ 
#define INCA_IP_Switch_PMAC_SA2                     (VREG32 (INCA_IP_Switch + 0x0288))
#define INCA_IP_Switch_PMAC_SA2_SA_31_0
      
/***PM Dest Address Register 1***/ 
#define INCA_IP_Switch_PMAC_DA1                     (VREG32 (INCA_IP_Switch + 0x028C))                         
#define INCA_IP_Switch_PMAC_DA1_DA_47_32_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_Switch_PMAC_DA1_DA_47_32_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***PM Dest Address Register 2***/ 
#define INCA_IP_Switch_PMAC_DA2                     (VREG32 (INCA_IP_Switch + 0x0290))
#define INCA_IP_Switch_PMAC_DA2_DA_31_0
      
/***PM VLAN Register***/ 
#define INCA_IP_Switch_PMAC_VLAN                     (VREG32 (INCA_IP_Switch + 0x0294))                         
#define INCA_IP_Switch_PMAC_VLAN_PRI_GET(value)           (((value) >> 13) & ((1 << 3) - 1))
#define INCA_IP_Switch_PMAC_VLAN_PRI_SET(value)           ((((1 << 3) - 1) &(value)) << 13)
#define INCA_IP_Switch_PMAC_VLAN_CFI                    (1 << 12)                         
#define INCA_IP_Switch_PMAC_VLAN_VLANID_GET(value)           (((value) >> 0) & ((1 << 12) - 1))
#define INCA_IP_Switch_PMAC_VLAN_VLANID_SET(value)           ((((1 << 12) - 1) &(value)) << 0)
      
/***PM TX IPG Counter Register***/ 
#define INCA_IP_Switch_PMAC_TX_IPG                     (VREG32 (INCA_IP_Switch + 0x0298))                         
#define INCA_IP_Switch_PMAC_TX_IPG_IPGCNT_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_Switch_PMAC_TX_IPG_IPGCNT_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***PM RX IPG Counter Register***/ 
#define INCA_IP_Switch_PMAC_RX_IPG                     (VREG32 (INCA_IP_Switch + 0x029C))                         
#define INCA_IP_Switch_PMAC_RX_IPG_IPGCNT_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_Switch_PMAC_RX_IPG_IPGCNT_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***Packet Length Register***/ 
#define INCA_IP_Switch_PKT_LEN                     (VREG32 (INCA_IP_Switch + 0x304))
#define INCA_IP_Switch_PKT_LEN_ADD                    (1 << 11)                         
#define INCA_IP_Switch_PKT_LEN_MAX_PKT_LEN_GET(value)           (((value) >> 0) & ((1 << 11) - 1))
#define INCA_IP_Switch_PKT_LEN_MAX_PKT_LEN_SET(value)           ((((1 << 11) - 1) &(value)) << 0)
      
/***MDIO Access Register***/ 
#define INCA_IP_Switch_MDIO_ACC                     (VREG32 (INCA_IP_Switch + 0x0480))
#define INCA_IP_Switch_MDIO_ACC_RA                    (1 << 31)
#define INCA_IP_Switch_MDIO_ACC_RW                    (1 << 30)                         
#define INCA_IP_Switch_MDIO_ACC_PHY_ADDR_GET(value)           (((value) >> 21) & ((1 << 5) - 1))
#define INCA_IP_Switch_MDIO_ACC_PHY_ADDR_SET(value)           ((((1 << 5) - 1) &(value)) << 21)                         
#define INCA_IP_Switch_MDIO_ACC_REG_ADDR_GET(value)           (((value) >> 16) & ((1 << 5) - 1))
#define INCA_IP_Switch_MDIO_ACC_REG_ADDR_SET(value)           ((((1 << 5) - 1) &(value)) << 16)                         
#define INCA_IP_Switch_MDIO_ACC_PHY_DATA_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_Switch_MDIO_ACC_PHY_DATA_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***Ethernet PHY Register***/ 
#define INCA_IP_Switch_EPHY                     (VREG32 (INCA_IP_Switch + 0x0484))
#define INCA_IP_Switch_EPHY_SL                    (1 << 7)
#define INCA_IP_Switch_EPHY_SP                    (1 << 6)
#define INCA_IP_Switch_EPHY_LL                    (1 << 5)
#define INCA_IP_Switch_EPHY_LP                    (1 << 4)
#define INCA_IP_Switch_EPHY_DL                    (1 << 3)
#define INCA_IP_Switch_EPHY_DP                    (1 << 2)
#define INCA_IP_Switch_EPHY_PL                    (1 << 1)
#define INCA_IP_Switch_EPHY_PP                    (1 << 0)
      
/***Pause Write Enable Register***/ 
#define INCA_IP_Switch_PWR_EN                     (VREG32 (INCA_IP_Switch + 0x0488))
#define INCA_IP_Switch_PWR_EN_PL                    (1 << 1)
#define INCA_IP_Switch_PWR_EN_PP                    (1 << 0)
      
/***MDIO Configuration Register***/ 
#define INCA_IP_Switch_MDIO_CFG                     (VREG32 (INCA_IP_Switch + 0x048C))
#define INCA_IP_Switch_MDIO_CFG_RST                    (1 << 31)                         
#define INCA_IP_Switch_MDIO_CFG_MDS_GET(value)        (((value) >> 14) & ((1 << 2) - 1))
#define INCA_IP_Switch_MDIO_CFG_MDS_SET(value)        ((((1 << 2) - 1) &(value)) << 14)
#define INCA_IP_Switch_MDIO_CFG_MDS_2ms               0x00
#define INCA_IP_Switch_MDIO_CFG_MDS_4ms               0x01
#define INCA_IP_Switch_MDIO_CFG_MDS_8ms               0x02
#define INCA_IP_Switch_MDIO_CFG_MDS_16ms              0x03
#define INCA_IP_Switch_MDIO_CFG_PHY_LAN_ADDR_GET(value)           (((value) >> 9) & ((1 << 5) - 1))
#define INCA_IP_Switch_MDIO_CFG_PHY_LAN_ADDR_SET(value)           ((((1 << 5) - 1) &(value)) << 9)                         
#define INCA_IP_Switch_MDIO_CFG_PHY_PC_ADDR_GET(value)           (((value) >> 4) & ((1 << 5) - 1))
#define INCA_IP_Switch_MDIO_CFG_PHY_PC_ADDR_SET(value)           ((((1 << 5) - 1) &(value)) << 4)
#define INCA_IP_Switch_MDIO_CFG_UEP                    (1 << 3)
#define INCA_IP_Switch_MDIO_CFG_PS                    (1 << 2)
#define INCA_IP_Switch_MDIO_CFG_PT                    (1 << 1)
#define INCA_IP_Switch_MDIO_CFG_UMM                    (1 << 0)
      
/***Switch Interrupt Node Control Register 1***/ 
#define INCA_IP_Switch_SWITCH_IRNCR1                 (VREG32 (INCA_IP_Switch + 0x07F8))
#define INCA_IP_Switch_SWITCH_IRNCR1_RXC_PD                    (1 << 17)
#define INCA_IP_Switch_SWITCH_IRNCR1_RXC_NB                    (1 << 15)
#define INCA_IP_Switch_SWITCH_IRNCR1_RXC_NP                    (1 << 14)
#define INCA_IP_Switch_SWITCH_IRNCR1_RXL_PD                    (1 << 13)
#define INCA_IP_Switch_SWITCH_IRNCR1_RXL_NB                    (1 << 11)
#define INCA_IP_Switch_SWITCH_IRNCR1_RXL_NP                    (1 << 10)
#define INCA_IP_Switch_SWITCH_IRNCR1_RXP_PD                    (1 << 9)
#define INCA_IP_Switch_SWITCH_IRNCR1_RXP_NB                    (1 << 7)
#define INCA_IP_Switch_SWITCH_IRNCR1_RXP_NP                    (1 << 6)
#define INCA_IP_Switch_SWITCH_IRNCR1_PR                    (1 << 5)
#define INCA_IP_Switch_SWITCH_IRNCR1_MAC                    (1 << 4)
#define INCA_IP_Switch_SWITCH_IRNCR1_MPD                    (1 << 3)
#define INCA_IP_Switch_SWITCH_IRNCR1_PI                    (1 << 2)
#define INCA_IP_Switch_SWITCH_IRNCR1_MAF                    (1 << 1)
#define INCA_IP_Switch_SWITCH_IRNCR1_DAP                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  MBC register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_MBC                     (0xBF103000)
/***********************************************************************/   

      
/***Mailbox CPU Configuration Register***/ 
#define INCA_IP_MBC_MBC_CFG                     (VREG32 (INCA_IP_MBC + 0x0080))                         
#define INCA_IP_MBC_MBC_CFG_SWAP_GET(value)           (((value) >> 6) & ((1 << 2) - 1))
#define INCA_IP_MBC_MBC_CFG_SWAP_SET(value)           ((((1 << 2) - 1) &(value)) << 6)
#define INCA_IP_MBC_MBC_CFG_RST                    (1 << 5)                         
#define INCA_IP_MBC_MBC_CFG_FWID_GET(value)           (((value) >> 1) & ((1 << 4) - 1))
#define INCA_IP_MBC_MBC_CFG_FWID_SET(value)           ((((1 << 4) - 1) &(value)) << 1)
#define INCA_IP_MBC_MBC_CFG_SIZE                    (1 << 0)
      
/***Mailbox CPU Interrupt Status Register***/ 
#define INCA_IP_MBC_MBC_ISR                     (VREG32 (INCA_IP_MBC + 0x0084))
#define INCA_IP_MBC_MBC_ISR_B3DA                    (1 << 31)
#define INCA_IP_MBC_MBC_ISR_B2DA                    (1 << 30)
#define INCA_IP_MBC_MBC_ISR_B1E                    (1 << 29)
#define INCA_IP_MBC_MBC_ISR_B0E                    (1 << 28)
#define INCA_IP_MBC_MBC_ISR_WDT                    (1 << 27)
#define INCA_IP_MBC_MBC_ISR_SP_TRA                    (1 << 26)
#define INCA_IP_MBC_MBC_ISR_SP_IDLE                    (1 << 25)
#define INCA_IP_MBC_MBC_ISR_SP_DBL                    (1 << 24)
#define INCA_IP_MBC_MBC_ISR_CMD_CERR                    (1 << 23)
#define INCA_IP_MBC_MBC_ISR_MIPS_OL                    (1 << 22)
#define INCA_IP_MBC_MBC_ISR_AFE_OF                    (1 << 21)
#define INCA_IP_MBC_MBC_ISR_DWL_END                    (1 << 20)
#define INCA_IP_MBC_MBC_ISR_CID_TR_ACT                    (1 << 18)
#define INCA_IP_MBC_MBC_ISR_CID_TR_REQ                    (1 << 17)
#define INCA_IP_MBC_MBC_ISR_CID_TR_BUF                    (1 << 16)
#define INCA_IP_MBC_MBC_ISR_TG_ACT                    (1 << 14)
#define INCA_IP_MBC_MBC_ISR_DTMFR_DTV                    (1 << 13)
#define INCA_IP_MBC_MBC_ISR_DTMFR_DTP                    (1 << 12)                         
#define INCA_IP_MBC_MBC_ISR_DTMFR_DTC_GET(value)           (((value) >> 8) & ((1 << 4) - 1))
#define INCA_IP_MBC_MBC_ISR_DTMFR_DTC_SET(value)           ((((1 << 4) - 1) &(value)) << 8)
#define INCA_IP_MBC_MBC_ISR_ENC1_OF                    (1 << 7)
#define INCA_IP_MBC_MBC_ISR_ENC2_OF                    (1 << 6)
#define INCA_IP_MBC_MBC_ISR_DEC1_ERRSR1_ERR                    (1 << 5)
#define INCA_IP_MBC_MBC_ISR_DEC2_ERRSR2_ERR                    (1 << 4)
#define INCA_IP_MBC_MBC_ISR_DEC1_REQSR1_REQ                    (1 << 3)
#define INCA_IP_MBC_MBC_ISR_DEC1_UFSR1_IVW                    (1 << 2)
#define INCA_IP_MBC_MBC_ISR_DEC2_REQSR2_REQ                    (1 << 1)
#define INCA_IP_MBC_MBC_ISR_DEC2_UFSR2_IVW                    (1 << 0)
      
/***Mailbox CPU Interrupt Acknowledge Register***/ 
#define INCA_IP_MBC_MBC_ACK                     (VREG32 (INCA_IP_MBC + 0x0098))
#define INCA_IP_MBC_MBC_ACK_B3DA                    (1 << 31)
#define INCA_IP_MBC_MBC_ACK_B2DA                    (1 << 30)
#define INCA_IP_MBC_MBC_ACK_B1E                    (1 << 29)
#define INCA_IP_MBC_MBC_ACK_B0E                    (1 << 28)
#define INCA_IP_MBC_MBC_ACK_WDT                    (1 << 27)
#define INCA_IP_MBC_MBC_ACK_SP_TRA                    (1 << 26)
#define INCA_IP_MBC_MBC_ACK_SP_IDLE                    (1 << 25)
#define INCA_IP_MBC_MBC_ACK_SP_DBL                    (1 << 24)
#define INCA_IP_MBC_MBC_ACK_CMD_CERR                    (1 << 23)
#define INCA_IP_MBC_MBC_ACK_MIPS_OL                    (1 << 22)
#define INCA_IP_MBC_MBC_ACK_AFE_OF                    (1 << 21)
#define INCA_IP_MBC_MBC_ACK_DWL_END                    (1 << 20)
#define INCA_IP_MBC_MBC_ACK_CID_TR_ACT                    (1 << 18)
#define INCA_IP_MBC_MBC_ACK_CID_TR_REQ                    (1 << 17)
#define INCA_IP_MBC_MBC_ACK_CID_TR_BUF                    (1 << 16)
#define INCA_IP_MBC_MBC_ACK_TG_ACT                    (1 << 14)
#define INCA_IP_MBC_MBC_ACK_DTMFR_DTV                    (1 << 13)
#define INCA_IP_MBC_MBC_ACK_DTMFR_DTP                    (1 << 12)                         
#define INCA_IP_MBC_MBC_ACK_DTMFR_DTC_GET(value)           (((value) >> 8) & ((1 << 4) - 1))
#define INCA_IP_MBC_MBC_ACK_DTMFR_DTC_SET(value)           ((((1 << 4) - 1) &(value)) << 8)
#define INCA_IP_MBC_MBC_ACK_ENC1_OF                    (1 << 7)
#define INCA_IP_MBC_MBC_ACK_ENC2_OF                    (1 << 6)
#define INCA_IP_MBC_MBC_ACK_DEC1_ERRSR1_ERR                    (1 << 5)
#define INCA_IP_MBC_MBC_ACK_DEC2_ERRSR2_ERR                    (1 << 4)
#define INCA_IP_MBC_MBC_ACK_DEC1_REQSR1_REQ                    (1 << 3)
#define INCA_IP_MBC_MBC_ACK_DEC1_UFSR1_IVW                    (1 << 2)
#define INCA_IP_MBC_MBC_ACK_DEC2_REQSR2_REQ                    (1 << 1)
#define INCA_IP_MBC_MBC_ACK_DEC2_UFSR2_IVW                    (1 << 0)
      
/***Mailbox CPU Mask Register***/ 
#define INCA_IP_MBC_MBC_MSK                     (VREG32 (INCA_IP_MBC + 0x0088))
#define INCA_IP_MBC_MBC_MSK_B3DA                    (1 << 31)
#define INCA_IP_MBC_MBC_MSK_B2DA                    (1 << 30)
#define INCA_IP_MBC_MBC_MSK_B1E                    (1 << 29)
#define INCA_IP_MBC_MBC_MSK_B0E                    (1 << 28)
#define INCA_IP_MBC_MBC_MSK_WDT                    (1 << 27)
#define INCA_IP_MBC_MBC_MSK_SP_TRA                    (1 << 26)
#define INCA_IP_MBC_MBC_MSK_SP_IDLE                    (1 << 25)
#define INCA_IP_MBC_MBC_MSK_SP_DBL                    (1 << 24)
#define INCA_IP_MBC_MBC_MSK_CMD_CERR                    (1 << 23)
#define INCA_IP_MBC_MBC_MSK_MIPS_OL                    (1 << 22)
#define INCA_IP_MBC_MBC_MSK_AFE_OF                    (1 << 21)
#define INCA_IP_MBC_MBC_MSK_DWL_END                    (1 << 20)
#define INCA_IP_MBC_MBC_MSK_CID_TR_ACT                    (1 << 18)
#define INCA_IP_MBC_MBC_MSK_CID_TR_REQ                    (1 << 17)
#define INCA_IP_MBC_MBC_MSK_CID_TR_BUF                    (1 << 16)
#define INCA_IP_MBC_MBC_MSK_TG_ACT                    (1 << 14)
#define INCA_IP_MBC_MBC_MSK_DTMFR_DTV                    (1 << 13)
#define INCA_IP_MBC_MBC_MSK_DTMFR_DTP                    (1 << 12)                         
#define INCA_IP_MBC_MBC_MSK_DTMFR_DTC_GET(value)           (((value) >> 8) & ((1 << 4) - 1))
#define INCA_IP_MBC_MBC_MSK_DTMFR_DTC_SET(value)           ((((1 << 4) - 1) &(value)) << 8)
#define INCA_IP_MBC_MBC_MSK_ENC1_OF                    (1 << 7)
#define INCA_IP_MBC_MBC_MSK_ENC2_OF                    (1 << 6)
#define INCA_IP_MBC_MBC_MSK_DEC1_ERRSR1_ERR                    (1 << 5)
#define INCA_IP_MBC_MBC_MSK_DEC2_ERRSR2_ERR                    (1 << 4)
#define INCA_IP_MBC_MBC_MSK_DEC1_REQSR1_REQ                    (1 << 3)
#define INCA_IP_MBC_MBC_MSK_DEC1_UFSR1_IVW                    (1 << 2)
#define INCA_IP_MBC_MBC_MSK_DEC2_REQSR2_REQ                    (1 << 1)
#define INCA_IP_MBC_MBC_MSK_DEC2_UFSR2_IVW                    (1 << 0)
      
/***Mailbox CPU Mask 01 Register***/ 
#define INCA_IP_MBC_MBC_MSK01                     (VREG32 (INCA_IP_MBC + 0x008C))
#define INCA_IP_MBC_MBC_MSK01_B3DA                    (1 << 31)
#define INCA_IP_MBC_MBC_MSK01_B2DA                    (1 << 30)
#define INCA_IP_MBC_MBC_MSK01_B1E                    (1 << 29)
#define INCA_IP_MBC_MBC_MSK01_B0E                    (1 << 28)
#define INCA_IP_MBC_MBC_MSK01_WDT                    (1 << 27)
#define INCA_IP_MBC_MBC_MSK01_SP_TRA                    (1 << 26)
#define INCA_IP_MBC_MBC_MSK01_SP_IDLE                    (1 << 25)
#define INCA_IP_MBC_MBC_MSK01_SP_DBL                    (1 << 24)
#define INCA_IP_MBC_MBC_MSK01_CMD_CERR                    (1 << 23)
#define INCA_IP_MBC_MBC_MSK01_MIPS_OL                    (1 << 22)
#define INCA_IP_MBC_MBC_MSK01_AFE_OF                    (1 << 21)
#define INCA_IP_MBC_MBC_MSK01_DWL_END                    (1 << 20)
#define INCA_IP_MBC_MBC_MSK01_CID_TR_ACT                    (1 << 18)
#define INCA_IP_MBC_MBC_MSK01_CID_TR_REQ                    (1 << 17)
#define INCA_IP_MBC_MBC_MSK01_CID_TR_BUF                    (1 << 16)
#define INCA_IP_MBC_MBC_MSK01_TG_ACT                    (1 << 14)
#define INCA_IP_MBC_MBC_MSK01_DTMFR_DTV                    (1 << 13)
#define INCA_IP_MBC_MBC_MSK01_DTMFR_DTP                    (1 << 12)                         
#define INCA_IP_MBC_MBC_MSK01_DTMFR_DTC_GET(value)           (((value) >> 8) & ((1 << 4) - 1))
#define INCA_IP_MBC_MBC_MSK01_DTMFR_DTC_SET(value)           ((((1 << 4) - 1) &(value)) << 8)
#define INCA_IP_MBC_MBC_MSK01_ENC1_OF                    (1 << 7)
#define INCA_IP_MBC_MBC_MSK01_ENC2_OF                    (1 << 6)
#define INCA_IP_MBC_MBC_MSK01_DEC1_ERRSR1_ERR                    (1 << 5)
#define INCA_IP_MBC_MBC_MSK01_DEC2_ERRSR2_ERR                    (1 << 4)
#define INCA_IP_MBC_MBC_MSK01_DEC1_REQSR1_REQ                    (1 << 3)
#define INCA_IP_MBC_MBC_MSK01_DEC1_UFSR1_IVW                    (1 << 2)
#define INCA_IP_MBC_MBC_MSK01_DEC2_REQSR2_REQ                    (1 << 1)
#define INCA_IP_MBC_MBC_MSK01_DEC2_UFSR2_IVW                    (1 << 0)
      
/***Mailbox CPU Mask 10 Register***/ 
#define INCA_IP_MBC_MBC_MSK10                     (VREG32 (INCA_IP_MBC + 0x0090))
#define INCA_IP_MBC_MBC_MSK10_B3DA                    (1 << 31)
#define INCA_IP_MBC_MBC_MSK10_B2DA                    (1 << 30)
#define INCA_IP_MBC_MBC_MSK10_B1E                    (1 << 29)
#define INCA_IP_MBC_MBC_MSK10_B0E                    (1 << 28)
#define INCA_IP_MBC_MBC_MSK10_WDT                    (1 << 27)
#define INCA_IP_MBC_MBC_MSK10_SP_TRA                    (1 << 26)
#define INCA_IP_MBC_MBC_MSK10_SP_IDLE                    (1 << 25)
#define INCA_IP_MBC_MBC_MSK10_SP_DBL                    (1 << 24)
#define INCA_IP_MBC_MBC_MSK10_CMD_CERR                    (1 << 23)
#define INCA_IP_MBC_MBC_MSK10_MIPS_OL                    (1 << 22)
#define INCA_IP_MBC_MBC_MSK10_AFE_OF                    (1 << 21)
#define INCA_IP_MBC_MBC_MSK10_DWL_END                    (1 << 20)
#define INCA_IP_MBC_MBC_MSK10_CID_TR_ACT                    (1 << 18)
#define INCA_IP_MBC_MBC_MSK10_CID_TR_REQ                    (1 << 17)
#define INCA_IP_MBC_MBC_MSK10_CID_TR_BUF                    (1 << 16)
#define INCA_IP_MBC_MBC_MSK10_TG_ACT                    (1 << 14)
#define INCA_IP_MBC_MBC_MSK10_DTMFR_DTV                    (1 << 13)
#define INCA_IP_MBC_MBC_MSK10_DTMFR_DTP                    (1 << 12)                         
#define INCA_IP_MBC_MBC_MSK10_DTMFR_DTC_GET(value)           (((value) >> 8) & ((1 << 4) - 1))
#define INCA_IP_MBC_MBC_MSK10_DTMFR_DTC_SET(value)           ((((1 << 4) - 1) &(value)) << 8)
#define INCA_IP_MBC_MBC_MSK10_ENC1_OF                    (1 << 7)
#define INCA_IP_MBC_MBC_MSK10_ENC2_OF                    (1 << 6)
#define INCA_IP_MBC_MBC_MSK10_DEC1_ERRSR1_ERR                    (1 << 5)
#define INCA_IP_MBC_MBC_MSK10_DEC2_ERRSR2_ERR                    (1 << 4)
#define INCA_IP_MBC_MBC_MSK10_DEC1_REQSR1_REQ                    (1 << 3)
#define INCA_IP_MBC_MBC_MSK10_DEC1_UFSR1_IVW                    (1 << 2)
#define INCA_IP_MBC_MBC_MSK10_DEC2_REQSR2_REQ                    (1 << 1)
#define INCA_IP_MBC_MBC_MSK10_DEC2_UFSR2_IVW                    (1 << 0)
      
/***Mailbox CPU Short Command Register***/ 
#define INCA_IP_MBC_MBC_CMD                     (VREG32 (INCA_IP_MBC + 0x0094))                         
#define INCA_IP_MBC_MBC_CMD_CS270_GET(value)           (((value) >> 0) & ((1 << 28) - 1))
#define INCA_IP_MBC_MBC_CMD_CS270_SET(value)           ((((1 << 28) - 1) &(value)) << 0)
      
/***Mailbox CPU Input Data of Buffer 0***/ 
#define INCA_IP_MBC_MBC_ID0                     (VREG32 (INCA_IP_MBC + 0x0000))
#define INCA_IP_MBC_MBC_ID0_INDATA
      
/***Mailbox CPU Input Data of Buffer 1***/ 
#define INCA_IP_MBC_MBC_ID1                     (VREG32 (INCA_IP_MBC + 0x0020))
#define INCA_IP_MBC_MBC_ID1_INDATA
      
/***Mailbox CPU Output Data of Buffer 2***/ 
#define INCA_IP_MBC_MBC_OD2                     (VREG32 (INCA_IP_MBC + 0x0040))
#define INCA_IP_MBC_MBC_OD2_OUTDATA
      
/***Mailbox CPU Output Data of Buffer 3***/ 
#define INCA_IP_MBC_MBC_OD3                     (VREG32 (INCA_IP_MBC + 0x0060))
#define INCA_IP_MBC_MBC_OD3_OUTDATA
      
/***Mailbox CPU Control Register of Buffer 0***/ 
#define INCA_IP_MBC_MBC_CR0                     (VREG32 (INCA_IP_MBC + 0x0004))                         
#define INCA_IP_MBC_MBC_CR0_RDYABTFLS_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_MBC_MBC_CR0_RDYABTFLS_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***Mailbox CPU Control Register of Buffer 1***/ 
#define INCA_IP_MBC_MBC_CR1                     (VREG32 (INCA_IP_MBC + 0x0024))                         
#define INCA_IP_MBC_MBC_CR1_RDYABTFLS_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_MBC_MBC_CR1_RDYABTFLS_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***Mailbox CPU Control Register of Buffer 2***/ 
#define INCA_IP_MBC_MBC_CR2                     (VREG32 (INCA_IP_MBC + 0x0044))                         
#define INCA_IP_MBC_MBC_CR2_RDYABTFLS_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_MBC_MBC_CR2_RDYABTFLS_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***Mailbox CPU Control Register of Buffer 3***/ 
#define INCA_IP_MBC_MBC_CR3                     (VREG32 (INCA_IP_MBC + 0x0064))                         
#define INCA_IP_MBC_MBC_CR3_RDYABTFLS_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_MBC_MBC_CR3_RDYABTFLS_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***Mailbox CPU Free Space of Buffer 0***/ 
#define INCA_IP_MBC_MBC_FS0                     (VREG32 (INCA_IP_MBC + 0x0008))
#define INCA_IP_MBC_MBC_FS0_FS
      
/***Mailbox CPU Free Space of Buffer 1***/ 
#define INCA_IP_MBC_MBC_FS1                     (VREG32 (INCA_IP_MBC + 0x0028))
#define INCA_IP_MBC_MBC_FS1_FS
      
/***Mailbox CPU Free Space of Buffer 2***/ 
#define INCA_IP_MBC_MBC_FS2                     (VREG32 (INCA_IP_MBC + 0x0048))
#define INCA_IP_MBC_MBC_FS2_FS
      
/***Mailbox CPU Free Space of Buffer 3***/ 
#define INCA_IP_MBC_MBC_FS3                     (VREG32 (INCA_IP_MBC + 0x0068))
#define INCA_IP_MBC_MBC_FS3_FS
      
/***Mailbox CPU Data Available in Buffer 0***/ 
#define INCA_IP_MBC_MBC_DA0                     (VREG32 (INCA_IP_MBC + 0x000C))
#define INCA_IP_MBC_MBC_DA0_DA
      
/***Mailbox CPU Data Available in Buffer 1***/ 
#define INCA_IP_MBC_MBC_DA1                     (VREG32 (INCA_IP_MBC + 0x002C))
#define INCA_IP_MBC_MBC_DA1_DA
      
/***Mailbox CPU Data Available in Buffer 2***/ 
#define INCA_IP_MBC_MBC_DA2                     (VREG32 (INCA_IP_MBC + 0x004C))
#define INCA_IP_MBC_MBC_DA2_DA
      
/***Mailbox CPU Data Available in Buffer 3***/ 
#define INCA_IP_MBC_MBC_DA3                     (VREG32 (INCA_IP_MBC + 0x006C))
#define INCA_IP_MBC_MBC_DA3_DA
      
/***Mailbox CPU Input Absolute Pointer of Buffer 0***/ 
#define INCA_IP_MBC_MBC_IABS0                     (VREG32 (INCA_IP_MBC + 0x0010))
#define INCA_IP_MBC_MBC_IABS0_IABS
      
/***Mailbox CPU Input Absolute Pointer of Buffer 1***/ 
#define INCA_IP_MBC_MBC_IABS1                     (VREG32 (INCA_IP_MBC + 0x0030))
#define INCA_IP_MBC_MBC_IABS1_IABS
      
/***Mailbox CPU Input Absolute Pointer of Buffer 2***/ 
#define INCA_IP_MBC_MBC_IABS2                     (VREG32 (INCA_IP_MBC + 0x0050))
#define INCA_IP_MBC_MBC_IABS2_IABS
      
/***Mailbox CPU Input Absolute Pointer of Buffer 3***/ 
#define INCA_IP_MBC_MBC_IABS3                     (VREG32 (INCA_IP_MBC + 0x0070))
#define INCA_IP_MBC_MBC_IABS3_IABS
      
/***Mailbox CPU Input Temporary Pointer of Buffer 0***/ 
#define INCA_IP_MBC_MBC_ITMP0                     (VREG32 (INCA_IP_MBC + 0x0014))
#define INCA_IP_MBC_MBC_ITMP0_ITMP
      
/***Mailbox CPU Input Temporary Pointer of Buffer 1***/ 
#define INCA_IP_MBC_MBC_ITMP1                     (VREG32 (INCA_IP_MBC + 0x0034))
#define INCA_IP_MBC_MBC_ITMP1_ITMP
      
/***Mailbox CPU Input Temporary Pointer of Buffer 2***/ 
#define INCA_IP_MBC_MBC_ITMP2                     (VREG32 (INCA_IP_MBC + 0x0054))
#define INCA_IP_MBC_MBC_ITMP2_ITMP
      
/***Mailbox CPU Input Temporary Pointer of Buffer 3***/ 
#define INCA_IP_MBC_MBC_ITMP3                     (VREG32 (INCA_IP_MBC + 0x0074))
#define INCA_IP_MBC_MBC_ITMP3_ITMP
      
/***Mailbox CPU Output Absolute Pointer of Buffer 0***/ 
#define INCA_IP_MBC_MBC_OABS0                     (VREG32 (INCA_IP_MBC + 0x0018))
#define INCA_IP_MBC_MBC_OABS0_OABS
      
/***Mailbox CPU Output Absolute Pointer of Buffer 1***/ 
#define INCA_IP_MBC_MBC_OABS1                     (VREG32 (INCA_IP_MBC + 0x0038))
#define INCA_IP_MBC_MBC_OABS1_OABS
      
/***Mailbox CPU Output Absolute Pointer of Buffer 2***/ 
#define INCA_IP_MBC_MBC_OABS2                     (VREG32 (INCA_IP_MBC + 0x0058))
#define INCA_IP_MBC_MBC_OABS2_OABS
      
/***Mailbox CPU Output Absolute Pointer of Buffer 3***/ 
#define INCA_IP_MBC_MBC_OABS3                     (VREG32 (INCA_IP_MBC + 0x0078))
#define INCA_IP_MBC_MBC_OABS3_OABS
      
/***Mailbox CPU Output Temporary Pointer of Buffer 0***/ 
#define INCA_IP_MBC_MBC_OTMP0                     (VREG32 (INCA_IP_MBC + 0x001C))
#define INCA_IP_MBC_MBC_OTMP0_OTMP
      
/***Mailbox CPU Output Temporary Pointer of Buffer 1***/ 
#define INCA_IP_MBC_MBC_OTMP1                     (VREG32 (INCA_IP_MBC + 0x003C))
#define INCA_IP_MBC_MBC_OTMP1_OTMP
      
/***Mailbox CPU Output Temporary Pointer of Buffer 2***/ 
#define INCA_IP_MBC_MBC_OTMP2                     (VREG32 (INCA_IP_MBC + 0x005C))
#define INCA_IP_MBC_MBC_OTMP2_OTMP
      
/***Mailbox CPU Output Temporary Pointer of Buffer 3***/ 
#define INCA_IP_MBC_MBC_OTMP3                     (VREG32 (INCA_IP_MBC + 0x007C))
#define INCA_IP_MBC_MBC_OTMP3_OTMP
      
/***DSP Control Register***/ 
#define INCA_IP_MBC_DCTRL                     (VREG32 (INCA_IP_MBC + 0x00A0))
#define INCA_IP_MBC_DCTRL_BA                    (1 << 0)                         
#define INCA_IP_MBC_DCTRL_BMOD_GET(value)           (((value) >> 1) & ((1 << 3) - 1))
#define INCA_IP_MBC_DCTRL_BMOD_SET(value)           ((((1 << 3) - 1) &(value)) << 1)
#define INCA_IP_MBC_DCTRL_IDL                    (1 << 4)
#define INCA_IP_MBC_DCTRL_RST                    (1 << 15)
      
/***DSP Status Register***/ 
#define INCA_IP_MBC_DSTA                     (VREG32 (INCA_IP_MBC + 0x00A4))
#define INCA_IP_MBC_DSTA_IDLE                    (1 << 0)
#define INCA_IP_MBC_DSTA_PD                    (1 << 1)		
         
/***********************************************************************/
/*  Module      :  FB register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_FB                     (0xBF880000)
/***********************************************************************/   

      
/***FB Access Error Cause Register***/ 
#define INCA_IP_FB_FB_ERRCAUSE                     (VREG32 (INCA_IP_FB + 0x0100))
#define INCA_IP_FB_FB_ERRCAUSE_ERR                    (1 << 31)                         
#define INCA_IP_FB_FB_ERRCAUSE_PORT_GET(value)           (((value) >> 16) & ((1 << 4) - 1))
#define INCA_IP_FB_FB_ERRCAUSE_PORT_SET(value)           ((((1 << 4) - 1) &(value)) << 16)                         
#define INCA_IP_FB_FB_ERRCAUSE_CAUSE_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_FB_FB_ERRCAUSE_CAUSE_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***FB Access Error Address Register***/ 
#define INCA_IP_FB_FB_ERRADDR                     (VREG32 (INCA_IP_FB + 0x0108))
#define INCA_IP_FB_FB_ERRADDR_ADDR
      
/***FB Configuration Register***/ 
#define INCA_IP_FB_FB_CFG                     (VREG32 (INCA_IP_FB + 0x0800))
#define INCA_IP_FB_FB_CFG_SVM                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  SRAM register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_SRAM                     (0xBF980000)
/***********************************************************************/   

      
/***SRAM Size Register***/ 
#define INCA_IP_SRAM_SRAM_SIZE                     (VREG32 (INCA_IP_SRAM + 0x0800))                         
#define INCA_IP_SRAM_SRAM_SIZE_SIZE_GET(value)           (((value) >> 0) & ((1 << 23) - 1))
#define INCA_IP_SRAM_SRAM_SIZE_SIZE_SET(value)           ((((1 << 23) - 1) &(value)) << 0)		
         
/***********************************************************************/
/*  Module      :  BIU register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_BIU                     (0xBFA80000)
/***********************************************************************/   

      
/***BIU Identification Register***/ 
#define INCA_IP_BIU_BIU_ID                     (VREG32 (INCA_IP_BIU + 0x0000))
#define INCA_IP_BIU_BIU_ID_ARCH                    (1 << 16)                         
#define INCA_IP_BIU_BIU_ID_ID_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_BIU_BIU_ID_ID_SET(value)           ((((1 << 8) - 1) &(value)) << 8)                         
#define INCA_IP_BIU_BIU_ID_REV_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_BIU_BIU_ID_REV_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***BIU Access Error Cause Register***/ 
#define INCA_IP_BIU_BIU_ERRCAUSE                     (VREG32 (INCA_IP_BIU + 0x0100))
#define INCA_IP_BIU_BIU_ERRCAUSE_ERR                    (1 << 31)                         
#define INCA_IP_BIU_BIU_ERRCAUSE_PORT_GET(value)           (((value) >> 16) & ((1 << 4) - 1))
#define INCA_IP_BIU_BIU_ERRCAUSE_PORT_SET(value)           ((((1 << 4) - 1) &(value)) << 16)                         
#define INCA_IP_BIU_BIU_ERRCAUSE_CAUSE_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_BIU_BIU_ERRCAUSE_CAUSE_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***BIU Access Error Address Register***/ 
#define INCA_IP_BIU_BIU_ERRADDR                     (VREG32 (INCA_IP_BIU + 0x0108))
#define INCA_IP_BIU_BIU_ERRADDR_ADDR		
         
/***********************************************************************/
/*  Module      :  PMU register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_PMU                     (0xBF102000)
/***********************************************************************/   

      
/***PM Global Enable Register***/ 
#define INCA_IP_PMU_PM_GEN                     (VREG32 (INCA_IP_PMU + 0x0000))
#define INCA_IP_PMU_PM_GEN_EN16                    (1 << 16)
#define INCA_IP_PMU_PM_GEN_EN15                    (1 << 15)
#define INCA_IP_PMU_PM_GEN_EN14                    (1 << 14)
#define INCA_IP_PMU_PM_GEN_EN13                    (1 << 13)
#define INCA_IP_PMU_PM_GEN_EN12                    (1 << 12)
#define INCA_IP_PMU_PM_GEN_EN11                    (1 << 11)
#define INCA_IP_PMU_PM_GEN_EN10                    (1 << 10)
#define INCA_IP_PMU_PM_GEN_EN9                    (1 << 9)
#define INCA_IP_PMU_PM_GEN_EN8                    (1 << 8)
#define INCA_IP_PMU_PM_GEN_EN7                    (1 << 7)
#define INCA_IP_PMU_PM_GEN_EN6                    (1 << 6)
#define INCA_IP_PMU_PM_GEN_EN5                    (1 << 5)
#define INCA_IP_PMU_PM_GEN_EN4                    (1 << 4)
#define INCA_IP_PMU_PM_GEN_EN3                    (1 << 3)
#define INCA_IP_PMU_PM_GEN_EN2                    (1 << 2)
#define INCA_IP_PMU_PM_GEN_EN0                    (1 << 0)
      
/***PM Power Down Enable Register***/ 
#define INCA_IP_PMU_PM_PDEN                     (VREG32 (INCA_IP_PMU + 0x0008))
#define INCA_IP_PMU_PM_PDEN_EN16                    (1 << 16)
#define INCA_IP_PMU_PM_PDEN_EN15                    (1 << 15)
#define INCA_IP_PMU_PM_PDEN_EN14                    (1 << 14)
#define INCA_IP_PMU_PM_PDEN_EN13                    (1 << 13)
#define INCA_IP_PMU_PM_PDEN_EN12                    (1 << 12)
#define INCA_IP_PMU_PM_PDEN_EN11                    (1 << 11)
#define INCA_IP_PMU_PM_PDEN_EN10                    (1 << 10)
#define INCA_IP_PMU_PM_PDEN_EN9                    (1 << 9)
#define INCA_IP_PMU_PM_PDEN_EN8                    (1 << 8)
#define INCA_IP_PMU_PM_PDEN_EN7                    (1 << 7)
#define INCA_IP_PMU_PM_PDEN_EN5                    (1 << 5)
#define INCA_IP_PMU_PM_PDEN_EN4                    (1 << 4)
#define INCA_IP_PMU_PM_PDEN_EN3                    (1 << 3)
#define INCA_IP_PMU_PM_PDEN_EN2                    (1 << 2)
#define INCA_IP_PMU_PM_PDEN_EN0                    (1 << 0)
      
/***PM Wake-Up from Power Down Register***/ 
#define INCA_IP_PMU_PM_WUP                     (VREG32 (INCA_IP_PMU + 0x0010))
#define INCA_IP_PMU_PM_WUP_WUP16                    (1 << 16)
#define INCA_IP_PMU_PM_WUP_WUP15                    (1 << 15)
#define INCA_IP_PMU_PM_WUP_WUP14                    (1 << 14)
#define INCA_IP_PMU_PM_WUP_WUP13                    (1 << 13)
#define INCA_IP_PMU_PM_WUP_WUP12                    (1 << 12)
#define INCA_IP_PMU_PM_WUP_WUP11                    (1 << 11)
#define INCA_IP_PMU_PM_WUP_WUP10                    (1 << 10)
#define INCA_IP_PMU_PM_WUP_WUP9                    (1 << 9)
#define INCA_IP_PMU_PM_WUP_WUP8                    (1 << 8)
#define INCA_IP_PMU_PM_WUP_WUP7                    (1 << 7)
#define INCA_IP_PMU_PM_WUP_WUP5                    (1 << 5)
#define INCA_IP_PMU_PM_WUP_WUP4                    (1 << 4)
#define INCA_IP_PMU_PM_WUP_WUP3                    (1 << 3)
#define INCA_IP_PMU_PM_WUP_WUP2                    (1 << 2)
#define INCA_IP_PMU_PM_WUP_WUP0                    (1 << 0)
      
/***PM Control Register***/ 
#define INCA_IP_PMU_PM_CR                     (VREG32 (INCA_IP_PMU + 0x0014))
#define INCA_IP_PMU_PM_CR_AWEN                    (1 << 31)
#define INCA_IP_PMU_PM_CR_SWRST                    (1 << 30)
#define INCA_IP_PMU_PM_CR_SWCR                    (1 << 2)                         
#define INCA_IP_PMU_PM_CR_CRD_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_PMU_PM_CR_CRD_SET(value)           ((((1 << 2) - 1) &(value)) << 0)		
         
/***********************************************************************/
/*  Module      :  WDT register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_WDT                     (0xB8000000)
/***********************************************************************/   

      
/***Reset Status Register Power On***/ 
#define INCA_IP_WDT_RST_SR                     (VREG32 (INCA_IP_WDT + 0x0014))
#define INCA_IP_WDT_RST_SR_WDTRST                    (1 << 30)
#define INCA_IP_WDT_RST_SR_SFTRST                    (1 << 29)
#define INCA_IP_WDT_RST_SR_HDRST                    (1 << 28)
#define INCA_IP_WDT_RST_SR_PWORST                    (1 << 27)
#define INCA_IP_WDT_RST_SR_HWCFG                    (1 << 18)
#define INCA_IP_WDT_RST_SR_RSPHY                    (1 << 5)
#define INCA_IP_WDT_RST_SR_RSHSP                    (1 << 4)
#define INCA_IP_WDT_RST_SR_RSFPI                    (1 << 3)
#define INCA_IP_WDT_RST_SR_RSEXT                    (1 << 2)
#define INCA_IP_WDT_RST_SR_RSDSP                    (1 << 1)
#define INCA_IP_WDT_RST_SR_RSCPU                    (1 << 0)
      
/***Reset Request Register***/ 
#define INCA_IP_WDT_RST_REQ                     (VREG32 (INCA_IP_WDT + 0x0010))
#define INCA_IP_WDT_RST_REQ_SWBOOT                    (1 << 24)
#define INCA_IP_WDT_RST_REQ_SWCFG                    (1 << 16)
#define INCA_IP_WDT_RST_REQ_RRPHY                    (1 << 5)
#define INCA_IP_WDT_RST_REQ_RRHSP                    (1 << 4)
#define INCA_IP_WDT_RST_REQ_RRFPI                    (1 << 3)
#define INCA_IP_WDT_RST_REQ_RREXT                    (1 << 2)
#define INCA_IP_WDT_RST_REQ_RRDSP                    (1 << 1)
#define INCA_IP_WDT_RST_REQ_RRCPU                    (1 << 0)
      
/***NMI Status Register***/ 
#define INCA_IP_WDT_NMISR                     (VREG32 (INCA_IP_WDT + 0x002C))
#define INCA_IP_WDT_NMISR_NMIWDT                    (1 << 2)
#define INCA_IP_WDT_NMISR_NMIPLL                    (1 << 1)
#define INCA_IP_WDT_NMISR_NMIEXT                    (1 << 0)
      
/***Manufacturer Identification Register***/ 
#define INCA_IP_WDT_MANID                     (VREG32 (INCA_IP_WDT + 0x0070))                         
#define INCA_IP_WDT_MANID_MANUF_GET(value)           (((value) >> 5) & ((1 << 11) - 1))
#define INCA_IP_WDT_MANID_MANUF_SET(value)           ((((1 << 11) - 1) &(value)) << 5)
      
/***Chip Identification Register***/ 
#define INCA_IP_WDT_CHIPID                     (VREG32 (INCA_IP_WDT + 0x0074))                         
#define INCA_IP_WDT_CHIPID_VERSION_GET(value)           (((value) >> 28) & ((1 << 4) - 1))
#define INCA_IP_WDT_CHIPID_VERSION_SET(value)           ((((1 << 4) - 1) &(value)) << 28)                         
#define INCA_IP_WDT_CHIPID_PART_NUMBER_GET(value)           (((value) >> 12) & ((1 << 16) - 1))
#define INCA_IP_WDT_CHIPID_PART_NUMBER_SET(value)           ((((1 << 16) - 1) &(value)) << 12)                         
#define INCA_IP_WDT_CHIPID_MANID_GET(value)           (((value) >> 1) & ((1 << 11) - 1))
#define INCA_IP_WDT_CHIPID_MANID_SET(value)           ((((1 << 11) - 1) &(value)) << 1)
      
/***Redesign Tracing Identification Register***/ 
#define INCA_IP_WDT_RTID                     (VREG32 (INCA_IP_WDT + 0x0078))
#define INCA_IP_WDT_RTID_LC                    (1 << 15)                         
#define INCA_IP_WDT_RTID_RIX_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_WDT_RTID_RIX_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***Watchdog Timer Control Register 0***/ 
#define INCA_IP_WDT_WDT_CON0                     (VREG32 (INCA_IP_WDT + 0x0020))                         
#define INCA_IP_WDT_WDT_CON0_WDTREL_GET(value)           (((value) >> 16) & ((1 << 16) - 1))
#define INCA_IP_WDT_WDT_CON0_WDTREL_SET(value)           ((((1 << 16) - 1) &(value)) << 16)                         
#define INCA_IP_WDT_WDT_CON0_WDTPW_GET(value)           (((value) >> 8) & ((1 << 8) - 1))
#define INCA_IP_WDT_WDT_CON0_WDTPW_SET(value)           ((((1 << 8) - 1) &(value)) << 8)                         
#define INCA_IP_WDT_WDT_CON0_WDTHPW1_GET(value)           (((value) >> 4) & ((1 << 4) - 1))
#define INCA_IP_WDT_WDT_CON0_WDTHPW1_SET(value)           ((((1 << 4) - 1) &(value)) << 4)                         
#define INCA_IP_WDT_WDT_CON0_WDTHPW0_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_WDT_WDT_CON0_WDTHPW0_SET(value)           ((((1 << 2) - 1) &(value)) << 2)
#define INCA_IP_WDT_WDT_CON0_WDTLCK                    (1 << 1)
#define INCA_IP_WDT_WDT_CON0_ENDINIT                    (1 << 0)
      
/***Watchdog Timer Control Register 1***/ 
#define INCA_IP_WDT_WDT_CON1                     (VREG32 (INCA_IP_WDT + 0x0024))
#define INCA_IP_WDT_WDT_CON1_WDTDR                    (1 << 3)
#define INCA_IP_WDT_WDT_CON1_WDTIR                    (1 << 2)
      
/***Watchdog Timer Status Register***/ 
#define INCA_IP_WDT_WDT_SR                     (VREG32 (INCA_IP_WDT + 0x0028))                         
#define INCA_IP_WDT_WDT_SR_WDTTIM_GET(value)           (((value) >> 16) & ((1 << 16) - 1))
#define INCA_IP_WDT_WDT_SR_WDTTIM_SET(value)           ((((1 << 16) - 1) &(value)) << 16)
#define INCA_IP_WDT_WDT_SR_WDTPR                    (1 << 5)
#define INCA_IP_WDT_WDT_SR_WDTTO                    (1 << 4)
#define INCA_IP_WDT_WDT_SR_WDTDS                    (1 << 3)
#define INCA_IP_WDT_WDT_SR_WDTIS                    (1 << 2)
#define INCA_IP_WDT_WDT_SR_WDTOE                    (1 << 1)
#define INCA_IP_WDT_WDT_SR_WDTAE                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  CGU register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_CGU                     (0xBF107000)
/***********************************************************************/   

      
/***CGU PLL1 Control Register***/ 
#define INCA_IP_CGU_CGU_PLL1CR                     (VREG32 (INCA_IP_CGU + 0x0008))
#define INCA_IP_CGU_CGU_PLL1CR_SWRST                    (1 << 31)
#define INCA_IP_CGU_CGU_PLL1CR_EN                    (1 << 30)                         
#define INCA_IP_CGU_CGU_PLL1CR_NDIV_GET(value)           (((value) >> 16) & ((1 << 6) - 1))
#define INCA_IP_CGU_CGU_PLL1CR_NDIV_SET(value)           ((((1 << 6) - 1) &(value)) << 16)                         
#define INCA_IP_CGU_CGU_PLL1CR_MDIV_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_CGU_CGU_PLL1CR_MDIV_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***CGU PLL0 Control Register***/ 
#define INCA_IP_CGU_CGU_PLL0CR                     (VREG32 (INCA_IP_CGU + 0x0000))
#define INCA_IP_CGU_CGU_PLL0CR_SWRST                    (1 << 31)
#define INCA_IP_CGU_CGU_PLL0CR_EN                    (1 << 30)                         
#define INCA_IP_CGU_CGU_PLL0CR_NDIV_GET(value)           (((value) >> 16) & ((1 << 6) - 1))
#define INCA_IP_CGU_CGU_PLL0CR_NDIV_SET(value)           ((((1 << 6) - 1) &(value)) << 16)                         
#define INCA_IP_CGU_CGU_PLL0CR_MDIV_GET(value)           (((value) >> 0) & ((1 << 4) - 1))
#define INCA_IP_CGU_CGU_PLL0CR_MDIV_SET(value)           ((((1 << 4) - 1) &(value)) << 0)
      
/***CGU PLL0 Status Register***/ 
#define INCA_IP_CGU_CGU_PLL0SR                     (VREG32 (INCA_IP_CGU + 0x0004))
#define INCA_IP_CGU_CGU_PLL0SR_LOCK                    (1 << 31)
#define INCA_IP_CGU_CGU_PLL0SR_RCF                    (1 << 29)
#define INCA_IP_CGU_CGU_PLL0SR_PLLBYP                    (1 << 15)
      
/***CGU PLL1 Status Register***/ 
#define INCA_IP_CGU_CGU_PLL1SR                     (VREG32 (INCA_IP_CGU + 0x000C))
#define INCA_IP_CGU_CGU_PLL1SR_LOCK                    (1 << 31)
#define INCA_IP_CGU_CGU_PLL1SR_RCF                    (1 << 29)
#define INCA_IP_CGU_CGU_PLL1SR_PLLBYP                    (1 << 15)
      
/***CGU Divider Control Register***/ 
#define INCA_IP_CGU_CGU_DIVCR                     (VREG32 (INCA_IP_CGU + 0x0010))
#define INCA_IP_CGU_CGU_DIVCR_SWRST                    (1 << 31)
#define INCA_IP_CGU_CGU_DIVCR_DIVI                    (1 << 6)                         
#define INCA_IP_CGU_CGU_DIVCR_DSP_GET(value)           (((value) >> 4) & ((1 << 2) - 1))
#define INCA_IP_CGU_CGU_DIVCR_DSP_SET(value)           ((((1 << 2) - 1) &(value)) << 4)                         
#define INCA_IP_CGU_CGU_DIVCR_FPI_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_CGU_CGU_DIVCR_FPI_SET(value)           ((((1 << 2) - 1) &(value)) << 2)                         
#define INCA_IP_CGU_CGU_DIVCR_IOREGION_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_CGU_CGU_DIVCR_IOREGION_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***CGU Multiplexer Control Register***/ 
#define INCA_IP_CGU_CGU_MUXCR                     (VREG32 (INCA_IP_CGU + 0x0014))
#define INCA_IP_CGU_CGU_MUXCR_SWRST                    (1 << 31)
#define INCA_IP_CGU_CGU_MUXCR_MUXII                    (1 << 1)
#define INCA_IP_CGU_CGU_MUXCR_MUXI                    (1 << 0)
      
/***CGU Fractional Divider Control Register***/ 
#define INCA_IP_CGU_CGU_FDCR                     (VREG32 (INCA_IP_CGU + 0x0018))
#define INCA_IP_CGU_CGU_FDCR_FDEN                    (1 << 31)                         
#define INCA_IP_CGU_CGU_FDCR_INTEGER_GET(value)           (((value) >> 16) & ((1 << 12) - 1))
#define INCA_IP_CGU_CGU_FDCR_INTEGER_SET(value)           ((((1 << 12) - 1) &(value)) << 16)                         
#define INCA_IP_CGU_CGU_FDCR_FRACTION_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_CGU_CGU_FDCR_FRACTION_SET(value)           ((((1 << 16) - 1) &(value)) << 0)		
         
/***********************************************************************/
/*  Module      :  ICU register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_ICU                     (0xBF101000)
/***********************************************************************/   

      
/***IM0 Interrupt Status Register***/ 
#define INCA_IP_ICU_IM0_ISR                     (VREG32 (INCA_IP_ICU + 0x0000))
#define INCA_IP_ICU_IM0_ISR_IR(value)          (1 << value)
      
/***IM1 Interrupt Status Register***/ 
#define INCA_IP_ICU_IM1_ISR                     (VREG32 (INCA_IP_ICU + 0x0200))
#define INCA_IP_ICU_IM1_ISR_IR(value)          (1 << value)
      
/***IM2 Interrupt Status Register***/ 
#define INCA_IP_ICU_IM2_ISR                     (VREG32 (INCA_IP_ICU + 0x0400))
#define INCA_IP_ICU_IM2_ISR_IR(value)          (1 << value)
      
/***IM0 Interrupt Enable Register***/ 
#define INCA_IP_ICU_IM0_IER                     (VREG32 (INCA_IP_ICU + 0x0008))
#define INCA_IP_ICU_IM0_IER_IR(value)          (1 << value)
      
/***IM1 Interrupt Enable Register***/ 
#define INCA_IP_ICU_IM1_IER                     (VREG32 (INCA_IP_ICU + 0x0208))
#define INCA_IP_ICU_IM1_IER_IR(value)          (1 << value)
      
/***IM2 Interrupt Enable Register***/ 
#define INCA_IP_ICU_IM2_IER                     (VREG32 (INCA_IP_ICU + 0x0408))
#define INCA_IP_ICU_IM2_IER_IR(value)          (1 << value)
      
/***IM0 Interrupt Output Status Register***/ 
#define INCA_IP_ICU_IM0_IOSR                     (VREG32 (INCA_IP_ICU + 0x0010))
#define INCA_IP_ICU_IM0_IOSR_IR(value)          (1 << value)
      
/***IM1 Interrupt Output Status Register***/ 
#define INCA_IP_ICU_IM1_IOSR                     (VREG32 (INCA_IP_ICU + 0x0210))
#define INCA_IP_ICU_IM1_IOSR_IR(value)          (1 << value)
      
/***IM2 Interrupt Output Status Register***/ 
#define INCA_IP_ICU_IM2_IOSR                     (VREG32 (INCA_IP_ICU + 0x0410))
#define INCA_IP_ICU_IM2_IOSR_IR(value)          (1 << value)
      
/***IM0 Interrupt Request Set Register***/ 
#define INCA_IP_ICU_IM0_IRSR                     (VREG32 (INCA_IP_ICU + 0x0018))
#define INCA_IP_ICU_IM0_IRSR_IR(value)          (1 << value)
      
/***IM1 Interrupt Request Set Register***/ 
#define INCA_IP_ICU_IM1_IRSR                     (VREG32 (INCA_IP_ICU + 0x0218))
#define INCA_IP_ICU_IM1_IRSR_IR(value)          (1 << value)
      
/***IM2 Interrupt Request Set Register***/ 
#define INCA_IP_ICU_IM2_IRSR                     (VREG32 (INCA_IP_ICU + 0x0418))
#define INCA_IP_ICU_IM2_IRSR_IR(value)          (1 << value)
      
/***External Interrupt Control Register***/ 
#define INCA_IP_ICU_ICU_EICR                     (VREG32 (INCA_IP_ICU + 0x0B00))                         
#define INCA_IP_ICU_ICU_EICR_EII5_GET(value)           (((value) >> 20) & ((1 << 3) - 1))
#define INCA_IP_ICU_ICU_EICR_EII5_SET(value)           ((((1 << 3) - 1) &(value)) << 20)                         
#define INCA_IP_ICU_ICU_EICR_EII4_GET(value)           (((value) >> 16) & ((1 << 3) - 1))
#define INCA_IP_ICU_ICU_EICR_EII4_SET(value)           ((((1 << 3) - 1) &(value)) << 16)                         
#define INCA_IP_ICU_ICU_EICR_EII3_GET(value)           (((value) >> 12) & ((1 << 3) - 1))
#define INCA_IP_ICU_ICU_EICR_EII3_SET(value)           ((((1 << 3) - 1) &(value)) << 12)                         
#define INCA_IP_ICU_ICU_EICR_EII2_GET(value)           (((value) >> 8) & ((1 << 3) - 1))
#define INCA_IP_ICU_ICU_EICR_EII2_SET(value)           ((((1 << 3) - 1) &(value)) << 8)                         
#define INCA_IP_ICU_ICU_EICR_EII1_GET(value)           (((value) >> 4) & ((1 << 3) - 1))
#define INCA_IP_ICU_ICU_EICR_EII1_SET(value)           ((((1 << 3) - 1) &(value)) << 4)                         
#define INCA_IP_ICU_ICU_EICR_EII0_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_ICU_ICU_EICR_EII0_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***Interrupt Node Control Register 1***/ 
#define INCA_IP_ICU_ICU_IRNCR1                     (VREG32 (INCA_IP_ICU + 0x0BF8))
#define INCA_IP_ICU_ICU_IRNCR1_IR5                    (1 << 5)
#define INCA_IP_ICU_ICU_IRNCR1_IR4                    (1 << 4)
#define INCA_IP_ICU_ICU_IRNCR1_IR3                    (1 << 3)
#define INCA_IP_ICU_ICU_IRNCR1_IR2                    (1 << 2)
#define INCA_IP_ICU_ICU_IRNCR1_IR1                    (1 << 1)
#define INCA_IP_ICU_ICU_IRNCR1_IR0                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  DES/3DES register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_DES_3DES                     (0xB8000800)
/***********************************************************************/   

      
/***DES Input Data High Register***/ 
#define INCA_IP_DES_3DES_DES_IHR                     (VREG32 (INCA_IP_DES_3DES + 0x0000))
#define INCA_IP_DES_3DES_DES_IHR_IH(value)          (1 << value)
                      
      
/***DES Input Data Low Register***/ 
#define INCA_IP_DES_3DES_DES_ILR                     (VREG32 (INCA_IP_DES_3DES + 0x0004))
#define INCA_IP_DES_3DES_DES_ILR_IL(value)          (1 << value)
                      
      
/***DES Key #1 High Register***/ 
#define INCA_IP_DES_3DES_DES_K1HR                     (VREG32 (INCA_IP_DES_3DES + 0x0008))
#define INCA_IP_DES_3DES_DES_K1HR_K1H(value)          (1 << value)
                      
      
/***DES Key #1 Low Register***/ 
#define INCA_IP_DES_3DES_DES_K1LR                     (VREG32 (INCA_IP_DES_3DES + 0x000C))
#define INCA_IP_DES_3DES_DES_K1LR_K1L(value)          (1 << value)
                      
      
/***DES Key #2 High Register***/ 
#define INCA_IP_DES_3DES_DES_K2HR                     (VREG32 (INCA_IP_DES_3DES + 0x0010))
#define INCA_IP_DES_3DES_DES_K2HR_K2H(value)          (1 << value)
                      
      
/***DES Key #2 Low Register***/ 
#define INCA_IP_DES_3DES_DES_K2LR                     (VREG32 (INCA_IP_DES_3DES + 0x0014))
#define INCA_IP_DES_3DES_DES_K2LR_K2L(value)          (1 << value)
                      
      
/***DES Key #3 High Register***/ 
#define INCA_IP_DES_3DES_DES_K3HR                     (VREG32 (INCA_IP_DES_3DES + 0x0018))
#define INCA_IP_DES_3DES_DES_K3HR_K3H(value)          (1 << value)
                      
      
/***DES Key #3 Low Register***/ 
#define INCA_IP_DES_3DES_DES_K3LR                     (VREG32 (INCA_IP_DES_3DES + 0x001C))
#define INCA_IP_DES_3DES_DES_K3LR_K3L(value)          (1 << value)
                      
      
/***DES Initialization Vector High Register***/ 
#define INCA_IP_DES_3DES_DES_IVHR                     (VREG32 (INCA_IP_DES_3DES + 0x0020))
#define INCA_IP_DES_3DES_DES_IVHR_IVH(value)          (1 << value)
                      
      
/***DES Initialization Vector Low Register***/ 
#define INCA_IP_DES_3DES_DES_IVLR                     (VREG32 (INCA_IP_DES_3DES + 0x0024))
#define INCA_IP_DES_3DES_DES_IVLR_IVL(value)          (1 << value)
                      
      
/***DES Control Register***/ 
#define INCA_IP_DES_3DES_DES_CONTROLR                     (VREG32 (INCA_IP_DES_3DES + 0x0028))
#define INCA_IP_DES_3DES_DES_CONTROLR_KRE                    (1 << 31)
#define INCA_IP_DES_3DES_DES_CONTROLR_DAU                    (1 << 16)
#define INCA_IP_DES_3DES_DES_CONTROLR_F(value)          (1 << value)
                      
#define INCA_IP_DES_3DES_DES_CONTROLR_O(value)          (1 << value)
                      
#define INCA_IP_DES_3DES_DES_CONTROLR_GO                    (1 << 8)
#define INCA_IP_DES_3DES_DES_CONTROLR_STP                    (1 << 7)
#define INCA_IP_DES_3DES_DES_CONTROLR_IEN                    (1 << 6)
#define INCA_IP_DES_3DES_DES_CONTROLR_BUS                    (1 << 5)
#define INCA_IP_DES_3DES_DES_CONTROLR_SM                    (1 << 4)
#define INCA_IP_DES_3DES_DES_CONTROLR_E_D                    (1 << 3)
#define INCA_IP_DES_3DES_DES_CONTROLR_M(value)          (1 << value)
                      
      
/***DES Output Data High Register***/ 
#define INCA_IP_DES_3DES_DES_OHR                     (VREG32 (INCA_IP_DES_3DES + 0x002C))
#define INCA_IP_DES_3DES_DES_OHR_OH(value)          (1 << value)
                      
      
/***DES Output Data Low Register***/ 
#define INCA_IP_DES_3DES_DES_OLR                     (VREG32 (INCA_IP_DES_3DES + 0x0030))
#define INCA_IP_DES_3DES_DES_OLR_OL(value)          (1 << value)
                      		
         
/***********************************************************************/
/*  Module      :  AES register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_AES                     (0xB8000880)
/***********************************************************************/   

      
/***AES Input Data 3 Register***/ 
#define INCA_IP_AES_AES_ID3R                     (VREG32 (INCA_IP_AES + 0x0000))
#define INCA_IP_AES_AES_ID3R_I(value)          (1 << value)
                      
      
/***AES Input Data 2 Register***/ 
#define INCA_IP_AES_AES_ID2R                     (VREG32 (INCA_IP_AES + 0x0004))
#define INCA_IP_AES_AES_ID2R_I(value)          (1 << value)
                      
      
/***AES Input Data 1 Register***/ 
#define INCA_IP_AES_AES_ID1R                     (VREG32 (INCA_IP_AES + 0x0008))
#define INCA_IP_AES_AES_ID1R_I(value)          (1 << value)
                      
      
/***AES Input Data 0 Register***/ 
#define INCA_IP_AES_AES_ID0R                     (VREG32 (INCA_IP_AES + 0x000C))
#define INCA_IP_AES_AES_ID0R_I(value)          (1 << value)
                      
      
/***AES Key 7 Register***/ 
#define INCA_IP_AES_AES_K7R                     (VREG32 (INCA_IP_AES + 0x0010))
#define INCA_IP_AES_AES_K7R_K(value)          (1 << value)
                      
      
/***AES Key 6 Register***/ 
#define INCA_IP_AES_AES_K6R                     (VREG32 (INCA_IP_AES + 0x0014))
#define INCA_IP_AES_AES_K6R_K(value)          (1 << value)
                      
      
/***AES Key 5 Register***/ 
#define INCA_IP_AES_AES_K5R                     (VREG32 (INCA_IP_AES + 0x0018))
#define INCA_IP_AES_AES_K5R_K(value)          (1 << value)
                      
      
/***AES Key 4 Register***/ 
#define INCA_IP_AES_AES_K4R                     (VREG32 (INCA_IP_AES + 0x001C))
#define INCA_IP_AES_AES_K4R_K(value)          (1 << value)
                      
      
/***AES Key 3 Register***/ 
#define INCA_IP_AES_AES_K3R                     (VREG32 (INCA_IP_AES + 0x0020))
#define INCA_IP_AES_AES_K3R_K(value)          (1 << value)
                      
      
/***AES Key 2 Register***/ 
#define INCA_IP_AES_AES_K2R                     (VREG32 (INCA_IP_AES + 0x0024))
#define INCA_IP_AES_AES_K2R_K(value)          (1 << value)
                      
      
/***AES Key 1 Register***/ 
#define INCA_IP_AES_AES_K1R                     (VREG32 (INCA_IP_AES + 0x0028))
#define INCA_IP_AES_AES_K1R_K(value)          (1 << value)
                      
      
/***AES Key 0 Register***/ 
#define INCA_IP_AES_AES_K0R                     (VREG32 (INCA_IP_AES + 0x002C))
#define INCA_IP_AES_AES_K0R_K(value)          (1 << value)
      
/***AES Initialization Vector 3 Register***/ 
#define INCA_IP_AES_AES_IV3R                     (VREG32 (INCA_IP_AES + 0x0030))
#define INCA_IP_AES_AES_IV3R_IV(value)          (1 << value)
                      
                      
/***AES Initialization Vector 2 Register***/ 
#define INCA_IP_AES_AES_IV2R                     (VREG32 (INCA_IP_AES + 0x0034))
#define INCA_IP_AES_AES_IV2R_IV(value)          (1 << value)
                      
      
/***AES Initialization Vector 1 Register***/ 
#define INCA_IP_AES_AES_IV1R                     (VREG32 (INCA_IP_AES + 0x0038))
#define INCA_IP_AES_AES_IV1R_IV(value)          (1 << value)
                      
      
/***AES Initialization Vector 0 Register***/ 
#define INCA_IP_AES_AES_IV0R                     (VREG32 (INCA_IP_AES + 0x003C))     	
#define INCA_IP_AES_AES_IV0R_IV_GET(value)           (((value) >> 0) & ((1 << 32) - 1))
#define INCA_IP_AES_AES_IV0R_IV_SET(value)           ((((1 << 32) - 1) &(value)) << 0)
      
      
/***AES Control Register***/ 
#define INCA_IP_AES_AES_CONTROLR                     (VREG32 (INCA_IP_AES + 0x0050))
#define INCA_IP_AES_AES_CONTROLR_KRE                    (1 << 31)
#define INCA_IP_AES_AES_CONTROLR_DAU                    (1 << 16)
#define INCA_IP_AES_AES_CONTROLR_PNK                    (1 << 15)
#define INCA_IP_AES_AES_CONTROLR_F(value)          (1 << value)
                      
#define INCA_IP_AES_AES_CONTROLR_O(value)          (1 << value)
                      
#define INCA_IP_AES_AES_CONTROLR_GO                    (1 << 8)
#define INCA_IP_AES_AES_CONTROLR_STP                    (1 << 7)
#define INCA_IP_AES_AES_CONTROLR_IEN                    (1 << 6)
#define INCA_IP_AES_AES_CONTROLR_BUS                    (1 << 5)
#define INCA_IP_AES_AES_CONTROLR_SM                    (1 << 4)
#define INCA_IP_AES_AES_CONTROLR_E_D                    (1 << 3)
#define INCA_IP_AES_AES_CONTROLR_KV                    (1 << 2)
#define INCA_IP_AES_AES_CONTROLR_K(value)          (1 << value)
                      		
         
      
/***AES Output Data 3 Register***/ 
#define INCA_IP_AES_AES_OD3R                     (VREG32 (INCA_IP_AES + 0x0054))
#define INCA_IP_AES_AES_OD3R_O(value)          (1 << value)
                      
      
/***AES Output Data 2 Register***/ 
#define INCA_IP_AES_AES_OD2R                     (VREG32 (INCA_IP_AES + 0x0058))
#define INCA_IP_AES_AES_OD2R_O(value)          (1 << value)
                      
      
/***AES Output Data 1 Register***/ 
#define INCA_IP_AES_AES_OD1R                     (VREG32 (INCA_IP_AES + 0x005C))
#define INCA_IP_AES_AES_OD1R_O(value)          (1 << value)
                      
      
/***AES Output Data 0 Register***/ 
#define INCA_IP_AES_AES_OD0R                     (VREG32 (INCA_IP_AES + 0x0060))
#define INCA_IP_AES_AES_OD0R_O(value)          (1 << value)
                      
/***********************************************************************/
/*  Module      :  Debug register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_Debug                     (0xBF106000)
/***********************************************************************/   

      
/***MCD Break Bus Switch Register***/ 
#define INCA_IP_Debug_MCD_BBS                     (VREG32 (INCA_IP_Debug + 0x0000))
#define INCA_IP_Debug_MCD_BBS_BTP1                    (1 << 19)
#define INCA_IP_Debug_MCD_BBS_BTP0                    (1 << 18)
#define INCA_IP_Debug_MCD_BBS_BSP1                    (1 << 17)
#define INCA_IP_Debug_MCD_BBS_BSP0                    (1 << 16)
#define INCA_IP_Debug_MCD_BBS_BT5EN                    (1 << 15)
#define INCA_IP_Debug_MCD_BBS_BT4EN                    (1 << 14)
#define INCA_IP_Debug_MCD_BBS_BT5                    (1 << 13)
#define INCA_IP_Debug_MCD_BBS_BT4                    (1 << 12)
#define INCA_IP_Debug_MCD_BBS_BS5EN                    (1 << 7)
#define INCA_IP_Debug_MCD_BBS_BS4EN                    (1 << 6)
#define INCA_IP_Debug_MCD_BBS_BS5                    (1 << 5)
#define INCA_IP_Debug_MCD_BBS_BS4                    (1 << 4)
      
/***MCD Multiplexer Control Register***/ 
#define INCA_IP_Debug_MCD_MCR                     (VREG32 (INCA_IP_Debug + 0x0008))
#define INCA_IP_Debug_MCD_MCR_MUX5                    (1 << 4)
#define INCA_IP_Debug_MCD_MCR_MUX4                    (1 << 3)
#define INCA_IP_Debug_MCD_MCR_MUX1                    (1 << 0)		
         
/***********************************************************************/
/*  Module      :  BCU register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_BCU                     (0xB8000100)
/***********************************************************************/   

      
/***BCU Control Register (0010H)***/ 
#define INCA_IP_BCU_BCU_CON                     (VREG32 (INCA_IP_BCU + 0x0010))                         
#define INCA_IP_BCU_BCU_CON_SPC_GET(value)           (((value) >> 24) & ((1 << 8) - 1))
#define INCA_IP_BCU_BCU_CON_SPC_SET(value)           ((((1 << 8) - 1) &(value)) << 24)
#define INCA_IP_BCU_BCU_CON_SPE                    (1 << 19)
#define INCA_IP_BCU_BCU_CON_PSE                    (1 << 18)
#define INCA_IP_BCU_BCU_CON_DBG                    (1 << 16)                         
#define INCA_IP_BCU_BCU_CON_TOUT_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_BCU_BCU_CON_TOUT_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***BCU Error Control Capture Register (0020H)***/ 
#define INCA_IP_BCU_BCU_ECON                     (VREG32 (INCA_IP_BCU + 0x0020))                         
#define INCA_IP_BCU_BCU_ECON_TAG_GET(value)           (((value) >> 24) & ((1 << 4) - 1))
#define INCA_IP_BCU_BCU_ECON_TAG_SET(value)           ((((1 << 4) - 1) &(value)) << 24)
#define INCA_IP_BCU_BCU_ECON_RDN                    (1 << 23)
#define INCA_IP_BCU_BCU_ECON_WRN                    (1 << 22)
#define INCA_IP_BCU_BCU_ECON_SVM                    (1 << 21)                         
#define INCA_IP_BCU_BCU_ECON_ACK_GET(value)           (((value) >> 19) & ((1 << 2) - 1))
#define INCA_IP_BCU_BCU_ECON_ACK_SET(value)           ((((1 << 2) - 1) &(value)) << 19)
#define INCA_IP_BCU_BCU_ECON_ABT                    (1 << 18)
#define INCA_IP_BCU_BCU_ECON_RDY                    (1 << 17)
#define INCA_IP_BCU_BCU_ECON_TOUT                    (1 << 16)                         
#define INCA_IP_BCU_BCU_ECON_ERRCNT_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_BCU_BCU_ECON_ERRCNT_SET(value)           ((((1 << 16) - 1) &(value)) << 0)                         
#define INCA_IP_BCU_BCU_ECON_OPC_GET(value)           (((value) >> 28) & ((1 << 4) - 1))
#define INCA_IP_BCU_BCU_ECON_OPC_SET(value)           ((((1 << 4) - 1) &(value)) << 28)
      
/***BCU Error Address Capture Register (0024 H)***/ 
#define INCA_IP_BCU_BCU_EADD                     (VREG32 (INCA_IP_BCU + 0x0024))
#define INCA_IP_BCU_BCU_EADD_FPIADR
      
/***BCU Error Data Capture Register (0028H)***/ 
#define INCA_IP_BCU_BCU_EDAT                     (VREG32 (INCA_IP_BCU + 0x0028))
#define INCA_IP_BCU_BCU_EDAT_FPIDAT		
         
/***********************************************************************/
/*  Module      :  DMA register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_DMA                     (0xBF108000)
/***********************************************************************/   

      
/***DMA RX Channel 0 Command Register***/ 
#define INCA_IP_DMA_DMA_RXCCR0                     (VREG32 (INCA_IP_DMA + 0x0800))
#define INCA_IP_DMA_DMA_RXCCR0_LBE                    (1 << 31)
#define INCA_IP_DMA_DMA_RXCCR0_HPEN                    (1 << 30)
#define INCA_IP_DMA_DMA_RXCCR0_INIT                    (1 << 2)
#define INCA_IP_DMA_DMA_RXCCR0_OFF                    (1 << 1)
#define INCA_IP_DMA_DMA_RXCCR0_HR                    (1 << 0)
      
/***DMA RX Channel 1 Command Register***/ 
#define INCA_IP_DMA_DMA_RXCCR1                     (VREG32 (INCA_IP_DMA + 0x0804))
#define INCA_IP_DMA_DMA_RXCCR1_LBE                    (1 << 31)
#define INCA_IP_DMA_DMA_RXCCR1_HPEN                    (1 << 30)
#define INCA_IP_DMA_DMA_RXCCR1_INIT                    (1 << 2)
#define INCA_IP_DMA_DMA_RXCCR1_OFF                    (1 << 1)
#define INCA_IP_DMA_DMA_RXCCR1_HR                    (1 << 0)
      
/***DMA Receive Interrupt Status Register***/ 
#define INCA_IP_DMA_DMA_RXISR                     (VREG32 (INCA_IP_DMA + 0x0808))                         
#define INCA_IP_DMA_DMA_RXISR_RDERRx_GET(value)           (((value) >> 8) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXISR_RDERRx_SET(value)           ((((1 << 2) - 1) &(value)) << 8)                         
#define INCA_IP_DMA_DMA_RXISR_CMDCPTx_GET(value)           (((value) >> 6) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXISR_CMDCPTx_SET(value)           ((((1 << 2) - 1) &(value)) << 6)                         
#define INCA_IP_DMA_DMA_RXISR_EOPx_GET(value)           (((value) >> 4) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXISR_EOPx_SET(value)           ((((1 << 2) - 1) &(value)) << 4)                         
#define INCA_IP_DMA_DMA_RXISR_CPTx_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXISR_CPTx_SET(value)           ((((1 << 2) - 1) &(value)) << 2)                         
#define INCA_IP_DMA_DMA_RXISR_HLDx_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXISR_HLDx_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***DMA Receive Interrupt Mask Register***/ 
#define INCA_IP_DMA_DMA_RXIMR                     (VREG32 (INCA_IP_DMA + 0x080C))                         
#define INCA_IP_DMA_DMA_RXIMR_RDERRx_GET(value)           (((value) >> 8) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXIMR_RDERRx_SET(value)           ((((1 << 2) - 1) &(value)) << 8)                         
#define INCA_IP_DMA_DMA_RXIMR_CMDCPTx_GET(value)           (((value) >> 6) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXIMR_CMDCPTx_SET(value)           ((((1 << 2) - 1) &(value)) << 6)                         
#define INCA_IP_DMA_DMA_RXIMR_EOPx_GET(value)           (((value) >> 4) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXIMR_EOPx_SET(value)           ((((1 << 2) - 1) &(value)) << 4)                         
#define INCA_IP_DMA_DMA_RXIMR_CPTx_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXIMR_CPTx_SET(value)           ((((1 << 2) - 1) &(value)) << 2)                         
#define INCA_IP_DMA_DMA_RXIMR_HLDx_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXIMR_HLDx_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***DMA First Receive Descriptor Addr. for Rx Channel 0
***/
#define INCA_IP_DMA_DMA_RXFRDA0                     (VREG32 (INCA_IP_DMA + 0x0810))                         
#define INCA_IP_DMA_DMA_RXFRDA0_RXFRDA_GET(value)           (((value) >> 0) & ((1 << 28) - 1))
#define INCA_IP_DMA_DMA_RXFRDA0_RXFRDA_SET(value)           ((((1 << 28) - 1) &(value)) << 0)
      
/***DMA First Receive Descriptor Addr. for Rx Channel 1
***/
#define INCA_IP_DMA_DMA_RXFRDA1                     (VREG32 (INCA_IP_DMA + 0x0814))                         
#define INCA_IP_DMA_DMA_RXFRDA1_RXFRDA_GET(value)           (((value) >> 0) & ((1 << 28) - 1))
#define INCA_IP_DMA_DMA_RXFRDA1_RXFRDA_SET(value)           ((((1 << 28) - 1) &(value)) << 0)
      
/***DMA Receive Channel Polling Time***/ 
#define INCA_IP_DMA_DMA_RXPOLL                     (VREG32 (INCA_IP_DMA + 0x0818))                         
#define INCA_IP_DMA_DMA_RXPOLL_BSZ1_GET(value)           (((value) >> 30) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXPOLL_BSZ1_SET(value)           ((((1 << 2) - 1) &(value)) << 30)                         
#define INCA_IP_DMA_DMA_RXPOLL_BSZ0_GET(value)           (((value) >> 28) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_RXPOLL_BSZ0_SET(value)           ((((1 << 2) - 1) &(value)) << 28)                         
#define INCA_IP_DMA_DMA_RXPOLL_RXPOLLTIME_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_DMA_DMA_RXPOLL_RXPOLLTIME_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***DMA TX Channel 0 Command Register (Voice Port)***/ 
#define INCA_IP_DMA_DMA_TXCCR0                     (VREG32 (INCA_IP_DMA + 0x0880))
#define INCA_IP_DMA_DMA_TXCCR0_LBE                    (1 << 31)
#define INCA_IP_DMA_DMA_TXCCR0_HPEN                    (1 << 30)
#define INCA_IP_DMA_DMA_TXCCR0_HR                    (1 << 2)
#define INCA_IP_DMA_DMA_TXCCR0_OFF                    (1 << 1)
#define INCA_IP_DMA_DMA_TXCCR0_INIT                    (1 << 0)
      
/***DMA TX Channel 1 Command Register (Mangmt Port)***/ 
#define INCA_IP_DMA_DMA_TXCCR1                     (VREG32 (INCA_IP_DMA + 0x0884))
#define INCA_IP_DMA_DMA_TXCCR1_LBE                    (1 << 31)
#define INCA_IP_DMA_DMA_TXCCR1_HPEN                    (1 << 30)
#define INCA_IP_DMA_DMA_TXCCR1_HR                    (1 << 2)
#define INCA_IP_DMA_DMA_TXCCR1_OFF                    (1 << 1)
#define INCA_IP_DMA_DMA_TXCCR1_INIT                    (1 << 0)
      
/***DMA TX Channel 2 Command Register (SSC Port)***/ 
#define INCA_IP_DMA_DMA_TXCCR2                     (VREG32 (INCA_IP_DMA + 0x0888))
#define INCA_IP_DMA_DMA_TXCCR2_LBE                    (1 << 31)
#define INCA_IP_DMA_DMA_TXCCR2_HPEN                    (1 << 30)
#define INCA_IP_DMA_DMA_TXCCR2_HBF                    (1 << 29)
#define INCA_IP_DMA_DMA_TXCCR2_HR                    (1 << 2)
#define INCA_IP_DMA_DMA_TXCCR2_OFF                    (1 << 1)
#define INCA_IP_DMA_DMA_TXCCR2_INIT                    (1 << 0)
      
/***DMA First Receive Descriptor Addr. for Tx Channel 0
***/
#define INCA_IP_DMA_DMA_TXFRDA0                     (VREG32 (INCA_IP_DMA + 0x08A0))                         
#define INCA_IP_DMA_DMA_TXFRDA0_TXFRDA_GET(value)           (((value) >> 0) & ((1 << 28) - 1))
#define INCA_IP_DMA_DMA_TXFRDA0_TXFRDA_SET(value)           ((((1 << 28) - 1) &(value)) << 0)
      
/***DMA First Receive Descriptor Addr. for Tx Channel 1
***/
#define INCA_IP_DMA_DMA_TXFRDA1                     (VREG32 (INCA_IP_DMA + 0x08A4))                         
#define INCA_IP_DMA_DMA_TXFRDA1_TXFRDA_GET(value)           (((value) >> 0) & ((1 << 28) - 1))
#define INCA_IP_DMA_DMA_TXFRDA1_TXFRDA_SET(value)           ((((1 << 28) - 1) &(value)) << 0)
      
/***DMA First Receive Descriptor Addr. for Tx Channel 2
***/
#define INCA_IP_DMA_DMA_TXFRDA2                     (VREG32 (INCA_IP_DMA + 0x08A8))                         
#define INCA_IP_DMA_DMA_TXFRDA2_TXFRDA_GET(value)           (((value) >> 0) & ((1 << 28) - 1))
#define INCA_IP_DMA_DMA_TXFRDA2_TXFRDA_SET(value)           ((((1 << 28) - 1) &(value)) << 0)
      
/***DMA Transmit Channel Arbitration Register***/ 
#define INCA_IP_DMA_DMA_TXWGT                     (VREG32 (INCA_IP_DMA + 0x08C0))                         
#define INCA_IP_DMA_DMA_TXWGT_TX2PR_GET(value)           (((value) >> 4) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_TXWGT_TX2PR_SET(value)           ((((1 << 2) - 1) &(value)) << 4)                         
#define INCA_IP_DMA_DMA_TXWGT_TX1PRI_GET(value)           (((value) >> 2) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_TXWGT_TX1PRI_SET(value)           ((((1 << 2) - 1) &(value)) << 2)                         
#define INCA_IP_DMA_DMA_TXWGT_TX0PRI_GET(value)           (((value) >> 0) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_TXWGT_TX0PRI_SET(value)           ((((1 << 2) - 1) &(value)) << 0)
      
/***DMA Transmit Channel Polling Time***/ 
#define INCA_IP_DMA_DMA_TXPOLL                     (VREG32 (INCA_IP_DMA + 0x08C4))                         
#define INCA_IP_DMA_DMA_TXPOLL_BSZ2_GET(value)           (((value) >> 30) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_TXPOLL_BSZ2_SET(value)           ((((1 << 2) - 1) &(value)) << 30)                         
#define INCA_IP_DMA_DMA_TXPOLL_BSZ1_GET(value)           (((value) >> 28) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_TXPOLL_BSZ1_SET(value)           ((((1 << 2) - 1) &(value)) << 28)                         
#define INCA_IP_DMA_DMA_TXPOLL_BSZ0_GET(value)           (((value) >> 26) & ((1 << 2) - 1))
#define INCA_IP_DMA_DMA_TXPOLL_BSZ0_SET(value)           ((((1 << 2) - 1) &(value)) << 26)                         
#define INCA_IP_DMA_DMA_TXPOLL_TXPOLLTIME_GET(value)           (((value) >> 0) & ((1 << 8) - 1))
#define INCA_IP_DMA_DMA_TXPOLL_TXPOLLTIME_SET(value)           ((((1 << 8) - 1) &(value)) << 0)
      
/***DMA Transmit Interrupt Status Register***/ 
#define INCA_IP_DMA_DMA_TXISR                     (VREG32 (INCA_IP_DMA + 0x08C8))                         
#define INCA_IP_DMA_DMA_TXISR_RDERRx_GET(value)           (((value) >> 12) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXISR_RDERRx_SET(value)           ((((1 << 3) - 1) &(value)) << 12)                         
#define INCA_IP_DMA_DMA_TXISR_HLDx_GET(value)           (((value) >> 9) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXISR_HLDx_SET(value)           ((((1 << 3) - 1) &(value)) << 9)                         
#define INCA_IP_DMA_DMA_TXISR_CPTx_GET(value)           (((value) >> 6) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXISR_CPTx_SET(value)           ((((1 << 3) - 1) &(value)) << 6)                         
#define INCA_IP_DMA_DMA_TXISR_EOPx_GET(value)           (((value) >> 3) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXISR_EOPx_SET(value)           ((((1 << 3) - 1) &(value)) << 3)                         
#define INCA_IP_DMA_DMA_TXISR_CMDCPTx_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXISR_CMDCPTx_SET(value)           ((((1 << 3) - 1) &(value)) << 0)
      
/***DMA Transmit Interrupt Mask Register***/ 
#define INCA_IP_DMA_DMA_TXIMR                     (VREG32 (INCA_IP_DMA + 0x08CC))                         
#define INCA_IP_DMA_DMA_TXIMR_RDERRx_GET(value)           (((value) >> 12) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXIMR_RDERRx_SET(value)           ((((1 << 3) - 1) &(value)) << 12)                         
#define INCA_IP_DMA_DMA_TXIMR_HLDx_GET(value)           (((value) >> 9) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXIMR_HLDx_SET(value)           ((((1 << 3) - 1) &(value)) << 9)                         
#define INCA_IP_DMA_DMA_TXIMR_CPTx_GET(value)           (((value) >> 6) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXIMR_CPTx_SET(value)           ((((1 << 3) - 1) &(value)) << 6)                         
#define INCA_IP_DMA_DMA_TXIMR_EOPx_GET(value)           (((value) >> 3) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXIMR_EOPx_SET(value)           ((((1 << 3) - 1) &(value)) << 3)                         
#define INCA_IP_DMA_DMA_TXIMR_CMDCPTx_GET(value)           (((value) >> 0) & ((1 << 3) - 1))
#define INCA_IP_DMA_DMA_TXIMR_CMDCPTx_SET(value)           ((((1 << 3) - 1) &(value)) << 0)		
         
/***********************************************************************/
/*  Module      :  Ports register address and bits                  */
/***********************************************************************/

         
#define INCA_IP_Ports                     (0xB8000A00)
/***********************************************************************/   

      
/***Port 1 Data Output Register (0020H)***/ 
#define INCA_IP_Ports_P1_OUT                     (VREG32 (INCA_IP_Ports + 0x0020))
#define INCA_IP_Ports_P1_OUT_P(value)          (1 << value)
      
/***Port 2 Data Output Register (0040H)***/ 
#define INCA_IP_Ports_P2_OUT                     (VREG32 (INCA_IP_Ports + 0x0040))
#define INCA_IP_Ports_P2_OUT_P(value)          (1 << value)
      
/***Port 1 Data Input Register (0024H)***/ 
#define INCA_IP_Ports_P1_IN                     (VREG32 (INCA_IP_Ports + 0x0024))
#define INCA_IP_Ports_P1_IN_P(value)          (1 << value)
      
/***Port 2 Data Input Register (0044H)***/ 
#define INCA_IP_Ports_P2_IN                     (VREG32 (INCA_IP_Ports + 0x0044))
#define INCA_IP_Ports_P2_IN_P(value)          (1 << value)
      
/***Port 1 Direction Register (0028H)***/ 
#define INCA_IP_Ports_P1_DIR                     (VREG32 (INCA_IP_Ports + 0x0028))
#define INCA_IP_Ports_P1_DIR_Port1P(value)          (1 << value)
      
/***Port 2 Direction Register (0048H)***/ 
#define INCA_IP_Ports_P2_DIR                     (VREG32 (INCA_IP_Ports + 0x0048))                         
#define INCA_IP_Ports_P2_DIR_Port2Pn_GET(value)           (((value) >> 0) & ((1 << 16) - 1))
#define INCA_IP_Ports_P2_DIR_Port2Pn_SET(value)           ((((1 << 16) - 1) &(value)) << 0)
      
/***Port 0 Alternate Function Select Register 0 (000C H)
***/
#define INCA_IP_Ports_P0_ALTSEL                     (VREG32 (INCA_IP_Ports + 0x000C))
#define INCA_IP_Ports_P0_ALTSEL_Port0P(value)          (1 << value)
      
/***Port 1 Alternate Function Select Register 0 (002C H)
***/
#define INCA_IP_Ports_P1_ALTSEL                     (VREG32 (INCA_IP_Ports + 0x002C))
#define INCA_IP_Ports_P1_ALTSEL_Port1P(value)          (1 << value)
      
/***Port 2 Alternate Function Select Register 0 (004C H)
***/
#define INCA_IP_Ports_P2_ALTSEL                     (VREG32 (INCA_IP_Ports + 0x004C))
#define INCA_IP_Ports_P2_ALTSEL_Port2P(value)          (1 << value)
      
/***Port 0 Input Schmitt-Trigger Off Register (0010 H)
***/
#define INCA_IP_Ports_P0_STOFF                     (VREG32 (INCA_IP_Ports + 0x0010))
#define INCA_IP_Ports_P0_STOFF_Port0P(value)          (1 << value)
      
/***Port 1 Input Schmitt-Trigger Off Register (0030 H)
***/
#define INCA_IP_Ports_P1_STOFF                     (VREG32 (INCA_IP_Ports + 0x0030))
#define INCA_IP_Ports_P1_STOFF_Port1P(value)          (1 << value)
      
/***Port 2 Input Schmitt-Trigger Off Register (0050 H)
***/
#define INCA_IP_Ports_P2_STOFF                     (VREG32 (INCA_IP_Ports + 0x0050))
#define INCA_IP_Ports_P2_STOFF_Port2P(value)          (1 << value)
      
/***Port 2 Open Drain Control Register (0054H)***/ 
#define INCA_IP_Ports_P2_OD                     (VREG32 (INCA_IP_Ports + 0x0054))
#define INCA_IP_Ports_P2_OD_Port2P(value)          (1 << value)
      
/***Port 0 Pull Up Device Enable Register (0018 H)***/ 
#define INCA_IP_Ports_P0_PUDEN                     (VREG32 (INCA_IP_Ports + 0x0018))
#define INCA_IP_Ports_P0_PUDEN_Port0P(value)          (1 << value)
      
/***Port 2 Pull Up Device Enable Register (0058 H)***/ 
#define INCA_IP_Ports_P2_PUDEN                     (VREG32 (INCA_IP_Ports + 0x0058))
#define INCA_IP_Ports_P2_PUDEN_Port2P(value)          (1 << value)
      
/***Port 0 Pull Up/Pull Down Select Register (001C H)***/ 
#define INCA_IP_Ports_P0_PUDSEL                     (VREG32 (INCA_IP_Ports + 0x001C))
#define INCA_IP_Ports_P0_PUDSEL_Port0P(value)          (1 << value)
      
/***Port 2 Pull Up/Pull Down Select Register (005C H)***/ 
#define INCA_IP_Ports_P2_PUDSEL                     (VREG32 (INCA_IP_Ports + 0x005C))
#define INCA_IP_Ports_P2_PUDSEL_Port2P(value)          (1 << value)

#ifdef __cplusplus
   }
#endif
       
#endif /* _INCA_IP_H */
